(function () { "use strict";
var $hxClasses = {};
function $extend(from, fields) {
	function Inherit() {} Inherit.prototype = from; var proto = new Inherit();
	for (var name in fields) proto[name] = fields[name];
	if( fields.toString !== Object.prototype.toString ) proto.toString = fields.toString;
	return proto;
}
var EReg = function(r,opt) {
	opt = opt.split("u").join("");
	this.r = new RegExp(r,opt);
};
$hxClasses["EReg"] = EReg;
EReg.__name__ = true;
EReg.prototype = {
	match: function(s) {
		if(this.r.global) this.r.lastIndex = 0;
		this.r.m = this.r.exec(s);
		this.r.s = s;
		return this.r.m != null;
	}
	,matched: function(n) {
		if(this.r.m != null && n >= 0 && n < this.r.m.length) return this.r.m[n]; else throw "EReg::matched";
	}
	,matchedPos: function() {
		if(this.r.m == null) throw "No string matched";
		return { pos : this.r.m.index, len : this.r.m[0].length};
	}
	,__class__: EReg
};
var HxOverrides = function() { };
$hxClasses["HxOverrides"] = HxOverrides;
HxOverrides.__name__ = true;
HxOverrides.cca = function(s,index) {
	var x = s.charCodeAt(index);
	if(x != x) return undefined;
	return x;
};
HxOverrides.substr = function(s,pos,len) {
	if(pos != null && pos != 0 && len != null && len < 0) return "";
	if(len == null) len = s.length;
	if(pos < 0) {
		pos = s.length + pos;
		if(pos < 0) pos = 0;
	} else if(len < 0) len = s.length + len - pos;
	return s.substr(pos,len);
};
HxOverrides.remove = function(a,obj) {
	var i = a.indexOf(obj);
	if(i == -1) return false;
	a.splice(i,1);
	return true;
};
HxOverrides.iter = function(a) {
	return { cur : 0, arr : a, hasNext : function() {
		return this.cur < this.arr.length;
	}, next : function() {
		return this.arr[this.cur++];
	}};
};
var Lambda = function() { };
$hxClasses["Lambda"] = Lambda;
Lambda.__name__ = true;
Lambda.array = function(it) {
	var a = new Array();
	var $it0 = $iterator(it)();
	while( $it0.hasNext() ) {
		var i = $it0.next();
		a.push(i);
	}
	return a;
};
Lambda.count = function(it,pred) {
	var n = 0;
	if(pred == null) {
		var $it0 = $iterator(it)();
		while( $it0.hasNext() ) {
			var _ = $it0.next();
			n++;
		}
	} else {
		var $it1 = $iterator(it)();
		while( $it1.hasNext() ) {
			var x = $it1.next();
			if(pred(x)) n++;
		}
	}
	return n;
};
var IMap = function() { };
$hxClasses["IMap"] = IMap;
IMap.__name__ = true;
Math.__name__ = true;
var Reflect = function() { };
$hxClasses["Reflect"] = Reflect;
Reflect.__name__ = true;
Reflect.hasField = function(o,field) {
	return Object.prototype.hasOwnProperty.call(o,field);
};
Reflect.field = function(o,field) {
	try {
		return o[field];
	} catch( e ) {
		return null;
	}
};
Reflect.setField = function(o,field,value) {
	o[field] = value;
};
Reflect.callMethod = function(o,func,args) {
	return func.apply(o,args);
};
var Std = function() { };
$hxClasses["Std"] = Std;
Std.__name__ = true;
Std["is"] = function(v,t) {
	return js_Boot.__instanceof(v,t);
};
Std.string = function(s) {
	return js_Boot.__string_rec(s,"");
};
Std["int"] = function(x) {
	return x | 0;
};
Std.parseInt = function(x) {
	var v = parseInt(x,10);
	if(v == 0 && (HxOverrides.cca(x,1) == 120 || HxOverrides.cca(x,1) == 88)) v = parseInt(x);
	if(isNaN(v)) return null;
	return v;
};
Std.parseFloat = function(x) {
	return parseFloat(x);
};
var StringBuf = function() {
	this.b = "";
};
$hxClasses["StringBuf"] = StringBuf;
StringBuf.__name__ = true;
StringBuf.prototype = {
	add: function(x) {
		this.b += Std.string(x);
	}
	,addSub: function(s,pos,len) {
		if(len == null) this.b += HxOverrides.substr(s,pos,null); else this.b += HxOverrides.substr(s,pos,len);
	}
	,toString: function() {
		return this.b;
	}
	,__class__: StringBuf
};
var StringTools = function() { };
$hxClasses["StringTools"] = StringTools;
StringTools.__name__ = true;
StringTools.startsWith = function(s,start) {
	return s.length >= start.length && HxOverrides.substr(s,0,start.length) == start;
};
StringTools.replace = function(s,sub,by) {
	return s.split(sub).join(by);
};
StringTools.fastCodeAt = function(s,index) {
	return s.charCodeAt(index);
};
StringTools.isEof = function(c) {
	return c != c;
};
var Type = function() { };
$hxClasses["Type"] = Type;
Type.__name__ = true;
Type.resolveClass = function(name) {
	var cl = $hxClasses[name];
	if(cl == null || !js_Boot.isClass(cl)) return null;
	return cl;
};
Type.resolveEnum = function(name) {
	var e = $hxClasses[name];
	if(e == null || !js_Boot.isEnum(e)) return null;
	return e;
};
Type.enumIndex = function(e) {
	return e[1];
};
var XmlType = $hxClasses["XmlType"] = { __ename__ : true, __constructs__ : [] };
var Xml = function() {
};
$hxClasses["Xml"] = Xml;
Xml.__name__ = true;
Xml.parse = function(str) {
	return haxe_xml_Parser.parse(str);
};
Xml.createElement = function(name) {
	var r = new Xml();
	r.nodeType = Xml.Element;
	r._children = new Array();
	r._attributes = new haxe_ds_StringMap();
	r.set_nodeName(name);
	return r;
};
Xml.createPCData = function(data) {
	var r = new Xml();
	r.nodeType = Xml.PCData;
	r.set_nodeValue(data);
	return r;
};
Xml.createCData = function(data) {
	var r = new Xml();
	r.nodeType = Xml.CData;
	r.set_nodeValue(data);
	return r;
};
Xml.createComment = function(data) {
	var r = new Xml();
	r.nodeType = Xml.Comment;
	r.set_nodeValue(data);
	return r;
};
Xml.createDocType = function(data) {
	var r = new Xml();
	r.nodeType = Xml.DocType;
	r.set_nodeValue(data);
	return r;
};
Xml.createProcessingInstruction = function(data) {
	var r = new Xml();
	r.nodeType = Xml.ProcessingInstruction;
	r.set_nodeValue(data);
	return r;
};
Xml.createDocument = function() {
	var r = new Xml();
	r.nodeType = Xml.Document;
	r._children = new Array();
	return r;
};
Xml.prototype = {
	get_nodeName: function() {
		if(this.nodeType != Xml.Element) throw "bad nodeType";
		return this._nodeName;
	}
	,set_nodeName: function(n) {
		if(this.nodeType != Xml.Element) throw "bad nodeType";
		return this._nodeName = n;
	}
	,set_nodeValue: function(v) {
		if(this.nodeType == Xml.Element || this.nodeType == Xml.Document) throw "bad nodeType";
		return this._nodeValue = v;
	}
	,get: function(att) {
		if(this.nodeType != Xml.Element) throw "bad nodeType";
		return this._attributes.get(att);
	}
	,set: function(att,value) {
		if(this.nodeType != Xml.Element) throw "bad nodeType";
		this._attributes.set(att,value);
	}
	,exists: function(att) {
		if(this.nodeType != Xml.Element) throw "bad nodeType";
		return this._attributes.exists(att);
	}
	,elements: function() {
		if(this._children == null) throw "bad nodetype";
		return { cur : 0, x : this._children, hasNext : function() {
			var k = this.cur;
			var l = this.x.length;
			while(k < l) {
				if(this.x[k].nodeType == Xml.Element) break;
				k += 1;
			}
			this.cur = k;
			return k < l;
		}, next : function() {
			var k1 = this.cur;
			var l1 = this.x.length;
			while(k1 < l1) {
				var n = this.x[k1];
				k1 += 1;
				if(n.nodeType == Xml.Element) {
					this.cur = k1;
					return n;
				}
			}
			return null;
		}};
	}
	,firstElement: function() {
		if(this._children == null) throw "bad nodetype";
		var cur = 0;
		var l = this._children.length;
		while(cur < l) {
			var n = this._children[cur];
			if(n.nodeType == Xml.Element) return n;
			cur++;
		}
		return null;
	}
	,addChild: function(x) {
		if(this._children == null) throw "bad nodetype";
		if(x._parent != null) HxOverrides.remove(x._parent._children,x);
		x._parent = this;
		this._children.push(x);
	}
	,__class__: Xml
};
var flambe_util_Disposable = function() { };
$hxClasses["flambe.util.Disposable"] = flambe_util_Disposable;
flambe_util_Disposable.__name__ = true;
flambe_util_Disposable.prototype = {
	__class__: flambe_util_Disposable
};
var flambe_Component = function() { };
$hxClasses["flambe.Component"] = flambe_Component;
flambe_Component.__name__ = true;
flambe_Component.__interfaces__ = [flambe_util_Disposable];
flambe_Component.prototype = {
	onAdded: function() {
	}
	,onRemoved: function() {
	}
	,onUpdate: function(dt) {
	}
	,dispose: function() {
		if(this.owner != null) this.owner.remove(this);
	}
	,get_name: function() {
		return null;
	}
	,init: function(owner,next) {
		this.owner = owner;
		this.next = next;
	}
	,setNext: function(next) {
		this.next = next;
	}
	,__class__: flambe_Component
};
var com_newwave_components_display_PngSequence = function(images,centered,speed,loop,paused) {
	if(paused == null) paused = false;
	if(loop == null) loop = true;
	if(speed == null) speed = 0.3;
	if(centered == null) centered = false;
	this.active = true;
	this.speed = 0.3;
	this.time = 0;
	this.currentImage = 0;
	this.imageArray = images;
	this.centerAnchor = centered;
	this.shouldLoop = loop;
	this.startpaused = paused;
};
$hxClasses["com.newwave.components.display.PngSequence"] = com_newwave_components_display_PngSequence;
com_newwave_components_display_PngSequence.__name__ = true;
com_newwave_components_display_PngSequence.__super__ = flambe_Component;
com_newwave_components_display_PngSequence.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "PngSequence_3";
	}
	,onAdded: function() {
		var img = this.imageArray[0];
		if(this.centerAnchor) img.centerAnchor(); else null;
		this.owner.addChild(new flambe_Entity().add(img));
		if(this.startpaused) this.active = false;
	}
	,onUpdate: function(dt) {
		if(this.active) {
			this.time += this.speed;
			if(Math.floor(this.time) >= 1) {
				this.time = 0;
				if(this.currentImage >= this.imageArray.length - 1) {
					if(this.shouldLoop) this.currentImage = 0; else {
						this.currentImage = this.imageArray.length - 1;
						this.active = false;
					}
				} else this.currentImage++;
			}
			this.owner.disposeChildren();
			var img = this.imageArray[this.currentImage];
			if(this.centerAnchor) img.centerAnchor(); else null;
			this.owner.addChild(new flambe_Entity().add(img));
		}
	}
	,pause: function() {
		this.active = false;
	}
	,play: function() {
		this.active = true;
	}
	,__class__: com_newwave_components_display_PngSequence
});
var flambe_math_Point = function(x,y) {
	if(y == null) y = 0;
	if(x == null) x = 0;
	this.x = x;
	this.y = y;
};
$hxClasses["flambe.math.Point"] = flambe_math_Point;
flambe_math_Point.__name__ = true;
flambe_math_Point.prototype = {
	toString: function() {
		return "(" + this.x + "," + this.y + ")";
	}
	,__class__: flambe_math_Point
};
var flambe_display_Sprite = function() {
	this.scissor = null;
	this.blendMode = null;
	var _g = this;
	this._flags = 1 | 2 | 8 | 128;
	this._localMatrix = new flambe_math_Matrix();
	var dirtyMatrix = function(_,_1) {
		_g._flags = flambe_util_BitSets.add(_g._flags,4 | 8);
	};
	this.x = new flambe_animation_AnimatedFloat(0,dirtyMatrix);
	this.y = new flambe_animation_AnimatedFloat(0,dirtyMatrix);
	this.rotation = new flambe_animation_AnimatedFloat(0,dirtyMatrix);
	this.scaleX = new flambe_animation_AnimatedFloat(1,dirtyMatrix);
	this.scaleY = new flambe_animation_AnimatedFloat(1,dirtyMatrix);
	this.anchorX = new flambe_animation_AnimatedFloat(0,dirtyMatrix);
	this.anchorY = new flambe_animation_AnimatedFloat(0,dirtyMatrix);
	this.alpha = new flambe_animation_AnimatedFloat(1);
};
$hxClasses["flambe.display.Sprite"] = flambe_display_Sprite;
flambe_display_Sprite.__name__ = true;
flambe_display_Sprite.hitTest = function(entity,x,y) {
	var sprite = entity.getComponent("Sprite_4");
	if(sprite != null) {
		if(!flambe_util_BitSets.containsAll(sprite._flags,1 | 2)) return null;
		if(sprite.getLocalMatrix().inverseTransform(x,y,flambe_display_Sprite._scratchPoint)) {
			x = flambe_display_Sprite._scratchPoint.x;
			y = flambe_display_Sprite._scratchPoint.y;
		}
		var scissor = sprite.scissor;
		if(scissor != null && !scissor.contains(x,y)) return null;
	}
	var result = flambe_display_Sprite.hitTestBackwards(entity.firstChild,x,y);
	if(result != null) return result;
	if(sprite != null && sprite.containsLocal(x,y)) return sprite; else return null;
};
flambe_display_Sprite.render = function(entity,g) {
	var sprite = entity.getComponent("Sprite_4");
	if(sprite != null) {
		var alpha = sprite.alpha.get__();
		if(!sprite.get_visible() || alpha <= 0) return;
		g.save();
		if(alpha < 1) g.multiplyAlpha(alpha);
		if(sprite.blendMode != null) g.setBlendMode(sprite.blendMode);
		var matrix = sprite.getLocalMatrix();
		var m02 = matrix.m02;
		var m12 = matrix.m12;
		if(sprite.get_pixelSnapping()) {
			m02 = Math.round(m02);
			m12 = Math.round(m12);
		}
		g.transform(matrix.m00,matrix.m10,matrix.m01,matrix.m11,m02,m12);
		var scissor = sprite.scissor;
		if(scissor != null) g.applyScissor(scissor.x,scissor.y,scissor.width,scissor.height);
		sprite.draw(g);
	}
	var director = entity.getComponent("Director_6");
	if(director != null) {
		var scenes = director.occludedScenes;
		var _g = 0;
		while(_g < scenes.length) {
			var scene = scenes[_g];
			++_g;
			flambe_display_Sprite.render(scene,g);
		}
	}
	var p = entity.firstChild;
	while(p != null) {
		var next = p.next;
		flambe_display_Sprite.render(p,g);
		p = next;
	}
	if(sprite != null) g.restore();
};
flambe_display_Sprite.hitTestBackwards = function(entity,x,y) {
	if(entity != null) {
		var result = flambe_display_Sprite.hitTestBackwards(entity.next,x,y);
		if(result != null) return result; else return flambe_display_Sprite.hitTest(entity,x,y);
	}
	return null;
};
flambe_display_Sprite.__super__ = flambe_Component;
flambe_display_Sprite.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Sprite_4";
	}
	,getNaturalWidth: function() {
		return 0;
	}
	,getNaturalHeight: function() {
		return 0;
	}
	,containsLocal: function(localX,localY) {
		return localX >= 0 && localX < this.getNaturalWidth() && localY >= 0 && localY < this.getNaturalHeight();
	}
	,getLocalMatrix: function() {
		if(flambe_util_BitSets.contains(this._flags,4)) {
			this._flags = flambe_util_BitSets.remove(this._flags,4);
			this._localMatrix.compose(this.x.get__(),this.y.get__(),this.scaleX.get__(),this.scaleY.get__(),flambe_math_FMath.toRadians(this.rotation.get__()));
			this._localMatrix.translate(-this.anchorX.get__(),-this.anchorY.get__());
		}
		return this._localMatrix;
	}
	,setAnchor: function(x,y) {
		this.anchorX.set__(x);
		this.anchorY.set__(y);
		return this;
	}
	,centerAnchor: function() {
		this.anchorX.set__(this.getNaturalWidth() / 2);
		this.anchorY.set__(this.getNaturalHeight() / 2);
		return this;
	}
	,setXY: function(x,y) {
		this.x.set__(x);
		this.y.set__(y);
		return this;
	}
	,setAlpha: function(alpha) {
		this.alpha.set__(alpha);
		return this;
	}
	,setRotation: function(rotation) {
		this.rotation.set__(rotation);
		return this;
	}
	,setScale: function(scale) {
		this.scaleX.set__(scale);
		this.scaleY.set__(scale);
		return this;
	}
	,setScaleXY: function(scaleX,scaleY) {
		this.scaleX.set__(scaleX);
		this.scaleY.set__(scaleY);
		return this;
	}
	,disablePointer: function() {
		this.set_pointerEnabled(false);
		return this;
	}
	,onAdded: function() {
		if(flambe_util_BitSets.contains(this._flags,256)) this.connectHover();
	}
	,onRemoved: function() {
		if(this._hoverConnection != null) {
			this._hoverConnection.dispose();
			this._hoverConnection = null;
		}
	}
	,onUpdate: function(dt) {
		this.x.update(dt);
		this.y.update(dt);
		this.rotation.update(dt);
		this.scaleX.update(dt);
		this.scaleY.update(dt);
		this.alpha.update(dt);
		this.anchorX.update(dt);
		this.anchorY.update(dt);
	}
	,draw: function(g) {
	}
	,getParentSprite: function() {
		if(this.owner == null) return null;
		var entity = this.owner.parent;
		while(entity != null) {
			var sprite = entity.getComponent("Sprite_4");
			if(sprite != null) return sprite;
			entity = entity.parent;
		}
		return null;
	}
	,get_pointerDown: function() {
		if(this._pointerDown == null) this._pointerDown = new flambe_util_Signal1();
		return this._pointerDown;
	}
	,get_pointerIn: function() {
		if(this._pointerIn == null) this._pointerIn = new flambe_util_Signal1();
		return this._pointerIn;
	}
	,get_pointerOut: function() {
		if(this._pointerOut == null) this._pointerOut = new flambe_util_Signal1();
		return this._pointerOut;
	}
	,connectHover: function() {
		var _g = this;
		if(this._hoverConnection != null) return;
		this._hoverConnection = flambe_System.get_pointer().move.connect(function(event) {
			var hit = event.hit;
			while(hit != null) {
				if(hit == _g) return;
				hit = hit.getParentSprite();
			}
			if(_g._pointerOut != null && flambe_util_BitSets.contains(_g._flags,256)) _g._pointerOut.emit(event);
			_g._flags = flambe_util_BitSets.remove(_g._flags,256);
			_g._hoverConnection.dispose();
			_g._hoverConnection = null;
		});
	}
	,get_visible: function() {
		return flambe_util_BitSets.contains(this._flags,1);
	}
	,set_pointerEnabled: function(pointerEnabled) {
		this._flags = flambe_util_BitSets.set(this._flags,2,pointerEnabled);
		return pointerEnabled;
	}
	,get_pixelSnapping: function() {
		return flambe_util_BitSets.contains(this._flags,128);
	}
	,onPointerDown: function(event) {
		this.onHover(event);
		if(this._pointerDown != null) this._pointerDown.emit(event);
	}
	,onPointerMove: function(event) {
		this.onHover(event);
		if(this._pointerMove != null) this._pointerMove.emit(event);
	}
	,onHover: function(event) {
		if(flambe_util_BitSets.contains(this._flags,256)) return;
		this._flags = flambe_util_BitSets.add(this._flags,256);
		if(this._pointerIn != null || this._pointerOut != null) {
			if(this._pointerIn != null) this._pointerIn.emit(event);
			this.connectHover();
		}
	}
	,onPointerUp: function(event) {
		{
			var _g = event.source;
			switch(Type.enumIndex(_g)) {
			case 1:
				var point = _g[2];
				if(this._pointerOut != null && flambe_util_BitSets.contains(this._flags,256)) this._pointerOut.emit(event);
				this._flags = flambe_util_BitSets.remove(this._flags,256);
				if(this._hoverConnection != null) {
					this._hoverConnection.dispose();
					this._hoverConnection = null;
				}
				break;
			default:
			}
		}
		if(this._pointerUp != null) this._pointerUp.emit(event);
	}
	,__class__: flambe_display_Sprite
});
var com_newwave_components_display_TiledImage = function(pack,data,sprites,_multiplier) {
	if(_multiplier == null) _multiplier = 1;
	flambe_display_Sprite.call(this);
	this.assetpack = pack;
	this.imageData = data;
	this.spriteArr = sprites;
	this.multiplier = _multiplier;
};
$hxClasses["com.newwave.components.display.TiledImage"] = com_newwave_components_display_TiledImage;
com_newwave_components_display_TiledImage.__name__ = true;
com_newwave_components_display_TiledImage.__super__ = flambe_display_Sprite;
com_newwave_components_display_TiledImage.prototype = $extend(flambe_display_Sprite.prototype,{
	onAdded: function() {
		var i = 0;
		var xPos = 0;
		var yPos = 0;
		var columnNum = 0;
		var rowNum = 0;
		while(i < this.spriteArr.length) {
			var entity = new flambe_Entity();
			var sprite = new flambe_display_ImageSprite(this.assetpack.getTexture(this.spriteArr[i]));
			sprite.setXY(xPos,yPos);
			sprite.setScale(this.multiplier);
			entity.add(sprite);
			this.owner.addChild(entity);
			xPos += sprite.getNaturalWidth() * this.multiplier;
			columnNum++;
			if(columnNum == this.imageData.columns) {
				this.width = xPos;
				columnNum = xPos = 0;
				rowNum++;
				yPos += sprite.getNaturalHeight() * this.multiplier;
			}
			this.height = yPos;
			i++;
		}
	}
	,__class__: com_newwave_components_display_TiledImage
});
var com_newwave_components_effects_Blink = function(_speed,_duration) {
	this.count = 0;
	this.duration = 60;
	this.speed = 3;
	if(_speed != null) this.speed = _speed;
	this.duration = _duration;
};
$hxClasses["com.newwave.components.effects.Blink"] = com_newwave_components_effects_Blink;
com_newwave_components_effects_Blink.__name__ = true;
com_newwave_components_effects_Blink.__super__ = flambe_Component;
com_newwave_components_effects_Blink.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Blink_15";
	}
	,onAdded: function() {
		if(this.owner.getComponent("Sprite_4") != null) this.target = this.owner.getComponent("Sprite_4"); else if(this.owner.getComponent("Sprite_4") != null) this.target = this.owner.getComponent("Sprite_4");
	}
	,onUpdate: function(dt) {
		this.count++;
		if(this.count % this.speed == 0) {
			if(this.target.alpha.get__() == 1) this.target.alpha.set__(0.3); else this.target.alpha.set__(1);
		}
		if(this.count >= this.duration) {
			this.target.alpha.set__(1);
			this.owner.remove(this);
		}
	}
	,__class__: com_newwave_components_effects_Blink
});
var com_newwave_components_game_Gravity = function(_amount,hasbounds) {
	this.highestVelocity = 0;
	this.isBouncing = false;
	this.isFalling = false;
	this.hasBounds = true;
	this.active = true;
	this.velocity = 0;
	this.amount = 0;
	this.amount = _amount;
	if(hasbounds == false) this.hasBounds = false;
};
$hxClasses["com.newwave.components.game.Gravity"] = com_newwave_components_game_Gravity;
com_newwave_components_game_Gravity.__name__ = true;
com_newwave_components_game_Gravity.__super__ = flambe_Component;
com_newwave_components_game_Gravity.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Gravity_13";
	}
	,onAdded: function() {
		this.sprite = this.owner.getComponent("Sprite_4");
	}
	,onUpdate: function(dt) {
		if(this.active) {
			this.sprite = this.owner.getComponent("Sprite_4");
			if(!this.isFalling && this.velocity < 0) {
				this.isFalling = true;
				if(this.velocity < this.highestVelocity) this.highestVelocity = this.velocity;
			}
			if(!this.isBouncing && this.velocity < 0) {
				this.isFalling = true;
				if(this.velocity < this.highestVelocity) this.highestVelocity = this.velocity;
			}
			this.velocity += this.amount;
			var _g = this.sprite.y;
			_g.set__(_g.get__() + this.velocity);
			if(this.hasBounds) {
				if(this.sprite.y.get__() >= this.maxY) {
					this.sprite.y.set__(this.maxY);
					if(this.isFalling) {
						this.isBouncing = true;
						this.isFalling = false;
						if(this.isBouncing) {
							if(this.highestVelocity > -5) this.isBouncing = false; else {
								this.velocity = this.highestVelocity / 3;
								this.highestVelocity = 0;
							}
						}
					} else this.velocity = 0;
				}
				if(this.sprite.y.get__() <= 0) {
					this.sprite.y.set__(0);
					this.velocity = 0;
				}
			}
		}
	}
	,disable: function() {
		this.active = false;
		this.velocity = 0;
	}
	,enable: function() {
		this.active = true;
	}
	,__class__: com_newwave_components_game_Gravity
});
var com_newwave_components_game_ParticleBurst = function(context,src,x,y,_xVel,_duration) {
	this.duration = 0.2;
	this.xVel = 0;
	this.source = src;
	this.ctx = context;
	this.xPos = x;
	this.yPos = y;
	if(_xVel != null) this.xVel = _xVel;
	if(_duration != null) this.duration = _duration;
};
$hxClasses["com.newwave.components.game.ParticleBurst"] = com_newwave_components_game_ParticleBurst;
com_newwave_components_game_ParticleBurst.__name__ = true;
com_newwave_components_game_ParticleBurst.__super__ = flambe_Component;
com_newwave_components_game_ParticleBurst.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "ParticleBurst_2";
	}
	,onAdded: function() {
		this.emitter = new flambe_display_EmitterMold(this.ctx.pack_mobileGame,this.source).createEmitter();
		this.emitter.duration = this.duration;
		this.emitter.emitX.set__(this.xPos);
		this.emitter.emitY.set__(this.yPos);
		this.emitterEntity = new flambe_Entity().add(this.emitter);
		this.owner.addChild(this.emitterEntity);
	}
	,onUpdate: function(dt) {
		if(this.xVel != 0) {
			var _g = this.emitter.x;
			_g.set__(_g.get__() + this.xVel);
		}
		if(!this.emitter.enabled && this.emitter.numParticles <= 0) this.owner.dispose();
	}
	,__class__: com_newwave_components_game_ParticleBurst
});
var com_newwave_components_game_RepeatingBackground = function(_gameWorld,_ctx,_imagePath,_yPos,_multiplier) {
	if(_multiplier == null) _multiplier = 1;
	this.active = true;
	this.speed = 0;
	this.gameWorld = _gameWorld;
	this.ctx = _ctx;
	this.assetPack = this.ctx.pack_mobileGame;
	this.imagePath = _imagePath;
	if(_yPos != null) this.yPos = _yPos; else this.yPos = 0;
	this.multiplier = _multiplier;
};
$hxClasses["com.newwave.components.game.RepeatingBackground"] = com_newwave_components_game_RepeatingBackground;
com_newwave_components_game_RepeatingBackground.__name__ = true;
com_newwave_components_game_RepeatingBackground.__super__ = flambe_Component;
com_newwave_components_game_RepeatingBackground.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "RepeatingBackground_1";
	}
	,onAdded: function() {
		this.image1 = new flambe_Entity();
		this.sprite1 = new flambe_display_ImageSprite(this.assetPack.getTexture(this.imagePath));
		this.sprite1.setScale(this.multiplier);
		this.sprite1.y.set__(this.yPos);
		this.image1.add(this.sprite1);
		this.image2 = new flambe_Entity();
		this.sprite2 = new flambe_display_ImageSprite(this.assetPack.getTexture(this.imagePath));
		this.sprite2.setScale(this.multiplier);
		this.sprite2.setXY(1028,this.yPos);
		this.image2.add(this.sprite2);
		this.owner.addChild(this.image1).addChild(this.image2);
		this.onImageRepeat(this.sprite1);
		this.onImageRepeat(this.sprite2);
	}
	,onUpdate: function(dt) {
		if(this.active) {
			var dx = dt * 60;
			if(this.speed != 0) {
				var _g = this.sprite1.x;
				_g.set__(_g.get__() + dx * this.speed);
				var _g1 = this.sprite2.x;
				_g1.set__(_g1.get__() + dx * this.speed);
				if(this.speed < 0) {
					if(this.sprite1.x.get__() <= 0 - 1028) {
						this.sprite1.x.set__(this.sprite2.x.get__() + this.sprite2.getNaturalWidth() * this.multiplier);
						this.onImageRepeat(this.sprite1);
					}
					if(this.sprite2.x.get__() <= 0 - 1028) {
						this.sprite2.x.set__(this.sprite1.x.get__() + this.sprite1.getNaturalWidth() * this.multiplier);
						this.onImageRepeat(this.sprite2);
					}
				} else {
					if(this.sprite1.x.get__() >= 1028) {
						this.sprite1.x.set__(this.sprite2.x.get__() - this.sprite2.getNaturalWidth() * this.multiplier);
						this.onImageRepeat(this.sprite1);
					}
					if(this.sprite2.x.get__() >= 1028) {
						this.sprite2.x.set__(this.sprite1.x.get__() - this.sprite1.getNaturalWidth() * this.multiplier);
						this.onImageRepeat(this.sprite2);
					}
				}
			}
		}
	}
	,onImageRepeat: function(image) {
	}
	,__class__: com_newwave_components_game_RepeatingBackground
});
var com_newwave_components_ui_button_RolloverButton = function(context,texture,_callback,_onOver,_onOut) {
	this.ctx = context;
	this.assetPack = this.ctx.preloaderPack;
	this.rollTexture = texture;
	this.callback = _callback;
	this.onOver = _onOver;
	this.onOut = _onOut;
};
$hxClasses["com.newwave.components.ui.button.RolloverButton"] = com_newwave_components_ui_button_RolloverButton;
com_newwave_components_ui_button_RolloverButton.__name__ = true;
com_newwave_components_ui_button_RolloverButton.__super__ = flambe_Component;
com_newwave_components_ui_button_RolloverButton.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "RolloverButton_4";
	}
	,onAdded: function() {
		this.disposer = this.owner.getComponent("Disposer_18");
		if(this.disposer == null) this.owner.add(this.disposer = new flambe_Disposer());
		this.sprite = this.owner.getComponent("Sprite_4");
		this.rollSprite = new flambe_display_ImageSprite(this.rollTexture);
		this.rollSprite.alpha.set__(0);
		this.owner.addChild(new flambe_Entity().add(this.rollSprite));
		this.sprite.get_pointerIn().connect($bind(this,this.onPointerIn));
		this.sprite.get_pointerOut().connect($bind(this,this.onPointerOut));
		this.sprite.get_pointerDown().connect($bind(this,this.onPointerDown));
	}
	,onPointerIn: function(event) {
		this.rollSprite.alpha.animateTo(1,0.25);
		flambe_System.get_mouse().set_cursor(flambe_input_MouseCursor.Button);
		if(this.onOver != null) this.onOver();
	}
	,onPointerOut: function(event) {
		this.rollSprite.alpha.animateTo(0,0.25);
		flambe_System.get_mouse().set_cursor(flambe_input_MouseCursor.Default);
		if(this.onOut != null) this.onOut();
	}
	,onPointerDown: function(event) {
		var sound = this.assetPack.getSound("sounds/buttonclick").play(0.7);
		flambe_System.get_mouse().set_cursor(flambe_input_MouseCursor.Default);
		this.callback();
	}
	,__class__: com_newwave_components_ui_button_RolloverButton
});
var com_newwave_components_ui_button_SoundButton = function(context,texture,_callback,_onOver,_onOut) {
	this.ctx = context;
	this.rollTexture = texture;
	this.callback = _callback;
	this.onOver = _onOver;
	this.onOut = _onOut;
};
$hxClasses["com.newwave.components.ui.button.SoundButton"] = com_newwave_components_ui_button_SoundButton;
com_newwave_components_ui_button_SoundButton.__name__ = true;
com_newwave_components_ui_button_SoundButton.__super__ = flambe_Component;
com_newwave_components_ui_button_SoundButton.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "SoundButton_3";
	}
	,onAdded: function() {
		this.disposer = this.owner.getComponent("Disposer_18");
		if(this.disposer == null) this.owner.add(this.disposer = new flambe_Disposer());
		this.sprite = this.owner.getComponent("Sprite_4");
		this.rollSprite = new flambe_display_ImageSprite(this.rollTexture);
		this.rollSprite.alpha.set__(0);
		this.owner.addChild(new flambe_Entity().add(this.rollSprite));
		this.sprite.get_pointerIn().connect($bind(this,this.onPointerIn));
		this.sprite.get_pointerOut().connect($bind(this,this.onPointerOut));
		this.sprite.get_pointerDown().connect($bind(this,this.onPointerDown));
		this.updateSoundBtn();
	}
	,onPointerIn: function(event) {
		this.rollSprite.alpha.animateTo(1,0.25);
		flambe_System.get_mouse().set_cursor(flambe_input_MouseCursor.Button);
		if(this.onOver != null) this.onOver();
	}
	,onPointerOut: function(event) {
		this.rollSprite.alpha.animateTo(0,0.25);
		flambe_System.get_mouse().set_cursor(flambe_input_MouseCursor.Default);
		if(this.onOut != null) this.onOut();
	}
	,onPointerDown: function(event) {
		var sound = this.ctx.pack.getSound("sounds/buttonclick").play(0.7);
		flambe_System.get_mouse().set_cursor(flambe_input_MouseCursor.Default);
		if(flambe_System.volume.get__() == 1) flambe_System.volume.set__(0); else flambe_System.volume.set__(1);
		this.updateSoundBtn();
		this.callback();
	}
	,updateSoundBtn: function() {
		var texture;
		var rollTexture;
		if(flambe_System.volume.get__() == 1) {
			texture = this.ctx.pack.getTexture("home/btn_sound_on");
			rollTexture = this.ctx.pack.getTexture("home/btn_sound_on_over");
		} else {
			texture = this.ctx.pack.getTexture("home/btn_sound_off");
			rollTexture = this.ctx.pack.getTexture("home/btn_sound_off_over");
		}
		this.owner.getComponent("Sprite_4").texture = texture;
		this.rollSprite.texture = rollTexture;
	}
	,__class__: com_newwave_components_ui_button_SoundButton
});
var com_newwave_components_ui_text_TextInput = function(thefont,_height) {
	if(_height == null) _height = 24;
	this.value = "";
	this.font = thefont;
	this.height = _height;
	flambe_System.get_external().bind("flambe_updateText",$bind(this,this.onTextUpdate));
	flambe_System.get_external().bind("flambe_textUnfocus",$bind(this,this.disableCursor));
};
$hxClasses["com.newwave.components.ui.text.TextInput"] = com_newwave_components_ui_text_TextInput;
com_newwave_components_ui_text_TextInput.__name__ = true;
com_newwave_components_ui_text_TextInput.__super__ = flambe_Component;
com_newwave_components_ui_text_TextInput.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "TextInput_14";
	}
	,onAdded: function() {
		this.textSprite = this.owner.getComponent("Sprite_4");
		this.value = this.textSprite.get_text();
		this.cursor = new flambe_Entity().add(new flambe_display_FillSprite(0,2,this.height).setXY(0,4).setAlpha(0));
		this.owner.addChild(this.cursor);
	}
	,connectToHTMLInput: function() {
		this.textSprite.set_font(this.font);
		this.textSprite.centerAnchor();
		this.cursor.getComponent("Sprite_4").x.set__(50);
		this.cursor.getComponent("Sprite_4").alpha.set__(1);
		this.cursor.add(new com_newwave_components_effects_Blink(25));
		flambe_System.get_external().call("activateTextField",[this.value]);
	}
	,onTextUpdate: function(str) {
		this.value = str;
		this.textSprite.set_text(str);
		this.textSprite.centerAnchor();
		this.cursor.getComponent("Sprite_4").x.set__(this.textSprite.getNaturalWidth());
		if(!(this.cursor.getComponent("Blink_15") != null)) this.cursor.add(new com_newwave_components_effects_Blink(25));
	}
	,disableCursor: function() {
		if(this.cursor.getComponent("Blink_15") != null) this.cursor.remove(this.cursor.getComponent("Blink_15"));
		this.cursor.getComponent("Sprite_4").alpha.set__(0);
		if(this.textSprite.get_text() == "") this.textSprite.set_text("ENTER HERE");
		this.textSprite.centerAnchor();
	}
	,__class__: com_newwave_components_ui_text_TextInput
});
var com_newwave_utils_GameUtils = function() { };
$hxClasses["com.newwave.utils.GameUtils"] = com_newwave_utils_GameUtils;
com_newwave_utils_GameUtils.__name__ = true;
com_newwave_utils_GameUtils.replaceImageSprite = function(target,newSprite,centered) {
	var sprite = target.getComponent("Sprite_4");
	var xPos = sprite.x.get__();
	var yPos = sprite.y.get__();
	target.remove(sprite);
	newSprite.setXY(xPos,yPos);
	if(centered) newSprite.centerAnchor();
	target.add(newSprite);
	return target;
};
com_newwave_utils_GameUtils.interpolate = function(a,b,percent) {
	return a + (b - a) * percent;
};
com_newwave_utils_GameUtils.percentRemaining = function(n,total) {
	return n % total / total;
};
com_newwave_utils_GameUtils.absDistance = function(v1,v2) {
	if(v1 > 0 && v2 > 0) return Math.abs(v1 - v2); else if(v1 < 0 && v2 < 0) return Math.abs(Math.abs(v1) - Math.abs(v2)); else return Math.abs(Math.abs(v1) + Math.abs(v2));
};
com_newwave_utils_GameUtils.easeIn = function(a,b,percent) {
	return a + (b - a) * Math.pow(percent,2);
};
com_newwave_utils_GameUtils.easeInOut = function(a,b,percent) {
	return a + (b - a) * (-Math.cos(percent * Math.PI) / 2 + 0.5);
};
com_newwave_utils_GameUtils.convertTime = function(t) {
	var seconds = Math.floor(t);
	var minutes = Math.floor(t / 60);
	var hundredths = (t - seconds) * 100;
	var milliseconds = Std.string(Math.floor(60 * hundredths / 100));
	if(milliseconds.length == 1) milliseconds = "0" + milliseconds;
	var secondsStr = Std.string(seconds % 60);
	if(secondsStr.length == 1) secondsStr = "0" + secondsStr;
	return Std.string(minutes + ":" + secondsStr);
};
var flambe_Disposer = function() {
	this._disposables = [];
};
$hxClasses["flambe.Disposer"] = flambe_Disposer;
flambe_Disposer.__name__ = true;
flambe_Disposer.__super__ = flambe_Component;
flambe_Disposer.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Disposer_18";
	}
	,add: function(disposable) {
		this._disposables.push(disposable);
		return this;
	}
	,onRemoved: function() {
		this.freeDisposables();
	}
	,dispose: function() {
		flambe_Component.prototype.dispose.call(this);
		this.freeDisposables();
	}
	,freeDisposables: function() {
		var snapshot = this._disposables;
		this._disposables = [];
		var _g = 0;
		while(_g < snapshot.length) {
			var disposable = snapshot[_g];
			++_g;
			disposable.dispose();
		}
	}
	,__class__: flambe_Disposer
});
var flambe_Entity = function() {
	this.firstComponent = null;
	this.next = null;
	this.firstChild = null;
	this.parent = null;
	this._compMap = { };
};
$hxClasses["flambe.Entity"] = flambe_Entity;
flambe_Entity.__name__ = true;
flambe_Entity.__interfaces__ = [flambe_util_Disposable];
flambe_Entity.prototype = {
	add: function(component) {
		if(component.owner != null) component.owner.remove(component);
		var name = component.get_name();
		var prev = this.getComponent(name);
		if(prev != null) this.remove(prev);
		this._compMap[name] = component;
		var tail = null;
		var p = this.firstComponent;
		while(p != null) {
			tail = p;
			p = p.next;
		}
		if(tail != null) tail.setNext(component); else this.firstComponent = component;
		component.init(this,null);
		component.onAdded();
		return this;
	}
	,remove: function(component) {
		var prev = null;
		var p = this.firstComponent;
		while(p != null) {
			var next = p.next;
			if(p == component) {
				if(prev == null) this.firstComponent = next; else prev.init(this,next);
				delete(this._compMap[p.get_name()]);
				p.onRemoved();
				p.init(null,null);
				return true;
			}
			prev = p;
			p = next;
		}
		return false;
	}
	,getComponent: function(name) {
		return this._compMap[name];
	}
	,addChild: function(entity,append) {
		if(append == null) append = true;
		if(entity.parent != null) entity.parent.removeChild(entity);
		entity.parent = this;
		if(append) {
			var tail = null;
			var p = this.firstChild;
			while(p != null) {
				tail = p;
				p = p.next;
			}
			if(tail != null) tail.next = entity; else this.firstChild = entity;
		} else {
			entity.next = this.firstChild;
			this.firstChild = entity;
		}
		return this;
	}
	,removeChild: function(entity) {
		var prev = null;
		var p = this.firstChild;
		while(p != null) {
			var next = p.next;
			if(p == entity) {
				if(prev == null) this.firstChild = next; else prev.next = next;
				p.parent = null;
				p.next = null;
				return;
			}
			prev = p;
			p = next;
		}
	}
	,disposeChildren: function() {
		while(this.firstChild != null) this.firstChild.dispose();
	}
	,dispose: function() {
		if(this.parent != null) this.parent.removeChild(this);
		while(this.firstComponent != null) this.firstComponent.dispose();
		this.disposeChildren();
	}
	,toString: function() {
		return this.toStringImpl("");
	}
	,toStringImpl: function(indent) {
		var output = "";
		var p = this.firstComponent;
		while(p != null) {
			output += p.get_name();
			if(p.next != null) output += ", ";
			p = p.next;
		}
		output += "\n";
		var u2514 = String.fromCharCode(9492);
		var u241c = String.fromCharCode(9500);
		var u2500 = String.fromCharCode(9472);
		var u2502 = String.fromCharCode(9474);
		var p1 = this.firstChild;
		while(p1 != null) {
			var last = p1.next == null;
			output += indent + (last?u2514:u241c) + u2500 + u2500 + " ";
			output += p1.toStringImpl(indent + (last?" ":u2502) + "   ");
			p1 = p1.next;
		}
		return output;
	}
	,__class__: flambe_Entity
};
var flambe_util_PackageLog = function() { };
$hxClasses["flambe.util.PackageLog"] = flambe_util_PackageLog;
flambe_util_PackageLog.__name__ = true;
var flambe_platform_Platform = function() { };
$hxClasses["flambe.platform.Platform"] = flambe_platform_Platform;
flambe_platform_Platform.__name__ = true;
flambe_platform_Platform.prototype = {
	__class__: flambe_platform_Platform
};
var flambe_platform_html_HtmlPlatform = function() {
};
$hxClasses["flambe.platform.html.HtmlPlatform"] = flambe_platform_html_HtmlPlatform;
flambe_platform_html_HtmlPlatform.__name__ = true;
flambe_platform_html_HtmlPlatform.__interfaces__ = [flambe_platform_Platform];
flambe_platform_html_HtmlPlatform.prototype = {
	init: function() {
		var _g = this;
		flambe_platform_html_HtmlUtil.fixAndroidMath();
		var canvas = null;
		try {
			canvas = js_Browser.get_window().flambe.canvas;
		} catch( error ) {
		}
		flambe_util_Assert.that(canvas != null,"Could not find a Flambe canvas! Are you embedding with flambe.js?");
		canvas.setAttribute("tabindex","0");
		canvas.style.outlineStyle = "none";
		canvas.style.webkitTapHighlightColor = "transparent";
		this._stage = new flambe_platform_html_HtmlStage(canvas);
		this._pointer = new flambe_platform_BasicPointer();
		this._mouse = new flambe_platform_html_HtmlMouse(this._pointer,canvas);
		this._renderer = this.createRenderer(canvas);
		this.mainLoop = new flambe_platform_MainLoop();
		this.musicPlaying = false;
		this._canvas = canvas;
		this._container = canvas.parentElement;
		this._container.style.overflow = "hidden";
		this._container.style.position = "relative";
		this._container.style.msTouchAction = "none";
		var lastTouchTime = 0;
		var onMouse = function(event) {
			if(event.timeStamp - lastTouchTime < 1000) return;
			var bounds = canvas.getBoundingClientRect();
			var x = _g.getX(event,bounds);
			var y = _g.getY(event,bounds);
			var _g1 = event.type;
			switch(_g1) {
			case "mousedown":
				if(event.target == canvas) {
					event.preventDefault();
					_g._mouse.submitDown(x,y,event.button);
					canvas.focus();
				}
				break;
			case "mousemove":
				_g._mouse.submitMove(x,y);
				break;
			case "mouseup":
				_g._mouse.submitUp(x,y,event.button);
				break;
			case "mousewheel":case "DOMMouseScroll":
				var velocity;
				if(event.type == "mousewheel") velocity = event.wheelDelta / 40; else velocity = -event.detail;
				if(_g._mouse.submitScroll(x,y,velocity)) event.preventDefault();
				break;
			}
		};
		js_Browser.get_window().addEventListener("mousedown",onMouse,false);
		js_Browser.get_window().addEventListener("mousemove",onMouse,false);
		js_Browser.get_window().addEventListener("mouseup",onMouse,false);
		canvas.addEventListener("mousewheel",onMouse,false);
		canvas.addEventListener("DOMMouseScroll",onMouse,false);
		canvas.addEventListener("contextmenu",function(event1) {
			event1.preventDefault();
		},false);
		var standardTouch = typeof(js_Browser.get_window().ontouchstart) != "undefined";
		var msTouch = 'msMaxTouchPoints' in window.navigator && (window.navigator.msMaxTouchPoints > 1);
		if(standardTouch || msTouch) {
			var basicTouch = new flambe_platform_BasicTouch(this._pointer,standardTouch?4:js_Browser.get_navigator().msMaxTouchPoints);
			this._touch = basicTouch;
			var onTouch = function(event2) {
				var changedTouches;
				if(standardTouch) changedTouches = event2.changedTouches; else changedTouches = [event2];
				var bounds1 = event2.target.getBoundingClientRect();
				lastTouchTime = event2.timeStamp;
				var _g2 = event2.type;
				switch(_g2) {
				case "touchstart":case "MSPointerDown":case "pointerdown":
					event2.preventDefault();
					if(flambe_platform_html_HtmlUtil.SHOULD_HIDE_MOBILE_BROWSER) flambe_platform_html_HtmlUtil.hideMobileBrowser();
					var _g11 = 0;
					while(_g11 < changedTouches.length) {
						var touch = changedTouches[_g11];
						++_g11;
						var x1 = _g.getX(touch,bounds1);
						var y1 = _g.getY(touch,bounds1);
						var id = Std["int"](standardTouch?touch.identifier:touch.pointerId);
						basicTouch.submitDown(id,x1,y1);
					}
					break;
				case "touchmove":case "MSPointerMove":case "pointermove":
					event2.preventDefault();
					var _g12 = 0;
					while(_g12 < changedTouches.length) {
						var touch1 = changedTouches[_g12];
						++_g12;
						var x2 = _g.getX(touch1,bounds1);
						var y2 = _g.getY(touch1,bounds1);
						var id1 = Std["int"](standardTouch?touch1.identifier:touch1.pointerId);
						basicTouch.submitMove(id1,x2,y2);
					}
					break;
				case "touchend":case "touchcancel":case "MSPointerUp":case "pointerup":
					var _g13 = 0;
					while(_g13 < changedTouches.length) {
						var touch2 = changedTouches[_g13];
						++_g13;
						var x3 = _g.getX(touch2,bounds1);
						var y3 = _g.getY(touch2,bounds1);
						var id2 = Std["int"](standardTouch?touch2.identifier:touch2.pointerId);
						basicTouch.submitUp(id2,x3,y3);
					}
					break;
				}
			};
			if(standardTouch) {
				canvas.addEventListener("touchstart",onTouch,false);
				canvas.addEventListener("touchmove",onTouch,false);
				canvas.addEventListener("touchend",onTouch,false);
				canvas.addEventListener("touchcancel",onTouch,false);
			} else {
				canvas.addEventListener("MSPointerDown",onTouch,false);
				canvas.addEventListener("MSPointerMove",onTouch,false);
				canvas.addEventListener("MSPointerUp",onTouch,false);
			}
		} else this._touch = new flambe_platform_DummyTouch();
		var oldErrorHandler = js_Browser.get_window().onerror;
		js_Browser.get_window().onerror = function(message,url,line) {
			flambe_System.uncaughtError.emit(message);
			if(oldErrorHandler != null) return oldErrorHandler(message,url,line); else return false;
		};
		var hiddenApi = flambe_platform_html_HtmlUtil.loadExtension("hidden",js_Browser.get_document());
		if(hiddenApi.value != null) {
			var onVisibilityChanged = function(_) {
				flambe_System.hidden.set__(Reflect.field(js_Browser.get_document(),hiddenApi.field));
			};
			onVisibilityChanged(null);
			js_Browser.get_document().addEventListener(hiddenApi.prefix + "visibilitychange",onVisibilityChanged,false);
		} else {
			var onPageTransitionChange = function(event3) {
				flambe_System.hidden.set__(event3.type == "pagehide");
			};
			js_Browser.get_window().addEventListener("pageshow",onPageTransitionChange,false);
			js_Browser.get_window().addEventListener("pagehide",onPageTransitionChange,false);
		}
		flambe_System.hidden.get_changed().connect(function(hidden,_1) {
			if(!hidden) _g._skipFrame = true;
		});
		this._skipFrame = false;
		this._lastUpdate = flambe_platform_html_HtmlUtil.now();
		var requestAnimationFrame = flambe_platform_html_HtmlUtil.loadExtension("requestAnimationFrame").value;
		if(requestAnimationFrame != null) {
			var performance = js_Browser.get_window().performance;
			var hasPerfNow = performance != null && flambe_platform_html_HtmlUtil.polyfill("now",performance);
			if(hasPerfNow) this._lastUpdate = performance.now(); else flambe_Log.warn("No monotonic timer support, falling back to the system date");
			var updateFrame = null;
			updateFrame = function(now) {
				_g.update(hasPerfNow?performance.now():now);
				requestAnimationFrame(updateFrame,canvas);
			};
			requestAnimationFrame(updateFrame,canvas);
		} else {
			flambe_Log.warn("No requestAnimationFrame support, falling back to setInterval");
			js_Browser.get_window().setInterval(function() {
				_g.update(flambe_platform_html_HtmlUtil.now());
			},16);
		}
		new flambe_platform_DebugLogic(this);
		if(flambe_platform_html_HtmlCatapultClient.canUse()) this._catapult = new flambe_platform_html_HtmlCatapultClient(); else this._catapult = null;
		flambe_Log.info("Initialized HTML platform",["renderer",this._renderer.get_type()]);
	}
	,loadAssetPack: function(manifest) {
		return new flambe_platform_html_HtmlAssetPackLoader(this,manifest).promise;
	}
	,getStage: function() {
		return this._stage;
	}
	,createLogHandler: function(tag) {
		if(flambe_platform_html_HtmlLogHandler.isSupported()) return new flambe_platform_html_HtmlLogHandler(tag);
		return null;
	}
	,getCatapultClient: function() {
		return this._catapult;
	}
	,update: function(now) {
		var dt = (now - this._lastUpdate) / 1000;
		this._lastUpdate = now;
		if(flambe_System.hidden.get__()) return;
		if(this._skipFrame) {
			this._skipFrame = false;
			return;
		}
		this.mainLoop.update(dt);
		this.mainLoop.render(this._renderer);
	}
	,getPointer: function() {
		return this._pointer;
	}
	,getMouse: function() {
		return this._mouse;
	}
	,getTouch: function() {
		return this._touch;
	}
	,getKeyboard: function() {
		var _g1 = this;
		if(this._keyboard == null) {
			this._keyboard = new flambe_platform_BasicKeyboard();
			var onKey = function(event) {
				var _g = event.type;
				switch(_g) {
				case "keydown":
					if(_g1._keyboard.submitDown(event.keyCode)) event.preventDefault();
					break;
				case "keyup":
					_g1._keyboard.submitUp(event.keyCode);
					break;
				}
			};
			this._canvas.addEventListener("keydown",onKey,false);
			this._canvas.addEventListener("keyup",onKey,false);
		}
		return this._keyboard;
	}
	,getExternal: function() {
		if(this._external == null) this._external = new flambe_platform_html_HtmlExternal();
		return this._external;
	}
	,getMotion: function() {
		if(this._motion == null) this._motion = new flambe_platform_html_HtmlMotion();
		return this._motion;
	}
	,getRenderer: function() {
		return this._renderer;
	}
	,getX: function(event,bounds) {
		return (event.clientX - bounds.left) * this._stage.get_width() / bounds.width;
	}
	,getY: function(event,bounds) {
		return (event.clientY - bounds.top) * this._stage.get_height() / bounds.height;
	}
	,createRenderer: function(canvas) {
		try {
			var gl = js_html__$CanvasElement_CanvasUtil.getContextWebGL(canvas,{ depth : false, failIfMajorPerformanceCaveat : true});
			if(gl != null) {
				if(flambe_platform_html_HtmlUtil.detectSlowDriver(gl)) flambe_Log.warn("Detected a slow WebGL driver, falling back to canvas"); else return new flambe_platform_html_WebGLRenderer(this._stage,gl);
			}
		} catch( _ ) {
		}
		return new flambe_platform_html_CanvasRenderer(canvas);
		flambe_Log.error("No renderer available!");
		return null;
	}
	,__class__: flambe_platform_html_HtmlPlatform
};
var flambe_util_Value = function(value,listener) {
	this._value = value;
	if(listener != null) this._changed = new flambe_util_Signal2(listener); else this._changed = null;
};
$hxClasses["flambe.util.Value"] = flambe_util_Value;
flambe_util_Value.__name__ = true;
flambe_util_Value.prototype = {
	watch: function(listener) {
		listener(this._value,this._value);
		return this.get_changed().connect(listener);
	}
	,get__: function() {
		return this._value;
	}
	,set__: function(newValue) {
		var oldValue = this._value;
		if(newValue != oldValue) {
			this._value = newValue;
			if(this._changed != null) this._changed.emit(newValue,oldValue);
		}
		return newValue;
	}
	,get_changed: function() {
		if(this._changed == null) this._changed = new flambe_util_Signal2();
		return this._changed;
	}
	,toString: function() {
		return this._value;
	}
	,__class__: flambe_util_Value
};
var flambe_util_SignalConnection = function(signal,listener) {
	this._next = null;
	this._signal = signal;
	this._listener = listener;
	this.stayInList = true;
};
$hxClasses["flambe.util.SignalConnection"] = flambe_util_SignalConnection;
flambe_util_SignalConnection.__name__ = true;
flambe_util_SignalConnection.__interfaces__ = [flambe_util_Disposable];
flambe_util_SignalConnection.prototype = {
	once: function() {
		this.stayInList = false;
		return this;
	}
	,dispose: function() {
		if(this._signal != null) {
			this._signal.disconnect(this);
			this._signal = null;
		}
	}
	,__class__: flambe_util_SignalConnection
};
var flambe_util_SignalBase = function(listener) {
	if(listener != null) this._head = new flambe_util_SignalConnection(this,listener); else this._head = null;
	this._deferredTasks = null;
};
$hxClasses["flambe.util.SignalBase"] = flambe_util_SignalBase;
flambe_util_SignalBase.__name__ = true;
flambe_util_SignalBase.prototype = {
	hasListeners: function() {
		return this._head != null;
	}
	,connectImpl: function(listener,prioritize) {
		var _g = this;
		var conn = new flambe_util_SignalConnection(this,listener);
		if(this.dispatching()) this.defer(function() {
			_g.listAdd(conn,prioritize);
		}); else this.listAdd(conn,prioritize);
		return conn;
	}
	,disconnect: function(conn) {
		var _g = this;
		if(this.dispatching()) this.defer(function() {
			_g.listRemove(conn);
		}); else this.listRemove(conn);
	}
	,defer: function(fn) {
		var tail = null;
		var p = this._deferredTasks;
		while(p != null) {
			tail = p;
			p = p.next;
		}
		var task = new flambe_util__$SignalBase_Task(fn);
		if(tail != null) tail.next = task; else this._deferredTasks = task;
	}
	,willEmit: function() {
		flambe_util_Assert.that(!this.dispatching());
		var snapshot = this._head;
		this._head = flambe_util_SignalBase.DISPATCHING_SENTINEL;
		return snapshot;
	}
	,didEmit: function(head) {
		this._head = head;
		var snapshot = this._deferredTasks;
		this._deferredTasks = null;
		while(snapshot != null) {
			snapshot.fn();
			snapshot = snapshot.next;
		}
	}
	,listAdd: function(conn,prioritize) {
		if(prioritize) {
			conn._next = this._head;
			this._head = conn;
		} else {
			var tail = null;
			var p = this._head;
			while(p != null) {
				tail = p;
				p = p._next;
			}
			if(tail != null) tail._next = conn; else this._head = conn;
		}
	}
	,listRemove: function(conn) {
		var prev = null;
		var p = this._head;
		while(p != null) {
			if(p == conn) {
				var next = p._next;
				if(prev == null) this._head = next; else prev._next = next;
				return;
			}
			prev = p;
			p = p._next;
		}
	}
	,dispatching: function() {
		return this._head == flambe_util_SignalBase.DISPATCHING_SENTINEL;
	}
	,__class__: flambe_util_SignalBase
};
var flambe_util_Signal2 = function(listener) {
	flambe_util_SignalBase.call(this,listener);
};
$hxClasses["flambe.util.Signal2"] = flambe_util_Signal2;
flambe_util_Signal2.__name__ = true;
flambe_util_Signal2.__super__ = flambe_util_SignalBase;
flambe_util_Signal2.prototype = $extend(flambe_util_SignalBase.prototype,{
	connect: function(listener,prioritize) {
		if(prioritize == null) prioritize = false;
		return this.connectImpl(listener,prioritize);
	}
	,emit: function(arg1,arg2) {
		var _g = this;
		if(this.dispatching()) this.defer(function() {
			_g.emitImpl(arg1,arg2);
		}); else this.emitImpl(arg1,arg2);
	}
	,emitImpl: function(arg1,arg2) {
		var head = this.willEmit();
		var p = head;
		while(p != null) {
			p._listener(arg1,arg2);
			if(!p.stayInList) p.dispose();
			p = p._next;
		}
		this.didEmit(head);
	}
	,__class__: flambe_util_Signal2
});
var flambe_util_Signal1 = function(listener) {
	flambe_util_SignalBase.call(this,listener);
};
$hxClasses["flambe.util.Signal1"] = flambe_util_Signal1;
flambe_util_Signal1.__name__ = true;
flambe_util_Signal1.__super__ = flambe_util_SignalBase;
flambe_util_Signal1.prototype = $extend(flambe_util_SignalBase.prototype,{
	connect: function(listener,prioritize) {
		if(prioritize == null) prioritize = false;
		return this.connectImpl(listener,prioritize);
	}
	,emit: function(arg1) {
		var _g = this;
		if(this.dispatching()) this.defer(function() {
			_g.emitImpl(arg1);
		}); else this.emitImpl(arg1);
	}
	,emitImpl: function(arg1) {
		var head = this.willEmit();
		var p = head;
		while(p != null) {
			p._listener(arg1);
			if(!p.stayInList) p.dispose();
			p = p._next;
		}
		this.didEmit(head);
	}
	,__class__: flambe_util_Signal1
});
var flambe_animation_AnimatedFloat = function(value,listener) {
	this._behavior = null;
	flambe_util_Value.call(this,value,listener);
};
$hxClasses["flambe.animation.AnimatedFloat"] = flambe_animation_AnimatedFloat;
flambe_animation_AnimatedFloat.__name__ = true;
flambe_animation_AnimatedFloat.__super__ = flambe_util_Value;
flambe_animation_AnimatedFloat.prototype = $extend(flambe_util_Value.prototype,{
	set__: function(value) {
		this._behavior = null;
		return flambe_util_Value.prototype.set__.call(this,value);
	}
	,update: function(dt) {
		if(this._behavior != null) {
			flambe_util_Value.prototype.set__.call(this,this._behavior.update(dt));
			if(this._behavior.isComplete()) this._behavior = null;
		}
	}
	,animate: function(from,to,seconds,easing) {
		this.set__(from);
		this.animateTo(to,seconds,easing);
	}
	,animateTo: function(to,seconds,easing) {
		this.set_behavior(new flambe_animation_Tween(this._value,to,seconds,easing));
	}
	,set_behavior: function(behavior) {
		this._behavior = behavior;
		this.update(0);
		return behavior;
	}
	,get_behavior: function() {
		return this._behavior;
	}
	,__class__: flambe_animation_AnimatedFloat
});
var flambe_System = function() { };
$hxClasses["flambe.System"] = flambe_System;
flambe_System.__name__ = true;
flambe_System.init = function() {
	if(!flambe_System._calledInit) {
		flambe_System._platform.init();
		flambe_System._calledInit = true;
	}
};
flambe_System.loadAssetPack = function(manifest) {
	flambe_System.assertCalledInit();
	return flambe_System._platform.loadAssetPack(manifest);
};
flambe_System.createLogger = function(tag) {
	return new flambe_util_Logger(flambe_System._platform.createLogHandler(tag));
};
flambe_System.get_stage = function() {
	flambe_System.assertCalledInit();
	return flambe_System._platform.getStage();
};
flambe_System.get_pointer = function() {
	flambe_System.assertCalledInit();
	return flambe_System._platform.getPointer();
};
flambe_System.get_mouse = function() {
	flambe_System.assertCalledInit();
	return flambe_System._platform.getMouse();
};
flambe_System.get_touch = function() {
	flambe_System.assertCalledInit();
	return flambe_System._platform.getTouch();
};
flambe_System.get_keyboard = function() {
	flambe_System.assertCalledInit();
	return flambe_System._platform.getKeyboard();
};
flambe_System.get_external = function() {
	flambe_System.assertCalledInit();
	return flambe_System._platform.getExternal();
};
flambe_System.get_motion = function() {
	flambe_System.assertCalledInit();
	return flambe_System._platform.getMotion();
};
flambe_System.assertCalledInit = function() {
	flambe_util_Assert.that(flambe_System._calledInit,"You must call System.init() first");
};
var flambe_util_Logger = function(handler) {
	this._handler = handler;
};
$hxClasses["flambe.util.Logger"] = flambe_util_Logger;
flambe_util_Logger.__name__ = true;
flambe_util_Logger.prototype = {
	info: function(text,args) {
		this.log(flambe_util_LogLevel.Info,text,args);
	}
	,warn: function(text,args) {
		this.log(flambe_util_LogLevel.Warn,text,args);
	}
	,error: function(text,args) {
		this.log(flambe_util_LogLevel.Error,text,args);
	}
	,log: function(level,text,args) {
		if(this._handler == null) return;
		if(text == null) text = "";
		if(args != null) text = flambe_util_Strings.withFields(text,args);
		this._handler.log(level,text);
	}
	,__class__: flambe_util_Logger
};
var flambe_Log = function() { };
$hxClasses["flambe.Log"] = flambe_Log;
flambe_Log.__name__ = true;
flambe_Log.info = function(text,args) {
	flambe_Log.logger.info(text,args);
};
flambe_Log.warn = function(text,args) {
	flambe_Log.logger.warn(text,args);
};
flambe_Log.error = function(text,args) {
	flambe_Log.logger.error(text,args);
};
flambe_Log.__super__ = flambe_util_PackageLog;
flambe_Log.prototype = $extend(flambe_util_PackageLog.prototype,{
	__class__: flambe_Log
});
var flambe_SpeedAdjuster = function() {
	this._realDt = 0;
};
$hxClasses["flambe.SpeedAdjuster"] = flambe_SpeedAdjuster;
flambe_SpeedAdjuster.__name__ = true;
flambe_SpeedAdjuster.__super__ = flambe_Component;
flambe_SpeedAdjuster.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "SpeedAdjuster_7";
	}
	,onUpdate: function(dt) {
		if(this._realDt > 0) {
			dt = this._realDt;
			this._realDt = 0;
		}
		this.scale.update(dt);
	}
	,__class__: flambe_SpeedAdjuster
});
var flambe_animation_Behavior = function() { };
$hxClasses["flambe.animation.Behavior"] = flambe_animation_Behavior;
flambe_animation_Behavior.__name__ = true;
flambe_animation_Behavior.prototype = {
	__class__: flambe_animation_Behavior
};
var flambe_animation_Ease = function() { };
$hxClasses["flambe.animation.Ease"] = flambe_animation_Ease;
flambe_animation_Ease.__name__ = true;
flambe_animation_Ease.linear = function(t) {
	return t;
};
flambe_animation_Ease.quadOut = function(t) {
	return t * (2 - t);
};
flambe_animation_Ease.sineOut = function(t) {
	return Math.sin(1.57079632679489656 * t);
};
flambe_animation_Ease.sineInOut = function(t) {
	return .5 - Math.cos(3.141592653589793 * t) / 2;
};
flambe_animation_Ease.bounceOut = function(t) {
	if(t < 0.363636363636363646) return 7.5625 * t * t;
	if(t < 0.727272727272727293) return 7.5625 * (t - 0.545454545454545414) * (t - 0.545454545454545414) + .75;
	if(t < 0.909090909090909061) return 7.5625 * (t - 0.818181818181818232) * (t - 0.818181818181818232) + .9375;
	return 7.5625 * (t - 0.954545454545454586) * (t - 0.954545454545454586) + .984375;
};
flambe_animation_Ease.expoIn = function(t) {
	return Math.pow(2,10 * (t - 1));
};
flambe_animation_Ease.expoOut = function(t) {
	return -Math.pow(2,-10 * t) + 1;
};
flambe_animation_Ease.backIn = function(t) {
	return t * t * (2.70158 * t - 1.70158);
};
flambe_animation_Ease.backOut = function(t) {
	return 1 - --t * t * (-2.70158 * t - 1.70158);
};
var flambe_animation_Tween = function(from,to,seconds,easing) {
	this._from = from;
	this._to = to;
	this._duration = seconds;
	this.elapsed = 0;
	if(easing != null) this._easing = easing; else this._easing = flambe_animation_Ease.linear;
};
$hxClasses["flambe.animation.Tween"] = flambe_animation_Tween;
flambe_animation_Tween.__name__ = true;
flambe_animation_Tween.__interfaces__ = [flambe_animation_Behavior];
flambe_animation_Tween.prototype = {
	update: function(dt) {
		this.elapsed += dt;
		if(this.elapsed >= this._duration) return this._to; else return this._from + (this._to - this._from) * this._easing(this.elapsed / this._duration);
	}
	,isComplete: function() {
		return this.elapsed >= this._duration;
	}
	,__class__: flambe_animation_Tween
};
var flambe_asset_Asset = function() { };
$hxClasses["flambe.asset.Asset"] = flambe_asset_Asset;
flambe_asset_Asset.__name__ = true;
flambe_asset_Asset.__interfaces__ = [flambe_util_Disposable];
flambe_asset_Asset.prototype = {
	__class__: flambe_asset_Asset
};
var flambe_asset_AssetFormat = $hxClasses["flambe.asset.AssetFormat"] = { __ename__ : true, __constructs__ : ["WEBP","JXR","PNG","JPG","GIF","DDS","PVR","PKM","MP3","M4A","OPUS","OGG","WAV","Data"] };
flambe_asset_AssetFormat.WEBP = ["WEBP",0];
flambe_asset_AssetFormat.WEBP.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.JXR = ["JXR",1];
flambe_asset_AssetFormat.JXR.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.PNG = ["PNG",2];
flambe_asset_AssetFormat.PNG.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.JPG = ["JPG",3];
flambe_asset_AssetFormat.JPG.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.GIF = ["GIF",4];
flambe_asset_AssetFormat.GIF.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.DDS = ["DDS",5];
flambe_asset_AssetFormat.DDS.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.PVR = ["PVR",6];
flambe_asset_AssetFormat.PVR.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.PKM = ["PKM",7];
flambe_asset_AssetFormat.PKM.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.MP3 = ["MP3",8];
flambe_asset_AssetFormat.MP3.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.M4A = ["M4A",9];
flambe_asset_AssetFormat.M4A.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.OPUS = ["OPUS",10];
flambe_asset_AssetFormat.OPUS.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.OGG = ["OGG",11];
flambe_asset_AssetFormat.OGG.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.WAV = ["WAV",12];
flambe_asset_AssetFormat.WAV.__enum__ = flambe_asset_AssetFormat;
flambe_asset_AssetFormat.Data = ["Data",13];
flambe_asset_AssetFormat.Data.__enum__ = flambe_asset_AssetFormat;
var flambe_asset_AssetEntry = function(name,url,format,bytes) {
	this.name = name;
	this.url = url;
	this.format = format;
	this.bytes = bytes;
};
$hxClasses["flambe.asset.AssetEntry"] = flambe_asset_AssetEntry;
flambe_asset_AssetEntry.__name__ = true;
flambe_asset_AssetEntry.prototype = {
	__class__: flambe_asset_AssetEntry
};
var flambe_asset_AssetPack = function() { };
$hxClasses["flambe.asset.AssetPack"] = flambe_asset_AssetPack;
flambe_asset_AssetPack.__name__ = true;
flambe_asset_AssetPack.__interfaces__ = [flambe_util_Disposable];
flambe_asset_AssetPack.prototype = {
	__class__: flambe_asset_AssetPack
};
var flambe_asset_File = function() { };
$hxClasses["flambe.asset.File"] = flambe_asset_File;
flambe_asset_File.__name__ = true;
flambe_asset_File.__interfaces__ = [flambe_asset_Asset];
flambe_asset_File.prototype = {
	__class__: flambe_asset_File
};
var js_Browser = function() { };
$hxClasses["js.Browser"] = js_Browser;
js_Browser.__name__ = true;
js_Browser.get_window = function() {
	return window;
};
js_Browser.get_document = function() {
	return window.document;
};
js_Browser.get_location = function() {
	return window.location;
};
js_Browser.get_navigator = function() {
	return window.navigator;
};
var flambe_asset_Manifest = function() {
	this._remoteBase = null;
	this._localBase = null;
	this._entries = [];
};
$hxClasses["flambe.asset.Manifest"] = flambe_asset_Manifest;
flambe_asset_Manifest.__name__ = true;
flambe_asset_Manifest.fromAssets = function(packName,required) {
	if(required == null) required = true;
	var packData = Reflect.field(haxe_rtti_Meta.getType(flambe_asset_Manifest).assets[0],packName);
	if(packData == null) {
		if(required) throw flambe_util_Strings.withFields("Missing asset pack",["name",packName]);
		return null;
	}
	var manifest = new flambe_asset_Manifest();
	manifest.set_localBase("assets");
	var _g = 0;
	while(_g < packData.length) {
		var asset = packData[_g];
		++_g;
		var name = asset.name;
		var path = packName + "/" + name + "?v=" + Std.string(asset.md5);
		var format = flambe_asset_Manifest.inferFormat(name);
		if(format != flambe_asset_AssetFormat.Data) name = flambe_util_Strings.removeFileExtension(name);
		manifest.add(name,path,asset.bytes,format);
	}
	return manifest;
};
flambe_asset_Manifest.inferFormat = function(url) {
	var extension = flambe_util_Strings.getUrlExtension(url);
	if(extension != null) {
		var _g = extension.toLowerCase();
		switch(_g) {
		case "gif":
			return flambe_asset_AssetFormat.GIF;
		case "jpg":case "jpeg":
			return flambe_asset_AssetFormat.JPG;
		case "jxr":case "wdp":
			return flambe_asset_AssetFormat.JXR;
		case "png":
			return flambe_asset_AssetFormat.PNG;
		case "webp":
			return flambe_asset_AssetFormat.WEBP;
		case "dds":
			return flambe_asset_AssetFormat.DDS;
		case "pvr":
			return flambe_asset_AssetFormat.PVR;
		case "pkm":
			return flambe_asset_AssetFormat.PKM;
		case "m4a":
			return flambe_asset_AssetFormat.M4A;
		case "mp3":
			return flambe_asset_AssetFormat.MP3;
		case "ogg":
			return flambe_asset_AssetFormat.OGG;
		case "opus":
			return flambe_asset_AssetFormat.OPUS;
		case "wav":
			return flambe_asset_AssetFormat.WAV;
		}
	} else flambe_Log.warn("No file extension for asset, it will be loaded as data",["url",url]);
	return flambe_asset_AssetFormat.Data;
};
flambe_asset_Manifest.prototype = {
	add: function(name,url,bytes,format) {
		if(bytes == null) bytes = 0;
		if(format == null) format = flambe_asset_Manifest.inferFormat(url);
		var entry = new flambe_asset_AssetEntry(name,url,format,bytes);
		this._entries.push(entry);
		return entry;
	}
	,iterator: function() {
		return HxOverrides.iter(this._entries);
	}
	,getFullURL: function(entry) {
		var basePath;
		if(this.get_remoteBase() != null && flambe_asset_Manifest._supportsCrossOrigin) basePath = this.get_remoteBase(); else basePath = this.get_localBase();
		if(basePath != null) return flambe_util_Strings.joinPath(basePath,entry.url); else return entry.url;
	}
	,get_localBase: function() {
		return this._localBase;
	}
	,set_localBase: function(localBase) {
		if(localBase != null) flambe_util_Assert.that(!StringTools.startsWith(localBase,"http://") && !StringTools.startsWith(localBase,"https://"),"localBase must be a path on the same domain, NOT starting with http(s)://");
		return this._localBase = localBase;
	}
	,get_remoteBase: function() {
		return this._remoteBase;
	}
	,__class__: flambe_asset_Manifest
};
var flambe_display_BlendMode = $hxClasses["flambe.display.BlendMode"] = { __ename__ : true, __constructs__ : ["Normal","Add","Mask","Copy"] };
flambe_display_BlendMode.Normal = ["Normal",0];
flambe_display_BlendMode.Normal.__enum__ = flambe_display_BlendMode;
flambe_display_BlendMode.Add = ["Add",1];
flambe_display_BlendMode.Add.__enum__ = flambe_display_BlendMode;
flambe_display_BlendMode.Mask = ["Mask",2];
flambe_display_BlendMode.Mask.__enum__ = flambe_display_BlendMode;
flambe_display_BlendMode.Copy = ["Copy",3];
flambe_display_BlendMode.Copy.__enum__ = flambe_display_BlendMode;
var flambe_display_EmitterType = $hxClasses["flambe.display.EmitterType"] = { __ename__ : true, __constructs__ : ["Gravity","Radial"] };
flambe_display_EmitterType.Gravity = ["Gravity",0];
flambe_display_EmitterType.Gravity.__enum__ = flambe_display_EmitterType;
flambe_display_EmitterType.Radial = ["Radial",1];
flambe_display_EmitterType.Radial.__enum__ = flambe_display_EmitterType;
var flambe_display_EmitterMold = function(pack,name) {
	var blendFuncSource = 0;
	var blendFuncDestination = 0;
	var xml = Xml.parse(pack.getFile(name + ".pex").toString());
	var $it0 = xml.firstElement().elements();
	while( $it0.hasNext() ) {
		var element = $it0.next();
		var _g = element.get_nodeName().toLowerCase();
		switch(_g) {
		case "texture":
			this.texture = pack.getTexture(flambe_util_Strings.removeFileExtension(element.get("name")));
			break;
		case "angle":
			this.angle = flambe_display_EmitterMold.getValue(element);
			break;
		case "anglevariance":
			this.angleVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "blendfuncdestination":
			blendFuncDestination = Std["int"](flambe_display_EmitterMold.getValue(element));
			break;
		case "blendfuncsource":
			blendFuncSource = Std["int"](flambe_display_EmitterMold.getValue(element));
			break;
		case "duration":
			this.duration = flambe_display_EmitterMold.getValue(element);
			break;
		case "emittertype":
			if(Std["int"](flambe_display_EmitterMold.getValue(element)) == 0) this.type = flambe_display_EmitterType.Gravity; else this.type = flambe_display_EmitterType.Radial;
			break;
		case "finishcolor":
			this.alphaEnd = flambe_display_EmitterMold.getFloat(element,"alpha");
			break;
		case "finishcolorvariance":
			this.alphaEndVariance = flambe_display_EmitterMold.getFloat(element,"alpha");
			break;
		case "finishparticlesize":
			this.sizeEnd = flambe_display_EmitterMold.getValue(element);
			break;
		case "finishparticlesizevariance":
			this.sizeEndVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "gravity":
			this.gravityX = flambe_display_EmitterMold.getX(element);
			this.gravityY = flambe_display_EmitterMold.getY(element);
			break;
		case "maxparticles":
			this.maxParticles = Std["int"](flambe_display_EmitterMold.getValue(element));
			break;
		case "maxradius":
			this.maxRadius = flambe_display_EmitterMold.getValue(element);
			break;
		case "maxradiusvariance":
			this.maxRadiusVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "minradius":
			this.minRadius = flambe_display_EmitterMold.getValue(element);
			break;
		case "particlelifespan":
			this.lifespan = flambe_display_EmitterMold.getValue(element);
			break;
		case "particlelifespanvariance":
			this.lifespanVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "radialaccelvariance":
			this.radialAccelVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "radialacceleration":
			this.radialAccel = flambe_display_EmitterMold.getValue(element);
			break;
		case "rotatepersecond":
			this.rotatePerSecond = flambe_display_EmitterMold.getValue(element);
			break;
		case "rotatepersecondvariance":
			this.rotatePerSecondVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "rotationend":
			this.rotationEnd = flambe_display_EmitterMold.getValue(element);
			break;
		case "rotationendvariance":
			this.rotationEndVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "rotationstart":
			this.rotationStart = flambe_display_EmitterMold.getValue(element);
			break;
		case "rotationstartvariance":
			this.rotationStartVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "sourcepositionvariance":
			this.emitXVariance = flambe_display_EmitterMold.getX(element);
			this.emitYVariance = flambe_display_EmitterMold.getY(element);
			break;
		case "speed":
			this.speed = flambe_display_EmitterMold.getValue(element);
			break;
		case "speedvariance":
			this.speedVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "startcolor":
			this.alphaStart = flambe_display_EmitterMold.getFloat(element,"alpha");
			break;
		case "startcolorvariance":
			this.alphaStartVariance = flambe_display_EmitterMold.getFloat(element,"alpha");
			break;
		case "startparticlesize":
			this.sizeStart = flambe_display_EmitterMold.getValue(element);
			break;
		case "startparticlesizevariance":
			this.sizeStartVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "tangentialaccelvariance":
			this.tangentialAccelVariance = flambe_display_EmitterMold.getValue(element);
			break;
		case "tangentialacceleration":
			this.tangentialAccel = flambe_display_EmitterMold.getValue(element);
			break;
		}
	}
	if(this.lifespan <= 0) this.lifespan = this.duration;
	if(blendFuncSource == 1 && blendFuncDestination == 1) this.blendMode = flambe_display_BlendMode.Add; else if(blendFuncSource == 1 && blendFuncDestination == 771) this.blendMode = null; else if(blendFuncSource != 0 || blendFuncDestination != 0) flambe_Log.warn("Unsupported particle blend functions",["emitter",name,"source",blendFuncSource,"dest",blendFuncDestination]);
};
$hxClasses["flambe.display.EmitterMold"] = flambe_display_EmitterMold;
flambe_display_EmitterMold.__name__ = true;
flambe_display_EmitterMold.getFloat = function(xml,name) {
	return Std.parseFloat(xml.get(name));
};
flambe_display_EmitterMold.getValue = function(xml) {
	return flambe_display_EmitterMold.getFloat(xml,"value");
};
flambe_display_EmitterMold.getX = function(xml) {
	return flambe_display_EmitterMold.getFloat(xml,"x");
};
flambe_display_EmitterMold.getY = function(xml) {
	return flambe_display_EmitterMold.getFloat(xml,"y");
};
flambe_display_EmitterMold.prototype = {
	createEmitter: function() {
		return new flambe_display_EmitterSprite(this);
	}
	,__class__: flambe_display_EmitterMold
};
var flambe_display_EmitterSprite = function(mold) {
	this._totalElapsed = 0;
	this._emitElapsed = 0;
	this.enabled = true;
	this.numParticles = 0;
	flambe_display_Sprite.call(this);
	this.texture = mold.texture;
	this.blendMode = mold.blendMode;
	this.type = mold.type;
	this.alphaEnd = new flambe_animation_AnimatedFloat(mold.alphaEnd);
	this.alphaEndVariance = new flambe_animation_AnimatedFloat(mold.alphaEndVariance);
	this.alphaStart = new flambe_animation_AnimatedFloat(mold.alphaStart);
	this.alphaStartVariance = new flambe_animation_AnimatedFloat(mold.alphaStartVariance);
	this.angle = new flambe_animation_AnimatedFloat(mold.angle);
	this.angleVariance = new flambe_animation_AnimatedFloat(mold.angleVariance);
	this.duration = mold.duration;
	this.emitXVariance = new flambe_animation_AnimatedFloat(mold.emitXVariance);
	this.emitYVariance = new flambe_animation_AnimatedFloat(mold.emitYVariance);
	this.gravityX = new flambe_animation_AnimatedFloat(mold.gravityX);
	this.gravityY = new flambe_animation_AnimatedFloat(mold.gravityY);
	this.maxRadius = new flambe_animation_AnimatedFloat(mold.maxRadius);
	this.maxRadiusVariance = new flambe_animation_AnimatedFloat(mold.maxRadiusVariance);
	this.minRadius = new flambe_animation_AnimatedFloat(mold.minRadius);
	this.lifespan = new flambe_animation_AnimatedFloat(mold.lifespan);
	this.lifespanVariance = new flambe_animation_AnimatedFloat(mold.lifespanVariance);
	this.radialAccel = new flambe_animation_AnimatedFloat(mold.radialAccel);
	this.radialAccelVariance = new flambe_animation_AnimatedFloat(mold.radialAccelVariance);
	this.rotatePerSecond = new flambe_animation_AnimatedFloat(mold.rotatePerSecond);
	this.rotatePerSecondVariance = new flambe_animation_AnimatedFloat(mold.rotatePerSecondVariance);
	this.rotationEnd = new flambe_animation_AnimatedFloat(mold.rotationEnd);
	this.rotationEndVariance = new flambe_animation_AnimatedFloat(mold.rotationEndVariance);
	this.rotationStart = new flambe_animation_AnimatedFloat(mold.rotationStart);
	this.rotationStartVariance = new flambe_animation_AnimatedFloat(mold.rotationStartVariance);
	this.sizeEnd = new flambe_animation_AnimatedFloat(mold.sizeEnd);
	this.sizeEndVariance = new flambe_animation_AnimatedFloat(mold.sizeEndVariance);
	this.sizeStart = new flambe_animation_AnimatedFloat(mold.sizeStart);
	this.sizeStartVariance = new flambe_animation_AnimatedFloat(mold.sizeStartVariance);
	this.speed = new flambe_animation_AnimatedFloat(mold.speed);
	this.speedVariance = new flambe_animation_AnimatedFloat(mold.speedVariance);
	this.tangentialAccel = new flambe_animation_AnimatedFloat(mold.tangentialAccel);
	this.tangentialAccelVariance = new flambe_animation_AnimatedFloat(mold.tangentialAccelVariance);
	this.emitX = new flambe_animation_AnimatedFloat(0);
	this.emitY = new flambe_animation_AnimatedFloat(0);
	this._particles = flambe_util_Arrays.create(mold.maxParticles);
	var ii = 0;
	var ll = this._particles.length;
	while(ii < ll) {
		this._particles[ii] = new flambe_display__$EmitterSprite_Particle();
		++ii;
	}
};
$hxClasses["flambe.display.EmitterSprite"] = flambe_display_EmitterSprite;
flambe_display_EmitterSprite.__name__ = true;
flambe_display_EmitterSprite.random = function(base,variance) {
	if(variance != 0) base += variance * (2 * Math.random() - 1);
	return base;
};
flambe_display_EmitterSprite.__super__ = flambe_display_Sprite;
flambe_display_EmitterSprite.prototype = $extend(flambe_display_Sprite.prototype,{
	onUpdate: function(dt) {
		flambe_display_Sprite.prototype.onUpdate.call(this,dt);
		this.alphaEnd.update(dt);
		this.alphaEndVariance.update(dt);
		this.alphaStart.update(dt);
		this.alphaStartVariance.update(dt);
		this.angle.update(dt);
		this.angleVariance.update(dt);
		this.emitX.update(dt);
		this.emitXVariance.update(dt);
		this.emitY.update(dt);
		this.emitYVariance.update(dt);
		this.gravityX.update(dt);
		this.gravityY.update(dt);
		this.lifespan.update(dt);
		this.lifespanVariance.update(dt);
		this.maxRadius.update(dt);
		this.maxRadiusVariance.update(dt);
		this.minRadius.update(dt);
		this.radialAccel.update(dt);
		this.radialAccelVariance.update(dt);
		this.rotatePerSecond.update(dt);
		this.rotatePerSecondVariance.update(dt);
		this.rotationEnd.update(dt);
		this.rotationEndVariance.update(dt);
		this.rotationStart.update(dt);
		this.rotationStartVariance.update(dt);
		this.sizeEnd.update(dt);
		this.sizeEndVariance.update(dt);
		this.sizeStart.update(dt);
		this.sizeStartVariance.update(dt);
		this.speed.update(dt);
		this.speedVariance.update(dt);
		this.tangentialAccel.update(dt);
		this.tangentialAccelVariance.update(dt);
		var gravityType = this.type == flambe_display_EmitterType.Gravity;
		var ii = 0;
		while(ii < this.numParticles) {
			var particle = this._particles[ii];
			if(particle.life > dt) {
				if(gravityType) {
					particle.x += particle.velX * dt;
					particle.y += particle.velY * dt;
					var accelX = this.gravityX.get__();
					var accelY = -this.gravityY.get__();
					if(particle.radialAccel != 0 || particle.tangentialAccel != 0) {
						var dx = particle.x - particle.emitX;
						var dy = particle.y - particle.emitY;
						var distance = Math.sqrt(dx * dx + dy * dy);
						var radialX = dx / distance;
						var radialY = dy / distance;
						accelX += radialX * particle.radialAccel;
						accelY += radialY * particle.radialAccel;
						var tangentialX = -radialY;
						var tangentialY = radialX;
						accelX += tangentialX * particle.tangentialAccel;
						accelY += tangentialY * particle.tangentialAccel;
					}
					particle.velX += accelX * dt;
					particle.velY += accelY * dt;
				} else {
					particle.radialRotation += particle.velRadialRotation * dt;
					particle.radialRadius += particle.velRadialRadius * dt;
					var radius = particle.radialRadius;
					particle.x = this.emitX.get__() - Math.cos(particle.radialRotation) * radius;
					particle.y = this.emitY.get__() - Math.sin(particle.radialRotation) * radius;
					if(radius < this.minRadius.get__()) particle.life = 0;
				}
				particle.scale += particle.velScale * dt;
				particle.rotation += particle.velRotation * dt;
				particle.alpha += particle.velAlpha * dt;
				particle.life -= dt;
				++ii;
			} else {
				--this.numParticles;
				if(ii != this.numParticles) {
					this._particles[ii] = this._particles[this.numParticles];
					this._particles[this.numParticles] = particle;
				}
			}
		}
		if(!this.enabled) return;
		if(this.duration > 0) {
			this._totalElapsed += dt;
			if(this._totalElapsed >= this.duration) {
				this.enabled = false;
				return;
			}
		}
		var emitDelay = this.lifespan.get__() / this._particles.length;
		this._emitElapsed += dt;
		while(this._emitElapsed >= emitDelay) {
			if(this.numParticles < this._particles.length) {
				var particle1 = this._particles[this.numParticles];
				if(this.initParticle(particle1)) ++this.numParticles;
			}
			this._emitElapsed -= emitDelay;
		}
	}
	,draw: function(g) {
		var offset = -this.texture.get_width() / 2;
		var ii = 0;
		var ll = this.numParticles;
		while(ii < ll) {
			var particle = this._particles[ii];
			g.save();
			g.translate(particle.x,particle.y);
			if(particle.alpha < 1) g.multiplyAlpha(particle.alpha);
			if(particle.rotation != 0) g.rotate(particle.rotation);
			if(particle.scale != 1) g.scale(particle.scale,particle.scale);
			g.drawTexture(this.texture,offset,offset);
			g.restore();
			++ii;
		}
	}
	,initParticle: function(particle) {
		particle.life = flambe_display_EmitterSprite.random(this.lifespan.get__(),this.lifespanVariance.get__());
		if(particle.life <= 0) return false;
		particle.emitX = this.emitX.get__();
		particle.emitY = this.emitY.get__();
		var angle = -flambe_math_FMath.toRadians(flambe_display_EmitterSprite.random(this.angle.get__(),this.angleVariance.get__()));
		var speed = flambe_display_EmitterSprite.random(this.speed.get__(),this.speedVariance.get__());
		particle.velX = speed * Math.cos(angle);
		particle.velY = speed * Math.sin(angle);
		particle.radialAccel = flambe_display_EmitterSprite.random(this.radialAccel.get__(),this.radialAccelVariance.get__());
		particle.tangentialAccel = flambe_display_EmitterSprite.random(this.tangentialAccel.get__(),this.tangentialAccelVariance.get__());
		particle.radialRadius = flambe_display_EmitterSprite.random(this.maxRadius.get__(),this.maxRadiusVariance.get__());
		particle.velRadialRadius = -particle.radialRadius / particle.life;
		particle.radialRotation = angle;
		particle.velRadialRotation = flambe_math_FMath.toRadians(flambe_display_EmitterSprite.random(this.rotatePerSecond.get__(),this.rotatePerSecondVariance.get__()));
		if(this.type == flambe_display_EmitterType.Gravity) {
			particle.x = flambe_display_EmitterSprite.random(this.emitX.get__(),this.emitXVariance.get__());
			particle.y = flambe_display_EmitterSprite.random(this.emitY.get__(),this.emitYVariance.get__());
		} else {
			var radius = particle.radialRadius;
			particle.x = this.emitX.get__() - Math.cos(particle.radialRotation) * radius;
			particle.y = this.emitY.get__() - Math.sin(particle.radialRotation) * radius;
		}
		var width = this.texture.get_width();
		var scaleStart = flambe_display_EmitterSprite.random(this.sizeStart.get__(),this.sizeStartVariance.get__()) / width;
		var scaleEnd = flambe_display_EmitterSprite.random(this.sizeEnd.get__(),this.sizeEndVariance.get__()) / width;
		particle.scale = scaleStart;
		particle.velScale = (scaleEnd - scaleStart) / particle.life;
		var rotationStart = flambe_display_EmitterSprite.random(this.rotationStart.get__(),this.rotationStartVariance.get__());
		var rotationEnd = flambe_display_EmitterSprite.random(this.rotationEnd.get__(),this.rotationEndVariance.get__());
		particle.rotation = rotationStart;
		particle.velRotation = (rotationEnd - rotationStart) / particle.life;
		var alphaStart = flambe_display_EmitterSprite.random(this.alphaStart.get__(),this.alphaStartVariance.get__());
		var alphaEnd = flambe_display_EmitterSprite.random(this.alphaEnd.get__(),this.alphaEndVariance.get__());
		particle.alpha = alphaStart;
		particle.velAlpha = (alphaEnd - alphaStart) / particle.life;
		return true;
	}
	,__class__: flambe_display_EmitterSprite
});
var flambe_display__$EmitterSprite_Particle = function() {
	this.life = 0;
	this.velAlpha = 0;
	this.alpha = 0;
	this.velRotation = 0;
	this.rotation = 0;
	this.velScale = 0;
	this.scale = 0;
	this.tangentialAccel = 0;
	this.radialAccel = 0;
	this.velRadialRotation = 0;
	this.radialRotation = 0;
	this.velRadialRadius = 0;
	this.radialRadius = 0;
	this.velY = 0;
	this.y = 0;
	this.velX = 0;
	this.x = 0;
	this.emitY = 0;
	this.emitX = 0;
};
$hxClasses["flambe.display._EmitterSprite.Particle"] = flambe_display__$EmitterSprite_Particle;
flambe_display__$EmitterSprite_Particle.__name__ = true;
flambe_display__$EmitterSprite_Particle.prototype = {
	__class__: flambe_display__$EmitterSprite_Particle
};
var flambe_display_FillSprite = function(color,width,height) {
	flambe_display_Sprite.call(this);
	this.color = color;
	this.width = new flambe_animation_AnimatedFloat(width);
	this.height = new flambe_animation_AnimatedFloat(height);
};
$hxClasses["flambe.display.FillSprite"] = flambe_display_FillSprite;
flambe_display_FillSprite.__name__ = true;
flambe_display_FillSprite.__super__ = flambe_display_Sprite;
flambe_display_FillSprite.prototype = $extend(flambe_display_Sprite.prototype,{
	draw: function(g) {
		g.fillRect(this.color,0,0,this.width.get__(),this.height.get__());
	}
	,getNaturalWidth: function() {
		return this.width.get__();
	}
	,getNaturalHeight: function() {
		return this.height.get__();
	}
	,onUpdate: function(dt) {
		flambe_display_Sprite.prototype.onUpdate.call(this,dt);
		this.width.update(dt);
		this.height.update(dt);
	}
	,__class__: flambe_display_FillSprite
});
var flambe_display_Glyph = function(charCode) {
	this._kernings = null;
	this.xAdvance = 0;
	this.yOffset = 0;
	this.xOffset = 0;
	this.page = null;
	this.height = 0;
	this.width = 0;
	this.y = 0;
	this.x = 0;
	this.charCode = charCode;
};
$hxClasses["flambe.display.Glyph"] = flambe_display_Glyph;
flambe_display_Glyph.__name__ = true;
flambe_display_Glyph.prototype = {
	draw: function(g,destX,destY) {
		if(this.width > 0) g.drawSubTexture(this.page,destX + this.xOffset,destY + this.yOffset,this.x,this.y,this.width,this.height);
	}
	,getKerning: function(nextCharCode) {
		if(this._kernings != null) return Std["int"](this._kernings.get(nextCharCode)); else return 0;
	}
	,setKerning: function(nextCharCode,amount) {
		if(this._kernings == null) this._kernings = new haxe_ds_IntMap();
		this._kernings.set(nextCharCode,amount);
	}
	,__class__: flambe_display_Glyph
};
var flambe_display_Font = function(pack,name) {
	this.name = name;
	this._pack = pack;
	this.reload();
	this._reloadCount = pack.getFile(name + ".fnt").get_reloadCount();
	this._lastReloadCount = this._reloadCount.get__();
};
$hxClasses["flambe.display.Font"] = flambe_display_Font;
flambe_display_Font.__name__ = true;
flambe_display_Font.prototype = {
	layoutText: function(text,align,wrapWidth,letterSpacing,lineSpacing) {
		if(lineSpacing == null) lineSpacing = 0;
		if(letterSpacing == null) letterSpacing = 0;
		if(wrapWidth == null) wrapWidth = 0;
		if(align == null) align = flambe_display_TextAlign.Left;
		return new flambe_display_TextLayout(this,text,align,wrapWidth,letterSpacing,lineSpacing);
	}
	,getGlyph: function(charCode) {
		return this._glyphs.get(charCode);
	}
	,checkReload: function() {
		if(this._lastReloadCount != this._reloadCount.get__()) {
			this._lastReloadCount = this._reloadCount.get__();
			this.reload();
		}
		return this._lastReloadCount;
	}
	,reload: function() {
		this._glyphs = new haxe_ds_IntMap();
		this._glyphs.set(flambe_display_Font.NEWLINE.charCode,flambe_display_Font.NEWLINE);
		var parser = new flambe_display__$Font_ConfigParser(this._pack.getFile(this.name + ".fnt").toString());
		var pages = new haxe_ds_IntMap();
		var idx = this.name.lastIndexOf("/");
		var basePath;
		if(idx >= 0) basePath = HxOverrides.substr(this.name,0,idx + 1); else basePath = "";
		var $it0 = parser.keywords();
		while( $it0.hasNext() ) {
			var keyword = $it0.next();
			switch(keyword) {
			case "info":
				var $it1 = parser.pairs();
				while( $it1.hasNext() ) {
					var pair = $it1.next();
					var _g = pair.key;
					switch(_g) {
					case "size":
						this.size = pair.getInt();
						break;
					}
				}
				break;
			case "common":
				var $it2 = parser.pairs();
				while( $it2.hasNext() ) {
					var pair1 = $it2.next();
					var _g1 = pair1.key;
					switch(_g1) {
					case "lineHeight":
						this.lineHeight = pair1.getInt();
						break;
					}
				}
				break;
			case "page":
				var pageId = 0;
				var file = null;
				var $it3 = parser.pairs();
				while( $it3.hasNext() ) {
					var pair2 = $it3.next();
					var _g2 = pair2.key;
					switch(_g2) {
					case "id":
						pageId = pair2.getInt();
						break;
					case "file":
						file = pair2.getString();
						break;
					}
				}
				var value = this._pack.getTexture(basePath + flambe_util_Strings.removeFileExtension(file));
				pages.set(pageId,value);
				break;
			case "char":
				var glyph = null;
				var $it4 = parser.pairs();
				while( $it4.hasNext() ) {
					var pair3 = $it4.next();
					var _g3 = pair3.key;
					switch(_g3) {
					case "id":
						glyph = new flambe_display_Glyph(pair3.getInt());
						break;
					case "x":
						glyph.x = pair3.getInt();
						break;
					case "y":
						glyph.y = pair3.getInt();
						break;
					case "width":
						glyph.width = pair3.getInt();
						break;
					case "height":
						glyph.height = pair3.getInt();
						break;
					case "page":
						var key = pair3.getInt();
						glyph.page = pages.get(key);
						break;
					case "xoffset":
						glyph.xOffset = pair3.getInt();
						break;
					case "yoffset":
						glyph.yOffset = pair3.getInt();
						break;
					case "xadvance":
						glyph.xAdvance = pair3.getInt();
						break;
					}
				}
				this._glyphs.set(glyph.charCode,glyph);
				break;
			case "kerning":
				var first = null;
				var second = 0;
				var amount = 0;
				var $it5 = parser.pairs();
				while( $it5.hasNext() ) {
					var pair4 = $it5.next();
					var _g4 = pair4.key;
					switch(_g4) {
					case "first":
						var key1 = pair4.getInt();
						first = this._glyphs.get(key1);
						break;
					case "second":
						second = pair4.getInt();
						break;
					case "amount":
						amount = pair4.getInt();
						break;
					}
				}
				if(first != null && amount != 0) first.setKerning(second,amount);
				break;
			}
		}
	}
	,__class__: flambe_display_Font
};
var flambe_display_TextAlign = $hxClasses["flambe.display.TextAlign"] = { __ename__ : true, __constructs__ : ["Left","Center","Right"] };
flambe_display_TextAlign.Left = ["Left",0];
flambe_display_TextAlign.Left.__enum__ = flambe_display_TextAlign;
flambe_display_TextAlign.Center = ["Center",1];
flambe_display_TextAlign.Center.__enum__ = flambe_display_TextAlign;
flambe_display_TextAlign.Right = ["Right",2];
flambe_display_TextAlign.Right.__enum__ = flambe_display_TextAlign;
var flambe_display_TextLayout = function(font,text,align,wrapWidth,letterSpacing,lineSpacing) {
	this.lines = 0;
	var _g = this;
	this._font = font;
	this._glyphs = [];
	this._offsets = [];
	this._lineOffset = Math.round(font.lineHeight + lineSpacing);
	this.bounds = new flambe_math_Rectangle();
	var lineWidths = [];
	var ll = text.length;
	var _g1 = 0;
	while(_g1 < ll) {
		var ii = _g1++;
		var charCode = StringTools.fastCodeAt(text,ii);
		var glyph = font.getGlyph(charCode);
		if(glyph != null) this._glyphs.push(glyph); else flambe_Log.warn("Requested a missing character from font",["font",font.name,"charCode",charCode]);
	}
	var lastSpaceIdx = -1;
	var lineWidth = 0.0;
	var lineHeight = 0.0;
	var newline = font.getGlyph(10);
	var addLine = function() {
		_g.bounds.width = flambe_math_FMath.max(_g.bounds.width,lineWidth);
		_g.bounds.height += lineHeight;
		lineWidths[_g.lines] = lineWidth;
		lineWidth = 0;
		lineHeight = 0;
		++_g.lines;
	};
	var ii1 = 0;
	while(ii1 < this._glyphs.length) {
		var glyph1 = this._glyphs[ii1];
		this._offsets[ii1] = Math.round(lineWidth);
		var wordWrap = wrapWidth > 0 && lineWidth + glyph1.width > wrapWidth;
		if(wordWrap || glyph1 == newline) {
			if(wordWrap) {
				if(lastSpaceIdx >= 0) {
					this._glyphs[lastSpaceIdx] = newline;
					lineWidth = this._offsets[lastSpaceIdx];
					ii1 = lastSpaceIdx;
				} else this._glyphs.splice(ii1,0,newline);
			}
			lastSpaceIdx = -1;
			lineHeight = this._lineOffset;
			addLine();
		} else {
			if(glyph1.charCode == 32) lastSpaceIdx = ii1;
			lineWidth += glyph1.xAdvance + letterSpacing;
			lineHeight = flambe_math_FMath.max(lineHeight,glyph1.height + glyph1.yOffset);
			if(ii1 + 1 < this._glyphs.length) {
				var nextGlyph = this._glyphs[ii1 + 1];
				lineWidth += glyph1.getKerning(nextGlyph.charCode);
			}
		}
		++ii1;
	}
	addLine();
	var lineY = 0.0;
	var alignOffset = flambe_display_TextLayout.getAlignOffset(align,lineWidths[0],wrapWidth);
	var top = 1.79769313486231e+308;
	var bottom = -1.79769313486231e+308;
	var line = 0;
	var ii2 = 0;
	var ll1 = this._glyphs.length;
	while(ii2 < ll1) {
		var glyph2 = this._glyphs[ii2];
		if(glyph2.charCode == 10) {
			lineY += this._lineOffset;
			++line;
			alignOffset = flambe_display_TextLayout.getAlignOffset(align,lineWidths[line],wrapWidth);
		}
		this._offsets[ii2] += alignOffset;
		var glyphY = lineY + glyph2.yOffset;
		top = flambe_math_FMath.min(top,glyphY);
		bottom = flambe_math_FMath.max(bottom,glyphY + glyph2.height);
		++ii2;
	}
	this.bounds.x = flambe_display_TextLayout.getAlignOffset(align,this.bounds.width,wrapWidth);
	this.bounds.y = top;
	this.bounds.height = bottom - top;
};
$hxClasses["flambe.display.TextLayout"] = flambe_display_TextLayout;
flambe_display_TextLayout.__name__ = true;
flambe_display_TextLayout.getAlignOffset = function(align,lineWidth,totalWidth) {
	switch(Type.enumIndex(align)) {
	case 0:
		return 0;
	case 2:
		return totalWidth - lineWidth;
	case 1:
		return Math.round((totalWidth - lineWidth) / 2);
	}
};
flambe_display_TextLayout.prototype = {
	draw: function(g) {
		var y = 0.0;
		var ii = 0;
		var ll = this._glyphs.length;
		while(ii < ll) {
			var glyph = this._glyphs[ii];
			if(glyph.charCode == 10) y += this._lineOffset; else {
				var x = this._offsets[ii];
				glyph.draw(g,x,y);
			}
			++ii;
		}
	}
	,__class__: flambe_display_TextLayout
};
var flambe_display__$Font_ConfigParser = function(config) {
	this._configText = config;
	this._keywordPattern = new EReg("([A-Za-z]+)(.*)","");
	this._pairPattern = new EReg("([A-Za-z]+)=(\"[^\"]*\"|[^\\s]+)","");
};
$hxClasses["flambe.display._Font.ConfigParser"] = flambe_display__$Font_ConfigParser;
flambe_display__$Font_ConfigParser.__name__ = true;
flambe_display__$Font_ConfigParser.advance = function(text,expr) {
	var m = expr.matchedPos();
	return HxOverrides.substr(text,m.pos + m.len,text.length);
};
flambe_display__$Font_ConfigParser.prototype = {
	keywords: function() {
		var _g = this;
		var text = this._configText;
		return { next : function() {
			text = flambe_display__$Font_ConfigParser.advance(text,_g._keywordPattern);
			_g._pairText = _g._keywordPattern.matched(2);
			return _g._keywordPattern.matched(1);
		}, hasNext : function() {
			return _g._keywordPattern.match(text);
		}};
	}
	,pairs: function() {
		var _g = this;
		var text = this._pairText;
		return { next : function() {
			text = flambe_display__$Font_ConfigParser.advance(text,_g._pairPattern);
			return new flambe_display__$Font_ConfigPair(_g._pairPattern.matched(1),_g._pairPattern.matched(2));
		}, hasNext : function() {
			return _g._pairPattern.match(text);
		}};
	}
	,__class__: flambe_display__$Font_ConfigParser
};
var flambe_display__$Font_ConfigPair = function(key,value) {
	this.key = key;
	this._value = value;
};
$hxClasses["flambe.display._Font.ConfigPair"] = flambe_display__$Font_ConfigPair;
flambe_display__$Font_ConfigPair.__name__ = true;
flambe_display__$Font_ConfigPair.prototype = {
	getInt: function() {
		return Std.parseInt(this._value);
	}
	,getString: function() {
		if(StringTools.fastCodeAt(this._value,0) != 34) return null;
		return HxOverrides.substr(this._value,1,this._value.length - 2);
	}
	,__class__: flambe_display__$Font_ConfigPair
};
var flambe_display_Graphics = function() { };
$hxClasses["flambe.display.Graphics"] = flambe_display_Graphics;
flambe_display_Graphics.__name__ = true;
flambe_display_Graphics.prototype = {
	__class__: flambe_display_Graphics
};
var flambe_display_ImageSprite = function(texture) {
	flambe_display_Sprite.call(this);
	this.texture = texture;
};
$hxClasses["flambe.display.ImageSprite"] = flambe_display_ImageSprite;
flambe_display_ImageSprite.__name__ = true;
flambe_display_ImageSprite.__super__ = flambe_display_Sprite;
flambe_display_ImageSprite.prototype = $extend(flambe_display_Sprite.prototype,{
	draw: function(g) {
		if(this.texture != null) g.drawTexture(this.texture,0,0);
	}
	,getNaturalWidth: function() {
		if(this.texture != null) return this.texture.get_width(); else return 0;
	}
	,getNaturalHeight: function() {
		if(this.texture != null) return this.texture.get_height(); else return 0;
	}
	,__class__: flambe_display_ImageSprite
});
var flambe_display_Orientation = $hxClasses["flambe.display.Orientation"] = { __ename__ : true, __constructs__ : ["Portrait","Landscape"] };
flambe_display_Orientation.Portrait = ["Portrait",0];
flambe_display_Orientation.Portrait.__enum__ = flambe_display_Orientation;
flambe_display_Orientation.Landscape = ["Landscape",1];
flambe_display_Orientation.Landscape.__enum__ = flambe_display_Orientation;
var flambe_display_PatternSprite = function(texture,width,height) {
	if(height == null) height = -1;
	if(width == null) width = -1;
	flambe_display_Sprite.call(this);
	this.texture = texture;
	if(width < 0) if(texture != null) width = texture.get_width(); else width = 0;
	this.width = new flambe_animation_AnimatedFloat(width);
	if(height < 0) if(texture != null) height = texture.get_height(); else height = 0;
	this.height = new flambe_animation_AnimatedFloat(height);
};
$hxClasses["flambe.display.PatternSprite"] = flambe_display_PatternSprite;
flambe_display_PatternSprite.__name__ = true;
flambe_display_PatternSprite.__super__ = flambe_display_Sprite;
flambe_display_PatternSprite.prototype = $extend(flambe_display_Sprite.prototype,{
	draw: function(g) {
		if(this.texture != null) g.drawPattern(this.texture,0,0,this.width.get__(),this.height.get__());
	}
	,getNaturalWidth: function() {
		return this.width.get__();
	}
	,getNaturalHeight: function() {
		return this.height.get__();
	}
	,onUpdate: function(dt) {
		flambe_display_Sprite.prototype.onUpdate.call(this,dt);
		this.width.update(dt);
		this.height.update(dt);
	}
	,__class__: flambe_display_PatternSprite
});
var flambe_display_Texture = function() { };
$hxClasses["flambe.display.Texture"] = flambe_display_Texture;
flambe_display_Texture.__name__ = true;
flambe_display_Texture.__interfaces__ = [flambe_asset_Asset];
flambe_display_Texture.prototype = {
	__class__: flambe_display_Texture
};
var flambe_display_SubTexture = function() { };
$hxClasses["flambe.display.SubTexture"] = flambe_display_SubTexture;
flambe_display_SubTexture.__name__ = true;
flambe_display_SubTexture.__interfaces__ = [flambe_display_Texture];
var flambe_display_TextSprite = function(font,text) {
	if(text == null) text = "";
	this._lastReloadCount = -1;
	this._layout = null;
	var _g = this;
	flambe_display_Sprite.call(this);
	this._font = font;
	this._text = text;
	this._align = flambe_display_TextAlign.Left;
	this._flags = flambe_util_BitSets.add(this._flags,64);
	var dirtyText = function(_,_1) {
		_g._flags = flambe_util_BitSets.add(_g._flags,64);
	};
	this.wrapWidth = new flambe_animation_AnimatedFloat(0,dirtyText);
	this.letterSpacing = new flambe_animation_AnimatedFloat(0,dirtyText);
	this.lineSpacing = new flambe_animation_AnimatedFloat(0,dirtyText);
};
$hxClasses["flambe.display.TextSprite"] = flambe_display_TextSprite;
flambe_display_TextSprite.__name__ = true;
flambe_display_TextSprite.__super__ = flambe_display_Sprite;
flambe_display_TextSprite.prototype = $extend(flambe_display_Sprite.prototype,{
	draw: function(g) {
		this.updateLayout();
		this._layout.draw(g);
	}
	,getNaturalWidth: function() {
		this.updateLayout();
		if(this.wrapWidth.get__() > 0) return this.wrapWidth.get__(); else return this._layout.bounds.width;
	}
	,getNaturalHeight: function() {
		this.updateLayout();
		var paddedHeight = this._layout.lines * (this._font.lineHeight + this.lineSpacing.get__());
		var boundsHeight = this._layout.bounds.height;
		return flambe_math_FMath.max(paddedHeight,boundsHeight);
	}
	,containsLocal: function(localX,localY) {
		this.updateLayout();
		return this._layout.bounds.contains(localX,localY);
	}
	,setLetterSpacing: function(letterSpacing) {
		this.letterSpacing.set__(letterSpacing);
		return this;
	}
	,get_text: function() {
		return this._text;
	}
	,set_text: function(text) {
		if(text != this._text) {
			this._text = text;
			this._flags = flambe_util_BitSets.add(this._flags,64);
		}
		return text;
	}
	,get_font: function() {
		return this._font;
	}
	,set_font: function(font) {
		if(font != this._font) {
			this._font = font;
			this._flags = flambe_util_BitSets.add(this._flags,64);
		}
		return font;
	}
	,set_align: function(align) {
		if(align != this._align) {
			this._align = align;
			this._flags = flambe_util_BitSets.add(this._flags,64);
		}
		return align;
	}
	,updateLayout: function() {
		var reloadCount = this._font.checkReload();
		if(reloadCount != this._lastReloadCount) {
			this._lastReloadCount = reloadCount;
			this._flags = flambe_util_BitSets.add(this._flags,64);
		}
		if(flambe_util_BitSets.contains(this._flags,64)) {
			this._flags = flambe_util_BitSets.remove(this._flags,64);
			this._layout = this.get_font().layoutText(this._text,this._align,this.wrapWidth.get__(),this.letterSpacing.get__(),this.lineSpacing.get__());
		}
	}
	,onUpdate: function(dt) {
		flambe_display_Sprite.prototype.onUpdate.call(this,dt);
		this.wrapWidth.update(dt);
		this.letterSpacing.update(dt);
		this.lineSpacing.update(dt);
	}
	,__class__: flambe_display_TextSprite
});
var flambe_input_Acceleration = function() {
	this.init(0,0,0);
};
$hxClasses["flambe.input.Acceleration"] = flambe_input_Acceleration;
flambe_input_Acceleration.__name__ = true;
flambe_input_Acceleration.prototype = {
	init: function(x,y,z) {
		this.x = x;
		this.y = y;
		this.z = z;
	}
	,__class__: flambe_input_Acceleration
};
var flambe_input_Attitude = function() {
	this.init(0,0,0);
};
$hxClasses["flambe.input.Attitude"] = flambe_input_Attitude;
flambe_input_Attitude.__name__ = true;
flambe_input_Attitude.prototype = {
	init: function(pitch,roll,azimuth) {
		this.pitch = pitch;
		this.roll = roll;
		this.azimuth = azimuth;
	}
	,__class__: flambe_input_Attitude
};
var flambe_input_Key = $hxClasses["flambe.input.Key"] = { __ename__ : true, __constructs__ : ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","Number0","Number1","Number2","Number3","Number4","Number5","Number6","Number7","Number8","Number9","Numpad0","Numpad1","Numpad2","Numpad3","Numpad4","Numpad5","Numpad6","Numpad7","Numpad8","Numpad9","NumpadAdd","NumpadDecimal","NumpadDivide","NumpadEnter","NumpadMultiply","NumpadSubtract","F1","F2","F3","F4","F5","F6","F7","F8","F9","F10","F11","F12","F13","F14","F15","Left","Up","Right","Down","Alt","Backquote","Backslash","Backspace","CapsLock","Comma","Command","Control","Delete","End","Enter","Equals","Escape","Home","Insert","LeftBracket","Minus","PageDown","PageUp","Period","Quote","RightBracket","Semicolon","Shift","Slash","Space","Tab","Menu","Search","Unknown"] };
flambe_input_Key.A = ["A",0];
flambe_input_Key.A.__enum__ = flambe_input_Key;
flambe_input_Key.B = ["B",1];
flambe_input_Key.B.__enum__ = flambe_input_Key;
flambe_input_Key.C = ["C",2];
flambe_input_Key.C.__enum__ = flambe_input_Key;
flambe_input_Key.D = ["D",3];
flambe_input_Key.D.__enum__ = flambe_input_Key;
flambe_input_Key.E = ["E",4];
flambe_input_Key.E.__enum__ = flambe_input_Key;
flambe_input_Key.F = ["F",5];
flambe_input_Key.F.__enum__ = flambe_input_Key;
flambe_input_Key.G = ["G",6];
flambe_input_Key.G.__enum__ = flambe_input_Key;
flambe_input_Key.H = ["H",7];
flambe_input_Key.H.__enum__ = flambe_input_Key;
flambe_input_Key.I = ["I",8];
flambe_input_Key.I.__enum__ = flambe_input_Key;
flambe_input_Key.J = ["J",9];
flambe_input_Key.J.__enum__ = flambe_input_Key;
flambe_input_Key.K = ["K",10];
flambe_input_Key.K.__enum__ = flambe_input_Key;
flambe_input_Key.L = ["L",11];
flambe_input_Key.L.__enum__ = flambe_input_Key;
flambe_input_Key.M = ["M",12];
flambe_input_Key.M.__enum__ = flambe_input_Key;
flambe_input_Key.N = ["N",13];
flambe_input_Key.N.__enum__ = flambe_input_Key;
flambe_input_Key.O = ["O",14];
flambe_input_Key.O.__enum__ = flambe_input_Key;
flambe_input_Key.P = ["P",15];
flambe_input_Key.P.__enum__ = flambe_input_Key;
flambe_input_Key.Q = ["Q",16];
flambe_input_Key.Q.__enum__ = flambe_input_Key;
flambe_input_Key.R = ["R",17];
flambe_input_Key.R.__enum__ = flambe_input_Key;
flambe_input_Key.S = ["S",18];
flambe_input_Key.S.__enum__ = flambe_input_Key;
flambe_input_Key.T = ["T",19];
flambe_input_Key.T.__enum__ = flambe_input_Key;
flambe_input_Key.U = ["U",20];
flambe_input_Key.U.__enum__ = flambe_input_Key;
flambe_input_Key.V = ["V",21];
flambe_input_Key.V.__enum__ = flambe_input_Key;
flambe_input_Key.W = ["W",22];
flambe_input_Key.W.__enum__ = flambe_input_Key;
flambe_input_Key.X = ["X",23];
flambe_input_Key.X.__enum__ = flambe_input_Key;
flambe_input_Key.Y = ["Y",24];
flambe_input_Key.Y.__enum__ = flambe_input_Key;
flambe_input_Key.Z = ["Z",25];
flambe_input_Key.Z.__enum__ = flambe_input_Key;
flambe_input_Key.Number0 = ["Number0",26];
flambe_input_Key.Number0.__enum__ = flambe_input_Key;
flambe_input_Key.Number1 = ["Number1",27];
flambe_input_Key.Number1.__enum__ = flambe_input_Key;
flambe_input_Key.Number2 = ["Number2",28];
flambe_input_Key.Number2.__enum__ = flambe_input_Key;
flambe_input_Key.Number3 = ["Number3",29];
flambe_input_Key.Number3.__enum__ = flambe_input_Key;
flambe_input_Key.Number4 = ["Number4",30];
flambe_input_Key.Number4.__enum__ = flambe_input_Key;
flambe_input_Key.Number5 = ["Number5",31];
flambe_input_Key.Number5.__enum__ = flambe_input_Key;
flambe_input_Key.Number6 = ["Number6",32];
flambe_input_Key.Number6.__enum__ = flambe_input_Key;
flambe_input_Key.Number7 = ["Number7",33];
flambe_input_Key.Number7.__enum__ = flambe_input_Key;
flambe_input_Key.Number8 = ["Number8",34];
flambe_input_Key.Number8.__enum__ = flambe_input_Key;
flambe_input_Key.Number9 = ["Number9",35];
flambe_input_Key.Number9.__enum__ = flambe_input_Key;
flambe_input_Key.Numpad0 = ["Numpad0",36];
flambe_input_Key.Numpad0.__enum__ = flambe_input_Key;
flambe_input_Key.Numpad1 = ["Numpad1",37];
flambe_input_Key.Numpad1.__enum__ = flambe_input_Key;
flambe_input_Key.Numpad2 = ["Numpad2",38];
flambe_input_Key.Numpad2.__enum__ = flambe_input_Key;
flambe_input_Key.Numpad3 = ["Numpad3",39];
flambe_input_Key.Numpad3.__enum__ = flambe_input_Key;
flambe_input_Key.Numpad4 = ["Numpad4",40];
flambe_input_Key.Numpad4.__enum__ = flambe_input_Key;
flambe_input_Key.Numpad5 = ["Numpad5",41];
flambe_input_Key.Numpad5.__enum__ = flambe_input_Key;
flambe_input_Key.Numpad6 = ["Numpad6",42];
flambe_input_Key.Numpad6.__enum__ = flambe_input_Key;
flambe_input_Key.Numpad7 = ["Numpad7",43];
flambe_input_Key.Numpad7.__enum__ = flambe_input_Key;
flambe_input_Key.Numpad8 = ["Numpad8",44];
flambe_input_Key.Numpad8.__enum__ = flambe_input_Key;
flambe_input_Key.Numpad9 = ["Numpad9",45];
flambe_input_Key.Numpad9.__enum__ = flambe_input_Key;
flambe_input_Key.NumpadAdd = ["NumpadAdd",46];
flambe_input_Key.NumpadAdd.__enum__ = flambe_input_Key;
flambe_input_Key.NumpadDecimal = ["NumpadDecimal",47];
flambe_input_Key.NumpadDecimal.__enum__ = flambe_input_Key;
flambe_input_Key.NumpadDivide = ["NumpadDivide",48];
flambe_input_Key.NumpadDivide.__enum__ = flambe_input_Key;
flambe_input_Key.NumpadEnter = ["NumpadEnter",49];
flambe_input_Key.NumpadEnter.__enum__ = flambe_input_Key;
flambe_input_Key.NumpadMultiply = ["NumpadMultiply",50];
flambe_input_Key.NumpadMultiply.__enum__ = flambe_input_Key;
flambe_input_Key.NumpadSubtract = ["NumpadSubtract",51];
flambe_input_Key.NumpadSubtract.__enum__ = flambe_input_Key;
flambe_input_Key.F1 = ["F1",52];
flambe_input_Key.F1.__enum__ = flambe_input_Key;
flambe_input_Key.F2 = ["F2",53];
flambe_input_Key.F2.__enum__ = flambe_input_Key;
flambe_input_Key.F3 = ["F3",54];
flambe_input_Key.F3.__enum__ = flambe_input_Key;
flambe_input_Key.F4 = ["F4",55];
flambe_input_Key.F4.__enum__ = flambe_input_Key;
flambe_input_Key.F5 = ["F5",56];
flambe_input_Key.F5.__enum__ = flambe_input_Key;
flambe_input_Key.F6 = ["F6",57];
flambe_input_Key.F6.__enum__ = flambe_input_Key;
flambe_input_Key.F7 = ["F7",58];
flambe_input_Key.F7.__enum__ = flambe_input_Key;
flambe_input_Key.F8 = ["F8",59];
flambe_input_Key.F8.__enum__ = flambe_input_Key;
flambe_input_Key.F9 = ["F9",60];
flambe_input_Key.F9.__enum__ = flambe_input_Key;
flambe_input_Key.F10 = ["F10",61];
flambe_input_Key.F10.__enum__ = flambe_input_Key;
flambe_input_Key.F11 = ["F11",62];
flambe_input_Key.F11.__enum__ = flambe_input_Key;
flambe_input_Key.F12 = ["F12",63];
flambe_input_Key.F12.__enum__ = flambe_input_Key;
flambe_input_Key.F13 = ["F13",64];
flambe_input_Key.F13.__enum__ = flambe_input_Key;
flambe_input_Key.F14 = ["F14",65];
flambe_input_Key.F14.__enum__ = flambe_input_Key;
flambe_input_Key.F15 = ["F15",66];
flambe_input_Key.F15.__enum__ = flambe_input_Key;
flambe_input_Key.Left = ["Left",67];
flambe_input_Key.Left.__enum__ = flambe_input_Key;
flambe_input_Key.Up = ["Up",68];
flambe_input_Key.Up.__enum__ = flambe_input_Key;
flambe_input_Key.Right = ["Right",69];
flambe_input_Key.Right.__enum__ = flambe_input_Key;
flambe_input_Key.Down = ["Down",70];
flambe_input_Key.Down.__enum__ = flambe_input_Key;
flambe_input_Key.Alt = ["Alt",71];
flambe_input_Key.Alt.__enum__ = flambe_input_Key;
flambe_input_Key.Backquote = ["Backquote",72];
flambe_input_Key.Backquote.__enum__ = flambe_input_Key;
flambe_input_Key.Backslash = ["Backslash",73];
flambe_input_Key.Backslash.__enum__ = flambe_input_Key;
flambe_input_Key.Backspace = ["Backspace",74];
flambe_input_Key.Backspace.__enum__ = flambe_input_Key;
flambe_input_Key.CapsLock = ["CapsLock",75];
flambe_input_Key.CapsLock.__enum__ = flambe_input_Key;
flambe_input_Key.Comma = ["Comma",76];
flambe_input_Key.Comma.__enum__ = flambe_input_Key;
flambe_input_Key.Command = ["Command",77];
flambe_input_Key.Command.__enum__ = flambe_input_Key;
flambe_input_Key.Control = ["Control",78];
flambe_input_Key.Control.__enum__ = flambe_input_Key;
flambe_input_Key.Delete = ["Delete",79];
flambe_input_Key.Delete.__enum__ = flambe_input_Key;
flambe_input_Key.End = ["End",80];
flambe_input_Key.End.__enum__ = flambe_input_Key;
flambe_input_Key.Enter = ["Enter",81];
flambe_input_Key.Enter.__enum__ = flambe_input_Key;
flambe_input_Key.Equals = ["Equals",82];
flambe_input_Key.Equals.__enum__ = flambe_input_Key;
flambe_input_Key.Escape = ["Escape",83];
flambe_input_Key.Escape.__enum__ = flambe_input_Key;
flambe_input_Key.Home = ["Home",84];
flambe_input_Key.Home.__enum__ = flambe_input_Key;
flambe_input_Key.Insert = ["Insert",85];
flambe_input_Key.Insert.__enum__ = flambe_input_Key;
flambe_input_Key.LeftBracket = ["LeftBracket",86];
flambe_input_Key.LeftBracket.__enum__ = flambe_input_Key;
flambe_input_Key.Minus = ["Minus",87];
flambe_input_Key.Minus.__enum__ = flambe_input_Key;
flambe_input_Key.PageDown = ["PageDown",88];
flambe_input_Key.PageDown.__enum__ = flambe_input_Key;
flambe_input_Key.PageUp = ["PageUp",89];
flambe_input_Key.PageUp.__enum__ = flambe_input_Key;
flambe_input_Key.Period = ["Period",90];
flambe_input_Key.Period.__enum__ = flambe_input_Key;
flambe_input_Key.Quote = ["Quote",91];
flambe_input_Key.Quote.__enum__ = flambe_input_Key;
flambe_input_Key.RightBracket = ["RightBracket",92];
flambe_input_Key.RightBracket.__enum__ = flambe_input_Key;
flambe_input_Key.Semicolon = ["Semicolon",93];
flambe_input_Key.Semicolon.__enum__ = flambe_input_Key;
flambe_input_Key.Shift = ["Shift",94];
flambe_input_Key.Shift.__enum__ = flambe_input_Key;
flambe_input_Key.Slash = ["Slash",95];
flambe_input_Key.Slash.__enum__ = flambe_input_Key;
flambe_input_Key.Space = ["Space",96];
flambe_input_Key.Space.__enum__ = flambe_input_Key;
flambe_input_Key.Tab = ["Tab",97];
flambe_input_Key.Tab.__enum__ = flambe_input_Key;
flambe_input_Key.Menu = ["Menu",98];
flambe_input_Key.Menu.__enum__ = flambe_input_Key;
flambe_input_Key.Search = ["Search",99];
flambe_input_Key.Search.__enum__ = flambe_input_Key;
flambe_input_Key.Unknown = function(keyCode) { var $x = ["Unknown",100,keyCode]; $x.__enum__ = flambe_input_Key; return $x; };
var flambe_input_KeyboardEvent = function() {
	this.init(0,null);
};
$hxClasses["flambe.input.KeyboardEvent"] = flambe_input_KeyboardEvent;
flambe_input_KeyboardEvent.__name__ = true;
flambe_input_KeyboardEvent.prototype = {
	init: function(id,key) {
		this.id = id;
		this.key = key;
	}
	,__class__: flambe_input_KeyboardEvent
};
var flambe_input_MouseButton = $hxClasses["flambe.input.MouseButton"] = { __ename__ : true, __constructs__ : ["Left","Middle","Right","Unknown"] };
flambe_input_MouseButton.Left = ["Left",0];
flambe_input_MouseButton.Left.__enum__ = flambe_input_MouseButton;
flambe_input_MouseButton.Middle = ["Middle",1];
flambe_input_MouseButton.Middle.__enum__ = flambe_input_MouseButton;
flambe_input_MouseButton.Right = ["Right",2];
flambe_input_MouseButton.Right.__enum__ = flambe_input_MouseButton;
flambe_input_MouseButton.Unknown = function(buttonCode) { var $x = ["Unknown",3,buttonCode]; $x.__enum__ = flambe_input_MouseButton; return $x; };
var flambe_input_MouseCursor = $hxClasses["flambe.input.MouseCursor"] = { __ename__ : true, __constructs__ : ["Default","Button","None"] };
flambe_input_MouseCursor.Default = ["Default",0];
flambe_input_MouseCursor.Default.__enum__ = flambe_input_MouseCursor;
flambe_input_MouseCursor.Button = ["Button",1];
flambe_input_MouseCursor.Button.__enum__ = flambe_input_MouseCursor;
flambe_input_MouseCursor.None = ["None",2];
flambe_input_MouseCursor.None.__enum__ = flambe_input_MouseCursor;
var flambe_input_MouseEvent = function() {
	this.init(0,0,0,null);
};
$hxClasses["flambe.input.MouseEvent"] = flambe_input_MouseEvent;
flambe_input_MouseEvent.__name__ = true;
flambe_input_MouseEvent.prototype = {
	init: function(id,viewX,viewY,button) {
		this.id = id;
		this.viewX = viewX;
		this.viewY = viewY;
		this.button = button;
	}
	,__class__: flambe_input_MouseEvent
};
var flambe_input_EventSource = $hxClasses["flambe.input.EventSource"] = { __ename__ : true, __constructs__ : ["Mouse","Touch"] };
flambe_input_EventSource.Mouse = function(event) { var $x = ["Mouse",0,event]; $x.__enum__ = flambe_input_EventSource; return $x; };
flambe_input_EventSource.Touch = function(point) { var $x = ["Touch",1,point]; $x.__enum__ = flambe_input_EventSource; return $x; };
var flambe_input_PointerEvent = function() {
	this.init(0,0,0,null,null);
};
$hxClasses["flambe.input.PointerEvent"] = flambe_input_PointerEvent;
flambe_input_PointerEvent.__name__ = true;
flambe_input_PointerEvent.prototype = {
	init: function(id,viewX,viewY,hit,source) {
		this.id = id;
		this.viewX = viewX;
		this.viewY = viewY;
		this.hit = hit;
		this.source = source;
		this._stopped = false;
	}
	,__class__: flambe_input_PointerEvent
};
var flambe_input_TouchPoint = function(id) {
	this.id = id;
	this._source = flambe_input_EventSource.Touch(this);
};
$hxClasses["flambe.input.TouchPoint"] = flambe_input_TouchPoint;
flambe_input_TouchPoint.__name__ = true;
flambe_input_TouchPoint.prototype = {
	init: function(viewX,viewY) {
		this.viewX = viewX;
		this.viewY = viewY;
	}
	,__class__: flambe_input_TouchPoint
};
var flambe_math_FMath = function() { };
$hxClasses["flambe.math.FMath"] = flambe_math_FMath;
flambe_math_FMath.__name__ = true;
flambe_math_FMath.toRadians = function(degrees) {
	return degrees * 3.141592653589793 / 180;
};
flambe_math_FMath.max = function(a,b) {
	if(a > b) return a; else return b;
};
flambe_math_FMath.min = function(a,b) {
	if(a < b) return a; else return b;
};
var flambe_math_Matrix = function() {
	this.identity();
};
$hxClasses["flambe.math.Matrix"] = flambe_math_Matrix;
flambe_math_Matrix.__name__ = true;
flambe_math_Matrix.multiply = function(lhs,rhs,result) {
	if(result == null) result = new flambe_math_Matrix();
	var a = lhs.m00 * rhs.m00 + lhs.m01 * rhs.m10;
	var b = lhs.m00 * rhs.m01 + lhs.m01 * rhs.m11;
	var c = lhs.m00 * rhs.m02 + lhs.m01 * rhs.m12 + lhs.m02;
	result.m00 = a;
	result.m01 = b;
	result.m02 = c;
	a = lhs.m10 * rhs.m00 + lhs.m11 * rhs.m10;
	b = lhs.m10 * rhs.m01 + lhs.m11 * rhs.m11;
	c = lhs.m10 * rhs.m02 + lhs.m11 * rhs.m12 + lhs.m12;
	result.m10 = a;
	result.m11 = b;
	result.m12 = c;
	return result;
};
flambe_math_Matrix.prototype = {
	set: function(m00,m10,m01,m11,m02,m12) {
		this.m00 = m00;
		this.m01 = m01;
		this.m02 = m02;
		this.m10 = m10;
		this.m11 = m11;
		this.m12 = m12;
	}
	,identity: function() {
		this.set(1,0,0,1,0,0);
	}
	,compose: function(x,y,scaleX,scaleY,rotation) {
		var sin = Math.sin(rotation);
		var cos = Math.cos(rotation);
		this.set(cos * scaleX,sin * scaleX,-sin * scaleY,cos * scaleY,x,y);
	}
	,translate: function(x,y) {
		this.m02 += this.m00 * x + this.m01 * y;
		this.m12 += this.m11 * y + this.m10 * x;
	}
	,invert: function() {
		var det = this.determinant();
		if(det == 0) return false;
		this.set(this.m11 / det,-this.m01 / det,-this.m10 / det,this.m00 / det,(this.m01 * this.m12 - this.m11 * this.m02) / det,(this.m10 * this.m02 - this.m00 * this.m12) / det);
		return true;
	}
	,transformArray: function(points,length,result) {
		var ii = 0;
		while(ii < length) {
			var x = points[ii];
			var y = points[ii + 1];
			result[ii++] = x * this.m00 + y * this.m01 + this.m02;
			result[ii++] = x * this.m10 + y * this.m11 + this.m12;
		}
	}
	,determinant: function() {
		return this.m00 * this.m11 - this.m01 * this.m10;
	}
	,inverseTransform: function(x,y,result) {
		var det = this.determinant();
		if(det == 0) return false;
		x -= this.m02;
		y -= this.m12;
		result.x = (x * this.m11 - y * this.m01) / det;
		result.y = (y * this.m00 - x * this.m10) / det;
		return true;
	}
	,clone: function(result) {
		if(result == null) result = new flambe_math_Matrix();
		result.set(this.m00,this.m10,this.m01,this.m11,this.m02,this.m12);
		return result;
	}
	,toString: function() {
		return this.m00 + " " + this.m01 + " " + this.m02 + " \\ " + this.m10 + " " + this.m11 + " " + this.m12;
	}
	,__class__: flambe_math_Matrix
};
var flambe_math_Rectangle = function(x,y,width,height) {
	if(height == null) height = 0;
	if(width == null) width = 0;
	if(y == null) y = 0;
	if(x == null) x = 0;
	this.set(x,y,width,height);
};
$hxClasses["flambe.math.Rectangle"] = flambe_math_Rectangle;
flambe_math_Rectangle.__name__ = true;
flambe_math_Rectangle.prototype = {
	set: function(x,y,width,height) {
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	}
	,contains: function(x,y) {
		x -= this.x;
		if(this.width >= 0) {
			if(x < 0 || x > this.width) return false;
		} else if(x > 0 || x < this.width) return false;
		y -= this.y;
		if(this.height >= 0) {
			if(y < 0 || y > this.height) return false;
		} else if(y > 0 || y < this.height) return false;
		return true;
	}
	,clone: function(result) {
		if(result == null) result = new flambe_math_Rectangle();
		result.set(this.x,this.y,this.width,this.height);
		return result;
	}
	,equals: function(other) {
		return this.x == other.x && this.y == other.y && this.width == other.width && this.height == other.height;
	}
	,toString: function() {
		return "(" + this.x + "," + this.y + " " + this.width + "x" + this.height + ")";
	}
	,__class__: flambe_math_Rectangle
};
var flambe_platform_BasicAsset = function() {
	this._reloadCount = null;
	this._disposed = false;
};
$hxClasses["flambe.platform.BasicAsset"] = flambe_platform_BasicAsset;
flambe_platform_BasicAsset.__name__ = true;
flambe_platform_BasicAsset.__interfaces__ = [flambe_asset_Asset];
flambe_platform_BasicAsset.prototype = {
	assertNotDisposed: function() {
		flambe_util_Assert.that(!this._disposed,"Asset cannot be used after being disposed");
	}
	,reload: function(asset) {
		this.copyFrom(asset);
		var _g = this.get_reloadCount();
		_g.set__(_g.get__() + 1);
	}
	,dispose: function() {
		if(!this._disposed) {
			this._disposed = true;
			this.onDisposed();
		}
	}
	,copyFrom: function(asset) {
		flambe_util_Assert.fail();
	}
	,onDisposed: function() {
		flambe_util_Assert.fail();
	}
	,get_reloadCount: function() {
		if(this._reloadCount == null) this._reloadCount = new flambe_util_Value(0);
		return this._reloadCount;
	}
	,__class__: flambe_platform_BasicAsset
};
var flambe_platform_BasicAssetPackLoader = function(platform,manifest) {
	var _g = this;
	this.manifest = manifest;
	this._platform = platform;
	this.promise = new flambe_util_Promise();
	this._bytesLoaded = new haxe_ds_StringMap();
	this._pack = new flambe_platform__$BasicAssetPackLoader_BasicAssetPack(manifest,this);
	var entries = Lambda.array(manifest);
	if(entries.length == 0) this.handleSuccess(); else {
		var groups = new haxe_ds_StringMap();
		var _g1 = 0;
		while(_g1 < entries.length) {
			var entry = entries[_g1];
			++_g1;
			var group = groups.get(entry.name);
			if(group == null) {
				group = [];
				groups.set(entry.name,group);
			}
			group.push(entry);
		}
		this._assetsRemaining = Lambda.count(groups);
		var $it0 = groups.iterator();
		while( $it0.hasNext() ) {
			var group1 = $it0.next();
			var group2 = [group1];
			this.pickBestEntry(group2[0],(function(group2) {
				return function(bestEntry) {
					if(bestEntry != null) {
						var url = manifest.getFullURL(bestEntry);
						try {
							_g.loadEntry(url,bestEntry);
						} catch( error ) {
							_g.handleError(bestEntry,"Unexpected error: " + Std.string(error));
						}
						var _g11 = _g.promise;
						_g11.set_total(_g11.get_total() + bestEntry.bytes);
					} else {
						var badEntry = group2[0][0];
						if(flambe_platform_BasicAssetPackLoader.isAudio(badEntry.format)) {
							flambe_Log.warn("Could not find a supported audio format to load",["name",badEntry.name]);
							_g.handleLoad(badEntry,flambe_platform_DummySound.getInstance());
						} else _g.handleError(badEntry,"Could not find a supported format to load");
					}
				};
			})(group2));
		}
	}
	var catapult = this._platform.getCatapultClient();
	if(catapult != null) catapult.add(this);
};
$hxClasses["flambe.platform.BasicAssetPackLoader"] = flambe_platform_BasicAssetPackLoader;
flambe_platform_BasicAssetPackLoader.__name__ = true;
flambe_platform_BasicAssetPackLoader.removeUrlParams = function(url) {
	var query = url.indexOf("?");
	if(query > 0) return HxOverrides.substr(url,0,query); else return url;
};
flambe_platform_BasicAssetPackLoader.isAudio = function(format) {
	switch(Type.enumIndex(format)) {
	case 8:case 9:case 10:case 11:case 12:
		return true;
	default:
		return false;
	}
};
flambe_platform_BasicAssetPackLoader.prototype = {
	reload: function(url) {
		var _g = this;
		var baseUrl = flambe_platform_BasicAssetPackLoader.removeUrlParams(url);
		var foundEntry = null;
		var $it0 = this.manifest.iterator();
		while( $it0.hasNext() ) {
			var entry = $it0.next();
			if(baseUrl == flambe_platform_BasicAssetPackLoader.removeUrlParams(entry.url)) {
				foundEntry = entry;
				break;
			}
		}
		if(foundEntry != null) this.getAssetFormats(function(formats) {
			if(formats.indexOf(foundEntry.format) >= 0) {
				var entry1 = new flambe_asset_AssetEntry(foundEntry.name,url,foundEntry.format,0);
				_g.loadEntry(_g.manifest.getFullURL(entry1),entry1);
			}
		});
	}
	,onDisposed: function() {
		var catapult = this._platform.getCatapultClient();
		if(catapult != null) catapult.remove(this);
	}
	,pickBestEntry: function(entries,fn) {
		var onFormatsAvailable = function(formats) {
			var _g = 0;
			while(_g < formats.length) {
				var format = formats[_g];
				++_g;
				var _g1 = 0;
				while(_g1 < entries.length) {
					var entry = entries[_g1];
					++_g1;
					if(entry.format == format) {
						fn(entry);
						return;
					}
				}
			}
			fn(null);
		};
		this.getAssetFormats(onFormatsAvailable);
	}
	,loadEntry: function(url,entry) {
		flambe_util_Assert.fail();
	}
	,getAssetFormats: function(fn) {
		flambe_util_Assert.fail();
	}
	,handleLoad: function(entry,asset) {
		if(this._pack.disposed) return;
		this.handleProgress(entry,entry.bytes);
		var map;
		var _g = entry.format;
		switch(Type.enumIndex(_g)) {
		case 0:case 1:case 2:case 3:case 4:case 5:case 6:case 7:
			map = this._pack.textures;
			break;
		case 8:case 9:case 10:case 11:case 12:
			map = this._pack.sounds;
			break;
		case 13:
			map = this._pack.files;
			break;
		}
		var oldAsset = map.get(entry.name);
		if(oldAsset != null) {
			flambe_Log.info("Reloaded asset",["url",entry.url]);
			oldAsset.reload(asset);
		} else {
			map.set(entry.name,asset);
			this._assetsRemaining -= 1;
			if(this._assetsRemaining == 0) this.handleSuccess();
		}
	}
	,handleProgress: function(entry,bytesLoaded) {
		this._bytesLoaded.set(entry.name,bytesLoaded);
		var bytesTotal = 0;
		var $it0 = this._bytesLoaded.iterator();
		while( $it0.hasNext() ) {
			var bytes = $it0.next();
			bytesTotal += bytes;
		}
		this.promise.set_progress(bytesTotal);
	}
	,handleSuccess: function() {
		this.promise.set_result(this._pack);
	}
	,handleError: function(entry,message) {
		flambe_Log.warn("Error loading asset pack",["error",message,"url",entry.url]);
		this.promise.error.emit(flambe_util_Strings.withFields(message,["url",entry.url]));
	}
	,handleTextureError: function(entry) {
		this.handleError(entry,"Failed to create texture. Is the GPU context unavailable?");
	}
	,__class__: flambe_platform_BasicAssetPackLoader
};
var flambe_platform__$BasicAssetPackLoader_BasicAssetPack = function(manifest,loader) {
	this.disposed = false;
	this._manifest = manifest;
	this.loader = loader;
	this.textures = new haxe_ds_StringMap();
	this.sounds = new haxe_ds_StringMap();
	this.files = new haxe_ds_StringMap();
};
$hxClasses["flambe.platform._BasicAssetPackLoader.BasicAssetPack"] = flambe_platform__$BasicAssetPackLoader_BasicAssetPack;
flambe_platform__$BasicAssetPackLoader_BasicAssetPack.__name__ = true;
flambe_platform__$BasicAssetPackLoader_BasicAssetPack.__interfaces__ = [flambe_asset_AssetPack];
flambe_platform__$BasicAssetPackLoader_BasicAssetPack.warnOnExtension = function(path) {
	var ext = flambe_util_Strings.getFileExtension(path);
	if(ext != null && ext.length == 3) flambe_Log.warn("Requested asset \"" + path + "\" should not have a file extension," + " did you mean \"" + flambe_util_Strings.removeFileExtension(path) + "\"?");
};
flambe_platform__$BasicAssetPackLoader_BasicAssetPack.prototype = {
	getTexture: function(name,required) {
		if(required == null) required = true;
		this.assertNotDisposed();
		flambe_platform__$BasicAssetPackLoader_BasicAssetPack.warnOnExtension(name);
		var texture = this.textures.get(name);
		if(texture == null && required) throw flambe_util_Strings.withFields("Missing texture",["name",name]);
		return texture;
	}
	,getSound: function(name,required) {
		if(required == null) required = true;
		this.assertNotDisposed();
		flambe_platform__$BasicAssetPackLoader_BasicAssetPack.warnOnExtension(name);
		var sound = this.sounds.get(name);
		if(sound == null && required) throw flambe_util_Strings.withFields("Missing sound",["name",name]);
		return sound;
	}
	,getFile: function(name,required) {
		if(required == null) required = true;
		this.assertNotDisposed();
		var file = this.files.get(name);
		if(file == null && required) throw flambe_util_Strings.withFields("Missing file",["name",name]);
		return file;
	}
	,dispose: function() {
		if(!this.disposed) {
			this.disposed = true;
			var $it0 = this.textures.iterator();
			while( $it0.hasNext() ) {
				var texture = $it0.next();
				texture.dispose();
			}
			this.textures = null;
			var $it1 = this.sounds.iterator();
			while( $it1.hasNext() ) {
				var sound = $it1.next();
				sound.dispose();
			}
			this.sounds = null;
			var $it2 = this.files.iterator();
			while( $it2.hasNext() ) {
				var file = $it2.next();
				file.dispose();
			}
			this.files = null;
			this.loader.onDisposed();
		}
	}
	,assertNotDisposed: function() {
		flambe_util_Assert.that(!this.disposed,"AssetPack cannot be used after being disposed");
	}
	,__class__: flambe_platform__$BasicAssetPackLoader_BasicAssetPack
};
var flambe_platform_BasicFile = function(content) {
	flambe_platform_BasicAsset.call(this);
	this._content = content;
};
$hxClasses["flambe.platform.BasicFile"] = flambe_platform_BasicFile;
flambe_platform_BasicFile.__name__ = true;
flambe_platform_BasicFile.__interfaces__ = [flambe_asset_File];
flambe_platform_BasicFile.__super__ = flambe_platform_BasicAsset;
flambe_platform_BasicFile.prototype = $extend(flambe_platform_BasicAsset.prototype,{
	toString: function() {
		this.assertNotDisposed();
		return this._content;
	}
	,copyFrom: function(that) {
		this._content = that._content;
	}
	,onDisposed: function() {
		this._content = null;
	}
	,__class__: flambe_platform_BasicFile
});
var flambe_subsystem_KeyboardSystem = function() { };
$hxClasses["flambe.subsystem.KeyboardSystem"] = flambe_subsystem_KeyboardSystem;
flambe_subsystem_KeyboardSystem.__name__ = true;
flambe_subsystem_KeyboardSystem.prototype = {
	__class__: flambe_subsystem_KeyboardSystem
};
var flambe_platform_BasicKeyboard = function() {
	this.down = new flambe_util_Signal1();
	this.up = new flambe_util_Signal1();
	this.backButton = new flambe_util_Signal0();
	this._keyStates = new haxe_ds_IntMap();
};
$hxClasses["flambe.platform.BasicKeyboard"] = flambe_platform_BasicKeyboard;
flambe_platform_BasicKeyboard.__name__ = true;
flambe_platform_BasicKeyboard.__interfaces__ = [flambe_subsystem_KeyboardSystem];
flambe_platform_BasicKeyboard.prototype = {
	isDown: function(key) {
		return this.isCodeDown(flambe_platform_KeyCodes.toKeyCode(key));
	}
	,isCodeDown: function(keyCode) {
		return this._keyStates.exists(keyCode);
	}
	,submitDown: function(keyCode) {
		if(keyCode == 16777238) {
			if(this.backButton.hasListeners()) {
				this.backButton.emit();
				return true;
			}
			return false;
		}
		if(!this.isCodeDown(keyCode)) {
			this._keyStates.set(keyCode,true);
			flambe_platform_BasicKeyboard._sharedEvent.init(flambe_platform_BasicKeyboard._sharedEvent.id + 1,flambe_platform_KeyCodes.toKey(keyCode));
			this.down.emit(flambe_platform_BasicKeyboard._sharedEvent);
		}
		return true;
	}
	,submitUp: function(keyCode) {
		if(this.isCodeDown(keyCode)) {
			this._keyStates.remove(keyCode);
			flambe_platform_BasicKeyboard._sharedEvent.init(flambe_platform_BasicKeyboard._sharedEvent.id + 1,flambe_platform_KeyCodes.toKey(keyCode));
			this.up.emit(flambe_platform_BasicKeyboard._sharedEvent);
		}
	}
	,__class__: flambe_platform_BasicKeyboard
};
var flambe_subsystem_MouseSystem = function() { };
$hxClasses["flambe.subsystem.MouseSystem"] = flambe_subsystem_MouseSystem;
flambe_subsystem_MouseSystem.__name__ = true;
flambe_subsystem_MouseSystem.prototype = {
	__class__: flambe_subsystem_MouseSystem
};
var flambe_platform_BasicMouse = function(pointer) {
	this._pointer = pointer;
	this._source = flambe_input_EventSource.Mouse(flambe_platform_BasicMouse._sharedEvent);
	this.down = new flambe_util_Signal1();
	this.move = new flambe_util_Signal1();
	this.up = new flambe_util_Signal1();
	this.scroll = new flambe_util_Signal1();
	this._x = 0;
	this._y = 0;
	this._cursor = flambe_input_MouseCursor.Default;
	this._buttonStates = new haxe_ds_IntMap();
};
$hxClasses["flambe.platform.BasicMouse"] = flambe_platform_BasicMouse;
flambe_platform_BasicMouse.__name__ = true;
flambe_platform_BasicMouse.__interfaces__ = [flambe_subsystem_MouseSystem];
flambe_platform_BasicMouse.prototype = {
	set_cursor: function(cursor) {
		return this._cursor = cursor;
	}
	,submitDown: function(viewX,viewY,buttonCode) {
		if(!this.isCodeDown(buttonCode)) {
			this._buttonStates.set(buttonCode,true);
			this.prepare(viewX,viewY,flambe_platform_MouseCodes.toButton(buttonCode));
			this._pointer.submitDown(viewX,viewY,this._source);
			this.down.emit(flambe_platform_BasicMouse._sharedEvent);
		}
	}
	,submitMove: function(viewX,viewY) {
		this.prepare(viewX,viewY,null);
		this._pointer.submitMove(viewX,viewY,this._source);
		this.move.emit(flambe_platform_BasicMouse._sharedEvent);
	}
	,submitUp: function(viewX,viewY,buttonCode) {
		if(this.isCodeDown(buttonCode)) {
			this._buttonStates.remove(buttonCode);
			this.prepare(viewX,viewY,flambe_platform_MouseCodes.toButton(buttonCode));
			this._pointer.submitUp(viewX,viewY,this._source);
			this.up.emit(flambe_platform_BasicMouse._sharedEvent);
		}
	}
	,submitScroll: function(viewX,viewY,velocity) {
		this._x = viewX;
		this._y = viewY;
		if(!this.scroll.hasListeners()) return false;
		this.scroll.emit(velocity);
		return true;
	}
	,isCodeDown: function(buttonCode) {
		return this._buttonStates.exists(buttonCode);
	}
	,prepare: function(viewX,viewY,button) {
		this._x = viewX;
		this._y = viewY;
		flambe_platform_BasicMouse._sharedEvent.init(flambe_platform_BasicMouse._sharedEvent.id + 1,viewX,viewY,button);
	}
	,__class__: flambe_platform_BasicMouse
};
var flambe_subsystem_PointerSystem = function() { };
$hxClasses["flambe.subsystem.PointerSystem"] = flambe_subsystem_PointerSystem;
flambe_subsystem_PointerSystem.__name__ = true;
flambe_subsystem_PointerSystem.prototype = {
	__class__: flambe_subsystem_PointerSystem
};
var flambe_platform_BasicPointer = function(x,y,isDown) {
	if(isDown == null) isDown = false;
	if(y == null) y = 0;
	if(x == null) x = 0;
	this.down = new flambe_util_Signal1();
	this.move = new flambe_util_Signal1();
	this.up = new flambe_util_Signal1();
	this._x = x;
	this._y = y;
	this._isDown = isDown;
};
$hxClasses["flambe.platform.BasicPointer"] = flambe_platform_BasicPointer;
flambe_platform_BasicPointer.__name__ = true;
flambe_platform_BasicPointer.__interfaces__ = [flambe_subsystem_PointerSystem];
flambe_platform_BasicPointer.prototype = {
	submitDown: function(viewX,viewY,source) {
		if(this._isDown) return;
		this.submitMove(viewX,viewY,source);
		this._isDown = true;
		var chain = [];
		var hit = flambe_display_Sprite.hitTest(flambe_System.root,viewX,viewY);
		if(hit != null) {
			var entity = hit.owner;
			do {
				var sprite = entity.getComponent("Sprite_4");
				if(sprite != null) chain.push(sprite);
				entity = entity.parent;
			} while(entity != null);
		}
		this.prepare(viewX,viewY,hit,source);
		var _g = 0;
		while(_g < chain.length) {
			var sprite1 = chain[_g];
			++_g;
			sprite1.onPointerDown(flambe_platform_BasicPointer._sharedEvent);
			if(flambe_platform_BasicPointer._sharedEvent._stopped) return;
		}
		this.down.emit(flambe_platform_BasicPointer._sharedEvent);
	}
	,submitMove: function(viewX,viewY,source) {
		if(viewX == this._x && viewY == this._y) return;
		var chain = [];
		var hit = flambe_display_Sprite.hitTest(flambe_System.root,viewX,viewY);
		if(hit != null) {
			var entity = hit.owner;
			do {
				var sprite = entity.getComponent("Sprite_4");
				if(sprite != null) chain.push(sprite);
				entity = entity.parent;
			} while(entity != null);
		}
		this.prepare(viewX,viewY,hit,source);
		var _g = 0;
		while(_g < chain.length) {
			var sprite1 = chain[_g];
			++_g;
			sprite1.onPointerMove(flambe_platform_BasicPointer._sharedEvent);
			if(flambe_platform_BasicPointer._sharedEvent._stopped) return;
		}
		this.move.emit(flambe_platform_BasicPointer._sharedEvent);
	}
	,submitUp: function(viewX,viewY,source) {
		if(!this._isDown) return;
		this.submitMove(viewX,viewY,source);
		this._isDown = false;
		var chain = [];
		var hit = flambe_display_Sprite.hitTest(flambe_System.root,viewX,viewY);
		if(hit != null) {
			var entity = hit.owner;
			do {
				var sprite = entity.getComponent("Sprite_4");
				if(sprite != null) chain.push(sprite);
				entity = entity.parent;
			} while(entity != null);
		}
		this.prepare(viewX,viewY,hit,source);
		var _g = 0;
		while(_g < chain.length) {
			var sprite1 = chain[_g];
			++_g;
			sprite1.onPointerUp(flambe_platform_BasicPointer._sharedEvent);
			if(flambe_platform_BasicPointer._sharedEvent._stopped) return;
		}
		this.up.emit(flambe_platform_BasicPointer._sharedEvent);
	}
	,prepare: function(viewX,viewY,hit,source) {
		this._x = viewX;
		this._y = viewY;
		flambe_platform_BasicPointer._sharedEvent.init(flambe_platform_BasicPointer._sharedEvent.id + 1,viewX,viewY,hit,source);
	}
	,__class__: flambe_platform_BasicPointer
};
var flambe_platform_BasicTexture = function(root,width,height) {
	this._y = 0;
	this._x = 0;
	this._parent = null;
	this.rootY = 0;
	this.rootX = 0;
	flambe_platform_BasicAsset.call(this);
	this.root = root;
	this._width = width;
	this._height = height;
};
$hxClasses["flambe.platform.BasicTexture"] = flambe_platform_BasicTexture;
flambe_platform_BasicTexture.__name__ = true;
flambe_platform_BasicTexture.__interfaces__ = [flambe_display_SubTexture];
flambe_platform_BasicTexture.__super__ = flambe_platform_BasicAsset;
flambe_platform_BasicTexture.prototype = $extend(flambe_platform_BasicAsset.prototype,{
	copyFrom: function(that) {
		this.root.copyFrom(that.root);
		this._width = that._width;
		this._height = that._height;
		flambe_util_Assert.that(this.rootX == that.rootX && this.rootY == that.rootY && this._x == that._x && this._y == that._y);
	}
	,onDisposed: function() {
		if(this._parent == null) this.root.dispose();
	}
	,get_reloadCount: function() {
		return this.root.get_reloadCount();
	}
	,get_width: function() {
		return this._width;
	}
	,get_height: function() {
		return this._height;
	}
	,__class__: flambe_platform_BasicTexture
});
var flambe_subsystem_TouchSystem = function() { };
$hxClasses["flambe.subsystem.TouchSystem"] = flambe_subsystem_TouchSystem;
flambe_subsystem_TouchSystem.__name__ = true;
flambe_subsystem_TouchSystem.prototype = {
	__class__: flambe_subsystem_TouchSystem
};
var flambe_platform_BasicTouch = function(pointer,maxPoints) {
	if(maxPoints == null) maxPoints = 4;
	this._pointer = pointer;
	this._maxPoints = maxPoints;
	this._pointMap = new haxe_ds_IntMap();
	this._points = [];
	this.down = new flambe_util_Signal1();
	this.move = new flambe_util_Signal1();
	this.up = new flambe_util_Signal1();
};
$hxClasses["flambe.platform.BasicTouch"] = flambe_platform_BasicTouch;
flambe_platform_BasicTouch.__name__ = true;
flambe_platform_BasicTouch.__interfaces__ = [flambe_subsystem_TouchSystem];
flambe_platform_BasicTouch.prototype = {
	get_supported: function() {
		return true;
	}
	,submitDown: function(id,viewX,viewY) {
		if(!this._pointMap.exists(id)) {
			var point = new flambe_input_TouchPoint(id);
			point.init(viewX,viewY);
			this._pointMap.set(id,point);
			this._points.push(point);
			if(this._pointerTouch == null) {
				this._pointerTouch = point;
				this._pointer.submitDown(viewX,viewY,point._source);
			}
			this.down.emit(point);
		}
	}
	,submitMove: function(id,viewX,viewY) {
		var point = this._pointMap.get(id);
		if(point != null) {
			point.init(viewX,viewY);
			if(this._pointerTouch == point) this._pointer.submitMove(viewX,viewY,point._source);
			this.move.emit(point);
		}
	}
	,submitUp: function(id,viewX,viewY) {
		var point = this._pointMap.get(id);
		if(point != null) {
			point.init(viewX,viewY);
			this._pointMap.remove(id);
			HxOverrides.remove(this._points,point);
			if(this._pointerTouch == point) {
				this._pointerTouch = null;
				this._pointer.submitUp(viewX,viewY,point._source);
			}
			this.up.emit(point);
		}
	}
	,__class__: flambe_platform_BasicTouch
};
var flambe_platform_CatapultClient = function() {
	this._loaders = [];
};
$hxClasses["flambe.platform.CatapultClient"] = flambe_platform_CatapultClient;
flambe_platform_CatapultClient.__name__ = true;
flambe_platform_CatapultClient.prototype = {
	add: function(loader) {
		if(loader.manifest.get_localBase() == "assets") this._loaders.push(loader);
	}
	,remove: function(loader) {
		HxOverrides.remove(this._loaders,loader);
	}
	,onError: function(cause) {
		flambe_Log.warn("Unable to connect to Catapult",["cause",cause]);
	}
	,onMessage: function(message) {
		var message1 = JSON.parse(message);
		var _g = message1.type;
		switch(_g) {
		case "file_changed":
			var url = message1.name + "?v=" + message1.md5;
			url = StringTools.replace(url,"\\","/");
			var _g1 = 0;
			var _g2 = this._loaders;
			while(_g1 < _g2.length) {
				var loader = _g2[_g1];
				++_g1;
				loader.reload(url);
			}
			break;
		case "restart":
			this.onRestart();
			break;
		}
	}
	,onRestart: function() {
		flambe_util_Assert.fail();
	}
	,__class__: flambe_platform_CatapultClient
};
var flambe_platform_DebugLogic = function(platform) {
	var _g = this;
	this._platform = platform;
	platform.getKeyboard().down.connect(function(event) {
		if(event.key == flambe_input_Key.O && platform.getKeyboard().isDown(flambe_input_Key.Control)) {
			if(_g.toggleOverdrawGraphics()) flambe_Log.info("Enabled overdraw visualizer, press Ctrl-O again to disable");
		}
	});
};
$hxClasses["flambe.platform.DebugLogic"] = flambe_platform_DebugLogic;
flambe_platform_DebugLogic.__name__ = true;
flambe_platform_DebugLogic.prototype = {
	toggleOverdrawGraphics: function() {
		var renderer = this._platform.getRenderer();
		if(this._savedGraphics != null) {
			renderer.graphics = this._savedGraphics;
			this._savedGraphics = null;
		} else if(renderer.graphics != null) {
			this._savedGraphics = renderer.graphics;
			renderer.graphics = new flambe_platform_OverdrawGraphics(this._savedGraphics);
			return true;
		}
		return false;
	}
	,__class__: flambe_platform_DebugLogic
};
var flambe_sound_Sound = function() { };
$hxClasses["flambe.sound.Sound"] = flambe_sound_Sound;
flambe_sound_Sound.__name__ = true;
flambe_sound_Sound.__interfaces__ = [flambe_asset_Asset];
flambe_sound_Sound.prototype = {
	__class__: flambe_sound_Sound
};
var flambe_platform_DummySound = function() {
	flambe_platform_BasicAsset.call(this);
	this._playback = new flambe_platform_DummyPlayback(this);
};
$hxClasses["flambe.platform.DummySound"] = flambe_platform_DummySound;
flambe_platform_DummySound.__name__ = true;
flambe_platform_DummySound.__interfaces__ = [flambe_sound_Sound];
flambe_platform_DummySound.getInstance = function() {
	if(flambe_platform_DummySound._instance == null) flambe_platform_DummySound._instance = new flambe_platform_DummySound();
	return flambe_platform_DummySound._instance;
};
flambe_platform_DummySound.__super__ = flambe_platform_BasicAsset;
flambe_platform_DummySound.prototype = $extend(flambe_platform_BasicAsset.prototype,{
	play: function(volume) {
		if(volume == null) volume = 1.0;
		return this._playback;
	}
	,loop: function(volume) {
		if(volume == null) volume = 1.0;
		return this._playback;
	}
	,copyFrom: function(asset) {
	}
	,onDisposed: function() {
	}
	,__class__: flambe_platform_DummySound
});
var flambe_sound_Playback = function() { };
$hxClasses["flambe.sound.Playback"] = flambe_sound_Playback;
flambe_sound_Playback.__name__ = true;
flambe_sound_Playback.__interfaces__ = [flambe_util_Disposable];
flambe_sound_Playback.prototype = {
	__class__: flambe_sound_Playback
};
var flambe_platform_DummyPlayback = function(sound) {
	this._sound = sound;
	this.volume = new flambe_animation_AnimatedFloat(0);
	this._complete = new flambe_util_Value(true);
};
$hxClasses["flambe.platform.DummyPlayback"] = flambe_platform_DummyPlayback;
flambe_platform_DummyPlayback.__name__ = true;
flambe_platform_DummyPlayback.__interfaces__ = [flambe_sound_Playback];
flambe_platform_DummyPlayback.prototype = {
	dispose: function() {
	}
	,__class__: flambe_platform_DummyPlayback
};
var flambe_platform_DummyTouch = function() {
	this.down = new flambe_util_Signal1();
	this.move = new flambe_util_Signal1();
	this.up = new flambe_util_Signal1();
};
$hxClasses["flambe.platform.DummyTouch"] = flambe_platform_DummyTouch;
flambe_platform_DummyTouch.__name__ = true;
flambe_platform_DummyTouch.__interfaces__ = [flambe_subsystem_TouchSystem];
flambe_platform_DummyTouch.prototype = {
	get_supported: function() {
		return false;
	}
	,__class__: flambe_platform_DummyTouch
};
var flambe_platform_EventGroup = function() {
	this._entries = [];
};
$hxClasses["flambe.platform.EventGroup"] = flambe_platform_EventGroup;
flambe_platform_EventGroup.__name__ = true;
flambe_platform_EventGroup.__interfaces__ = [flambe_util_Disposable];
flambe_platform_EventGroup.prototype = {
	addListener: function(dispatcher,type,listener) {
		dispatcher.addEventListener(type,listener,false);
		this._entries.push(new flambe_platform__$EventGroup_Entry(dispatcher,type,listener));
	}
	,addDisposingListener: function(dispatcher,type,listener) {
		var _g = this;
		this.addListener(dispatcher,type,function(event) {
			_g.dispose();
			listener(event);
		});
	}
	,dispose: function() {
		var _g = 0;
		var _g1 = this._entries;
		while(_g < _g1.length) {
			var entry = _g1[_g];
			++_g;
			entry.dispatcher.removeEventListener(entry.type,entry.listener,false);
		}
		this._entries = [];
	}
	,__class__: flambe_platform_EventGroup
};
var flambe_platform__$EventGroup_Entry = function(dispatcher,type,listener) {
	this.dispatcher = dispatcher;
	this.type = type;
	this.listener = listener;
};
$hxClasses["flambe.platform._EventGroup.Entry"] = flambe_platform__$EventGroup_Entry;
flambe_platform__$EventGroup_Entry.__name__ = true;
flambe_platform__$EventGroup_Entry.prototype = {
	__class__: flambe_platform__$EventGroup_Entry
};
var flambe_platform_HeavySignal1 = function(listener) {
	flambe_util_Signal1.call(this,listener);
	this.hasListenersValue = new flambe_util_Value(this.hasListeners());
};
$hxClasses["flambe.platform.HeavySignal1"] = flambe_platform_HeavySignal1;
flambe_platform_HeavySignal1.__name__ = true;
flambe_platform_HeavySignal1.__super__ = flambe_util_Signal1;
flambe_platform_HeavySignal1.prototype = $extend(flambe_util_Signal1.prototype,{
	connect: function(listener,prioritize) {
		if(prioritize == null) prioritize = false;
		var connection = flambe_util_Signal1.prototype.connect.call(this,listener,prioritize);
		this.hasListenersValue.set__(this.hasListeners());
		return connection;
	}
	,disconnect: function(conn) {
		flambe_util_Signal1.prototype.disconnect.call(this,conn);
		this.hasListenersValue.set__(this.hasListeners());
	}
	,didEmit: function(head) {
		flambe_util_Signal1.prototype.didEmit.call(this,head);
		this.hasListenersValue.set__(this.hasListeners());
	}
	,__class__: flambe_platform_HeavySignal1
});
var flambe_platform_InternalGraphics = function() { };
$hxClasses["flambe.platform.InternalGraphics"] = flambe_platform_InternalGraphics;
flambe_platform_InternalGraphics.__name__ = true;
flambe_platform_InternalGraphics.__interfaces__ = [flambe_display_Graphics];
flambe_platform_InternalGraphics.prototype = {
	__class__: flambe_platform_InternalGraphics
};
var flambe_subsystem_RendererSystem = function() { };
$hxClasses["flambe.subsystem.RendererSystem"] = flambe_subsystem_RendererSystem;
flambe_subsystem_RendererSystem.__name__ = true;
flambe_subsystem_RendererSystem.prototype = {
	__class__: flambe_subsystem_RendererSystem
};
var flambe_platform_InternalRenderer = function() { };
$hxClasses["flambe.platform.InternalRenderer"] = flambe_platform_InternalRenderer;
flambe_platform_InternalRenderer.__name__ = true;
flambe_platform_InternalRenderer.__interfaces__ = [flambe_subsystem_RendererSystem];
flambe_platform_InternalRenderer.prototype = {
	__class__: flambe_platform_InternalRenderer
};
var flambe_platform_KeyCodes = function() { };
$hxClasses["flambe.platform.KeyCodes"] = flambe_platform_KeyCodes;
flambe_platform_KeyCodes.__name__ = true;
flambe_platform_KeyCodes.toKey = function(keyCode) {
	switch(keyCode) {
	case 65:
		return flambe_input_Key.A;
	case 66:
		return flambe_input_Key.B;
	case 67:
		return flambe_input_Key.C;
	case 68:
		return flambe_input_Key.D;
	case 69:
		return flambe_input_Key.E;
	case 70:
		return flambe_input_Key.F;
	case 71:
		return flambe_input_Key.G;
	case 72:
		return flambe_input_Key.H;
	case 73:
		return flambe_input_Key.I;
	case 74:
		return flambe_input_Key.J;
	case 75:
		return flambe_input_Key.K;
	case 76:
		return flambe_input_Key.L;
	case 77:
		return flambe_input_Key.M;
	case 78:
		return flambe_input_Key.N;
	case 79:
		return flambe_input_Key.O;
	case 80:
		return flambe_input_Key.P;
	case 81:
		return flambe_input_Key.Q;
	case 82:
		return flambe_input_Key.R;
	case 83:
		return flambe_input_Key.S;
	case 84:
		return flambe_input_Key.T;
	case 85:
		return flambe_input_Key.U;
	case 86:
		return flambe_input_Key.V;
	case 87:
		return flambe_input_Key.W;
	case 88:
		return flambe_input_Key.X;
	case 89:
		return flambe_input_Key.Y;
	case 90:
		return flambe_input_Key.Z;
	case 48:
		return flambe_input_Key.Number0;
	case 49:
		return flambe_input_Key.Number1;
	case 50:
		return flambe_input_Key.Number2;
	case 51:
		return flambe_input_Key.Number3;
	case 52:
		return flambe_input_Key.Number4;
	case 53:
		return flambe_input_Key.Number5;
	case 54:
		return flambe_input_Key.Number6;
	case 55:
		return flambe_input_Key.Number7;
	case 56:
		return flambe_input_Key.Number8;
	case 57:
		return flambe_input_Key.Number9;
	case 96:
		return flambe_input_Key.Numpad0;
	case 97:
		return flambe_input_Key.Numpad1;
	case 98:
		return flambe_input_Key.Numpad2;
	case 99:
		return flambe_input_Key.Numpad3;
	case 100:
		return flambe_input_Key.Numpad4;
	case 101:
		return flambe_input_Key.Numpad5;
	case 102:
		return flambe_input_Key.Numpad6;
	case 103:
		return flambe_input_Key.Numpad7;
	case 104:
		return flambe_input_Key.Numpad8;
	case 105:
		return flambe_input_Key.Numpad9;
	case 107:
		return flambe_input_Key.NumpadAdd;
	case 110:
		return flambe_input_Key.NumpadDecimal;
	case 111:
		return flambe_input_Key.NumpadDivide;
	case 108:
		return flambe_input_Key.NumpadEnter;
	case 106:
		return flambe_input_Key.NumpadMultiply;
	case 109:
		return flambe_input_Key.NumpadSubtract;
	case 112:
		return flambe_input_Key.F1;
	case 113:
		return flambe_input_Key.F2;
	case 114:
		return flambe_input_Key.F3;
	case 115:
		return flambe_input_Key.F4;
	case 116:
		return flambe_input_Key.F5;
	case 117:
		return flambe_input_Key.F6;
	case 118:
		return flambe_input_Key.F7;
	case 119:
		return flambe_input_Key.F8;
	case 120:
		return flambe_input_Key.F9;
	case 121:
		return flambe_input_Key.F10;
	case 122:
		return flambe_input_Key.F11;
	case 123:
		return flambe_input_Key.F12;
	case 37:
		return flambe_input_Key.Left;
	case 38:
		return flambe_input_Key.Up;
	case 39:
		return flambe_input_Key.Right;
	case 40:
		return flambe_input_Key.Down;
	case 18:
		return flambe_input_Key.Alt;
	case 192:
		return flambe_input_Key.Backquote;
	case 220:
		return flambe_input_Key.Backslash;
	case 8:
		return flambe_input_Key.Backspace;
	case 20:
		return flambe_input_Key.CapsLock;
	case 188:
		return flambe_input_Key.Comma;
	case 15:
		return flambe_input_Key.Command;
	case 17:
		return flambe_input_Key.Control;
	case 46:
		return flambe_input_Key.Delete;
	case 35:
		return flambe_input_Key.End;
	case 13:
		return flambe_input_Key.Enter;
	case 187:
		return flambe_input_Key.Equals;
	case 27:
		return flambe_input_Key.Escape;
	case 36:
		return flambe_input_Key.Home;
	case 45:
		return flambe_input_Key.Insert;
	case 219:
		return flambe_input_Key.LeftBracket;
	case 189:
		return flambe_input_Key.Minus;
	case 34:
		return flambe_input_Key.PageDown;
	case 33:
		return flambe_input_Key.PageUp;
	case 190:
		return flambe_input_Key.Period;
	case 222:
		return flambe_input_Key.Quote;
	case 221:
		return flambe_input_Key.RightBracket;
	case 186:
		return flambe_input_Key.Semicolon;
	case 16:
		return flambe_input_Key.Shift;
	case 191:
		return flambe_input_Key.Slash;
	case 32:
		return flambe_input_Key.Space;
	case 9:
		return flambe_input_Key.Tab;
	case 16777234:
		return flambe_input_Key.Menu;
	case 16777247:
		return flambe_input_Key.Search;
	}
	return flambe_input_Key.Unknown(keyCode);
};
flambe_platform_KeyCodes.toKeyCode = function(key) {
	switch(Type.enumIndex(key)) {
	case 0:
		return 65;
	case 1:
		return 66;
	case 2:
		return 67;
	case 3:
		return 68;
	case 4:
		return 69;
	case 5:
		return 70;
	case 6:
		return 71;
	case 7:
		return 72;
	case 8:
		return 73;
	case 9:
		return 74;
	case 10:
		return 75;
	case 11:
		return 76;
	case 12:
		return 77;
	case 13:
		return 78;
	case 14:
		return 79;
	case 15:
		return 80;
	case 16:
		return 81;
	case 17:
		return 82;
	case 18:
		return 83;
	case 19:
		return 84;
	case 20:
		return 85;
	case 21:
		return 86;
	case 22:
		return 87;
	case 23:
		return 88;
	case 24:
		return 89;
	case 25:
		return 90;
	case 26:
		return 48;
	case 27:
		return 49;
	case 28:
		return 50;
	case 29:
		return 51;
	case 30:
		return 52;
	case 31:
		return 53;
	case 32:
		return 54;
	case 33:
		return 55;
	case 34:
		return 56;
	case 35:
		return 57;
	case 36:
		return 96;
	case 37:
		return 97;
	case 38:
		return 98;
	case 39:
		return 99;
	case 40:
		return 100;
	case 41:
		return 101;
	case 42:
		return 102;
	case 43:
		return 103;
	case 44:
		return 104;
	case 45:
		return 105;
	case 46:
		return 107;
	case 47:
		return 110;
	case 48:
		return 111;
	case 49:
		return 108;
	case 50:
		return 106;
	case 51:
		return 109;
	case 52:
		return 112;
	case 53:
		return 113;
	case 54:
		return 114;
	case 55:
		return 115;
	case 56:
		return 116;
	case 57:
		return 117;
	case 58:
		return 118;
	case 59:
		return 119;
	case 60:
		return 120;
	case 61:
		return 121;
	case 62:
		return 122;
	case 63:
		return 123;
	case 64:
		return 124;
	case 65:
		return 125;
	case 66:
		return 126;
	case 67:
		return 37;
	case 68:
		return 38;
	case 69:
		return 39;
	case 70:
		return 40;
	case 71:
		return 18;
	case 72:
		return 192;
	case 73:
		return 220;
	case 74:
		return 8;
	case 75:
		return 20;
	case 76:
		return 188;
	case 77:
		return 15;
	case 78:
		return 17;
	case 79:
		return 46;
	case 80:
		return 35;
	case 81:
		return 13;
	case 82:
		return 187;
	case 83:
		return 27;
	case 84:
		return 36;
	case 85:
		return 45;
	case 86:
		return 219;
	case 87:
		return 189;
	case 88:
		return 34;
	case 89:
		return 33;
	case 90:
		return 190;
	case 91:
		return 222;
	case 92:
		return 221;
	case 93:
		return 186;
	case 94:
		return 16;
	case 95:
		return 191;
	case 96:
		return 32;
	case 97:
		return 9;
	case 98:
		return 16777234;
	case 99:
		return 16777247;
	case 100:
		var keyCode = key[2];
		return keyCode;
	}
};
var flambe_platform_MainLoop = function() {
	this._tickables = [];
};
$hxClasses["flambe.platform.MainLoop"] = flambe_platform_MainLoop;
flambe_platform_MainLoop.__name__ = true;
flambe_platform_MainLoop.updateEntity = function(entity,dt) {
	var speed = entity.getComponent("SpeedAdjuster_7");
	if(speed != null) {
		speed._realDt = dt;
		dt *= speed.scale.get__();
		if(dt <= 0) {
			speed.onUpdate(dt);
			return;
		}
	}
	var p = entity.firstComponent;
	while(p != null) {
		var next = p.next;
		p.onUpdate(dt);
		p = next;
	}
	var p1 = entity.firstChild;
	while(p1 != null) {
		var next1 = p1.next;
		flambe_platform_MainLoop.updateEntity(p1,dt);
		p1 = next1;
	}
};
flambe_platform_MainLoop.prototype = {
	update: function(dt) {
		if(dt <= 0) {
			flambe_Log.warn("Zero or negative time elapsed since the last frame!",["dt",dt]);
			return;
		}
		if(dt > 1) dt = 1;
		var ii = 0;
		while(ii < this._tickables.length) {
			var t = this._tickables[ii];
			if(t == null || t.update(dt)) this._tickables.splice(ii,1); else ++ii;
		}
		flambe_System.volume.update(dt);
		flambe_platform_MainLoop.updateEntity(flambe_System.root,dt);
	}
	,render: function(renderer) {
		var graphics = renderer.graphics;
		if(graphics != null) {
			renderer.willRender();
			flambe_display_Sprite.render(flambe_System.root,graphics);
			renderer.didRender();
		}
	}
	,addTickable: function(t) {
		this._tickables.push(t);
	}
	,__class__: flambe_platform_MainLoop
};
var flambe_platform_MathUtil = function() { };
$hxClasses["flambe.platform.MathUtil"] = flambe_platform_MathUtil;
flambe_platform_MathUtil.__name__ = true;
flambe_platform_MathUtil.nextPowerOfTwo = function(n) {
	var p = 1;
	while(p < n) p <<= 1;
	return p;
};
var flambe_platform_MouseCodes = function() { };
$hxClasses["flambe.platform.MouseCodes"] = flambe_platform_MouseCodes;
flambe_platform_MouseCodes.__name__ = true;
flambe_platform_MouseCodes.toButton = function(buttonCode) {
	switch(buttonCode) {
	case 0:
		return flambe_input_MouseButton.Left;
	case 1:
		return flambe_input_MouseButton.Middle;
	case 2:
		return flambe_input_MouseButton.Right;
	}
	return flambe_input_MouseButton.Unknown(buttonCode);
};
var flambe_platform_OverdrawGraphics = function(impl) {
	this._impl = impl;
};
$hxClasses["flambe.platform.OverdrawGraphics"] = flambe_platform_OverdrawGraphics;
flambe_platform_OverdrawGraphics.__name__ = true;
flambe_platform_OverdrawGraphics.__interfaces__ = [flambe_platform_InternalGraphics];
flambe_platform_OverdrawGraphics.prototype = {
	save: function() {
		this._impl.save();
	}
	,translate: function(x,y) {
		this._impl.translate(x,y);
	}
	,scale: function(x,y) {
		this._impl.scale(x,y);
	}
	,rotate: function(rotation) {
		this._impl.rotate(rotation);
	}
	,transform: function(m00,m10,m01,m11,m02,m12) {
		this._impl.transform(m00,m10,m01,m11,m02,m12);
	}
	,multiplyAlpha: function(factor) {
	}
	,setBlendMode: function(blendMode) {
	}
	,applyScissor: function(x,y,width,height) {
		this._impl.applyScissor(x,y,width,height);
	}
	,restore: function() {
		this._impl.restore();
	}
	,drawTexture: function(texture,destX,destY) {
		this.drawRegion(destX,destY,texture.get_width(),texture.get_height());
	}
	,drawSubTexture: function(texture,destX,destY,sourceX,sourceY,sourceW,sourceH) {
		this.drawRegion(destX,destY,sourceW,sourceH);
	}
	,drawPattern: function(texture,destX,destY,width,height) {
		this.drawRegion(destX,destY,width,height);
	}
	,fillRect: function(color,x,y,width,height) {
		this.drawRegion(x,y,width,height);
	}
	,willRender: function() {
		this._impl.willRender();
		this._impl.save();
		this._impl.setBlendMode(flambe_display_BlendMode.Add);
	}
	,didRender: function() {
		this._impl.restore();
		this._impl.didRender();
	}
	,onResize: function(width,height) {
		this._impl.onResize(width,height);
	}
	,drawRegion: function(x,y,width,height) {
		this._impl.fillRect(1052680,x,y,width,height);
	}
	,__class__: flambe_platform_OverdrawGraphics
};
var flambe_platform_TextureRoot = function() { };
$hxClasses["flambe.platform.TextureRoot"] = flambe_platform_TextureRoot;
flambe_platform_TextureRoot.__name__ = true;
var flambe_platform_Tickable = function() { };
$hxClasses["flambe.platform.Tickable"] = flambe_platform_Tickable;
flambe_platform_Tickable.__name__ = true;
flambe_platform_Tickable.prototype = {
	__class__: flambe_platform_Tickable
};
var flambe_platform_html_CanvasGraphics = function(canvas) {
	this._firstDraw = false;
	this._canvasCtx = canvas.getContext("2d");
};
$hxClasses["flambe.platform.html.CanvasGraphics"] = flambe_platform_html_CanvasGraphics;
flambe_platform_html_CanvasGraphics.__name__ = true;
flambe_platform_html_CanvasGraphics.__interfaces__ = [flambe_platform_InternalGraphics];
flambe_platform_html_CanvasGraphics.prototype = {
	save: function() {
		this._canvasCtx.save();
	}
	,translate: function(x,y) {
		this._canvasCtx.translate(Std["int"](x),Std["int"](y));
	}
	,scale: function(x,y) {
		this._canvasCtx.scale(x,y);
	}
	,rotate: function(rotation) {
		this._canvasCtx.rotate(flambe_math_FMath.toRadians(rotation));
	}
	,transform: function(m00,m10,m01,m11,m02,m12) {
		this._canvasCtx.transform(m00,m10,m01,m11,m02,m12);
	}
	,restore: function() {
		this._canvasCtx.restore();
	}
	,drawTexture: function(texture,destX,destY) {
		this.drawSubTexture(texture,destX,destY,0,0,texture.get_width(),texture.get_height());
	}
	,drawSubTexture: function(texture,destX,destY,sourceX,sourceY,sourceW,sourceH) {
		if(this._firstDraw) {
			this._firstDraw = false;
			this._canvasCtx.globalCompositeOperation = "copy";
			this.drawSubTexture(texture,destX,destY,sourceX,sourceY,sourceW,sourceH);
			this._canvasCtx.globalCompositeOperation = "source-over";
			return;
		}
		var texture1 = texture;
		var root = texture1.root;
		root.assertNotDisposed();
		this._canvasCtx.drawImage(root.image,Std["int"](texture1.rootX + sourceX),Std["int"](texture1.rootY + sourceY),Std["int"](sourceW),Std["int"](sourceH),Std["int"](destX),Std["int"](destY),Std["int"](sourceW),Std["int"](sourceH));
	}
	,drawPattern: function(texture,x,y,width,height) {
		if(this._firstDraw) {
			this._firstDraw = false;
			this._canvasCtx.globalCompositeOperation = "copy";
			this.drawPattern(texture,x,y,width,height);
			this._canvasCtx.globalCompositeOperation = "source-over";
			return;
		}
		var texture1 = texture;
		var root = texture1.root;
		root.assertNotDisposed();
		this._canvasCtx.fillStyle = texture1.getPattern();
		this._canvasCtx.fillRect(Std["int"](x),Std["int"](y),Std["int"](width),Std["int"](height));
	}
	,fillRect: function(color,x,y,width,height) {
		if(this._firstDraw) {
			this._firstDraw = false;
			this._canvasCtx.globalCompositeOperation = "copy";
			this.fillRect(color,x,y,width,height);
			this._canvasCtx.globalCompositeOperation = "source-over";
			return;
		}
		var hex = (16777215 & color).toString(16);
		while(hex.length < 6) hex = "0" + Std.string(hex);
		this._canvasCtx.fillStyle = "#" + Std.string(hex);
		this._canvasCtx.fillRect(Std["int"](x),Std["int"](y),Std["int"](width),Std["int"](height));
	}
	,multiplyAlpha: function(factor) {
		this._canvasCtx.globalAlpha *= factor;
	}
	,setBlendMode: function(blendMode) {
		var op;
		switch(Type.enumIndex(blendMode)) {
		case 0:
			op = "source-over";
			break;
		case 1:
			op = "lighter";
			break;
		case 2:
			op = "destination-in";
			break;
		case 3:
			op = "copy";
			break;
		}
		this._canvasCtx.globalCompositeOperation = op;
	}
	,applyScissor: function(x,y,width,height) {
		this._canvasCtx.beginPath();
		this._canvasCtx.rect(Std["int"](x),Std["int"](y),Std["int"](width),Std["int"](height));
		this._canvasCtx.clip();
	}
	,willRender: function() {
		this._firstDraw = true;
	}
	,didRender: function() {
	}
	,onResize: function(width,height) {
	}
	,__class__: flambe_platform_html_CanvasGraphics
};
var flambe_platform_html_CanvasRenderer = function(canvas) {
	this.graphics = new flambe_platform_html_CanvasGraphics(canvas);
	this._hasGPU = new flambe_util_Value(true);
};
$hxClasses["flambe.platform.html.CanvasRenderer"] = flambe_platform_html_CanvasRenderer;
flambe_platform_html_CanvasRenderer.__name__ = true;
flambe_platform_html_CanvasRenderer.__interfaces__ = [flambe_platform_InternalRenderer];
flambe_platform_html_CanvasRenderer.prototype = {
	get_type: function() {
		return flambe_subsystem_RendererType.Canvas;
	}
	,createTextureFromImage: function(image) {
		var root = new flambe_platform_html_CanvasTextureRoot(flambe_platform_html_CanvasRenderer.CANVAS_TEXTURES?flambe_platform_html_HtmlUtil.createCanvas(image):image);
		return root.createTexture(root.width,root.height);
	}
	,getCompressedTextureFormats: function() {
		return [];
	}
	,createCompressedTexture: function(format,data) {
		flambe_util_Assert.fail();
		return null;
	}
	,willRender: function() {
		this.graphics.willRender();
	}
	,didRender: function() {
		this.graphics.didRender();
	}
	,__class__: flambe_platform_html_CanvasRenderer
};
var flambe_platform_html_CanvasTexture = function(root,width,height) {
	this._rootUpdateCount = 0;
	this._pattern = null;
	flambe_platform_BasicTexture.call(this,root,width,height);
};
$hxClasses["flambe.platform.html.CanvasTexture"] = flambe_platform_html_CanvasTexture;
flambe_platform_html_CanvasTexture.__name__ = true;
flambe_platform_html_CanvasTexture.__super__ = flambe_platform_BasicTexture;
flambe_platform_html_CanvasTexture.prototype = $extend(flambe_platform_BasicTexture.prototype,{
	getPattern: function() {
		if(this._rootUpdateCount != this.root.updateCount || this._pattern == null) {
			this._rootUpdateCount = this.root.updateCount;
			this._pattern = this.root.createPattern(this.rootX,this.rootY,this.get_width(),this.get_height());
		}
		return this._pattern;
	}
	,__class__: flambe_platform_html_CanvasTexture
});
var flambe_platform_html_CanvasTextureRoot = function(image) {
	this._graphics = null;
	this.updateCount = 0;
	flambe_platform_BasicAsset.call(this);
	this.image = image;
	this.width = image.width;
	this.height = image.height;
};
$hxClasses["flambe.platform.html.CanvasTextureRoot"] = flambe_platform_html_CanvasTextureRoot;
flambe_platform_html_CanvasTextureRoot.__name__ = true;
flambe_platform_html_CanvasTextureRoot.__interfaces__ = [flambe_platform_TextureRoot];
flambe_platform_html_CanvasTextureRoot.__super__ = flambe_platform_BasicAsset;
flambe_platform_html_CanvasTextureRoot.prototype = $extend(flambe_platform_BasicAsset.prototype,{
	createTexture: function(width,height) {
		return new flambe_platform_html_CanvasTexture(this,width,height);
	}
	,dirtyContents: function() {
		++this.updateCount;
	}
	,createPattern: function(x,y,width,height) {
		var ctx2d = this.getContext2d();
		var source = this.image;
		if(x != 0 || y != 0 || width != this.width || height != this.height) {
			source = flambe_platform_html_HtmlUtil.createEmptyCanvas(width,height);
			var crop = source.getContext("2d");
			crop.globalCompositeOperation = "copy";
			crop.drawImage(this.image,-x,-y);
		}
		return ctx2d.createPattern(source,"repeat");
	}
	,getContext2d: function() {
		if(!Std["is"](this.image,HTMLCanvasElement)) this.image = flambe_platform_html_HtmlUtil.createCanvas(this.image);
		var canvas = this.image;
		return canvas.getContext("2d");
	}
	,copyFrom: function(that) {
		this.image = that.image;
		this._graphics = that._graphics;
		this.dirtyContents();
	}
	,onDisposed: function() {
		this.image = null;
		this._graphics = null;
	}
	,__class__: flambe_platform_html_CanvasTextureRoot
});
var flambe_platform_html_HtmlAssetPackLoader = function(platform,manifest) {
	flambe_platform_BasicAssetPackLoader.call(this,platform,manifest);
};
$hxClasses["flambe.platform.html.HtmlAssetPackLoader"] = flambe_platform_html_HtmlAssetPackLoader;
flambe_platform_html_HtmlAssetPackLoader.__name__ = true;
flambe_platform_html_HtmlAssetPackLoader.detectImageFormats = function(fn) {
	var formats = [flambe_asset_AssetFormat.PNG,flambe_asset_AssetFormat.JPG,flambe_asset_AssetFormat.GIF];
	var formatTests = 2;
	var checkRemaining = function() {
		--formatTests;
		if(formatTests == 0) fn(formats);
	};
	var webp;
	var _this = js_Browser.get_document();
	webp = _this.createElement("img");
	webp.onload = webp.onerror = function(_) {
		if(webp.width == 1) formats.unshift(flambe_asset_AssetFormat.WEBP);
		checkRemaining();
	};
	webp.src = "data:image/webp;base64,UklGRhoAAABXRUJQVlA4TA0AAAAvAAAAEAcQERGIiP4HAA==";
	var jxr;
	var _this1 = js_Browser.get_document();
	jxr = _this1.createElement("img");
	jxr.onload = jxr.onerror = function(_1) {
		if(jxr.width == 1) formats.unshift(flambe_asset_AssetFormat.JXR);
		checkRemaining();
	};
	jxr.src = "data:image/vnd.ms-photo;base64,SUm8AQgAAAAFAAG8AQAQAAAASgAAAIC8BAABAAAAAQAAAIG8BAABAAAAAQAAAMC8BAABAAAAWgAAAMG8BAABAAAAHwAAAAAAAAAkw91vA07+S7GFPXd2jckNV01QSE9UTwAZAYBxAAAAABP/gAAEb/8AAQAAAQAAAA==";
};
flambe_platform_html_HtmlAssetPackLoader.detectAudioFormats = function() {
	var audio;
	var _this = js_Browser.get_document();
	audio = _this.createElement("audio");
	if(audio == null || $bind(audio,audio.canPlayType) == null) {
		flambe_Log.warn("Audio is not supported at all in this browser!");
		return [];
	}
	var blacklist = new EReg("\\b(iPhone|iPod|iPad|Android|Windows Phone)\\b","");
	var userAgent = js_Browser.get_navigator().userAgent;
	if(!flambe_platform_html_WebAudioSound.get_supported() && blacklist.match(userAgent)) {
		flambe_Log.warn("HTML5 audio is blacklisted for this browser",["userAgent",userAgent]);
		return [];
	}
	var types = [{ format : flambe_asset_AssetFormat.M4A, mimeType : "audio/mp4; codecs=mp4a"},{ format : flambe_asset_AssetFormat.MP3, mimeType : "audio/mpeg"},{ format : flambe_asset_AssetFormat.OPUS, mimeType : "audio/ogg; codecs=opus"},{ format : flambe_asset_AssetFormat.OGG, mimeType : "audio/ogg; codecs=vorbis"},{ format : flambe_asset_AssetFormat.WAV, mimeType : "audio/wav"}];
	var result = [];
	var _g = 0;
	while(_g < types.length) {
		var type = types[_g];
		++_g;
		var canPlayType = "";
		try {
			canPlayType = audio.canPlayType(type.mimeType);
		} catch( _ ) {
		}
		if(canPlayType != "") result.push(type.format);
	}
	return result;
};
flambe_platform_html_HtmlAssetPackLoader.supportsBlob = function() {
	if(flambe_platform_html_HtmlAssetPackLoader._detectBlobSupport) {
		flambe_platform_html_HtmlAssetPackLoader._detectBlobSupport = false;
		if(new EReg("\\bSilk\\b","").match(js_Browser.get_navigator().userAgent)) return false;
		if(js_Browser.get_window().Blob == null) return false;
		var xhr = new XMLHttpRequest();
		xhr.open("GET",".",true);
		if(xhr.responseType != "") return false;
		xhr.responseType = "blob";
		if(xhr.responseType != "blob") return false;
		flambe_platform_html_HtmlAssetPackLoader._URL = flambe_platform_html_HtmlUtil.loadExtension("URL").value;
	}
	return flambe_platform_html_HtmlAssetPackLoader._URL != null && flambe_platform_html_HtmlAssetPackLoader._URL.createObjectURL != null;
};
flambe_platform_html_HtmlAssetPackLoader.__super__ = flambe_platform_BasicAssetPackLoader;
flambe_platform_html_HtmlAssetPackLoader.prototype = $extend(flambe_platform_BasicAssetPackLoader.prototype,{
	loadEntry: function(url,entry) {
		var _g1 = this;
		var _g = entry.format;
		switch(Type.enumIndex(_g)) {
		case 0:case 1:case 2:case 3:case 4:
			var image;
			var _this = js_Browser.get_document();
			image = _this.createElement("img");
			var events = new flambe_platform_EventGroup();
			events.addDisposingListener(image,"load",function(_) {
				if(image.width > 1024 || image.height > 1024) flambe_Log.warn("Images larger than 1024px on a side will prevent GPU acceleration" + " on some platforms (iOS)",["url",url,"width",image.width,"height",image.height]);
				if(flambe_platform_html_HtmlAssetPackLoader.supportsBlob()) flambe_platform_html_HtmlAssetPackLoader._URL.revokeObjectURL(image.src);
				var texture = _g1._platform.getRenderer().createTextureFromImage(image);
				if(texture != null) _g1.handleLoad(entry,texture); else _g1.handleTextureError(entry);
			});
			events.addDisposingListener(image,"error",function(_1) {
				_g1.handleError(entry,"Failed to load image");
			});
			if(flambe_platform_html_HtmlAssetPackLoader.supportsBlob()) this.downloadBlob(url,entry,function(blob) {
				image.src = flambe_platform_html_HtmlAssetPackLoader._URL.createObjectURL(blob);
			}); else image.src = url;
			break;
		case 5:case 6:case 7:
			this.downloadArrayBuffer(url,entry,function(buffer) {
				var texture1 = _g1._platform.getRenderer().createCompressedTexture(entry.format,null);
				if(texture1 != null) _g1.handleLoad(entry,texture1); else _g1.handleTextureError(entry);
			});
			break;
		case 8:case 9:case 10:case 11:case 12:
			if(flambe_platform_html_WebAudioSound.get_supported()) this.downloadArrayBuffer(url,entry,function(buffer1) {
				flambe_platform_html_WebAudioSound.ctx.decodeAudioData(buffer1,function(decoded) {
					_g1.handleLoad(entry,new flambe_platform_html_WebAudioSound(decoded));
				},function() {
					flambe_Log.warn("Couldn't decode Web Audio, ignoring this asset",["url",url]);
					_g1.handleLoad(entry,flambe_platform_DummySound.getInstance());
				});
			}); else {
				var audio;
				var _this1 = js_Browser.get_document();
				audio = _this1.createElement("audio");
				audio.preload = "auto";
				var ref = ++flambe_platform_html_HtmlAssetPackLoader._mediaRefCount;
				if(flambe_platform_html_HtmlAssetPackLoader._mediaElements == null) flambe_platform_html_HtmlAssetPackLoader._mediaElements = new haxe_ds_IntMap();
				flambe_platform_html_HtmlAssetPackLoader._mediaElements.set(ref,audio);
				var events1 = new flambe_platform_EventGroup();
				events1.addDisposingListener(audio,"canplaythrough",function(_2) {
					flambe_platform_html_HtmlAssetPackLoader._mediaElements.remove(ref);
					_g1.handleLoad(entry,new flambe_platform_html_HtmlSound(audio));
				});
				events1.addDisposingListener(audio,"error",function(_3) {
					flambe_platform_html_HtmlAssetPackLoader._mediaElements.remove(ref);
					var code = audio.error.code;
					if(code == 3 || code == 4) {
						flambe_Log.warn("Couldn't decode HTML5 audio, ignoring this asset",["url",url,"code",code]);
						_g1.handleLoad(entry,flambe_platform_DummySound.getInstance());
					} else _g1.handleError(entry,"Failed to load audio: " + audio.error.code);
				});
				events1.addListener(audio,"progress",function(_4) {
					if(audio.buffered.length > 0 && audio.duration > 0) {
						var progress = audio.buffered.end(0) / audio.duration;
						_g1.handleProgress(entry,Std["int"](progress * entry.bytes));
					}
				});
				audio.src = url;
				audio.load();
			}
			break;
		case 13:
			this.downloadText(url,entry,function(text) {
				_g1.handleLoad(entry,new flambe_platform_BasicFile(text));
			});
			break;
		}
	}
	,getAssetFormats: function(fn) {
		var _g = this;
		if(flambe_platform_html_HtmlAssetPackLoader._supportedFormats == null) {
			flambe_platform_html_HtmlAssetPackLoader._supportedFormats = new flambe_util_Promise();
			flambe_platform_html_HtmlAssetPackLoader.detectImageFormats(function(imageFormats) {
				flambe_platform_html_HtmlAssetPackLoader._supportedFormats.set_result(_g._platform.getRenderer().getCompressedTextureFormats().concat(imageFormats).concat(flambe_platform_html_HtmlAssetPackLoader.detectAudioFormats()).concat([flambe_asset_AssetFormat.Data]));
			});
		}
		flambe_platform_html_HtmlAssetPackLoader._supportedFormats.get(fn);
	}
	,downloadArrayBuffer: function(url,entry,onLoad) {
		this.download(url,entry,"arraybuffer",onLoad);
	}
	,downloadBlob: function(url,entry,onLoad) {
		this.download(url,entry,"blob",onLoad);
	}
	,downloadText: function(url,entry,onLoad) {
		this.download(url,entry,"text",onLoad);
	}
	,download: function(url,entry,responseType,onLoad) {
		var _g = this;
		var xhr = null;
		var start = null;
		var intervalId = 0;
		var hasInterval = false;
		var clearRetryInterval = function() {
			if(hasInterval) {
				hasInterval = false;
				js_Browser.get_window().clearInterval(intervalId);
			}
		};
		var retries = 3;
		var maybeRetry = function() {
			--retries;
			if(retries >= 0) {
				flambe_Log.warn("Retrying asset download",["url",entry.url]);
				start();
				return true;
			}
			return false;
		};
		start = function() {
			clearRetryInterval();
			if(xhr != null) xhr.abort();
			xhr = new XMLHttpRequest();
			xhr.open("GET",url,true);
			xhr.responseType = responseType;
			var lastProgress = 0.0;
			xhr.onprogress = function(event) {
				if(!hasInterval) {
					hasInterval = true;
					intervalId = js_Browser.get_window().setInterval(function() {
						if(xhr.readyState != 4 && flambe_platform_html_HtmlUtil.now() - lastProgress > 5000) {
							if(!maybeRetry()) {
								clearRetryInterval();
								_g.handleError(entry,"Download stalled");
							}
						}
					},1000);
				}
				lastProgress = flambe_platform_html_HtmlUtil.now();
				_g.handleProgress(entry,event.loaded);
			};
			xhr.onerror = function(_) {
				if(xhr.status != 0 || !maybeRetry()) {
					clearRetryInterval();
					_g.handleError(entry,"HTTP error " + xhr.status);
				}
			};
			xhr.onload = function(_1) {
				var response = xhr.response;
				if(response == null) response = xhr.responseText;
				clearRetryInterval();
				onLoad(response);
			};
			xhr.send();
		};
		start();
	}
	,__class__: flambe_platform_html_HtmlAssetPackLoader
});
var flambe_platform_html_HtmlCatapultClient = function() {
	var _g = this;
	flambe_platform_CatapultClient.call(this);
	this._socket = new WebSocket("ws://" + js_Browser.get_location().host);
	this._socket.onerror = function(event) {
		_g.onError("unknown");
	};
	this._socket.onopen = function(event1) {
		flambe_Log.info("Catapult connected");
	};
	this._socket.onmessage = function(event2) {
		_g.onMessage(event2.data);
	};
};
$hxClasses["flambe.platform.html.HtmlCatapultClient"] = flambe_platform_html_HtmlCatapultClient;
flambe_platform_html_HtmlCatapultClient.__name__ = true;
flambe_platform_html_HtmlCatapultClient.canUse = function() {
	return Reflect.hasField(js_Browser.get_window(),"WebSocket");
};
flambe_platform_html_HtmlCatapultClient.__super__ = flambe_platform_CatapultClient;
flambe_platform_html_HtmlCatapultClient.prototype = $extend(flambe_platform_CatapultClient.prototype,{
	onRestart: function() {
		js_Browser.get_window().top.location.reload();
	}
	,__class__: flambe_platform_html_HtmlCatapultClient
});
var flambe_subsystem_ExternalSystem = function() { };
$hxClasses["flambe.subsystem.ExternalSystem"] = flambe_subsystem_ExternalSystem;
flambe_subsystem_ExternalSystem.__name__ = true;
flambe_subsystem_ExternalSystem.prototype = {
	__class__: flambe_subsystem_ExternalSystem
};
var flambe_platform_html_HtmlExternal = function() {
};
$hxClasses["flambe.platform.html.HtmlExternal"] = flambe_platform_html_HtmlExternal;
flambe_platform_html_HtmlExternal.__name__ = true;
flambe_platform_html_HtmlExternal.__interfaces__ = [flambe_subsystem_ExternalSystem];
flambe_platform_html_HtmlExternal.prototype = {
	call: function(name,params) {
		if(params == null) params = [];
		var object = js_Browser.get_window();
		var method = object;
		var _g = 0;
		var _g1 = name.split(".");
		while(_g < _g1.length) {
			var fieldName = _g1[_g];
			++_g;
			object = method;
			method = Reflect.field(object,fieldName);
		}
		return Reflect.callMethod(object,method,params);
	}
	,bind: function(name,fn) {
		Reflect.setField(js_Browser.get_window(),name,fn);
	}
	,__class__: flambe_platform_html_HtmlExternal
};
var flambe_util_LogHandler = function() { };
$hxClasses["flambe.util.LogHandler"] = flambe_util_LogHandler;
flambe_util_LogHandler.__name__ = true;
flambe_util_LogHandler.prototype = {
	__class__: flambe_util_LogHandler
};
var flambe_platform_html_HtmlLogHandler = function(tag) {
	this._tagPrefix = tag + ": ";
};
$hxClasses["flambe.platform.html.HtmlLogHandler"] = flambe_platform_html_HtmlLogHandler;
flambe_platform_html_HtmlLogHandler.__name__ = true;
flambe_platform_html_HtmlLogHandler.__interfaces__ = [flambe_util_LogHandler];
flambe_platform_html_HtmlLogHandler.isSupported = function() {
	return typeof console == "object" && console.info != null;
};
flambe_platform_html_HtmlLogHandler.prototype = {
	log: function(level,message) {
		message = this._tagPrefix + message;
		switch(Type.enumIndex(level)) {
		case 0:
			console.info(message);
			break;
		case 1:
			console.warn(message);
			break;
		case 2:
			console.error(message);
			break;
		}
	}
	,__class__: flambe_platform_html_HtmlLogHandler
};
var flambe_subsystem_MotionSystem = function() { };
$hxClasses["flambe.subsystem.MotionSystem"] = flambe_subsystem_MotionSystem;
flambe_subsystem_MotionSystem.__name__ = true;
flambe_subsystem_MotionSystem.prototype = {
	__class__: flambe_subsystem_MotionSystem
};
var flambe_platform_html_HtmlMotion = function() {
	var _g = this;
	var acceleration = new flambe_platform_HeavySignal1();
	this.acceleration = acceleration;
	var accelerationIncludingGravity = new flambe_platform_HeavySignal1();
	this.accelerationIncludingGravity = accelerationIncludingGravity;
	var attitude = new flambe_platform_HeavySignal1();
	this.attitude = attitude;
	if(this.get_accelerationSupported()) {
		this._sharedAcceleration = new flambe_input_Acceleration();
		this._sharedAccelerationIncludingGravity = new flambe_input_Acceleration();
		var motionEvents = null;
		var onListenersChanged = function(_,_1) {
			if(acceleration.hasListeners() || accelerationIncludingGravity.hasListeners()) {
				if(motionEvents == null) {
					motionEvents = new flambe_platform_EventGroup();
					motionEvents.addListener(js_Browser.get_window(),"devicemotion",$bind(_g,_g.onDeviceMotion));
				}
			} else if(motionEvents != null) {
				motionEvents.dispose();
				motionEvents = null;
			}
		};
		acceleration.hasListenersValue.get_changed().connect(onListenersChanged);
		accelerationIncludingGravity.hasListenersValue.get_changed().connect(onListenersChanged);
	}
	if(this.get_attitudeSupported()) {
		this._sharedAttitude = new flambe_input_Attitude();
		var orientationEvents = null;
		attitude.hasListenersValue.get_changed().connect(function(hasListeners,_2) {
			if(hasListeners) {
				orientationEvents = new flambe_platform_EventGroup();
				orientationEvents.addListener(js_Browser.get_window(),"deviceorientation",$bind(_g,_g.onDeviceOrientation));
			} else {
				orientationEvents.dispose();
				orientationEvents = null;
			}
		});
	}
};
$hxClasses["flambe.platform.html.HtmlMotion"] = flambe_platform_html_HtmlMotion;
flambe_platform_html_HtmlMotion.__name__ = true;
flambe_platform_html_HtmlMotion.__interfaces__ = [flambe_subsystem_MotionSystem];
flambe_platform_html_HtmlMotion.initAcceleration = function(acceleration,input) {
	var _g = js_Browser.get_window().orientation;
	switch(_g) {
	case -90:
		acceleration.init(input.y,-input.x,input.z);
		break;
	case 0:
		acceleration.init(input.x,input.y,input.z);
		break;
	case 90:
		acceleration.init(-input.y,input.x,input.z);
		break;
	case 180:
		acceleration.init(-input.x,-input.y,input.z);
		break;
	}
};
flambe_platform_html_HtmlMotion.prototype = {
	get_accelerationSupported: function() {
		return js_Browser.get_window().DeviceMotionEvent != null;
	}
	,onDeviceMotion: function(event) {
		if(event.acceleration != null) {
			flambe_platform_html_HtmlMotion.initAcceleration(this._sharedAcceleration,event.acceleration);
			this.acceleration.emit(this._sharedAcceleration);
		}
		if(event.accelerationIncludingGravity != null) {
			flambe_platform_html_HtmlMotion.initAcceleration(this._sharedAccelerationIncludingGravity,event.accelerationIncludingGravity);
			this.accelerationIncludingGravity.emit(this._sharedAccelerationIncludingGravity);
		}
	}
	,get_attitudeSupported: function() {
		return js_Browser.get_window().DeviceOrientationEvent != null;
	}
	,onDeviceOrientation: function(event) {
		var _g = js_Browser.get_window().orientation;
		switch(_g) {
		case -90:
			this._sharedAttitude.init(event.gamma,-event.beta,event.alpha);
			break;
		case 0:
			this._sharedAttitude.init(event.beta,event.gamma,event.alpha);
			break;
		case 90:
			this._sharedAttitude.init(-event.gamma,event.beta,event.alpha);
			break;
		case 180:
			this._sharedAttitude.init(-event.beta,-event.gamma,event.alpha);
			break;
		}
		this.attitude.emit(this._sharedAttitude);
	}
	,__class__: flambe_platform_html_HtmlMotion
};
var flambe_platform_html_HtmlMouse = function(pointer,canvas) {
	flambe_platform_BasicMouse.call(this,pointer);
	this._canvas = canvas;
};
$hxClasses["flambe.platform.html.HtmlMouse"] = flambe_platform_html_HtmlMouse;
flambe_platform_html_HtmlMouse.__name__ = true;
flambe_platform_html_HtmlMouse.__super__ = flambe_platform_BasicMouse;
flambe_platform_html_HtmlMouse.prototype = $extend(flambe_platform_BasicMouse.prototype,{
	set_cursor: function(cursor) {
		var name;
		switch(Type.enumIndex(cursor)) {
		case 0:
			name = "";
			break;
		case 1:
			name = "pointer";
			break;
		case 2:
			name = "none";
			break;
		}
		this._canvas.style.cursor = name;
		return flambe_platform_BasicMouse.prototype.set_cursor.call(this,cursor);
	}
	,__class__: flambe_platform_html_HtmlMouse
});
var flambe_platform_html_HtmlSound = function(audioElement) {
	flambe_platform_BasicAsset.call(this);
	this.audioElement = audioElement;
};
$hxClasses["flambe.platform.html.HtmlSound"] = flambe_platform_html_HtmlSound;
flambe_platform_html_HtmlSound.__name__ = true;
flambe_platform_html_HtmlSound.__interfaces__ = [flambe_sound_Sound];
flambe_platform_html_HtmlSound.__super__ = flambe_platform_BasicAsset;
flambe_platform_html_HtmlSound.prototype = $extend(flambe_platform_BasicAsset.prototype,{
	play: function(volume) {
		if(volume == null) volume = 1.0;
		this.assertNotDisposed();
		return new flambe_platform_html__$HtmlSound_HtmlPlayback(this,volume,false);
	}
	,loop: function(volume) {
		if(volume == null) volume = 1.0;
		this.assertNotDisposed();
		return new flambe_platform_html__$HtmlSound_HtmlPlayback(this,volume,true);
	}
	,copyFrom: function(that) {
		this.audioElement = that.audioElement;
	}
	,onDisposed: function() {
		this.audioElement = null;
	}
	,__class__: flambe_platform_html_HtmlSound
});
var flambe_platform_html__$HtmlSound_HtmlPlayback = function(sound,volume,loop) {
	var _g = this;
	this._sound = sound;
	this._tickableAdded = false;
	var _this = js_Browser.get_document();
	this._clonedElement = _this.createElement("audio");
	this._clonedElement.loop = loop;
	this._clonedElement.src = sound.audioElement.src;
	this.volume = new flambe_animation_AnimatedFloat(volume,function(_,_1) {
		_g.updateVolume();
	});
	this.updateVolume();
	this._complete = new flambe_util_Value(false);
	this.playAudio();
	if(flambe_System.hidden.get__()) this.set_paused(true);
};
$hxClasses["flambe.platform.html._HtmlSound.HtmlPlayback"] = flambe_platform_html__$HtmlSound_HtmlPlayback;
flambe_platform_html__$HtmlSound_HtmlPlayback.__name__ = true;
flambe_platform_html__$HtmlSound_HtmlPlayback.__interfaces__ = [flambe_platform_Tickable,flambe_sound_Playback];
flambe_platform_html__$HtmlSound_HtmlPlayback.prototype = {
	get_paused: function() {
		return this._clonedElement.paused;
	}
	,set_paused: function(paused) {
		if(this._clonedElement.paused != paused) {
			if(paused) this._clonedElement.pause(); else this.playAudio();
		}
		return paused;
	}
	,update: function(dt) {
		this.volume.update(dt);
		this._complete.set__(this._clonedElement.ended);
		if(this._complete.get__() || this.get_paused()) {
			this._tickableAdded = false;
			this._volumeBinding.dispose();
			this._hideBinding.dispose();
			return true;
		}
		return false;
	}
	,dispose: function() {
		this.set_paused(true);
		this._complete.set__(true);
	}
	,playAudio: function() {
		var _g = this;
		this._clonedElement.play();
		if(!this._tickableAdded) {
			flambe_platform_html_HtmlPlatform.instance.mainLoop.addTickable(this);
			this._tickableAdded = true;
			this._volumeBinding = flambe_System.volume.get_changed().connect(function(_,_1) {
				_g.updateVolume();
			});
			this._hideBinding = flambe_System.hidden.get_changed().connect(function(hidden,_2) {
				if(hidden) {
					_g._wasPaused = _g.get_paused();
					_g.set_paused(true);
				} else _g.set_paused(_g._wasPaused);
			});
		}
	}
	,updateVolume: function() {
		this._clonedElement.volume = flambe_System.volume.get__() * this.volume.get__();
	}
	,__class__: flambe_platform_html__$HtmlSound_HtmlPlayback
};
var flambe_subsystem_StageSystem = function() { };
$hxClasses["flambe.subsystem.StageSystem"] = flambe_subsystem_StageSystem;
flambe_subsystem_StageSystem.__name__ = true;
flambe_subsystem_StageSystem.prototype = {
	__class__: flambe_subsystem_StageSystem
};
var flambe_platform_html_HtmlStage = function(canvas) {
	var _g = this;
	this._canvas = canvas;
	this.resize = new flambe_util_Signal0();
	this.scaleFactor = flambe_platform_html_HtmlStage.computeScaleFactor();
	if(this.scaleFactor != 1) {
		flambe_Log.info("Reversing device DPI scaling",["scaleFactor",this.scaleFactor]);
		flambe_platform_html_HtmlUtil.setVendorStyle(this._canvas,"transform-origin","top left");
		flambe_platform_html_HtmlUtil.setVendorStyle(this._canvas,"transform","scale(" + 1 / this.scaleFactor + ")");
	}
	if(flambe_platform_html_HtmlUtil.SHOULD_HIDE_MOBILE_BROWSER) {
		js_Browser.get_window().addEventListener("orientationchange",function(_) {
			flambe_platform_html_HtmlUtil.callLater($bind(_g,_g.hideMobileBrowser),200);
		},false);
		this.hideMobileBrowser();
	}
	js_Browser.get_window().addEventListener("resize",$bind(this,this.onWindowResize),false);
	this.onWindowResize(null);
	this.orientation = new flambe_util_Value(null);
	if(js_Browser.get_window().orientation != null) {
		js_Browser.get_window().addEventListener("orientationchange",$bind(this,this.onOrientationChange),false);
		this.onOrientationChange(null);
	}
	this.fullscreen = new flambe_util_Value(false);
	flambe_platform_html_HtmlUtil.addVendorListener(js_Browser.get_document(),"fullscreenchange",function(_1) {
		_g.updateFullscreen();
	},false);
	flambe_platform_html_HtmlUtil.addVendorListener(js_Browser.get_document(),"fullscreenerror",function(_2) {
		flambe_Log.warn("Error when requesting fullscreen");
	},false);
	this.updateFullscreen();
};
$hxClasses["flambe.platform.html.HtmlStage"] = flambe_platform_html_HtmlStage;
flambe_platform_html_HtmlStage.__name__ = true;
flambe_platform_html_HtmlStage.__interfaces__ = [flambe_subsystem_StageSystem];
flambe_platform_html_HtmlStage.computeScaleFactor = function() {
	var devicePixelRatio = js_Browser.get_window().devicePixelRatio;
	if(devicePixelRatio == null) devicePixelRatio = 1;
	var canvas;
	var _this = js_Browser.get_document();
	canvas = _this.createElement("canvas");
	var ctx = canvas.getContext("2d");
	var backingStorePixelRatio = flambe_platform_html_HtmlUtil.loadExtension("backingStorePixelRatio",ctx).value;
	if(backingStorePixelRatio == null) backingStorePixelRatio = 1;
	var scale = devicePixelRatio / backingStorePixelRatio;
	var screenWidth = js_Browser.get_window().screen.width;
	var screenHeight = js_Browser.get_window().screen.height;
	if(scale * screenWidth > 1136 || scale * screenHeight > 1136) return 1;
	return scale;
};
flambe_platform_html_HtmlStage.prototype = {
	get_width: function() {
		return this._canvas.width;
	}
	,get_height: function() {
		return this._canvas.height;
	}
	,onWindowResize: function(_) {
		var container = this._canvas.parentElement;
		var rect = container.getBoundingClientRect();
		this.resizeCanvas(rect.width,rect.height);
	}
	,resizeCanvas: function(width,height) {
		var scaledWidth = this.scaleFactor * width;
		var scaledHeight = this.scaleFactor * height;
		if(this._canvas.width == scaledWidth && this._canvas.height == scaledHeight) return false;
		this._canvas.width = Std["int"](scaledWidth);
		this._canvas.height = Std["int"](scaledHeight);
		this.resize.emit();
		return true;
	}
	,hideMobileBrowser: function() {
		var _g = this;
		var mobileAddressBar = 100;
		var htmlStyle = js_Browser.get_document().documentElement.style;
		htmlStyle.height = js_Browser.get_window().innerHeight + mobileAddressBar + "px";
		htmlStyle.width = js_Browser.get_window().innerWidth + "px";
		htmlStyle.overflow = "visible";
		flambe_platform_html_HtmlUtil.callLater(function() {
			flambe_platform_html_HtmlUtil.hideMobileBrowser();
			flambe_platform_html_HtmlUtil.callLater(function() {
				htmlStyle.height = js_Browser.get_window().innerHeight + "px";
				_g.onWindowResize(null);
			},100);
		});
	}
	,onOrientationChange: function(_) {
		var value = flambe_platform_html_HtmlUtil.orientation(js_Browser.get_window().orientation);
		this.orientation.set__(value);
	}
	,updateFullscreen: function() {
		var state = flambe_platform_html_HtmlUtil.loadFirstExtension(["fullscreen","fullScreen","isFullScreen"],js_Browser.get_document()).value;
		this.fullscreen.set__(state == true);
	}
	,__class__: flambe_platform_html_HtmlStage
};
var flambe_platform_html_HtmlUtil = function() { };
$hxClasses["flambe.platform.html.HtmlUtil"] = flambe_platform_html_HtmlUtil;
flambe_platform_html_HtmlUtil.__name__ = true;
flambe_platform_html_HtmlUtil.callLater = function(func,delay) {
	if(delay == null) delay = 0;
	js_Browser.get_window().setTimeout(func,delay);
};
flambe_platform_html_HtmlUtil.hideMobileBrowser = function() {
	js_Browser.get_window().scrollTo(1,0);
};
flambe_platform_html_HtmlUtil.loadExtension = function(name,obj) {
	if(obj == null) obj = js_Browser.get_window();
	var extension = Reflect.field(obj,name);
	if(extension != null) return { prefix : "", field : name, value : extension};
	var capitalized = name.charAt(0).toUpperCase() + HxOverrides.substr(name,1,null);
	var _g = 0;
	var _g1 = flambe_platform_html_HtmlUtil.VENDOR_PREFIXES;
	while(_g < _g1.length) {
		var prefix = _g1[_g];
		++_g;
		var field = prefix + capitalized;
		var extension1 = Reflect.field(obj,field);
		if(extension1 != null) return { prefix : prefix, field : field, value : extension1};
	}
	return { prefix : null, field : null, value : null};
};
flambe_platform_html_HtmlUtil.loadFirstExtension = function(names,obj) {
	var _g = 0;
	while(_g < names.length) {
		var name = names[_g];
		++_g;
		var extension = flambe_platform_html_HtmlUtil.loadExtension(name,obj);
		if(extension.field != null) return extension;
	}
	return { prefix : null, field : null, value : null};
};
flambe_platform_html_HtmlUtil.polyfill = function(name,obj) {
	if(obj == null) obj = js_Browser.get_window();
	var value = flambe_platform_html_HtmlUtil.loadExtension(name,obj).value;
	if(value == null) return false;
	Reflect.setField(obj,name,value);
	return true;
};
flambe_platform_html_HtmlUtil.setVendorStyle = function(element,name,value) {
	var style = element.style;
	var _g = 0;
	var _g1 = flambe_platform_html_HtmlUtil.VENDOR_PREFIXES;
	while(_g < _g1.length) {
		var prefix = _g1[_g];
		++_g;
		style.setProperty("-" + prefix + "-" + name,value);
	}
	style.setProperty(name,value);
};
flambe_platform_html_HtmlUtil.addVendorListener = function(dispatcher,type,listener,useCapture) {
	var _g = 0;
	var _g1 = flambe_platform_html_HtmlUtil.VENDOR_PREFIXES;
	while(_g < _g1.length) {
		var prefix = _g1[_g];
		++_g;
		dispatcher.addEventListener(prefix + type,listener,useCapture);
	}
	dispatcher.addEventListener(type,listener,useCapture);
};
flambe_platform_html_HtmlUtil.orientation = function(angle) {
	switch(angle) {
	case -90:case 90:
		return flambe_display_Orientation.Landscape;
	default:
		return flambe_display_Orientation.Portrait;
	}
};
flambe_platform_html_HtmlUtil.now = function() {
	return Date.now();
};
flambe_platform_html_HtmlUtil.createEmptyCanvas = function(width,height) {
	var canvas;
	var _this = js_Browser.get_document();
	canvas = _this.createElement("canvas");
	canvas.width = width;
	canvas.height = height;
	return canvas;
};
flambe_platform_html_HtmlUtil.createCanvas = function(source) {
	var canvas = flambe_platform_html_HtmlUtil.createEmptyCanvas(source.width,source.height);
	var ctx = canvas.getContext("2d");
	ctx.save();
	ctx.globalCompositeOperation = "copy";
	ctx.drawImage(source,0,0);
	ctx.restore();
	return canvas;
};
flambe_platform_html_HtmlUtil.detectSlowDriver = function(gl) {
	var windows = js_Browser.get_navigator().platform.indexOf("Win") >= 0;
	if(windows) {
		var chrome = js_Browser.get_window().chrome != null;
		if(chrome) {
			var _g = 0;
			var _g1 = gl.getSupportedExtensions();
			while(_g < _g1.length) {
				var ext = _g1[_g];
				++_g;
				if(ext.indexOf("WEBGL_compressed_texture") >= 0) return false;
			}
			return true;
		}
	}
	return false;
};
flambe_platform_html_HtmlUtil.fixAndroidMath = function() {
	if(js_Browser.get_navigator().userAgent.indexOf("Linux; U; Android 4") >= 0) {
		flambe_Log.warn("Monkey patching around Android sin/cos bug");
		var sin = Math.sin;
		var cos = Math.cos;
		Math.sin = function(x) {
			if(x == 0) return 0; else return sin(x);
		};
		Math.cos = function(x1) {
			if(x1 == 0) return 1; else return cos(x1);
		};
	}
};
var flambe_platform_html_WebAudioSound = function(buffer) {
	flambe_platform_BasicAsset.call(this);
	this.buffer = buffer;
};
$hxClasses["flambe.platform.html.WebAudioSound"] = flambe_platform_html_WebAudioSound;
flambe_platform_html_WebAudioSound.__name__ = true;
flambe_platform_html_WebAudioSound.__interfaces__ = [flambe_sound_Sound];
flambe_platform_html_WebAudioSound.get_supported = function() {
	if(flambe_platform_html_WebAudioSound._detectSupport) {
		flambe_platform_html_WebAudioSound._detectSupport = false;
		var AudioContext = flambe_platform_html_HtmlUtil.loadExtension("AudioContext").value;
		if(AudioContext != null) {
			flambe_platform_html_WebAudioSound.ctx = new AudioContext();
			flambe_platform_html_WebAudioSound.gain = flambe_platform_html_WebAudioSound.createGain();
			flambe_platform_html_WebAudioSound.gain.connect(flambe_platform_html_WebAudioSound.ctx.destination);
			flambe_System.volume.watch(function(volume,_) {
				flambe_platform_html_WebAudioSound.gain.gain.value = volume;
			});
		}
	}
	return flambe_platform_html_WebAudioSound.ctx != null;
};
flambe_platform_html_WebAudioSound.createGain = function() {
	if(flambe_platform_html_WebAudioSound.ctx.createGain != null) return flambe_platform_html_WebAudioSound.ctx.createGain(); else return flambe_platform_html_WebAudioSound.ctx.createGainNode();
};
flambe_platform_html_WebAudioSound.start = function(node,time) {
	if(node.start != null) node.start(time); else node.noteOn(time);
};
flambe_platform_html_WebAudioSound.__super__ = flambe_platform_BasicAsset;
flambe_platform_html_WebAudioSound.prototype = $extend(flambe_platform_BasicAsset.prototype,{
	play: function(volume) {
		if(volume == null) volume = 1.0;
		this.assertNotDisposed();
		return new flambe_platform_html__$WebAudioSound_WebAudioPlayback(this,volume,false);
	}
	,loop: function(volume) {
		if(volume == null) volume = 1.0;
		this.assertNotDisposed();
		return new flambe_platform_html__$WebAudioSound_WebAudioPlayback(this,volume,true);
	}
	,get_duration: function() {
		this.assertNotDisposed();
		return this.buffer.duration;
	}
	,copyFrom: function(that) {
		this.buffer = that.buffer;
	}
	,onDisposed: function() {
		this.buffer = null;
	}
	,__class__: flambe_platform_html_WebAudioSound
});
var flambe_platform_html__$WebAudioSound_WebAudioPlayback = function(sound,volume,loop) {
	var _g = this;
	this._sound = sound;
	this._head = flambe_platform_html_WebAudioSound.gain;
	this._complete = new flambe_util_Value(false);
	this._sourceNode = flambe_platform_html_WebAudioSound.ctx.createBufferSource();
	this._sourceNode.buffer = sound.buffer;
	this._sourceNode.loop = loop;
	this._sourceNode.onended = function() {
		_g._complete.set__(true);
	};
	flambe_platform_html_WebAudioSound.start(this._sourceNode,0);
	this.playAudio();
	this.volume = new flambe_animation_AnimatedFloat(volume,function(v,_) {
		_g.setVolume(v);
	});
	if(volume != 1) this.setVolume(volume);
	if(flambe_System.hidden.get__()) this.set_paused(true);
};
$hxClasses["flambe.platform.html._WebAudioSound.WebAudioPlayback"] = flambe_platform_html__$WebAudioSound_WebAudioPlayback;
flambe_platform_html__$WebAudioSound_WebAudioPlayback.__name__ = true;
flambe_platform_html__$WebAudioSound_WebAudioPlayback.__interfaces__ = [flambe_platform_Tickable,flambe_sound_Playback];
flambe_platform_html__$WebAudioSound_WebAudioPlayback.prototype = {
	get_paused: function() {
		return this._pausedAt >= 0;
	}
	,set_paused: function(paused) {
		if(paused != this.get_paused()) {
			if(paused) {
				this._sourceNode.disconnect();
				this._pausedAt = this.get_position();
			} else this.playAudio();
		}
		return paused;
	}
	,get_position: function() {
		if(this._complete.get__()) return this._sound.get_duration(); else if(this.get_paused()) return this._pausedAt; else {
			var elapsed = flambe_platform_html_WebAudioSound.ctx.currentTime - this._startedAt;
			return elapsed % this._sound.get_duration();
		}
	}
	,update: function(dt) {
		this.volume.update(dt);
		if(this._sourceNode.playbackState == 3) this._complete.set__(true);
		if(this._complete.get__() || this.get_paused()) {
			this._tickableAdded = false;
			this._hideBinding.dispose();
			return true;
		}
		return false;
	}
	,dispose: function() {
		this.set_paused(true);
		this._complete.set__(true);
	}
	,setVolume: function(volume) {
		if(this._gainNode == null) {
			this._gainNode = flambe_platform_html_WebAudioSound.createGain();
			this.insertNode(this._gainNode);
		}
		this._gainNode.gain.value = volume;
	}
	,insertNode: function(head) {
		if(!this.get_paused()) {
			this._sourceNode.disconnect();
			this._sourceNode.connect(head);
		}
		head.connect(this._head);
		this._head = head;
	}
	,playAudio: function() {
		var _g = this;
		this._sourceNode.connect(this._head);
		this._startedAt = flambe_platform_html_WebAudioSound.ctx.currentTime;
		this._pausedAt = -1;
		if(!this._tickableAdded) {
			flambe_platform_html_HtmlPlatform.instance.mainLoop.addTickable(this);
			this._tickableAdded = true;
			this._hideBinding = flambe_System.hidden.get_changed().connect(function(hidden,_) {
				if(hidden) {
					_g._wasPaused = _g.get_paused();
					_g.set_paused(true);
				} else _g.set_paused(_g._wasPaused);
			});
		}
	}
	,__class__: flambe_platform_html__$WebAudioSound_WebAudioPlayback
};
var flambe_platform_html_WebGLBatcher = function(gl) {
	this._backbufferHeight = 0;
	this._backbufferWidth = 0;
	this._dataOffset = 0;
	this._maxQuads = 0;
	this._quads = 0;
	this._pendingSetScissor = false;
	this._currentRenderTarget = null;
	this._currentTexture = null;
	this._currentShader = null;
	this._currentBlendMode = null;
	this._lastScissor = null;
	this._lastTexture = null;
	this._lastShader = null;
	this._lastRenderTarget = null;
	this._lastBlendMode = null;
	this._gl = gl;
	gl.clearColor(0,0,0,0);
	gl.enable(3042);
	gl.pixelStorei(37441,1);
	this._vertexBuffer = gl.createBuffer();
	gl.bindBuffer(34962,this._vertexBuffer);
	this._quadIndexBuffer = gl.createBuffer();
	gl.bindBuffer(34963,this._quadIndexBuffer);
	this._drawTextureShader = new flambe_platform_shader_DrawTextureGL(gl);
	this._drawPatternShader = new flambe_platform_shader_DrawPatternGL(gl);
	this._fillRectShader = new flambe_platform_shader_FillRectGL(gl);
	this.resize(16);
};
$hxClasses["flambe.platform.html.WebGLBatcher"] = flambe_platform_html_WebGLBatcher;
flambe_platform_html_WebGLBatcher.__name__ = true;
flambe_platform_html_WebGLBatcher.prototype = {
	resizeBackbuffer: function(width,height) {
		this._gl.viewport(0,0,width,height);
		this._backbufferWidth = width;
		this._backbufferHeight = height;
	}
	,willRender: function() {
		this._gl.clear(16384);
	}
	,didRender: function() {
		this.flush();
	}
	,bindTexture: function(texture) {
		this.flush();
		this._lastTexture = null;
		this._currentTexture = null;
		this._gl.bindTexture(3553,texture);
	}
	,deleteTexture: function(texture) {
		if(this._lastTexture != null && this._lastTexture.root == texture) {
			this.flush();
			this._lastTexture = null;
			this._currentTexture = null;
		}
		this._gl.deleteTexture(texture.nativeTexture);
	}
	,deleteFramebuffer: function(texture) {
		if(texture == this._lastRenderTarget) {
			this.flush();
			this._lastRenderTarget = null;
			this._currentRenderTarget = null;
		}
		this._gl.deleteFramebuffer(texture.framebuffer);
	}
	,prepareDrawTexture: function(renderTarget,blendMode,scissor,texture) {
		if(texture != this._lastTexture) {
			this.flush();
			this._lastTexture = texture;
		}
		return this.prepareQuad(5,renderTarget,blendMode,scissor,this._drawTextureShader);
	}
	,prepareDrawPattern: function(renderTarget,blendMode,scissor,texture) {
		if(texture != this._lastTexture) {
			this.flush();
			this._lastTexture = texture;
		}
		return this.prepareQuad(5,renderTarget,blendMode,scissor,this._drawPatternShader);
	}
	,prepareFillRect: function(renderTarget,blendMode,scissor) {
		return this.prepareQuad(6,renderTarget,blendMode,scissor,this._fillRectShader);
	}
	,prepareQuad: function(elementsPerVertex,renderTarget,blendMode,scissor,shader) {
		if(renderTarget != this._lastRenderTarget) {
			this.flush();
			this._lastRenderTarget = renderTarget;
		}
		if(blendMode != this._lastBlendMode) {
			this.flush();
			this._lastBlendMode = blendMode;
		}
		if(shader != this._lastShader) {
			this.flush();
			this._lastShader = shader;
		}
		if(scissor != null || this._lastScissor != null) {
			if(scissor == null || this._lastScissor == null || !this._lastScissor.equals(scissor)) {
				this.flush();
				if(scissor != null) this._lastScissor = scissor.clone(this._lastScissor); else this._lastScissor = null;
				this._pendingSetScissor = true;
			}
		}
		if(this._quads >= this._maxQuads) this.resize(2 * this._maxQuads);
		++this._quads;
		var offset = this._dataOffset;
		this._dataOffset += 4 * elementsPerVertex;
		return offset;
	}
	,flush: function() {
		if(this._quads < 1) return;
		if(this._lastRenderTarget != this._currentRenderTarget) this.bindRenderTarget(this._lastRenderTarget);
		if(this._lastBlendMode != this._currentBlendMode) {
			var _g = this._lastBlendMode;
			switch(Type.enumIndex(_g)) {
			case 0:
				this._gl.blendFunc(1,771);
				break;
			case 1:
				this._gl.blendFunc(1,1);
				break;
			case 2:
				this._gl.blendFunc(0,770);
				break;
			case 3:
				this._gl.blendFunc(1,0);
				break;
			}
			this._currentBlendMode = this._lastBlendMode;
		}
		if(this._pendingSetScissor) {
			if(this._lastScissor != null) {
				this._gl.enable(3089);
				this._gl.scissor(Std["int"](this._lastScissor.x),Std["int"](this._lastScissor.y),Std["int"](this._lastScissor.width),Std["int"](this._lastScissor.height));
			} else this._gl.disable(3089);
			this._pendingSetScissor = false;
		}
		if(this._lastTexture != this._currentTexture) {
			this._gl.bindTexture(3553,this._lastTexture.root.nativeTexture);
			this._currentTexture = this._lastTexture;
		}
		if(this._lastShader != this._currentShader) {
			this._lastShader.useProgram();
			this._lastShader.prepare();
			this._currentShader = this._lastShader;
		}
		if(this._lastShader == this._drawPatternShader) {
			var texture = this._lastTexture;
			var root = texture.root;
			this._drawPatternShader.setRegion(texture.rootX / root.width,texture.rootY / root.height,texture.get_width() / root.width,texture.get_height() / root.height);
		}
		this._gl.bufferData(34962,this.data.subarray(0,this._dataOffset),35040);
		this._gl.drawElements(4,6 * this._quads,5123,0);
		this._quads = 0;
		this._dataOffset = 0;
	}
	,resize: function(maxQuads) {
		this.flush();
		if(maxQuads > 1024) return;
		this._maxQuads = maxQuads;
		this.data = new Float32Array(maxQuads * 4 * 6);
		this._gl.bufferData(34962,this.data.length * 4,35040);
		var indices = new Uint16Array(6 * maxQuads);
		var _g = 0;
		while(_g < maxQuads) {
			var ii = _g++;
			indices[ii * 6 + 0] = ii * 4 + 0;
			indices[ii * 6 + 1] = ii * 4 + 1;
			indices[ii * 6 + 2] = ii * 4 + 2;
			indices[ii * 6 + 3] = ii * 4 + 2;
			indices[ii * 6 + 4] = ii * 4 + 3;
			indices[ii * 6 + 5] = ii * 4 + 0;
		}
		this._gl.bufferData(34963,indices,35044);
	}
	,bindRenderTarget: function(texture) {
		if(texture != null) {
			this._gl.bindFramebuffer(36160,texture.framebuffer);
			this._gl.viewport(0,0,texture.width,texture.height);
		} else {
			this._gl.bindFramebuffer(36160,null);
			this._gl.viewport(0,0,this._backbufferWidth,this._backbufferHeight);
		}
		this._currentRenderTarget = texture;
		this._lastRenderTarget = texture;
	}
	,__class__: flambe_platform_html_WebGLBatcher
};
var flambe_platform_html_WebGLGraphics = function(batcher,renderTarget) {
	this._stateList = null;
	this._inverseProjection = null;
	if(flambe_platform_html_WebGLGraphics._scratchQuadArray == null) flambe_platform_html_WebGLGraphics._scratchQuadArray = new Float32Array(8);
	this._batcher = batcher;
	this._renderTarget = renderTarget;
};
$hxClasses["flambe.platform.html.WebGLGraphics"] = flambe_platform_html_WebGLGraphics;
flambe_platform_html_WebGLGraphics.__name__ = true;
flambe_platform_html_WebGLGraphics.__interfaces__ = [flambe_platform_InternalGraphics];
flambe_platform_html_WebGLGraphics.prototype = {
	save: function() {
		var current = this._stateList;
		var state = this._stateList.next;
		if(state == null) {
			state = new flambe_platform_html__$WebGLGraphics_DrawingState();
			state.prev = current;
			current.next = state;
		}
		current.matrix.clone(state.matrix);
		state.alpha = current.alpha;
		state.blendMode = current.blendMode;
		if(current.scissor != null) state.scissor = current.scissor.clone(state.scissor); else state.scissor = null;
		this._stateList = state;
	}
	,translate: function(x,y) {
		var matrix = this.getTopState().matrix;
		matrix.m02 += matrix.m00 * x + matrix.m01 * y;
		matrix.m12 += matrix.m10 * x + matrix.m11 * y;
	}
	,scale: function(x,y) {
		var matrix = this.getTopState().matrix;
		matrix.m00 *= x;
		matrix.m10 *= x;
		matrix.m01 *= y;
		matrix.m11 *= y;
	}
	,rotate: function(rotation) {
		var matrix = this.getTopState().matrix;
		rotation = flambe_math_FMath.toRadians(rotation);
		var sin = Math.sin(rotation);
		var cos = Math.cos(rotation);
		var m00 = matrix.m00;
		var m10 = matrix.m10;
		var m01 = matrix.m01;
		var m11 = matrix.m11;
		matrix.m00 = m00 * cos + m01 * sin;
		matrix.m10 = m10 * cos + m11 * sin;
		matrix.m01 = m01 * cos - m00 * sin;
		matrix.m11 = m11 * cos - m10 * sin;
	}
	,transform: function(m00,m10,m01,m11,m02,m12) {
		var state = this.getTopState();
		flambe_platform_html_WebGLGraphics._scratchMatrix.set(m00,m10,m01,m11,m02,m12);
		flambe_math_Matrix.multiply(state.matrix,flambe_platform_html_WebGLGraphics._scratchMatrix,state.matrix);
	}
	,restore: function() {
		flambe_util_Assert.that(this._stateList.prev != null,"Can't restore without a previous save");
		this._stateList = this._stateList.prev;
	}
	,drawTexture: function(texture,x,y) {
		this.drawSubTexture(texture,x,y,0,0,texture.get_width(),texture.get_height());
	}
	,drawSubTexture: function(texture,destX,destY,sourceX,sourceY,sourceW,sourceH) {
		var state = this.getTopState();
		var texture1 = texture;
		var root = texture1.root;
		root.assertNotDisposed();
		var pos = this.transformQuad(destX,destY,sourceW,sourceH);
		var rootWidth = root.width;
		var rootHeight = root.height;
		var u1 = (texture1.rootX + sourceX) / rootWidth;
		var v1 = (texture1.rootY + sourceY) / rootHeight;
		var u2 = u1 + sourceW / rootWidth;
		var v2 = v1 + sourceH / rootHeight;
		var alpha = state.alpha;
		var offset = this._batcher.prepareDrawTexture(this._renderTarget,state.blendMode,state.scissor,texture1);
		var data = this._batcher.data;
		data[offset] = pos[0];
		data[++offset] = pos[1];
		data[++offset] = u1;
		data[++offset] = v1;
		data[++offset] = alpha;
		data[++offset] = pos[2];
		data[++offset] = pos[3];
		data[++offset] = u2;
		data[++offset] = v1;
		data[++offset] = alpha;
		data[++offset] = pos[4];
		data[++offset] = pos[5];
		data[++offset] = u2;
		data[++offset] = v2;
		data[++offset] = alpha;
		data[++offset] = pos[6];
		data[++offset] = pos[7];
		data[++offset] = u1;
		data[++offset] = v2;
		data[++offset] = alpha;
	}
	,drawPattern: function(texture,x,y,width,height) {
		var state = this.getTopState();
		var texture1 = texture;
		var root = texture1.root;
		root.assertNotDisposed();
		var pos = this.transformQuad(x,y,width,height);
		var u2 = width / root.width;
		var v2 = height / root.height;
		var alpha = state.alpha;
		var offset = this._batcher.prepareDrawPattern(this._renderTarget,state.blendMode,state.scissor,texture1);
		var data = this._batcher.data;
		data[offset] = pos[0];
		data[++offset] = pos[1];
		data[++offset] = 0;
		data[++offset] = 0;
		data[++offset] = alpha;
		data[++offset] = pos[2];
		data[++offset] = pos[3];
		data[++offset] = u2;
		data[++offset] = 0;
		data[++offset] = alpha;
		data[++offset] = pos[4];
		data[++offset] = pos[5];
		data[++offset] = u2;
		data[++offset] = v2;
		data[++offset] = alpha;
		data[++offset] = pos[6];
		data[++offset] = pos[7];
		data[++offset] = 0;
		data[++offset] = v2;
		data[++offset] = alpha;
	}
	,fillRect: function(color,x,y,width,height) {
		var state = this.getTopState();
		var pos = this.transformQuad(x,y,width,height);
		var r = (color & 16711680) / 16711680;
		var g = (color & 65280) / 65280;
		var b = (color & 255) / 255;
		var a = state.alpha;
		var offset = this._batcher.prepareFillRect(this._renderTarget,state.blendMode,state.scissor);
		var data = this._batcher.data;
		data[offset] = pos[0];
		data[++offset] = pos[1];
		data[++offset] = r;
		data[++offset] = g;
		data[++offset] = b;
		data[++offset] = a;
		data[++offset] = pos[2];
		data[++offset] = pos[3];
		data[++offset] = r;
		data[++offset] = g;
		data[++offset] = b;
		data[++offset] = a;
		data[++offset] = pos[4];
		data[++offset] = pos[5];
		data[++offset] = r;
		data[++offset] = g;
		data[++offset] = b;
		data[++offset] = a;
		data[++offset] = pos[6];
		data[++offset] = pos[7];
		data[++offset] = r;
		data[++offset] = g;
		data[++offset] = b;
		data[++offset] = a;
	}
	,multiplyAlpha: function(factor) {
		this.getTopState().alpha *= factor;
	}
	,setBlendMode: function(blendMode) {
		this.getTopState().blendMode = blendMode;
	}
	,applyScissor: function(x,y,width,height) {
		var state = this.getTopState();
		var rect = flambe_platform_html_WebGLGraphics._scratchQuadArray;
		rect[0] = x;
		rect[1] = y;
		rect[2] = x + width;
		rect[3] = y + height;
		state.matrix.transformArray(rect,4,rect);
		this._inverseProjection.transformArray(rect,4,rect);
		x = rect[0];
		y = rect[1];
		width = rect[2] - x;
		height = rect[3] - y;
		if(width < 0) {
			x += width;
			width = -width;
		}
		if(height < 0) {
			y += height;
			height = -height;
		}
		state.applyScissor(x,y,width,height);
	}
	,willRender: function() {
		this._batcher.willRender();
	}
	,didRender: function() {
		this._batcher.didRender();
	}
	,onResize: function(width,height) {
		this._stateList = new flambe_platform_html__$WebGLGraphics_DrawingState();
		var flip;
		if(this._renderTarget != null) flip = -1; else flip = 1;
		this._stateList.matrix.set(2 / width,0,0,flip * -2 / height,-1,flip);
		this._inverseProjection = new flambe_math_Matrix();
		this._inverseProjection.set(2 / width,0,0,2 / height,-1,-1);
		this._inverseProjection.invert();
	}
	,getTopState: function() {
		return this._stateList;
	}
	,transformQuad: function(x,y,width,height) {
		var x2 = x + width;
		var y2 = y + height;
		var pos = flambe_platform_html_WebGLGraphics._scratchQuadArray;
		pos[0] = x;
		pos[1] = y;
		pos[2] = x2;
		pos[3] = y;
		pos[4] = x2;
		pos[5] = y2;
		pos[6] = x;
		pos[7] = y2;
		this.getTopState().matrix.transformArray(pos,8,pos);
		return pos;
	}
	,__class__: flambe_platform_html_WebGLGraphics
};
var flambe_platform_html__$WebGLGraphics_DrawingState = function() {
	this.next = null;
	this.prev = null;
	this.scissor = null;
	this.matrix = new flambe_math_Matrix();
	this.alpha = 1;
	this.blendMode = flambe_display_BlendMode.Normal;
};
$hxClasses["flambe.platform.html._WebGLGraphics.DrawingState"] = flambe_platform_html__$WebGLGraphics_DrawingState;
flambe_platform_html__$WebGLGraphics_DrawingState.__name__ = true;
flambe_platform_html__$WebGLGraphics_DrawingState.prototype = {
	applyScissor: function(x,y,width,height) {
		if(this.scissor != null) {
			var x1 = flambe_math_FMath.max(this.scissor.x,x);
			var y1 = flambe_math_FMath.max(this.scissor.y,y);
			var x2 = flambe_math_FMath.min(this.scissor.x + this.scissor.width,x + width);
			var y2 = flambe_math_FMath.min(this.scissor.y + this.scissor.height,y + height);
			x = x1;
			y = y1;
			width = x2 - x1;
			height = y2 - y1;
		} else this.scissor = new flambe_math_Rectangle();
		this.scissor.set(Math.round(x),Math.round(y),Math.round(width),Math.round(height));
	}
	,__class__: flambe_platform_html__$WebGLGraphics_DrawingState
};
var flambe_platform_html_WebGLRenderer = function(stage,gl) {
	var _g = this;
	this._hasGPU = new flambe_util_Value(true);
	this.gl = gl;
	gl.canvas.addEventListener("webglcontextlost",function(event) {
		event.preventDefault();
		flambe_Log.warn("WebGL context lost");
		_g._hasGPU.set__(false);
	},false);
	gl.canvas.addEventListener("webglcontextrestore",function(event1) {
		flambe_Log.warn("WebGL context restored");
		_g.init();
		_g._hasGPU.set__(true);
	},false);
	stage.resize.connect($bind(this,this.onResize));
	this.init();
};
$hxClasses["flambe.platform.html.WebGLRenderer"] = flambe_platform_html_WebGLRenderer;
flambe_platform_html_WebGLRenderer.__name__ = true;
flambe_platform_html_WebGLRenderer.__interfaces__ = [flambe_platform_InternalRenderer];
flambe_platform_html_WebGLRenderer.prototype = {
	get_type: function() {
		return flambe_subsystem_RendererType.WebGL;
	}
	,createTextureFromImage: function(image) {
		if(this.gl.isContextLost()) return null;
		var root = new flambe_platform_html_WebGLTextureRoot(this,image.width,image.height);
		root.uploadImageData(image);
		return root.createTexture(image.width,image.height);
	}
	,getCompressedTextureFormats: function() {
		return [];
	}
	,createCompressedTexture: function(format,data) {
		if(this.gl.isContextLost()) return null;
		flambe_util_Assert.fail();
		return null;
	}
	,willRender: function() {
		this.graphics.willRender();
	}
	,didRender: function() {
		this.graphics.didRender();
	}
	,onResize: function() {
		var width = this.gl.canvas.width;
		var height = this.gl.canvas.height;
		this.batcher.resizeBackbuffer(width,height);
		this.graphics.onResize(width,height);
	}
	,init: function() {
		this.batcher = new flambe_platform_html_WebGLBatcher(this.gl);
		this.graphics = new flambe_platform_html_WebGLGraphics(this.batcher,null);
		this.onResize();
	}
	,__class__: flambe_platform_html_WebGLRenderer
};
var flambe_platform_html_WebGLTexture = function(root,width,height) {
	flambe_platform_BasicTexture.call(this,root,width,height);
};
$hxClasses["flambe.platform.html.WebGLTexture"] = flambe_platform_html_WebGLTexture;
flambe_platform_html_WebGLTexture.__name__ = true;
flambe_platform_html_WebGLTexture.__super__ = flambe_platform_BasicTexture;
flambe_platform_html_WebGLTexture.prototype = $extend(flambe_platform_BasicTexture.prototype,{
	__class__: flambe_platform_html_WebGLTexture
});
var flambe_platform_html_WebGLTextureRoot = function(renderer,width,height) {
	this._graphics = null;
	this.framebuffer = null;
	flambe_platform_BasicAsset.call(this);
	this._renderer = renderer;
	this.width = flambe_math_FMath.max(2,flambe_platform_MathUtil.nextPowerOfTwo(width));
	this.height = flambe_math_FMath.max(2,flambe_platform_MathUtil.nextPowerOfTwo(height));
	var gl = renderer.gl;
	this.nativeTexture = gl.createTexture();
	renderer.batcher.bindTexture(this.nativeTexture);
	gl.texParameteri(3553,10242,33071);
	gl.texParameteri(3553,10243,33071);
	gl.texParameteri(3553,10240,9729);
	gl.texParameteri(3553,10241,9728);
};
$hxClasses["flambe.platform.html.WebGLTextureRoot"] = flambe_platform_html_WebGLTextureRoot;
flambe_platform_html_WebGLTextureRoot.__name__ = true;
flambe_platform_html_WebGLTextureRoot.__interfaces__ = [flambe_platform_TextureRoot];
flambe_platform_html_WebGLTextureRoot.drawBorder = function(canvas,width,height) {
	var ctx = canvas.getContext("2d");
	ctx.drawImage(canvas,width - 1,0,1,height,width,0,1,height);
	ctx.drawImage(canvas,0,height - 1,width,1,0,height,width,1);
};
flambe_platform_html_WebGLTextureRoot.__super__ = flambe_platform_BasicAsset;
flambe_platform_html_WebGLTextureRoot.prototype = $extend(flambe_platform_BasicAsset.prototype,{
	createTexture: function(width,height) {
		return new flambe_platform_html_WebGLTexture(this,width,height);
	}
	,uploadImageData: function(image) {
		this.assertNotDisposed();
		if(this.width != image.width || this.height != image.height) {
			var resized = flambe_platform_html_HtmlUtil.createEmptyCanvas(this.width,this.height);
			resized.getContext("2d").drawImage(image,0,0);
			flambe_platform_html_WebGLTextureRoot.drawBorder(resized,image.width,image.height);
			image = resized;
		}
		this._renderer.batcher.bindTexture(this.nativeTexture);
		var gl = this._renderer.gl;
		gl.texImage2D(3553,0,6408,6408,5121,image);
	}
	,copyFrom: function(that) {
		this.nativeTexture = that.nativeTexture;
		this.framebuffer = that.framebuffer;
		this.width = that.width;
		this.height = that.height;
		this._graphics = that._graphics;
	}
	,onDisposed: function() {
		var batcher = this._renderer.batcher;
		batcher.deleteTexture(this);
		if(this.framebuffer != null) batcher.deleteFramebuffer(this);
		this.nativeTexture = null;
		this.framebuffer = null;
		this._graphics = null;
	}
	,__class__: flambe_platform_html_WebGLTextureRoot
});
var flambe_platform_shader_ShaderGL = function(gl,vertSource,fragSource) {
	fragSource = ["#ifdef GL_ES","precision mediump float;","#endif"].join("\n") + "\n" + fragSource;
	this._gl = gl;
	this._program = gl.createProgram();
	gl.attachShader(this._program,flambe_platform_shader_ShaderGL.createShader(gl,35633,vertSource));
	gl.attachShader(this._program,flambe_platform_shader_ShaderGL.createShader(gl,35632,fragSource));
	gl.linkProgram(this._program);
	gl.useProgram(this._program);
	if(!gl.getProgramParameter(this._program,35714)) flambe_Log.error("Error linking shader program",["log",gl.getProgramInfoLog(this._program)]);
};
$hxClasses["flambe.platform.shader.ShaderGL"] = flambe_platform_shader_ShaderGL;
flambe_platform_shader_ShaderGL.__name__ = true;
flambe_platform_shader_ShaderGL.createShader = function(gl,type,source) {
	var shader = gl.createShader(type);
	gl.shaderSource(shader,source);
	gl.compileShader(shader);
	if(!gl.getShaderParameter(shader,35713)) {
		var typeName;
		if(type == 35633) typeName = "vertex"; else typeName = "fragment";
		flambe_Log.error("Error compiling " + typeName + " shader",["log",gl.getShaderInfoLog(shader)]);
	}
	return shader;
};
flambe_platform_shader_ShaderGL.prototype = {
	useProgram: function() {
		this._gl.useProgram(this._program);
	}
	,prepare: function() {
		flambe_util_Assert.fail("abstract");
	}
	,getAttribLocation: function(name) {
		var loc = this._gl.getAttribLocation(this._program,name);
		flambe_util_Assert.that(loc >= 0,"Missing attribute",["name",name]);
		return loc;
	}
	,getUniformLocation: function(name) {
		var loc = this._gl.getUniformLocation(this._program,name);
		flambe_util_Assert.that(loc != null,"Missing uniform",["name",name]);
		return loc;
	}
	,__class__: flambe_platform_shader_ShaderGL
};
var flambe_platform_shader_DrawPatternGL = function(gl) {
	flambe_platform_shader_ShaderGL.call(this,gl,["attribute highp vec2 a_pos;","attribute mediump vec2 a_uv;","attribute lowp float a_alpha;","varying mediump vec2 v_uv;","varying lowp float v_alpha;","void main (void) {","v_uv = a_uv;","v_alpha = a_alpha;","gl_Position = vec4(a_pos, 0, 1);","}"].join("\n"),["varying mediump vec2 v_uv;","varying lowp float v_alpha;","uniform lowp sampler2D u_texture;","uniform mediump vec4 u_region;","void main (void) {","gl_FragColor = texture2D(u_texture, u_region.xy + mod(v_uv, u_region.zw)) * v_alpha;","}"].join("\n"));
	this.a_pos = this.getAttribLocation("a_pos");
	this.a_uv = this.getAttribLocation("a_uv");
	this.a_alpha = this.getAttribLocation("a_alpha");
	this.u_texture = this.getUniformLocation("u_texture");
	this.u_region = this.getUniformLocation("u_region");
	this.setTexture(0);
};
$hxClasses["flambe.platform.shader.DrawPatternGL"] = flambe_platform_shader_DrawPatternGL;
flambe_platform_shader_DrawPatternGL.__name__ = true;
flambe_platform_shader_DrawPatternGL.__super__ = flambe_platform_shader_ShaderGL;
flambe_platform_shader_DrawPatternGL.prototype = $extend(flambe_platform_shader_ShaderGL.prototype,{
	setTexture: function(unit) {
		this._gl.uniform1i(this.u_texture,unit);
	}
	,setRegion: function(x,y,width,height) {
		this._gl.uniform4f(this.u_region,x,y,width,height);
	}
	,prepare: function() {
		this._gl.enableVertexAttribArray(this.a_pos);
		this._gl.enableVertexAttribArray(this.a_uv);
		this._gl.enableVertexAttribArray(this.a_alpha);
		var bytesPerFloat = 4;
		var stride = 5 * bytesPerFloat;
		this._gl.vertexAttribPointer(this.a_pos,2,5126,false,stride,0 * bytesPerFloat);
		this._gl.vertexAttribPointer(this.a_uv,2,5126,false,stride,2 * bytesPerFloat);
		this._gl.vertexAttribPointer(this.a_alpha,1,5126,false,stride,4 * bytesPerFloat);
	}
	,__class__: flambe_platform_shader_DrawPatternGL
});
var flambe_platform_shader_DrawTextureGL = function(gl) {
	flambe_platform_shader_ShaderGL.call(this,gl,["attribute highp vec2 a_pos;","attribute mediump vec2 a_uv;","attribute lowp float a_alpha;","varying mediump vec2 v_uv;","varying lowp float v_alpha;","void main (void) {","v_uv = a_uv;","v_alpha = a_alpha;","gl_Position = vec4(a_pos, 0, 1);","}"].join("\n"),["varying mediump vec2 v_uv;","varying lowp float v_alpha;","uniform lowp sampler2D u_texture;","void main (void) {","gl_FragColor = texture2D(u_texture, v_uv) * v_alpha;","}"].join("\n"));
	this.a_pos = this.getAttribLocation("a_pos");
	this.a_uv = this.getAttribLocation("a_uv");
	this.a_alpha = this.getAttribLocation("a_alpha");
	this.u_texture = this.getUniformLocation("u_texture");
	this.setTexture(0);
};
$hxClasses["flambe.platform.shader.DrawTextureGL"] = flambe_platform_shader_DrawTextureGL;
flambe_platform_shader_DrawTextureGL.__name__ = true;
flambe_platform_shader_DrawTextureGL.__super__ = flambe_platform_shader_ShaderGL;
flambe_platform_shader_DrawTextureGL.prototype = $extend(flambe_platform_shader_ShaderGL.prototype,{
	setTexture: function(unit) {
		this._gl.uniform1i(this.u_texture,unit);
	}
	,prepare: function() {
		this._gl.enableVertexAttribArray(this.a_pos);
		this._gl.enableVertexAttribArray(this.a_uv);
		this._gl.enableVertexAttribArray(this.a_alpha);
		var bytesPerFloat = 4;
		var stride = 5 * bytesPerFloat;
		this._gl.vertexAttribPointer(this.a_pos,2,5126,false,stride,0 * bytesPerFloat);
		this._gl.vertexAttribPointer(this.a_uv,2,5126,false,stride,2 * bytesPerFloat);
		this._gl.vertexAttribPointer(this.a_alpha,1,5126,false,stride,4 * bytesPerFloat);
	}
	,__class__: flambe_platform_shader_DrawTextureGL
});
var flambe_platform_shader_FillRectGL = function(gl) {
	flambe_platform_shader_ShaderGL.call(this,gl,["attribute highp vec2 a_pos;","attribute lowp vec3 a_rgb;","attribute lowp float a_alpha;","varying lowp vec4 v_color;","void main (void) {","v_color = vec4(a_rgb*a_alpha, a_alpha);","gl_Position = vec4(a_pos, 0, 1);","}"].join("\n"),["varying lowp vec4 v_color;","void main (void) {","gl_FragColor = v_color;","}"].join("\n"));
	this.a_pos = this.getAttribLocation("a_pos");
	this.a_rgb = this.getAttribLocation("a_rgb");
	this.a_alpha = this.getAttribLocation("a_alpha");
};
$hxClasses["flambe.platform.shader.FillRectGL"] = flambe_platform_shader_FillRectGL;
flambe_platform_shader_FillRectGL.__name__ = true;
flambe_platform_shader_FillRectGL.__super__ = flambe_platform_shader_ShaderGL;
flambe_platform_shader_FillRectGL.prototype = $extend(flambe_platform_shader_ShaderGL.prototype,{
	prepare: function() {
		this._gl.enableVertexAttribArray(this.a_pos);
		this._gl.enableVertexAttribArray(this.a_rgb);
		this._gl.enableVertexAttribArray(this.a_alpha);
		var bytesPerFloat = 4;
		var stride = 6 * bytesPerFloat;
		this._gl.vertexAttribPointer(this.a_pos,2,5126,false,stride,0 * bytesPerFloat);
		this._gl.vertexAttribPointer(this.a_rgb,3,5126,false,stride,2 * bytesPerFloat);
		this._gl.vertexAttribPointer(this.a_alpha,1,5126,false,stride,5 * bytesPerFloat);
	}
	,__class__: flambe_platform_shader_FillRectGL
});
var flambe_scene_Director = function() {
	this._height = -1;
	this._width = -1;
	this._transitor = null;
	this.scenes = [];
	this.occludedScenes = [];
	this._root = new flambe_Entity();
};
$hxClasses["flambe.scene.Director"] = flambe_scene_Director;
flambe_scene_Director.__name__ = true;
flambe_scene_Director.__super__ = flambe_Component;
flambe_scene_Director.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Director_6";
	}
	,pushScene: function(scene,transition) {
		var _g = this;
		this.completeTransition();
		var oldTop = this.get_topScene();
		if(oldTop != null) this.playTransition(oldTop,scene,transition,function() {
			_g.hide(oldTop);
		}); else {
			this.add(scene);
			this.invalidateVisibility();
		}
	}
	,popScene: function(transition) {
		var _g = this;
		this.completeTransition();
		var oldTop = this.get_topScene();
		if(oldTop != null) {
			this.scenes.pop();
			var newTop = this.get_topScene();
			if(newTop != null) this.playTransition(oldTop,newTop,transition,function() {
				_g.hideAndDispose(oldTop);
			}); else {
				this.hideAndDispose(oldTop);
				this.invalidateVisibility();
			}
		}
	}
	,unwindToScene: function(scene,transition) {
		var _g = this;
		this.completeTransition();
		var oldTop = this.get_topScene();
		if(oldTop != null) {
			if(oldTop == scene) return;
			this.scenes.pop();
			while(this.scenes.length > 0 && this.scenes[this.scenes.length - 1] != scene) this.scenes.pop().dispose();
			this.playTransition(oldTop,scene,transition,function() {
				_g.hideAndDispose(oldTop);
			});
		} else this.pushScene(scene,transition);
	}
	,onAdded: function() {
		this.owner.addChild(this._root);
	}
	,onRemoved: function() {
		this.completeTransition();
		var _g = 0;
		var _g1 = this.scenes;
		while(_g < _g1.length) {
			var scene = _g1[_g];
			++_g;
			scene.dispose();
		}
		this.scenes = [];
		this.occludedScenes = [];
		this._root.dispose();
	}
	,onUpdate: function(dt) {
		if(this._transitor != null && this._transitor.update(dt)) this.completeTransition();
	}
	,get_topScene: function() {
		var ll = this.scenes.length;
		if(ll > 0) return this.scenes[ll - 1]; else return null;
	}
	,add: function(scene) {
		var oldTop = this.get_topScene();
		if(oldTop != null) this._root.removeChild(oldTop);
		HxOverrides.remove(this.scenes,scene);
		this.scenes.push(scene);
		this._root.addChild(scene);
	}
	,hide: function(scene) {
		var events = scene.getComponent("Scene_8");
		if(events != null) events.hidden.emit();
	}
	,hideAndDispose: function(scene) {
		this.hide(scene);
		scene.dispose();
	}
	,show: function(scene) {
		var events = scene.getComponent("Scene_8");
		if(events != null) events.shown.emit();
	}
	,invalidateVisibility: function() {
		var ii = this.scenes.length;
		while(ii > 0) {
			var scene = this.scenes[--ii];
			var comp = scene.getComponent("Scene_8");
			if(comp == null || comp.opaque) break;
		}
		if(this.scenes.length > 0) this.occludedScenes = this.scenes.slice(ii,this.scenes.length - 1); else this.occludedScenes = [];
		var scene1 = this.get_topScene();
		if(scene1 != null) this.show(scene1);
	}
	,completeTransition: function() {
		if(this._transitor != null) {
			this._transitor.complete();
			this._transitor = null;
			this.invalidateVisibility();
		}
	}
	,playTransition: function(from,to,transition,onComplete) {
		this.completeTransition();
		this.add(to);
		if(transition != null) {
			this.occludedScenes.push(from);
			this._transitor = new flambe_scene__$Director_Transitor(from,to,transition,onComplete);
			this._transitor.init(this);
		} else {
			onComplete();
			this.invalidateVisibility();
		}
	}
	,get_width: function() {
		if(this._width < 0) return flambe_System.get_stage().get_width(); else return this._width;
	}
	,get_height: function() {
		if(this._height < 0) return flambe_System.get_stage().get_height(); else return this._height;
	}
	,__class__: flambe_scene_Director
});
var flambe_scene__$Director_Transitor = function(from,to,transition,onComplete) {
	this._from = from;
	this._to = to;
	this._transition = transition;
	this._onComplete = onComplete;
};
$hxClasses["flambe.scene._Director.Transitor"] = flambe_scene__$Director_Transitor;
flambe_scene__$Director_Transitor.__name__ = true;
flambe_scene__$Director_Transitor.prototype = {
	init: function(director) {
		this._transition.init(director,this._from,this._to);
	}
	,update: function(dt) {
		return this._transition.update(dt);
	}
	,complete: function() {
		this._transition.complete();
		this._onComplete();
	}
	,__class__: flambe_scene__$Director_Transitor
};
var flambe_scene_Transition = function() { };
$hxClasses["flambe.scene.Transition"] = flambe_scene_Transition;
flambe_scene_Transition.__name__ = true;
flambe_scene_Transition.prototype = {
	init: function(director,from,to) {
		this._director = director;
		this._from = from;
		this._to = to;
	}
	,update: function(dt) {
		return true;
	}
	,complete: function() {
	}
	,__class__: flambe_scene_Transition
};
var flambe_scene_TweenTransition = function(duration,ease) {
	this._duration = duration;
	if(ease != null) this._ease = ease; else this._ease = flambe_animation_Ease.linear;
};
$hxClasses["flambe.scene.TweenTransition"] = flambe_scene_TweenTransition;
flambe_scene_TweenTransition.__name__ = true;
flambe_scene_TweenTransition.__super__ = flambe_scene_Transition;
flambe_scene_TweenTransition.prototype = $extend(flambe_scene_Transition.prototype,{
	init: function(director,from,to) {
		flambe_scene_Transition.prototype.init.call(this,director,from,to);
		this._elapsed = 0;
	}
	,update: function(dt) {
		this._elapsed += dt;
		return this._elapsed >= this._duration;
	}
	,interp: function(from,to) {
		return from + (to - from) * this._ease(this._elapsed / this._duration);
	}
	,__class__: flambe_scene_TweenTransition
});
var flambe_scene_FadeTransition = function(duration,ease) {
	flambe_scene_TweenTransition.call(this,duration,ease);
};
$hxClasses["flambe.scene.FadeTransition"] = flambe_scene_FadeTransition;
flambe_scene_FadeTransition.__name__ = true;
flambe_scene_FadeTransition.__super__ = flambe_scene_TweenTransition;
flambe_scene_FadeTransition.prototype = $extend(flambe_scene_TweenTransition.prototype,{
	init: function(director,from,to) {
		flambe_scene_TweenTransition.prototype.init.call(this,director,from,to);
		var sprite = this._to.getComponent("Sprite_4");
		if(sprite == null) this._to.add(sprite = new flambe_display_Sprite());
		sprite.alpha.set__(0);
	}
	,update: function(dt) {
		var done = flambe_scene_TweenTransition.prototype.update.call(this,dt);
		this._to.getComponent("Sprite_4").alpha.set__(this.interp(0,1));
		return done;
	}
	,complete: function() {
		this._to.getComponent("Sprite_4").alpha.set__(1);
	}
	,__class__: flambe_scene_FadeTransition
});
var flambe_scene_Scene = function(opaque) {
	if(opaque == null) opaque = true;
	this.opaque = opaque;
	this.shown = new flambe_util_Signal0();
	this.hidden = new flambe_util_Signal0();
};
$hxClasses["flambe.scene.Scene"] = flambe_scene_Scene;
flambe_scene_Scene.__name__ = true;
flambe_scene_Scene.__super__ = flambe_Component;
flambe_scene_Scene.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Scene_8";
	}
	,__class__: flambe_scene_Scene
});
var flambe_scene_SlideTransition = function(duration,ease) {
	this._direction = 2;
	flambe_scene_TweenTransition.call(this,duration,ease);
};
$hxClasses["flambe.scene.SlideTransition"] = flambe_scene_SlideTransition;
flambe_scene_SlideTransition.__name__ = true;
flambe_scene_SlideTransition.__super__ = flambe_scene_TweenTransition;
flambe_scene_SlideTransition.prototype = $extend(flambe_scene_TweenTransition.prototype,{
	init: function(director,from,to) {
		flambe_scene_TweenTransition.prototype.init.call(this,director,from,to);
		var _g = this._direction;
		switch(_g) {
		case 0:
			this._x = 0;
			this._y = -this._director.get_height();
			break;
		case 1:
			this._x = 0;
			this._y = this._director.get_height();
			break;
		case 2:
			this._x = -this._director.get_width();
			this._y = 0;
			break;
		case 3:
			this._x = this._director.get_width();
			this._y = 0;
			break;
		}
		var sprite = this._from.getComponent("Sprite_4");
		if(sprite == null) this._from.add(sprite = new flambe_display_Sprite());
		sprite.setXY(0,0);
		var sprite1 = this._to.getComponent("Sprite_4");
		if(sprite1 == null) this._to.add(sprite1 = new flambe_display_Sprite());
		sprite1.setXY(-this._x,-this._y);
	}
	,update: function(dt) {
		var done = flambe_scene_TweenTransition.prototype.update.call(this,dt);
		this._from.getComponent("Sprite_4").setXY(this.interp(0,this._x),this.interp(0,this._y));
		this._to.getComponent("Sprite_4").setXY(this.interp(-this._x,0),this.interp(-this._y,0));
		return done;
	}
	,complete: function() {
		this._from.getComponent("Sprite_4").setXY(0,0);
		this._to.getComponent("Sprite_4").setXY(0,0);
	}
	,__class__: flambe_scene_SlideTransition
});
var flambe_script_Action = function() { };
$hxClasses["flambe.script.Action"] = flambe_script_Action;
flambe_script_Action.__name__ = true;
flambe_script_Action.prototype = {
	__class__: flambe_script_Action
};
var flambe_script_AnimateBy = function(value,by,seconds,easing) {
	this._value = value;
	this._by = by;
	this._seconds = seconds;
	this._easing = easing;
};
$hxClasses["flambe.script.AnimateBy"] = flambe_script_AnimateBy;
flambe_script_AnimateBy.__name__ = true;
flambe_script_AnimateBy.__interfaces__ = [flambe_script_Action];
flambe_script_AnimateBy.prototype = {
	update: function(dt,actor) {
		if(this._tween == null) {
			this._tween = new flambe_animation_Tween(this._value.get__(),this._value.get__() + this._by,this._seconds,this._easing);
			this._value.set_behavior(this._tween);
			this._value.update(dt);
		}
		if(this._value.get_behavior() != this._tween) {
			var overtime = this._tween.elapsed - this._seconds;
			this._tween = null;
			if(overtime > 0) return dt - overtime; else return 0;
		}
		return -1;
	}
	,__class__: flambe_script_AnimateBy
};
var flambe_script_AnimateTo = function(value,to,seconds,easing) {
	this._value = value;
	this._to = to;
	this._seconds = seconds;
	this._easing = easing;
};
$hxClasses["flambe.script.AnimateTo"] = flambe_script_AnimateTo;
flambe_script_AnimateTo.__name__ = true;
flambe_script_AnimateTo.__interfaces__ = [flambe_script_Action];
flambe_script_AnimateTo.prototype = {
	update: function(dt,actor) {
		if(this._tween == null) {
			this._tween = new flambe_animation_Tween(this._value.get__(),this._to,this._seconds,this._easing);
			this._value.set_behavior(this._tween);
			this._value.update(dt);
		}
		if(this._value.get_behavior() != this._tween) {
			var overtime = this._tween.elapsed - this._seconds;
			this._tween = null;
			if(overtime > 0) return dt - overtime; else return 0;
		}
		return -1;
	}
	,__class__: flambe_script_AnimateTo
};
var flambe_script_CallFunction = function(fn) {
	this._fn = fn;
};
$hxClasses["flambe.script.CallFunction"] = flambe_script_CallFunction;
flambe_script_CallFunction.__name__ = true;
flambe_script_CallFunction.__interfaces__ = [flambe_script_Action];
flambe_script_CallFunction.prototype = {
	update: function(dt,actor) {
		this._fn();
		return 0;
	}
	,__class__: flambe_script_CallFunction
};
var flambe_script_Delay = function(seconds) {
	this._duration = seconds;
	this._elapsed = 0;
};
$hxClasses["flambe.script.Delay"] = flambe_script_Delay;
flambe_script_Delay.__name__ = true;
flambe_script_Delay.__interfaces__ = [flambe_script_Action];
flambe_script_Delay.prototype = {
	update: function(dt,actor) {
		this._elapsed += dt;
		if(this._elapsed >= this._duration) {
			var overtime = this._elapsed - this._duration;
			this._elapsed = 0;
			return dt - overtime;
		}
		return -1;
	}
	,__class__: flambe_script_Delay
};
var flambe_script_Parallel = function(actions) {
	this._completedActions = [];
	if(actions != null) this._runningActions = actions.slice(); else this._runningActions = [];
};
$hxClasses["flambe.script.Parallel"] = flambe_script_Parallel;
flambe_script_Parallel.__name__ = true;
flambe_script_Parallel.__interfaces__ = [flambe_script_Action];
flambe_script_Parallel.prototype = {
	update: function(dt,actor) {
		var done = true;
		var maxSpent = 0.0;
		var _g1 = 0;
		var _g = this._runningActions.length;
		while(_g1 < _g) {
			var ii = _g1++;
			var action = this._runningActions[ii];
			if(action != null) {
				var spent = action.update(dt,actor);
				if(spent >= 0) {
					this._runningActions[ii] = null;
					this._completedActions.push(action);
					if(spent > maxSpent) maxSpent = spent;
				} else done = false;
			}
		}
		if(done) {
			this._runningActions = this._completedActions;
			this._completedActions = [];
			return maxSpent;
		}
		return -1;
	}
	,__class__: flambe_script_Parallel
};
var flambe_script_Repeat = function(action,count) {
	if(count == null) count = -1;
	this._action = action;
	this._count = count;
	this._remaining = count;
};
$hxClasses["flambe.script.Repeat"] = flambe_script_Repeat;
flambe_script_Repeat.__name__ = true;
flambe_script_Repeat.__interfaces__ = [flambe_script_Action];
flambe_script_Repeat.prototype = {
	update: function(dt,actor) {
		if(this._count == 0) return 0;
		var spent = this._action.update(dt,actor);
		if(this._count > 0 && spent >= 0 && --this._remaining == 0) {
			this._remaining = this._count;
			return spent;
		}
		return -1;
	}
	,__class__: flambe_script_Repeat
};
var flambe_script_Script = function() {
	this.stopAll();
};
$hxClasses["flambe.script.Script"] = flambe_script_Script;
flambe_script_Script.__name__ = true;
flambe_script_Script.__super__ = flambe_Component;
flambe_script_Script.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Script_1";
	}
	,run: function(action) {
		var handle = new flambe_script__$Script_Handle(action);
		this._handles.push(handle);
		return handle;
	}
	,stopAll: function() {
		this._handles = [];
	}
	,onUpdate: function(dt) {
		var ii = 0;
		while(ii < this._handles.length) {
			var handle = this._handles[ii];
			if(handle.removed || handle.action.update(dt,this.owner) >= 0) this._handles.splice(ii,1); else ++ii;
		}
	}
	,__class__: flambe_script_Script
});
var flambe_script__$Script_Handle = function(action) {
	this.removed = false;
	this.action = action;
};
$hxClasses["flambe.script._Script.Handle"] = flambe_script__$Script_Handle;
flambe_script__$Script_Handle.__name__ = true;
flambe_script__$Script_Handle.__interfaces__ = [flambe_util_Disposable];
flambe_script__$Script_Handle.prototype = {
	dispose: function() {
		this.removed = true;
		this.action = null;
	}
	,__class__: flambe_script__$Script_Handle
};
var flambe_script_Sequence = function(actions) {
	this._idx = 0;
	if(actions != null) this._runningActions = actions.slice(); else this._runningActions = [];
};
$hxClasses["flambe.script.Sequence"] = flambe_script_Sequence;
flambe_script_Sequence.__name__ = true;
flambe_script_Sequence.__interfaces__ = [flambe_script_Action];
flambe_script_Sequence.prototype = {
	update: function(dt,actor) {
		var total = 0.0;
		while(true) {
			var action = this._runningActions[this._idx];
			if(action != null) {
				var spent = action.update(dt - total,actor);
				if(spent >= 0) total += spent; else return -1;
			}
			++this._idx;
			if(this._idx >= this._runningActions.length) {
				this._idx = 0;
				break;
			} else if(total > dt) return -1;
		}
		return total;
	}
	,__class__: flambe_script_Sequence
};
var flambe_subsystem_RendererType = $hxClasses["flambe.subsystem.RendererType"] = { __ename__ : true, __constructs__ : ["Stage3D","WebGL","Canvas"] };
flambe_subsystem_RendererType.Stage3D = ["Stage3D",0];
flambe_subsystem_RendererType.Stage3D.__enum__ = flambe_subsystem_RendererType;
flambe_subsystem_RendererType.WebGL = ["WebGL",1];
flambe_subsystem_RendererType.WebGL.__enum__ = flambe_subsystem_RendererType;
flambe_subsystem_RendererType.Canvas = ["Canvas",2];
flambe_subsystem_RendererType.Canvas.__enum__ = flambe_subsystem_RendererType;
var flambe_util_Arrays = function() { };
$hxClasses["flambe.util.Arrays"] = flambe_util_Arrays;
flambe_util_Arrays.__name__ = true;
flambe_util_Arrays.create = function(length) {
	return new Array(length);
};
var flambe_util_Assert = function() { };
$hxClasses["flambe.util.Assert"] = flambe_util_Assert;
flambe_util_Assert.__name__ = true;
flambe_util_Assert.that = function(condition,message,fields) {
	if(!condition) flambe_util_Assert.fail(message,fields);
};
flambe_util_Assert.fail = function(message,fields) {
	var error = "Assertion failed!";
	if(message != null) error += " " + message;
	if(fields != null) error = flambe_util_Strings.withFields(error,fields);
	throw error;
};
var flambe_util_BitSets = function() { };
$hxClasses["flambe.util.BitSets"] = flambe_util_BitSets;
flambe_util_BitSets.__name__ = true;
flambe_util_BitSets.add = function(bits,mask) {
	return bits | mask;
};
flambe_util_BitSets.remove = function(bits,mask) {
	return bits & ~mask;
};
flambe_util_BitSets.contains = function(bits,mask) {
	return (bits & mask) != 0;
};
flambe_util_BitSets.containsAll = function(bits,mask) {
	return (bits & mask) == mask;
};
flambe_util_BitSets.set = function(bits,mask,enabled) {
	if(enabled) return flambe_util_BitSets.add(bits,mask); else return flambe_util_BitSets.remove(bits,mask);
};
var flambe_util_LogLevel = $hxClasses["flambe.util.LogLevel"] = { __ename__ : true, __constructs__ : ["Info","Warn","Error"] };
flambe_util_LogLevel.Info = ["Info",0];
flambe_util_LogLevel.Info.__enum__ = flambe_util_LogLevel;
flambe_util_LogLevel.Warn = ["Warn",1];
flambe_util_LogLevel.Warn.__enum__ = flambe_util_LogLevel;
flambe_util_LogLevel.Error = ["Error",2];
flambe_util_LogLevel.Error.__enum__ = flambe_util_LogLevel;
var flambe_util_Promise = function() {
	this.success = new flambe_util_Signal1();
	this.error = new flambe_util_Signal1();
	this.progressChanged = new flambe_util_Signal0();
	this.hasResult = false;
	this._progress = 0;
	this._total = 0;
};
$hxClasses["flambe.util.Promise"] = flambe_util_Promise;
flambe_util_Promise.__name__ = true;
flambe_util_Promise.prototype = {
	set_result: function(result) {
		if(this.hasResult) throw "Promise result already assigned";
		this._result = result;
		this.hasResult = true;
		this.success.emit(result);
		return result;
	}
	,get: function(fn) {
		if(this.hasResult) {
			fn(this._result);
			return null;
		}
		return this.success.connect(fn).once();
	}
	,get_progress: function() {
		return this._progress;
	}
	,set_progress: function(progress) {
		if(this._progress != progress) {
			this._progress = progress;
			this.progressChanged.emit();
		}
		return progress;
	}
	,set_total: function(total) {
		if(this._total != total) {
			this._total = total;
			this.progressChanged.emit();
		}
		return total;
	}
	,get_total: function() {
		return this._total;
	}
	,__class__: flambe_util_Promise
};
var flambe_util_Signal0 = function(listener) {
	flambe_util_SignalBase.call(this,listener);
};
$hxClasses["flambe.util.Signal0"] = flambe_util_Signal0;
flambe_util_Signal0.__name__ = true;
flambe_util_Signal0.__super__ = flambe_util_SignalBase;
flambe_util_Signal0.prototype = $extend(flambe_util_SignalBase.prototype,{
	connect: function(listener,prioritize) {
		if(prioritize == null) prioritize = false;
		return this.connectImpl(listener,prioritize);
	}
	,emit: function() {
		var _g = this;
		if(this.dispatching()) this.defer(function() {
			_g.emitImpl();
		}); else this.emitImpl();
	}
	,emitImpl: function() {
		var head = this.willEmit();
		var p = head;
		while(p != null) {
			p._listener();
			if(!p.stayInList) p.dispose();
			p = p._next;
		}
		this.didEmit(head);
	}
	,__class__: flambe_util_Signal0
});
var flambe_util__$SignalBase_Task = function(fn) {
	this.next = null;
	this.fn = fn;
};
$hxClasses["flambe.util._SignalBase.Task"] = flambe_util__$SignalBase_Task;
flambe_util__$SignalBase_Task.__name__ = true;
flambe_util__$SignalBase_Task.prototype = {
	__class__: flambe_util__$SignalBase_Task
};
var flambe_util_Strings = function() { };
$hxClasses["flambe.util.Strings"] = flambe_util_Strings;
flambe_util_Strings.__name__ = true;
flambe_util_Strings.getFileExtension = function(fileName) {
	var dot = fileName.lastIndexOf(".");
	if(dot > 0) return HxOverrides.substr(fileName,dot + 1,null); else return null;
};
flambe_util_Strings.removeFileExtension = function(fileName) {
	var dot = fileName.lastIndexOf(".");
	if(dot > 0) return HxOverrides.substr(fileName,0,dot); else return fileName;
};
flambe_util_Strings.getUrlExtension = function(url) {
	var question = url.lastIndexOf("?");
	if(question >= 0) url = HxOverrides.substr(url,0,question);
	var slash = url.lastIndexOf("/");
	if(slash >= 0) url = HxOverrides.substr(url,slash + 1,null);
	return flambe_util_Strings.getFileExtension(url);
};
flambe_util_Strings.joinPath = function(base,relative) {
	if(base.length > 0 && StringTools.fastCodeAt(base,base.length - 1) != 47) base += "/";
	return base + relative;
};
flambe_util_Strings.withFields = function(message,fields) {
	var ll = fields.length;
	if(ll > 0) {
		if(message.length > 0) message += " ["; else message += "[";
		var ii = 0;
		while(ii < ll) {
			if(ii > 0) message += ", ";
			var name = fields[ii];
			var value = fields[ii + 1];
			if(Std["is"](value,Error)) {
				var stack = value.stack;
				if(stack != null) value = stack;
			}
			message += name + "=" + Std.string(value);
			ii += 2;
		}
		message += "]";
	}
	return message;
};
var haxe_Timer = function(time_ms) {
	var me = this;
	this.id = setInterval(function() {
		me.run();
	},time_ms);
};
$hxClasses["haxe.Timer"] = haxe_Timer;
haxe_Timer.__name__ = true;
haxe_Timer.prototype = {
	stop: function() {
		if(this.id == null) return;
		clearInterval(this.id);
		this.id = null;
	}
	,run: function() {
	}
	,__class__: haxe_Timer
};
var haxe_ds_IntMap = function() {
	this.h = { };
};
$hxClasses["haxe.ds.IntMap"] = haxe_ds_IntMap;
haxe_ds_IntMap.__name__ = true;
haxe_ds_IntMap.__interfaces__ = [IMap];
haxe_ds_IntMap.prototype = {
	set: function(key,value) {
		this.h[key] = value;
	}
	,get: function(key) {
		return this.h[key];
	}
	,exists: function(key) {
		return this.h.hasOwnProperty(key);
	}
	,remove: function(key) {
		if(!this.h.hasOwnProperty(key)) return false;
		delete(this.h[key]);
		return true;
	}
	,__class__: haxe_ds_IntMap
};
var haxe_ds_StringMap = function() {
	this.h = { };
};
$hxClasses["haxe.ds.StringMap"] = haxe_ds_StringMap;
haxe_ds_StringMap.__name__ = true;
haxe_ds_StringMap.__interfaces__ = [IMap];
haxe_ds_StringMap.prototype = {
	set: function(key,value) {
		this.h["$" + key] = value;
	}
	,get: function(key) {
		return this.h["$" + key];
	}
	,exists: function(key) {
		return this.h.hasOwnProperty("$" + key);
	}
	,keys: function() {
		var a = [];
		for( var key in this.h ) {
		if(this.h.hasOwnProperty(key)) a.push(key.substr(1));
		}
		return HxOverrides.iter(a);
	}
	,iterator: function() {
		return { ref : this.h, it : this.keys(), hasNext : function() {
			return this.it.hasNext();
		}, next : function() {
			var i = this.it.next();
			return this.ref["$" + i];
		}};
	}
	,__class__: haxe_ds_StringMap
};
var haxe_io_Bytes = function() { };
$hxClasses["haxe.io.Bytes"] = haxe_io_Bytes;
haxe_io_Bytes.__name__ = true;
var haxe_io_Eof = function() { };
$hxClasses["haxe.io.Eof"] = haxe_io_Eof;
haxe_io_Eof.__name__ = true;
haxe_io_Eof.prototype = {
	toString: function() {
		return "Eof";
	}
	,__class__: haxe_io_Eof
};
var haxe_rtti_Meta = function() { };
$hxClasses["haxe.rtti.Meta"] = haxe_rtti_Meta;
haxe_rtti_Meta.__name__ = true;
haxe_rtti_Meta.getType = function(t) {
	var meta = t.__meta__;
	if(meta == null || meta.obj == null) return { }; else return meta.obj;
};
var haxe_xml_Parser = function() { };
$hxClasses["haxe.xml.Parser"] = haxe_xml_Parser;
haxe_xml_Parser.__name__ = true;
haxe_xml_Parser.parse = function(str) {
	var doc = Xml.createDocument();
	haxe_xml_Parser.doParse(str,0,doc);
	return doc;
};
haxe_xml_Parser.doParse = function(str,p,parent) {
	if(p == null) p = 0;
	var xml = null;
	var state = 1;
	var next = 1;
	var aname = null;
	var start = 0;
	var nsubs = 0;
	var nbrackets = 0;
	var c = StringTools.fastCodeAt(str,p);
	var buf = new StringBuf();
	while(!StringTools.isEof(c)) {
		switch(state) {
		case 0:
			switch(c) {
			case 10:case 13:case 9:case 32:
				break;
			default:
				state = next;
				continue;
			}
			break;
		case 1:
			switch(c) {
			case 60:
				state = 0;
				next = 2;
				break;
			default:
				start = p;
				state = 13;
				continue;
			}
			break;
		case 13:
			if(c == 60) {
				var child = Xml.createPCData(buf.toString() + HxOverrides.substr(str,start,p - start));
				buf = new StringBuf();
				parent.addChild(child);
				nsubs++;
				state = 0;
				next = 2;
			} else if(c == 38) {
				buf.addSub(str,start,p - start);
				state = 18;
				next = 13;
				start = p + 1;
			}
			break;
		case 17:
			if(c == 93 && StringTools.fastCodeAt(str,p + 1) == 93 && StringTools.fastCodeAt(str,p + 2) == 62) {
				var child1 = Xml.createCData(HxOverrides.substr(str,start,p - start));
				parent.addChild(child1);
				nsubs++;
				p += 2;
				state = 1;
			}
			break;
		case 2:
			switch(c) {
			case 33:
				if(StringTools.fastCodeAt(str,p + 1) == 91) {
					p += 2;
					if(HxOverrides.substr(str,p,6).toUpperCase() != "CDATA[") throw "Expected <![CDATA[";
					p += 5;
					state = 17;
					start = p + 1;
				} else if(StringTools.fastCodeAt(str,p + 1) == 68 || StringTools.fastCodeAt(str,p + 1) == 100) {
					if(HxOverrides.substr(str,p + 2,6).toUpperCase() != "OCTYPE") throw "Expected <!DOCTYPE";
					p += 8;
					state = 16;
					start = p + 1;
				} else if(StringTools.fastCodeAt(str,p + 1) != 45 || StringTools.fastCodeAt(str,p + 2) != 45) throw "Expected <!--"; else {
					p += 2;
					state = 15;
					start = p + 1;
				}
				break;
			case 63:
				state = 14;
				start = p;
				break;
			case 47:
				if(parent == null) throw "Expected node name";
				start = p + 1;
				state = 0;
				next = 10;
				break;
			default:
				state = 3;
				start = p;
				continue;
			}
			break;
		case 3:
			if(!haxe_xml_Parser.isValidChar(c)) {
				if(p == start) throw "Expected node name";
				xml = Xml.createElement(HxOverrides.substr(str,start,p - start));
				parent.addChild(xml);
				state = 0;
				next = 4;
				continue;
			}
			break;
		case 4:
			switch(c) {
			case 47:
				state = 11;
				nsubs++;
				break;
			case 62:
				state = 9;
				nsubs++;
				break;
			default:
				state = 5;
				start = p;
				continue;
			}
			break;
		case 5:
			if(!haxe_xml_Parser.isValidChar(c)) {
				var tmp;
				if(start == p) throw "Expected attribute name";
				tmp = HxOverrides.substr(str,start,p - start);
				aname = tmp;
				if(xml.exists(aname)) throw "Duplicate attribute";
				state = 0;
				next = 6;
				continue;
			}
			break;
		case 6:
			switch(c) {
			case 61:
				state = 0;
				next = 7;
				break;
			default:
				throw "Expected =";
			}
			break;
		case 7:
			switch(c) {
			case 34:case 39:
				state = 8;
				start = p;
				break;
			default:
				throw "Expected \"";
			}
			break;
		case 8:
			if(c == StringTools.fastCodeAt(str,start)) {
				var val = HxOverrides.substr(str,start + 1,p - start - 1);
				xml.set(aname,val);
				state = 0;
				next = 4;
			}
			break;
		case 9:
			p = haxe_xml_Parser.doParse(str,p,xml);
			start = p;
			state = 1;
			break;
		case 11:
			switch(c) {
			case 62:
				state = 1;
				break;
			default:
				throw "Expected >";
			}
			break;
		case 12:
			switch(c) {
			case 62:
				if(nsubs == 0) parent.addChild(Xml.createPCData(""));
				return p;
			default:
				throw "Expected >";
			}
			break;
		case 10:
			if(!haxe_xml_Parser.isValidChar(c)) {
				if(start == p) throw "Expected node name";
				var v = HxOverrides.substr(str,start,p - start);
				if(v != parent.get_nodeName()) throw "Expected </" + parent.get_nodeName() + ">";
				state = 0;
				next = 12;
				continue;
			}
			break;
		case 15:
			if(c == 45 && StringTools.fastCodeAt(str,p + 1) == 45 && StringTools.fastCodeAt(str,p + 2) == 62) {
				parent.addChild(Xml.createComment(HxOverrides.substr(str,start,p - start)));
				p += 2;
				state = 1;
			}
			break;
		case 16:
			if(c == 91) nbrackets++; else if(c == 93) nbrackets--; else if(c == 62 && nbrackets == 0) {
				parent.addChild(Xml.createDocType(HxOverrides.substr(str,start,p - start)));
				state = 1;
			}
			break;
		case 14:
			if(c == 63 && StringTools.fastCodeAt(str,p + 1) == 62) {
				p++;
				var str1 = HxOverrides.substr(str,start + 1,p - start - 2);
				parent.addChild(Xml.createProcessingInstruction(str1));
				state = 1;
			}
			break;
		case 18:
			if(c == 59) {
				var s = HxOverrides.substr(str,start,p - start);
				if(StringTools.fastCodeAt(s,0) == 35) {
					var i;
					if(StringTools.fastCodeAt(s,1) == 120) i = Std.parseInt("0" + HxOverrides.substr(s,1,s.length - 1)); else i = Std.parseInt(HxOverrides.substr(s,1,s.length - 1));
					buf.add(String.fromCharCode(i));
				} else if(!haxe_xml_Parser.escapes.exists(s)) buf.add("&" + s + ";"); else buf.add(haxe_xml_Parser.escapes.get(s));
				start = p + 1;
				state = next;
			}
			break;
		}
		c = StringTools.fastCodeAt(str,++p);
	}
	if(state == 1) {
		start = p;
		state = 13;
	}
	if(state == 13) {
		if(p != start || nsubs == 0) parent.addChild(Xml.createPCData(buf.toString() + HxOverrides.substr(str,start,p - start)));
		return p;
	}
	throw "Unexpected end";
};
haxe_xml_Parser.isValidChar = function(c) {
	return c >= 97 && c <= 122 || c >= 65 && c <= 90 || c >= 48 && c <= 57 || c == 58 || c == 46 || c == 95 || c == 45;
};
var js_Boot = function() { };
$hxClasses["js.Boot"] = js_Boot;
js_Boot.__name__ = true;
js_Boot.isClass = function(o) {
	return o.__name__;
};
js_Boot.isEnum = function(e) {
	return e.__ename__;
};
js_Boot.getClass = function(o) {
	if(Std["is"](o,Array)) return Array; else return o.__class__;
};
js_Boot.__string_rec = function(o,s) {
	if(o == null) return "null";
	if(s.length >= 5) return "<...>";
	var t = typeof(o);
	if(t == "function" && (js_Boot.isClass(o) || js_Boot.isEnum(o))) t = "object";
	switch(t) {
	case "object":
		if(o instanceof Array) {
			if(o.__enum__) {
				if(o.length == 2) return o[0];
				var str = o[0] + "(";
				s += "\t";
				var _g1 = 2;
				var _g = o.length;
				while(_g1 < _g) {
					var i = _g1++;
					if(i != 2) str += "," + js_Boot.__string_rec(o[i],s); else str += js_Boot.__string_rec(o[i],s);
				}
				return str + ")";
			}
			var l = o.length;
			var i1;
			var str1 = "[";
			s += "\t";
			var _g2 = 0;
			while(_g2 < l) {
				var i2 = _g2++;
				str1 += (i2 > 0?",":"") + js_Boot.__string_rec(o[i2],s);
			}
			str1 += "]";
			return str1;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( e ) {
			return "???";
		}
		if(tostr != null && tostr != Object.toString) {
			var s2 = o.toString();
			if(s2 != "[object Object]") return s2;
		}
		var k = null;
		var str2 = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		for( var k in o ) {
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str2.length != 2) str2 += ", \n";
		str2 += s + k + " : " + js_Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str2 += "\n" + s + "}";
		return str2;
	case "function":
		return "<function>";
	case "string":
		return o;
	default:
		return String(o);
	}
};
js_Boot.__interfLoop = function(cc,cl) {
	if(cc == null) return false;
	if(cc == cl) return true;
	var intf = cc.__interfaces__;
	if(intf != null) {
		var _g1 = 0;
		var _g = intf.length;
		while(_g1 < _g) {
			var i = _g1++;
			var i1 = intf[i];
			if(i1 == cl || js_Boot.__interfLoop(i1,cl)) return true;
		}
	}
	return js_Boot.__interfLoop(cc.__super__,cl);
};
js_Boot.__instanceof = function(o,cl) {
	if(cl == null) return false;
	switch(cl) {
	case Int:
		return (o|0) === o;
	case Float:
		return typeof(o) == "number";
	case Bool:
		return typeof(o) == "boolean";
	case String:
		return typeof(o) == "string";
	case Array:
		return (o instanceof Array) && o.__enum__ == null;
	case Dynamic:
		return true;
	default:
		if(o != null) {
			if(typeof(cl) == "function") {
				if(o instanceof cl) return true;
				if(js_Boot.__interfLoop(js_Boot.getClass(o),cl)) return true;
			}
		} else return false;
		if(cl == Class && o.__name__ != null) return true;
		if(cl == Enum && o.__ename__ != null) return true;
		return o.__enum__ == cl;
	}
};
var js_html__$CanvasElement_CanvasUtil = function() { };
$hxClasses["js.html._CanvasElement.CanvasUtil"] = js_html__$CanvasElement_CanvasUtil;
js_html__$CanvasElement_CanvasUtil.__name__ = true;
js_html__$CanvasElement_CanvasUtil.getContextWebGL = function(canvas,attribs) {
	var _g = 0;
	var _g1 = ["webgl","experimental-webgl"];
	while(_g < _g1.length) {
		var name = _g1[_g];
		++_g;
		var ctx = canvas.getContext(name,attribs);
		if(ctx != null) return ctx;
	}
	return null;
};
var threedracer_GameContext = function(director,mainPack,preloadPack) {
	this.bonus3 = false;
	this.bonus2 = false;
	this.bonus1 = false;
	this.racerData = [];
	this.chosenRacer = "spongebob";
	this.seenInstructions = false;
	this.BGmusic = null;
	this.director = director;
	this.pack = mainPack;
	this.preloaderPack = preloadPack;
	this.device = flambe_System.get_external().call("detectDevice");
};
$hxClasses["threedracer.GameContext"] = threedracer_GameContext;
threedracer_GameContext.__name__ = true;
threedracer_GameContext.prototype = {
	enterHomeScene: function(animate) {
		if(animate == null) animate = true;
		var _g = this;
		if(this.seenInstructions) {
			if(this.pack == null) {
				this.BGmusic.dispose();
				var path = "main";
				if(flambe_System.get_touch().get_supported()) path = "mobile";
				var loader = flambe_System.loadAssetPack(flambe_asset_Manifest.fromAssets(path));
				loader.get(function(assetpack) {
					_g.pack = assetpack;
					_g.director.unwindToScene(threedracer_scenes_HomeScene.create(_g),animate?new flambe_scene_FadeTransition(0.5,flambe_animation_Ease.quadOut):null);
				});
				var preloader = threedracer_scenes_PreloaderScene.create(this.preloaderPack,loader,1);
				this.director.unwindToScene(preloader);
				this.pack_mobileGame.dispose();
				this.pack_mobileGame = null;
			} else this.director.unwindToScene(threedracer_scenes_HomeScene.create(this),animate?new flambe_scene_FadeTransition(0.5,flambe_animation_Ease.quadOut):null);
		} else this.director.unwindToScene(threedracer_scenes_HomeScene.create(this),animate?new flambe_scene_FadeTransition(0.5,flambe_animation_Ease.quadOut):null);
	}
	,enterCodeScene: function(animate) {
		if(animate == null) animate = true;
		this.director.unwindToScene(threedracer_scenes_EnterCodeScene.create(this),animate?new flambe_scene_FadeTransition(0.5,flambe_animation_Ease.quadOut):null);
	}
	,enterChooseRacerScene: function(animate) {
		if(animate == null) animate = true;
		this.chosenRacer = "spongebob";
		this.director.unwindToScene(threedracer_scenes_ChooseRacerScene.create(this),animate?new flambe_scene_FadeTransition(0.5,flambe_animation_Ease.quadOut):null);
	}
	,enterGameScene: function(animate) {
		if(animate == null) animate = true;
		var _g = this;
		if(this.seenInstructions) {
			this.BGmusic.dispose();
			if(this.pack_mobileGame == null) {
				var path = "main_game";
				if(flambe_System.get_touch().get_supported()) path = "mobile_game";
				if(this.device == "phone") path = "mobile_game50";
				var loader = flambe_System.loadAssetPack(flambe_asset_Manifest.fromAssets(path));
				loader.get(function(pack) {
					_g.pack_mobileGame = pack;
					_g.director.unwindToScene(threedracer_scenes_GameScene.create(_g),animate?new flambe_scene_SlideTransition(0.5,flambe_animation_Ease.quadOut):null);
				});
				var preloader = threedracer_scenes_PreloaderScene.create(this.preloaderPack,loader,2);
				this.director.unwindToScene(preloader);
				this.pack.dispose();
				this.pack = null;
			} else this.director.unwindToScene(threedracer_scenes_GameScene.create(this),animate?new flambe_scene_SlideTransition(0.5,flambe_animation_Ease.quadOut):null);
		} else this.showInstructions(this.pack);
	}
	,enterEndScene: function(animate) {
		if(animate == null) animate = true;
		var _g = this;
		this.BGmusic.dispose();
		if(this.pack == null) {
			var path = "main";
			if(flambe_System.get_touch().get_supported()) path = "mobile";
			var loader = flambe_System.loadAssetPack(flambe_asset_Manifest.fromAssets(path));
			loader.get(function(assetpack) {
				_g.pack = assetpack;
				_g.director.unwindToScene(threedracer_scenes_EndScene.create(_g),animate?new flambe_scene_FadeTransition(1,flambe_animation_Ease.quadOut):null);
			});
			var preloader = threedracer_scenes_PreloaderScene.create(this.preloaderPack,loader,3);
			this.director.unwindToScene(preloader);
			this.pack_mobileGame.dispose();
			this.pack_mobileGame = null;
		} else this.director.unwindToScene(threedracer_scenes_EndScene.create(this),animate?new flambe_scene_FadeTransition(1,flambe_animation_Ease.quadOut):null);
	}
	,enterCloseConfirm: function() {
		this.director.pushScene(threedracer_scenes_CloseConfirmScene.create(this));
	}
	,unpauseGame: function() {
		this.director.popScene();
	}
	,showInstructions: function(pack) {
		this.director.pushScene(threedracer_scenes_InstructionsScene.create(this,pack));
	}
	,removeInstructions: function() {
		this.director.popScene(new flambe_scene_FadeTransition(0.5,flambe_animation_Ease.quadOut));
	}
	,__class__: threedracer_GameContext
};
var threedracer_Main = function() { };
$hxClasses["threedracer.Main"] = threedracer_Main;
threedracer_Main.__name__ = true;
threedracer_Main.main = function() {
	flambe_System.init();
	var director = new flambe_scene_Director();
	flambe_System.root.add(director);
	flambe_System.root.add(new flambe_display_Sprite());
	var manifest = flambe_asset_Manifest.fromAssets("bootstrap");
	flambe_System.loadAssetPack(manifest).get(function(bootstrapPack) {
		var src = "main";
		if(flambe_System.get_touch().get_supported()) src = "mobile";
		var loader = flambe_System.loadAssetPack(flambe_asset_Manifest.fromAssets(src));
		loader.get(function(mainPack) {
			var ctx = new threedracer_GameContext(director,mainPack,bootstrapPack);
			ctx.enterHomeScene(true);
		});
		var preloader = threedracer_scenes_PreloaderScene.create(bootstrapPack,loader);
		director.unwindToScene(preloader);
	});
	flambe_System.get_stage().resize.connect(threedracer_Main.onResize);
	threedracer_Main.onResize();
};
threedracer_Main.onResize = function() {
	var targetWidth = 1028;
	var targetHeight = 620;
	var scale = Math.min(flambe_System.get_stage().get_width() / targetWidth,flambe_System.get_stage().get_height() / targetHeight);
	flambe_System.root.getComponent("Sprite_4").setScale(scale).setXY((flambe_System.get_stage().get_width() - targetWidth * scale) / 2,(flambe_System.get_stage().get_height() - targetHeight * scale) / 2);
	flambe_System.root.getComponent("Sprite_4").scissor = new flambe_math_Rectangle(0,0,targetWidth,targetHeight);
};
var threedracer_anims_Feather = function(pack,_startX,_startY,_scale) {
	if(_scale == null) _scale = 1;
	threedracer_anims_Feather.startX = _startX;
	threedracer_anims_Feather.startY = _startY;
	this.scale = _scale;
	this.speedX = Math.round((Math.random() - 0.5) * 30);
	this.speedY = Math.round((Math.random() - 1.5) * 10);
	this.fID = Math.round(Math.random()) + 1;
	this.fDir = Math.round(Math.random()) * 2 - 1;
	this.fImage = new flambe_display_ImageSprite(pack.getTexture("feather-" + this.fID));
	this.rotateSc = new flambe_script_Script();
};
$hxClasses["threedracer.anims.Feather"] = threedracer_anims_Feather;
threedracer_anims_Feather.__name__ = true;
threedracer_anims_Feather.__super__ = flambe_Component;
threedracer_anims_Feather.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Feather_0";
	}
	,onAdded: function() {
		var rotType = Math.round(Math.random() * 2);
		this.fImage.centerAnchor().setXY(threedracer_anims_Feather.startX,threedracer_anims_Feather.startY);
		this.fImage.setAnchor(this.fImage.anchorX.get__(),this.fImage.anchorY.get__() - 40);
		this.fImage.scaleX.set__(this.fDir * this.scale);
		this.fImage.scaleY.set__(this.scale);
		this.setRotation(rotType);
		this.owner.add(this.fImage);
		this.owner.add(this.rotateSc);
	}
	,onUpdate: function(time) {
		var _g = this.fImage.x;
		_g.set__(_g.get__() + this.speedX);
		var _g1 = this.fImage.y;
		_g1.set__(_g1.get__() + this.speedY);
		if(this.speedY >= threedracer_anims_Feather.maxY) this.speedY = threedracer_anims_Feather.maxY; else this.speedY += 0.5;
		if(this.speedX < -threedracer_anims_Feather.frcX) this.speedX += threedracer_anims_Feather.frcX; else if(this.speedX > threedracer_anims_Feather.frcX) this.speedX -= threedracer_anims_Feather.frcX; else this.speedX = 0;
		if(this.fImage.y.get__() > 650) this.death();
	}
	,setRotation: function(type) {
		var rotDirection;
		var timer = Math.random() + 1;
		if(type == 0) {
			rotDirection = this.fDir * 360;
			this.rotateSc.run(new flambe_script_Repeat(new flambe_script_AnimateBy(this.fImage.rotation,rotDirection,timer,flambe_animation_Ease.linear),-1));
		} else if(type == 1) {
			rotDirection = this.fDir * 360;
			this.rotateSc.run(new flambe_script_Sequence([new flambe_script_AnimateTo(this.fImage.rotation,rotDirection + 45 * this.fDir,timer,flambe_animation_Ease.sineOut),new flambe_script_Repeat(new flambe_script_Sequence([new flambe_script_AnimateTo(this.fImage.rotation,rotDirection - 45 * this.fDir,timer,flambe_animation_Ease.sineInOut),new flambe_script_AnimateTo(this.fImage.rotation,rotDirection + 45 * this.fDir,timer,flambe_animation_Ease.sineInOut)]),-1)]));
		} else {
			this.fImage.rotation.set__(-(45 * this.fDir));
			this.rotateSc.run(new flambe_script_Repeat(new flambe_script_Sequence([new flambe_script_AnimateTo(this.fImage.rotation,45 * this.fDir,timer,flambe_animation_Ease.sineInOut),new flambe_script_AnimateTo(this.fImage.rotation,-(45 * this.fDir),timer,flambe_animation_Ease.sineInOut)]),-1));
		}
	}
	,death: function() {
		this.owner.dispose();
	}
	,__class__: threedracer_anims_Feather
});
var threedracer_anims_FinishStar = function(pack,_startX,_startY,_scale) {
	if(_scale == null) _scale = 1;
	threedracer_anims_FinishStar.startX = _startX;
	threedracer_anims_FinishStar.startY = _startY;
	this.scale = _scale;
	this.speedX = Math.round((Math.random() - 0.5) * 30);
	this.speedY = Math.round((Math.random() - 1.5) * 10);
	this.fID = Math.round(Math.random()) + 1;
	this.fDir = Math.round(Math.random()) * 2 - 1;
	this.fImage = new flambe_display_ImageSprite(pack.getTexture("finishstar"));
	this.rotateSc = new flambe_script_Script();
};
$hxClasses["threedracer.anims.FinishStar"] = threedracer_anims_FinishStar;
threedracer_anims_FinishStar.__name__ = true;
threedracer_anims_FinishStar.__super__ = flambe_Component;
threedracer_anims_FinishStar.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "FinishStar_10";
	}
	,onAdded: function() {
		var rotType = Math.round(Math.random() * 2);
		this.fImage.centerAnchor().setXY(threedracer_anims_FinishStar.startX,threedracer_anims_FinishStar.startY);
		this.fImage.setAnchor(this.fImage.anchorX.get__(),this.fImage.anchorY.get__() - 40);
		this.fImage.scaleX.set__(this.fDir * this.scale);
		this.fImage.scaleY.set__(this.scale);
		this.setRotation(rotType);
		this.owner.add(this.fImage);
		this.owner.add(this.rotateSc);
	}
	,onUpdate: function(time) {
		var _g = this.fImage.x;
		_g.set__(_g.get__() + this.speedX);
		var _g1 = this.fImage.y;
		_g1.set__(_g1.get__() + this.speedY);
		if(this.speedY >= threedracer_anims_FinishStar.maxY) this.speedY = threedracer_anims_FinishStar.maxY; else this.speedY += 0.5;
		if(this.speedX < -threedracer_anims_FinishStar.frcX) this.speedX += threedracer_anims_FinishStar.frcX; else if(this.speedX > threedracer_anims_FinishStar.frcX) this.speedX -= threedracer_anims_FinishStar.frcX; else this.speedX = 0;
		if(this.fImage.y.get__() > 650) this.death();
	}
	,setRotation: function(type) {
		var rotDirection;
		var timer = Math.random() + 1;
		if(type == 0) {
			rotDirection = this.fDir * 360;
			this.rotateSc.run(new flambe_script_Repeat(new flambe_script_AnimateBy(this.fImage.rotation,rotDirection,timer,flambe_animation_Ease.linear),-1));
		} else if(type == 1) {
			rotDirection = this.fDir * 360;
			this.rotateSc.run(new flambe_script_Sequence([new flambe_script_AnimateTo(this.fImage.rotation,rotDirection + 45 * this.fDir,timer,flambe_animation_Ease.sineOut),new flambe_script_Repeat(new flambe_script_Sequence([new flambe_script_AnimateTo(this.fImage.rotation,rotDirection - 45 * this.fDir,timer,flambe_animation_Ease.sineInOut),new flambe_script_AnimateTo(this.fImage.rotation,rotDirection + 45 * this.fDir,timer,flambe_animation_Ease.sineInOut)]),-1)]));
		} else {
			this.fImage.rotation.set__(-(45 * this.fDir));
			this.rotateSc.run(new flambe_script_Repeat(new flambe_script_Sequence([new flambe_script_AnimateTo(this.fImage.rotation,45 * this.fDir,timer,flambe_animation_Ease.sineInOut),new flambe_script_AnimateTo(this.fImage.rotation,-(45 * this.fDir),timer,flambe_animation_Ease.sineInOut)]),-1));
		}
	}
	,death: function() {
		this.owner.dispose();
	}
	,__class__: threedracer_anims_FinishStar
});
var threedracer_components_Game = function(_ctx) {
	this.racers = ["spongebob","patrick","squidward","crab"];
	this.road = { LENGTH : { NONE : 0, SHORT : 15, MEDIUM : 30, LONG : 60}, HILL : { NONE : 0, LOW : 20, MEDIUM : 40, HIGH : 60, RIDICULOUS : 140}, CURVE : { NONE : 0, EASY : 2, MEDIUM : 4, HARD : 6}};
	this.colors = { SKY : 7526382, TREE : 20744, FOG : 4472627, LIGHT : { road : "game/road_light", roadLeft : "game/road_light_left", roadRight : "game/road_light_right", grass : 1092112, rumble : 16777215, lane : 13421772}, DARK : { road : "game/road_dark", roadLeft : "game/road_dark_left", roadRight : "game/road_dark_right", grass : 39424, rumble : 14803425}, START : { road : "game/road_light", roadLeft : "game/road_light_left", roadRight : "game/road_light_right", grass : 1092112, rumble : 16777215}, FINISH : { road : "game/road_light", roadLeft : "game/road_light_left", roadRight : "game/road_light_right", grass : 0, rumble : 16777215}};
	this.maxLaps = 3;
	this.lapNum = 1;
	this.hotrod = false;
	this.invincible = false;
	this.unlimitedPillows = false;
	this.isAndroid = false;
	this.bonusCart = "";
	this.currentPlace = 4;
	this.bubbleCounter = 0;
	this.bubbleDelay = 30;
	this.spinningOut = false;
	this.inHole = false;
	this.treeSpeed = 1.4;
	this.hillSpeed = 1.2;
	this.skySpeed = 0.9;
	this.bigasfuck = 3.27;
	this.angle = "mid";
	this.countdownAnimTime = 0;
	this.introCount = 0;
	this.introTime = 0;
	this.introDelay = 60;
	this.isIntro = true;
	this.totalTime = 0;
	this.gameSeconds = 0;
	this.numPillows = 0;
	this.turboLength = 50;
	this.turboTime = 0;
	this.hasTurbo = false;
	this.playerY = 400;
	this.keySlower = false;
	this.keyFaster = false;
	this.keyRight = false;
	this.keyLeft = false;
	this.centrifugal = 0.2;
	this.speed = 0;
	this.position = 0;
	this.playerZ = 0;
	this.playerX = 0.20;
	this.drawDistance = 150;
	this.cameraHeight = 1000;
	this.fieldOfView = 140;
	this.lanes = 3;
	this.segmentLength = 100;
	this.roadWidth = 1800;
	this.height = 620;
	this.width = 1028;
	this.finished = false;
	this.active = true;
	this.ctx = _ctx;
	this.assetPack = this.ctx.pack_mobileGame;
	this.ctx.racerData = [];
	this.disposer = new flambe_Disposer();
	this.turboSpeed = this.segmentLength / (1 / 60) * 0.85;
	this.maxSpeed = this.turboSpeed * 0.5;
	this.accel = this.maxSpeed / 100;
	this.breaking = 0 - this.maxSpeed / 25;
	this.decel = 0 - this.maxSpeed / 100;
	this.offRoadDecel = this.decel * 2;
	this.offRoadLimit = this.maxSpeed / 4;
	this.cameraDepth = 1 / Math.tan(this.fieldOfView / 2 * Math.PI / 180);
	this.playerZ = this.cameraHeight * this.cameraDepth;
	this.resolution = this.height / 480;
	if(this.ctx.bonus2 == true) {
		this.invincible = true;
		this.bonusCart = "star_";
	}
	if(this.ctx.bonus1 == true) {
		this.hotrod = true;
		this.bonusCart = "hotrod_";
	}
	if(this.ctx.bonus3 == true) this.unlimitedPillows = true;
	if(flambe_System.get_touch().get_supported()) this.drawDistance = 75;
	this.isAndroid = flambe_System.get_external().call("isAndroid");
};
$hxClasses["threedracer.components.Game"] = threedracer_components_Game;
threedracer_components_Game.__name__ = true;
threedracer_components_Game.__super__ = flambe_Component;
threedracer_components_Game.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Game_0";
	}
	,onAdded: function() {
		var imageData = { rows : 1, columns : 3};
		var spriteData = ["game/bg_sky_left","game/bg_sky_mid","game/bg_sky_right"];
		var multiplier = 1;
		if(this.ctx.device == "phone") multiplier = 2;
		this.background = new com_newwave_components_display_TiledImage(this.assetPack,imageData,spriteData,multiplier);
		this.bg_sky = new flambe_Entity().add(this.background);
		this.background.setAnchor(2100,0).setXY(619,0);
		this.owner.addChild(this.bg_sky);
		this.bg_hills = new flambe_Entity();
		this.bg_hills.add(new com_newwave_components_game_RepeatingBackground(this.owner,this.ctx,"game/bg_hills",0,multiplier));
		this.owner.addChild(this.bg_hills);
		this.bg_trees = new flambe_Entity();
		this.bg_trees.add(new com_newwave_components_game_RepeatingBackground(this.owner,this.ctx,"game/bg_trees",0,multiplier));
		this.owner.addChild(this.bg_trees);
		if(!flambe_System.get_touch().get_supported()) {
			var moonimages = new Array();
			var _g = 1;
			while(_g < 36) {
				var i = _g++;
				moonimages.push(new flambe_display_ImageSprite(this.assetPack.getTexture("game/moon/" + i)));
			}
			this.moon = new flambe_Entity();
			var moonsprite = new flambe_display_Sprite();
			moonsprite.setXY(900,75).setScale(0.7);
			this.moon.add(moonsprite);
			this.moon.add(new com_newwave_components_display_PngSequence(moonimages,true,1));
			this.owner.addChild(this.moon);
			var sheepimages = new Array();
			var _g1 = 1;
			while(_g1 < 44) {
				var i1 = _g1++;
				sheepimages.push(new flambe_display_ImageSprite(this.assetPack.getTexture("game/sheep/" + i1)));
			}
			this.sheep = new flambe_Entity();
			var sheepsprite = new flambe_display_Sprite();
			sheepsprite.setXY(300,125).setScale(0.4);
			this.sheep.add(sheepsprite);
			this.sheep.add(new com_newwave_components_display_PngSequence(sheepimages,true,1));
			this.owner.addChild(this.sheep);
		}
		this.bgImageLayer = new flambe_Entity();
		this.bgImageLayer.add(new flambe_display_Sprite());
		this.owner.addChild(this.bgImageLayer);
		this.roadLayer = new flambe_Entity();
		this.roadLayer.add(new flambe_display_Sprite());
		this.owner.addChild(this.roadLayer);
		this.objectLayer = new flambe_Entity();
		this.objectLayer.add(new flambe_display_Sprite());
		this.owner.addChild(this.objectLayer);
		this.pillows = [];
		this.npcracers = [];
		this.cartPillowArray = [];
		this.particleLayer = new flambe_Entity().add(new flambe_display_Sprite());
		this.owner.addChild(this.particleLayer);
		this.carLayer = new flambe_Entity();
		this.carLayer.add(new flambe_display_Sprite());
		this.owner.addChild(this.carLayer);
		this.player = new flambe_Entity();
		var playerSprite = new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/straight_" + this.angle));
		playerSprite.centerAnchor();
		playerSprite.setXY(this.width / 2,this.playerY);
		this.player.add(playerSprite);
		this.player.add(new com_newwave_components_game_Gravity(5));
		this.carLayer.addChild(this.player);
		if(this.unlimitedPillows) this.gotPillows();
		if(this.invincible && !flambe_System.get_touch().get_supported()) {
			var starleftImages = new Array();
			var _g2 = 1;
			while(_g2 < 8) {
				var i2 = _g2++;
				starleftImages.push(new flambe_display_ImageSprite(this.assetPack.getTexture("game/stars/" + i2)));
			}
			this.bonusStarsLeft = new flambe_Entity();
			var starleftsprite = new flambe_display_Sprite();
			starleftsprite.setXY(117,120);
			this.bonusStarsLeft.add(starleftsprite);
			this.bonusStarsLeft.add(new com_newwave_components_display_PngSequence(starleftImages,true,1));
			this.player.addChild(this.bonusStarsLeft);
			var starrightImages = new Array();
			var _g3 = 1;
			while(_g3 < 8) {
				var i3 = _g3++;
				starrightImages.push(new flambe_display_ImageSprite(this.assetPack.getTexture("game/stars/" + i3)));
			}
			this.bonusStarsRight = new flambe_Entity();
			var starrightsprite = new flambe_display_Sprite();
			starrightsprite.setXY(290,120);
			this.bonusStarsRight.add(starrightsprite);
			this.bonusStarsRight.add(new com_newwave_components_display_PngSequence(starrightImages,true,1));
			this.player.addChild(this.bonusStarsRight);
		}
		if(this.hotrod && !flambe_System.get_touch().get_supported() && !this.invincible) {
			var flagleftImages = new Array();
			var _g4 = 1;
			while(_g4 < 15) {
				var i4 = _g4++;
				flagleftImages.push(new flambe_display_ImageSprite(this.assetPack.getTexture("game/flag/" + i4)));
			}
			this.bonusflagLeft = new flambe_Entity();
			var flagleftsprite = new flambe_display_Sprite();
			flagleftsprite.setXY(106,120).setScaleXY(-1,1);
			this.bonusflagLeft.add(flagleftsprite);
			this.bonusflagLeft.add(new com_newwave_components_display_PngSequence(flagleftImages,true,1));
			this.player.addChild(this.bonusflagLeft);
			var flagrightImages = new Array();
			var _g5 = 1;
			while(_g5 < 15) {
				var i5 = _g5++;
				flagrightImages.push(new flambe_display_ImageSprite(this.assetPack.getTexture("game/flag/" + i5)));
			}
			this.bonusflagRight = new flambe_Entity();
			var flagrightsprite = new flambe_display_Sprite();
			flagrightsprite.setXY(296,120);
			this.bonusflagRight.add(flagrightsprite);
			this.bonusflagRight.add(new com_newwave_components_display_PngSequence(flagrightImages,true,1));
			this.player.addChild(this.bonusflagRight);
		}
		if(!this.invincible && !flambe_System.get_touch().get_supported()) {
			var playerSpinImages = new Array();
			var _g6 = 0;
			while(_g6 < 8) {
				var i6 = _g6++;
				playerSpinImages.push(new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "_spin/0000" + i6)));
			}
			this.playerSpin = new flambe_Entity();
			this.playerSpin.add(new flambe_display_Sprite().setXY(400,400).setScale(1).setAlpha(0));
			this.playerSpin.add(new com_newwave_components_display_PngSequence(playerSpinImages,true,1));
			this.owner.addChild(this.playerSpin);
			this.playerSpin.getComponent("PngSequence_3").pause();
		}
		var scoreboard = new flambe_Entity();
		var img = new flambe_display_ImageSprite(this.assetPack.getTexture("game/scoreboard"));
		scoreboard.add(img);
		this.owner.addChild(scoreboard);
		this.stoplight = new flambe_Entity();
		var img1 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/stoplight"));
		img1.centerAnchor().setXY(514,-300);
		this.stoplight.add(img1);
		this.owner.addChild(this.stoplight);
		this.star3 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/star3"));
		this.star3.centerAnchor().setXY(57,155).setScale(0).setRotation(10);
		this.stoplight.addChild(new flambe_Entity().add(this.star3));
		this.star2 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/star2"));
		this.star2.centerAnchor().setXY(116,155).setScale(0).setRotation(10);
		this.stoplight.addChild(new flambe_Entity().add(this.star2));
		this.star1 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/star1"));
		this.star1.centerAnchor().setXY(180,155).setScale(0).setRotation(10);
		this.stoplight.addChild(new flambe_Entity().add(this.star1));
		var font = new flambe_display_Font(this.assetPack,"fonts/TimerTxt");
		this.timerTxt = new flambe_display_TextSprite(font,"0:00");
		this.timerTxt.x.set__(5);
		this.timerTxt.y.set__(40);
		this.timerTxt.disablePointer();
		this.timerTxt.setLetterSpacing(2);
		this.owner.addChild(new flambe_Entity().add(this.timerTxt));
		var font1 = new flambe_display_Font(this.assetPack,"fonts/LapTxt");
		this.lapTxt = new flambe_display_TextSprite(font1,"LAP 1/" + this.maxLaps);
		this.lapTxt.x.set__(5);
		this.lapTxt.y.set__(105);
		this.lapTxt.disablePointer();
		this.lapTxt.setLetterSpacing(1);
		this.owner.addChild(new flambe_Entity().add(this.lapTxt));
		var placeBg = new flambe_Entity();
		placeBg.add(new flambe_display_ImageSprite(this.assetPack.getTexture("game/place_empty")).setXY(877,520));
		this.owner.addChild(placeBg);
		this.placeGraphic = new flambe_Entity();
		this.placeGraphic.add(new flambe_display_ImageSprite(this.assetPack.getTexture("game/place_4")).setXY(877,520));
		this.owner.addChild(this.placeGraphic);
		this.spriteScale = 0.35 * (1 / this.player.getComponent("Sprite_4").getNaturalWidth());
		this.cartMotor = this.assetPack.getSound("sounds/motor_together").loop(0.5);
		this.resetRoad();
	}
	,startRace: function() {
		this.disposer = new flambe_Disposer();
		this.disposer.add(flambe_System.get_keyboard().down.connect($bind(this,this.handleKeyDown)));
		this.disposer.add(flambe_System.get_keyboard().up.connect($bind(this,this.handleKeyUp)));
		if(flambe_System.get_touch().get_supported()) {
			this.disposer.add(flambe_System.get_pointer().down.connect($bind(this,this.handlePointerDown)));
			this.disposer.add(flambe_System.get_pointer().up.connect($bind(this,this.handlePointerUp)));
		}
		if(flambe_System.get_touch().get_supported()) {
			this.disposer.add(flambe_System.get_motion().accelerationIncludingGravity.connect($bind(this,this.onAccelUpdate)));
			this.keyFaster = true;
		}
		this.owner.add(this.disposer);
		var i = 0;
		while(i < this.npcracers.length) {
			this.npcracers[i].getComponent("NPCRacer_5").active = true;
			i++;
		}
	}
	,onUpdate: function(dt) {
		var _g = this;
		if(this.isIntro) {
			this.stoplight.getComponent("Sprite_4").rotation.set__(Math.cos(this.countdownAnimTime) * 2);
			this.stoplight.getComponent("Sprite_4").x.set__(514 + Math.cos(this.countdownAnimTime) * 5);
			this.countdownAnimTime += 0.14;
			this.introTime++;
			if(this.introTime >= this.introDelay) {
				this.introCount++;
				if(this.introCount == 1) {
					this.stoplight.getComponent("Sprite_4").y.animateTo(130,1.3,flambe_animation_Ease.expoOut);
					this.introTime = 0;
				}
				if(this.introCount == 2) {
					var sound = this.assetPack.getSound("sounds/countdown1").play(0.9);
					this.star3.rotation.animateTo(0,0.5,flambe_animation_Ease.backOut);
					this.star3.scaleX.animateTo(1,0.5,flambe_animation_Ease.backOut);
					this.star3.scaleY.animateTo(1,0.5,flambe_animation_Ease.backOut);
					this.introTime = 0;
				}
				if(this.introCount == 3) {
					var sound1 = this.assetPack.getSound("sounds/countdown1").play(0.9);
					this.star2.rotation.animateTo(0,0.5,flambe_animation_Ease.backOut);
					this.star2.scaleX.animateTo(1,0.5,flambe_animation_Ease.backOut);
					this.star2.scaleY.animateTo(1,0.5,flambe_animation_Ease.backOut);
					this.introTime = 0;
				}
				if(this.introCount == 4) {
					var sound2 = this.assetPack.getSound("sounds/countdown1").play(0.9);
					this.star1.rotation.animateTo(0,0.5,flambe_animation_Ease.backOut);
					this.star1.scaleX.animateTo(1,0.5,flambe_animation_Ease.backOut);
					this.star1.scaleY.animateTo(1,0.5,flambe_animation_Ease.backOut);
					this.introTime = 0;
				}
				if(this.introCount == 5) {
					var sound3 = this.assetPack.getSound("sounds/countdown2").play(0.9);
					var go = new flambe_display_ImageSprite(this.assetPack.getTexture("game/text_go"));
					go.centerAnchor().setXY(514,300).setScale(0);
					this.owner.addChild(new flambe_Entity().add(go));
					var script = new flambe_script_Script();
					script.run(new flambe_script_Sequence([new flambe_script_Parallel([new flambe_script_AnimateTo(go.scaleX,1,0.4,flambe_animation_Ease.expoIn),new flambe_script_AnimateTo(go.scaleY,1,0.4,flambe_animation_Ease.expoIn)]),new flambe_script_Delay(0.3),new flambe_script_Parallel([new flambe_script_AnimateTo(this.stoplight.getComponent("Sprite_4").y,-300,0.8,flambe_animation_Ease.backIn),new flambe_script_AnimateTo(go.scaleX,0,0.4,flambe_animation_Ease.expoIn),new flambe_script_AnimateTo(go.scaleY,0,0.4,flambe_animation_Ease.expoIn)]),new flambe_script_CallFunction(function() {
						_g.stoplight.dispose();
					})]));
					this.owner.add(script);
					this.isIntro = false;
					this.startRace();
				}
			}
		}
		if(this.active) {
			if(!this.isIntro && !this.finished) {
				this.gameSeconds += dt;
				this.timerTxt.set_text(com_newwave_utils_GameUtils.convertTime(this.gameSeconds));
			}
			this.position += dt * this.speed;
			if(this.position >= this.trackLength) {
				var sound4 = this.assetPack.getSound("sounds/finishedlap").play(0.9);
				this.position = 0;
				this.lapNum++;
				if(this.lapNum > this.maxLaps) this.finishedrace(); else if(this.lapNum == 2) {
					this.lapTxt.set_text("LAP " + this.lapNum + "/" + this.maxLaps);
					this.addGraphic(8,"ring_lap3",0);
				} else if(this.lapNum == 3) {
					this.lapTxt.set_text("LAP " + this.lapNum + "/" + this.maxLaps);
					this.addGraphic(8,"ring_finish",0);
				}
			}
			var dx = dt * 2 * (this.speed / this.maxSpeed);
			var playerSegment = this.findSegment(this.position + this.playerZ);
			var frontSegment = this.findSegment(this.position + this.playerZ + 150);
			var backSegment = this.findSegment(this.position + this.playerZ - 60);
			var speedPercent = this.speed / this.maxSpeed;
			var dir;
			if(Math.random() > 0.5) dir = 1; else dir = -1;
			var bounce = 1.5 * Math.random() * speedPercent * this.resolution * dir;
			var sprite = this.player.getComponent("Sprite_4");
			this.player.getComponent("Gravity_13").maxY = this.playerY + bounce;
			var theangle = playerSegment.p1.world.y - playerSegment.p2.world.y;
			if(theangle > -100 && theangle < 100) {
				if(this.angle != "mid") {
					this.angle = "mid";
					this.updatePlayerSprite();
				}
			} else if(theangle < -100) {
				if(this.angle != "mid") {
					this.angle = "mid";
					this.updatePlayerSprite();
				}
			} else if(theangle > 100) {
				if(this.angle != "mid") {
					this.angle = "mid";
					this.updatePlayerSprite();
				}
			}
			if(!this.invincible && !flambe_System.get_touch().get_supported()) {
				this.playerSpin.getComponent("Sprite_4").x.set__(this.player.getComponent("Sprite_4").x.get__());
				this.playerSpin.getComponent("Sprite_4").y.set__(this.player.getComponent("Sprite_4").y.get__());
			}
			this.bubbleCounter += dt * this.speed;
			if(this.bubbleCounter >= this.bubbleDelay) {
				this.addCartBubbles();
				this.bubbleCounter = 0;
			}
			if(this.keyLeft) this.playerX = this.playerX - dx; else if(this.keyRight) this.playerX = this.playerX + dx;
			this.playerX = this.playerX - dx * speedPercent * playerSegment.curve * this.centrifugal;
			if(this.keyFaster) this.speed += this.accel; else if(this.keySlower) this.speed += this.breaking; else this.speed += this.decel;
			if((this.playerX < -0.84 || this.playerX > 0.84) && this.speed > this.offRoadLimit) this.speed += this.offRoadDecel * 0.65;
			if(!this.inHole && !this.spinningOut) {
				sprite.x.set__(this.width / 2 + this.playerX);
				sprite.y.set__(this.playerY + bounce);
			}
			if(this.playerX < -0.85) this.playerX = -0.85;
			if(this.playerX > 0.85) this.playerX = 0.85;
			if(this.speed > this.maxSpeed) this.speed = this.maxSpeed;
			if(this.speed < 0) this.speed = 0;
			var baseSegment = this.findSegment(this.position);
			var basePercent = com_newwave_utils_GameUtils.percentRemaining(this.position,this.segmentLength);
			var playerPercent = com_newwave_utils_GameUtils.percentRemaining(this.position + this.playerZ,this.segmentLength);
			var playerY = com_newwave_utils_GameUtils.interpolate(playerSegment.p1.world.y,playerSegment.p2.world.y,playerPercent);
			var dx1 = -(baseSegment.curve * basePercent);
			var x = 0;
			var maxy = this.height;
			var currentSegment;
			var n = 0;
			while(n < this.drawDistance) {
				currentSegment = this.segments[(baseSegment.index + n) % this.segments.length].getComponent("Segment_19");
				if(currentSegment.index < baseSegment.index) {
					this.project(currentSegment.p1,this.playerX * this.roadWidth - x,playerY + this.cameraHeight,this.position - this.trackLength);
					this.project(currentSegment.p2,this.playerX * this.roadWidth - x - dx1,playerY + this.cameraHeight,this.position - this.trackLength);
				} else {
					this.project(currentSegment.p1,this.playerX * this.roadWidth - x,playerY + this.cameraHeight,this.position);
					this.project(currentSegment.p2,this.playerX * this.roadWidth - x - dx1,playerY + this.cameraHeight,this.position);
				}
				if(currentSegment.p1.camera.z <= 1 || currentSegment.p2.screen.y >= maxy) currentSegment.hide(); else currentSegment.show();
				x = x + dx1;
				dx1 = dx1 + currentSegment.curve;
				var i = 0;
				while(i < currentSegment.powerups.length) {
					var powerup = currentSegment.powerups[i].getComponent("Powerup_20");
					var img = powerup.owner.getComponent("Sprite_4");
					var scale = currentSegment.p1.screen.scale;
					var imgWidth = img.getNaturalWidth();
					var imgHeight = img.getNaturalHeight();
					var destW = img.getNaturalWidth() * scale * this.width / 2 * (this.spriteScale * this.roadWidth);
					var spriteX = currentSegment.p1.screen.x + scale * powerup.offset * this.roadWidth * this.width / 2;
					var destX = spriteX + destW * powerup.offset;
					var destY = currentSegment.p1.screen.y;
					if(powerup.offsetY != 0) {
						imgWidth = 200;
						imgHeight = 200;
						destW = imgWidth * scale * this.width / 2 * (this.spriteScale * this.roadWidth);
						destW = destW * this.bigasfuck;
						destY = powerup.offsetY;
					}
					img.setXY(destX,destY);
					img.setScale(destW / imgWidth);
					if(powerup.type == "hole") img.scaleY.set__(img.scaleY.get__() / 2);
					var maxY = this.height;
					if(powerup.active) {
						img.alpha.set__((this.drawDistance - n) / this.drawDistance);
						var s = playerSegment.index;
						if(s + this.drawDistance > this.segments.length) s = 0;
						while(s < currentSegment.index) {
							var yPos = this.segments[s].getComponent("Segment_19").p2.screen.y;
							if(yPos < maxY) maxY = yPos;
							s++;
						}
						if(maxY < destY) {
							var overlap = destY - maxY;
							var scaledHeight = imgHeight * img.scaleX.get__();
							var scaledOverlap = imgHeight * overlap / scaledHeight;
							img.scissor = new flambe_math_Rectangle(0,0,imgWidth,imgHeight - scaledOverlap);
						} else {
							img.scissor = null;
							img.alpha.set__(1);
						}
						if(playerSegment == currentSegment && !this.spinningOut) {
							if(com_newwave_utils_GameUtils.absDistance(this.playerX,powerup.offset) < 0.15) {
								if(powerup.type == "lightning") {
									this.speed = this.speed * 1.5;
									this.hasTurbo = true;
									powerup.gotPowerup();
									var sound5 = this.assetPack.getSound("sounds/turbo").play(0.9);
								} else if(powerup.type == "powerup_pillow") {
									this.gotPillows();
									powerup.gotPowerup();
								} else if(powerup.type == "hole" && !this.inHole) this.fellInHole(img.x.get__(),img.y.get__(),powerup.offset); else if(powerup.type == "clock") {
									if(!this.invincible) this.doSpinOut();
									powerup.gotPowerup();
								}
							}
						}
					} else img.alpha.set__(0);
					if(powerup.type == "ramp_large") {
						if(img.y.get__() > this.player.getComponent("Sprite_4").y.get__() && img.y.get__() < 650) {
							if(Math.abs(this.player.getComponent("Sprite_4").x.get__() - img.x.get__()) < 180) {
								this.player.getComponent("Gravity_13").velocity = 0 - (img.y.get__() - this.player.getComponent("Sprite_4").y.get__()) * (this.speed / this.maxSpeed) * 1.3;
								this.speed = this.speed * 1.25;
								this.hasTurbo = true;
								var sound6 = this.assetPack.getSound("sounds/woosh").play(0.9);
							}
						}
					}
					var p = 0;
					while(p < this.npcracers.length) {
						var currentracer = this.npcracers[p].getComponent("NPCRacer_5");
						var racerSegment = this.findSegment(currentracer.zPos);
						if(racerSegment == currentSegment) {
							if(com_newwave_utils_GameUtils.absDistance(currentracer.offset,powerup.offset) < 0.17) {
								if(powerup.type == "lightning") {
									currentracer.gotTurbo();
									powerup.gotPowerup();
								} else if(powerup.type == "powerup_pillow") {
									currentracer.gotPillows();
									powerup.gotPowerup();
								} else if(powerup.type == "ramp") currentracer.hitRamp(); else if(powerup.type == "clock") {
									currentracer.doSpinOut();
									powerup.gotPowerup();
								}
							}
						}
						p++;
					}
					i++;
				}
				i = 0;
				while(i < currentSegment.graphics.length) {
					var graphic = currentSegment.graphics[i].getComponent("Graphic_21");
					var img1 = graphic.owner.getComponent("Sprite_4");
					var scale1 = currentSegment.p1.screen.scale;
					var imgWidth1 = graphic.img.getNaturalWidth();
					var imgHeight1 = graphic.img.getNaturalHeight();
					var destW1 = imgWidth1 * scale1 * this.width / 2 * (this.spriteScale * this.roadWidth);
					var spriteX1 = currentSegment.p1.screen.x + scale1 * graphic.offset * this.roadWidth * this.width / 2;
					var destX1 = spriteX1 + destW1 * graphic.offset;
					var destY1 = currentSegment.p1.screen.y;
					if(graphic.offsetY != 0) {
						imgWidth1 = 200;
						imgHeight1 = 200;
						destW1 = imgWidth1 * scale1 * this.width / 2 * (this.spriteScale * this.roadWidth);
						destW1 = destW1 * this.bigasfuck;
						destY1 = graphic.offsetY;
					}
					img1.setXY(destX1,destY1);
					img1.setScale(destW1 / imgWidth1);
					if(graphic.type == "ring" || graphic.type == "ring_lap2" || graphic.type == "ring_lap3" || graphic.type == "ring_finish") img1.setScale(destW1 / imgWidth1 * 2.6);
					var maxY1 = this.height;
					if(graphic.active) {
						var s1 = playerSegment.index;
						if(s1 + this.drawDistance > this.segments.length) s1 = 0;
						while(s1 < currentSegment.index) {
							var yPos1 = this.segments[s1].getComponent("Segment_19").p2.screen.y;
							if(yPos1 < maxY1) maxY1 = yPos1;
							s1++;
						}
						if(maxY1 < destY1) {
							var overlap1 = destY1 - maxY1;
							var scaledHeight1 = imgHeight1 * img1.scaleX.get__();
							var scaledOverlap1 = imgHeight1 * overlap1 / scaledHeight1;
							img1.scissor = new flambe_math_Rectangle(0,0,imgWidth1,imgHeight1 - scaledOverlap1);
						} else img1.scissor = null;
					} else img1.alpha.set__(0);
					i++;
				}
				if(currentSegment.p2.screen.y < maxy) maxy = currentSegment.p2.screen.y;
				n++;
			}
			if(this.hasTurbo) {
				this.maxSpeed = this.turboSpeed;
				this.turboTime += 1;
				if(this.turboTime >= this.turboLength) {
					this.hasTurbo = false;
					this.turboTime = 0;
					this.maxSpeed = this.turboSpeed * 0.5;
				}
			}
			var p1 = 0;
			while(p1 < this.pillows.length) {
				var currentpillow = this.pillows[p1].getComponent("Pillow_23");
				var pillowSegment = this.findSegment(currentpillow.zPos);
				var img2 = currentpillow.owner.getComponent("Sprite_4");
				var scale2 = pillowSegment.p1.screen.scale;
				var destW2 = img2.getNaturalWidth() * scale2 * this.width / 2 * (this.spriteScale * this.roadWidth);
				var spriteX2 = pillowSegment.p1.screen.x + scale2 * currentpillow.offset * this.roadWidth * this.width / 2;
				var destX2 = spriteX2 + destW2 * currentpillow.offset;
				var destY2 = pillowSegment.p1.screen.y;
				img2.setXY(destX2,destY2);
				img2.setScale(destW2 / img2.getNaturalWidth());
				if(img2.alpha.get__() > 0 && pillowSegment.index > playerSegment.index) {
					var maxY2 = this.height;
					var s2 = playerSegment.index;
					while(s2 < pillowSegment.index) {
						var yPos2 = this.segments[s2].getComponent("Segment_19").p2.screen.y;
						if(yPos2 < maxY2) maxY2 = yPos2;
						s2++;
					}
					if(maxY2 < destY2) {
						var overlap2 = destY2 - maxY2;
						var scaledHeight2 = img2.getNaturalHeight() * img2.scaleX.get__();
						var scaledOverlap2 = img2.getNaturalHeight() * overlap2 / scaledHeight2;
						if(img2.getNaturalHeight() - scaledOverlap2 > 0 && img2.getNaturalHeight() - scaledOverlap2 < this.height) img2.scissor = new flambe_math_Rectangle(0,0,img2.getNaturalWidth(),img2.getNaturalHeight() - scaledOverlap2); else {
							img2.scissor = null;
							img2.alpha.set__(0);
						}
					} else img2.scissor = null;
				}
				if(currentpillow.hitPlayer) img2.alpha.set__(0);
				var n1 = 0;
				while(n1 < this.npcracers.length) {
					var currentracer1 = this.npcracers[n1].getComponent("NPCRacer_5");
					var racerImg = this.npcracers[n1].getComponent("Sprite_4");
					var racerSegment1 = this.findSegment(currentracer1.zPos);
					if(racerSegment1 == pillowSegment && !currentpillow.hitPlayer) {
						var realPlayerX = racerSegment1.p1.screen.x + scale2 * currentracer1.offset * this.roadWidth * this.width / 2;
						if(com_newwave_utils_GameUtils.absDistance(currentpillow.offset,currentracer1.offset) < 0.15) {
							currentpillow.hitPlayer = true;
							currentracer1.pillowHit();
							var sound7 = this.assetPack.getSound("sounds/hitracer").play(0.9);
							this.addFeathers(5,racerImg.x.get__(),racerImg.y.get__(),racerImg.scaleX.get__());
						}
					}
					n1++;
				}
				if(currentpillow.zPos - currentpillow.startZ >= 25000) {
					currentpillow.owner.dispose();
					this.pillows.splice(p1,1);
				}
				p1++;
			}
			var maxZ = this.position + 370;
			p1 = 0;
			while(p1 < this.npcracers.length) {
				var currentracer2 = this.npcracers[p1].getComponent("NPCRacer_5");
				if(!this.finished) {
					var NPCpos = this.trackLength * currentracer2.lapNum + currentracer2.zPos;
					var playerPos = this.trackLength * this.lapNum + this.position;
					if(playerPos - NPCpos > 3500) {
						currentracer2.zPos++;
						if(currentracer2.zPos < 0) currentracer2.zPos = 0;
					}
				}
				if(currentracer2.zPos >= this.trackLength) {
					currentracer2.zPos = 0;
					currentracer2.lapNum++;
					if(currentracer2.lapNum > this.maxLaps && !currentracer2.finished) {
						currentracer2.totalTime = this.gameSeconds;
						currentracer2.finished = true;
					}
				}
				var racerSegment2 = this.findSegment(currentracer2.zPos);
				var img3 = currentracer2.owner.getComponent("Sprite_4");
				var segmentPercent = com_newwave_utils_GameUtils.percentRemaining(currentracer2.zPos,this.segmentLength);
				var scale3 = com_newwave_utils_GameUtils.interpolate(racerSegment2.p1.screen.scale,racerSegment2.p2.screen.scale,segmentPercent);
				var destW3 = img3.getNaturalWidth() * scale3 * this.width / 2 * (this.spriteScale * this.roadWidth);
				var spriteX3 = com_newwave_utils_GameUtils.interpolate(racerSegment2.p1.screen.x,racerSegment2.p2.screen.x,segmentPercent) + scale3 * currentracer2.offset * this.roadWidth * this.width / 2;
				var destX3 = spriteX3 + destW3 * currentracer2.offset;
				var destY3 = racerSegment2.p1.screen.y - (racerSegment2.p1.screen.y - racerSegment2.p2.screen.y) * segmentPercent;
				destY3 -= currentracer2.offsetY;
				img3.setXY(destX3,destY3);
				img3.setScale(destW3 / img3.getNaturalWidth());
				currentracer2.playerDist = currentracer2.zPos - this.position;
				currentracer2.playerX = this.playerX;
				if(baseSegment.index + this.drawDistance > this.segments.length) {
					var racerIndex = racerSegment2.index;
					var currentIndex = baseSegment.index;
					if(racerIndex < this.segments.length && racerIndex > currentIndex) img3.alpha.set__(currentracer2.spinningOut == true?0:1); else if(racerIndex > 0 && racerIndex < currentIndex - this.segments.length + this.drawDistance) img3.alpha.set__(currentracer2.spinningOut == true?0:1); else img3.alpha.set__(0);
				} else if(racerSegment2.index < baseSegment.index || racerSegment2.index - baseSegment.index > this.drawDistance || img3.scaleX.get__() < 0) img3.alpha.set__(0); else img3.alpha.set__(currentracer2.spinningOut == true?0:1);
				if(img3.alpha.get__() > 0 && racerSegment2.index > playerSegment.index) {
					var maxY3 = this.height;
					var s3 = playerSegment.index;
					while(s3 < racerSegment2.index) {
						var yPos3 = this.segments[s3].getComponent("Segment_19").p2.screen.y;
						if(yPos3 < maxY3) maxY3 = yPos3;
						s3++;
					}
					if(maxY3 < destY3) {
						var overlap3 = destY3 - maxY3;
						var scaledHeight3 = img3.getNaturalHeight() * img3.scaleX.get__();
						var scaledOverlap3 = img3.getNaturalHeight() * overlap3 / scaledHeight3;
						if(img3.getNaturalHeight() - scaledOverlap3 > 0 && img3.getNaturalHeight() - scaledOverlap3 < this.height) img3.scissor = new flambe_math_Rectangle(0,0,img3.getNaturalWidth(),img3.getNaturalHeight() - scaledOverlap3); else {
							img3.scissor = null;
							img3.alpha.set__(0);
						}
					} else img3.scissor = null;
				}
				if(currentracer2.zPos > maxZ) {
					this.carLayer.addChild(currentracer2.owner,false);
					maxZ = currentracer2.zPos;
				}
				if(racerSegment2 == frontSegment || racerSegment2 == playerSegment) {
					var dist = 0;
					if(this.playerX > 0 && currentracer2.offset < 0) dist = Math.abs(this.playerX) + Math.abs(currentracer2.offset); else if(currentracer2.offset > 0 && this.playerX < 0) dist = Math.abs(this.playerX) + Math.abs(currentracer2.offset); else dist = Math.abs(this.playerX - currentracer2.offset);
					if(dist < 0.1) {
						if(this.invincible) {
							if(playerSegment.index != 3) currentracer2.doSpinOut();
						} else {
							this.speed = 0;
							if(playerSegment.index != 3) {
								var sound8 = this.assetPack.getSound("sounds/hitracer").play(0.9);
							}
						}
					} else if(dist < 0.15) {
						currentracer2.speed = currentracer2.speed * 0.7;
						if(this.playerX > currentracer2.offset) currentracer2.xForce -= 0.002; else if(currentracer2.offset > this.playerX) currentracer2.xForce += 0.002;
					}
				}
				if(racerSegment2 == backSegment && playerSegment.index != 3) {
					var dist1 = 0;
					if(this.playerX > 0 && currentracer2.offset < 0) dist1 = Math.abs(this.playerX) + Math.abs(currentracer2.offset); else if(currentracer2.offset > 0 && this.playerX < 0) dist1 = Math.abs(this.playerX) + Math.abs(currentracer2.offset); else dist1 = Math.abs(this.playerX - currentracer2.offset);
					if(dist1 < 0.15) {
						if(this.invincible) {
							if(playerSegment.index != 3) currentracer2.doSpinOut();
						} else {
							currentracer2.speed = 0;
							this.speed += 100;
							var sound9 = this.assetPack.getSound("sounds/hitracer").play(0.9);
						}
					}
				}
				p1++;
			}
			var _g1 = this.background.x;
			_g1.set__(_g1.get__() - this.skySpeed * playerSegment.curve * speedPercent);
			this.bg_hills.getComponent("RepeatingBackground_1").speed = -1 * this.hillSpeed * playerSegment.curve * speedPercent;
			this.bg_trees.getComponent("RepeatingBackground_1").speed = -1 * this.treeSpeed * playerSegment.curve * speedPercent;
			if(!flambe_System.get_touch().get_supported()) {
				var _g2 = this.moon.getComponent("Sprite_4").x;
				_g2.set__(_g2.get__() - 1 * (this.skySpeed * 0.6) * playerSegment.curve * speedPercent);
				if(this.moon.getComponent("Sprite_4").x.get__() > 1500) this.moon.getComponent("Sprite_4").x.set__(1500);
				if(this.moon.getComponent("Sprite_4").x.get__() < -500) this.moon.getComponent("Sprite_4").x.set__(-500);
				var _g3 = this.sheep.getComponent("Sprite_4").x;
				_g3.set__(_g3.get__() - 1 * (this.skySpeed * 0.6) * playerSegment.curve * speedPercent);
				if(this.sheep.getComponent("Sprite_4").x.get__() > 1500) this.sheep.getComponent("Sprite_4").x.set__(1500);
				if(this.sheep.getComponent("Sprite_4").x.get__() < -500) this.sheep.getComponent("Sprite_4").x.set__(-500);
			}
			if(this.inHole) {
				this.speed = 0;
				this.position += 1.5;
				if(flambe_System.get_touch().get_supported()) {
					this.player.getComponent("Sprite_4").setAlpha(0);
					this.position += 1.5;
				}
			}
			this.cartMotor.volume.set__(0.8 * (this.speed / this.maxSpeed));
			this.findPlayerPlace();
		}
		if(this.ctx.device == "phone") this.player.getComponent("Sprite_4").setScale(2);
	}
	,resetRoad: function() {
		this.segments = [];
		this.addStart();
		this.addStraight(this.road.LENGTH.SHORT / 4);
		this.addLowRollingHills(this.road.LENGTH.SHORT,this.road.HILL.LOW);
		this.addHill(this.road.LENGTH.SHORT,this.road.HILL.LOW);
		this.addCurve(this.road.LENGTH.SHORT,this.road.CURVE.HARD);
		this.addStraight(this.road.LENGTH.SHORT / 2);
		if(!flambe_System.get_touch().get_supported()) this.addCurve(this.road.LENGTH.SHORT,-1 * this.road.CURVE.HARD);
		this.addDownhillToEnd(this.road.LENGTH.MEDIUM);
		this.trackLength = this.segments.length * this.segmentLength;
		this.resetPowerups();
		this.resetRacers();
	}
	,resetPowerups: function() {
		if(flambe_System.get_touch().get_supported()) {
			this.addGraphic(9,"books",1.25,200);
			this.addGraphic(15,"spatula",-1.35,160);
			this.addGraphic(100,"books",1.25,200);
			this.addGraphic(200,"spatulagroup",-1.35,200);
			this.addGraphic(300,"sheep",1.25,200);
			this.addGraphic(400,"books",-1.25,200);
			this.addGraphic(150,"spatulagroup",1.25,200);
			this.addGraphic(250,"spatula",-1.35,160);
			this.addGraphic(350,"sheep",1.25,200);
			this.addGraphic(450,"books",-1.25,200);
			this.addGraphic(375,"books",-1.25,200);
			this.addGraphic(400,"sheep",1.25,200);
			this.addGraphic(425,"spatulagroup",-1.25,200);
			this.addGraphic(450,"books",1.25,200);
		} else {
			this.addBGAnimation(9,"books",1.25,200,14);
			this.addBGAnimation(15,"spatula",-1.35,160,44);
			this.addBGAnimation(100,"books",1.25,200,14);
			this.addBGAnimation(200,"spatulagroup",-1.35,200,18);
			this.addBGAnimation(300,"sheep",1.25,200,44);
			this.addBGAnimation(400,"books",-1.25,200,14);
			this.addBGAnimation(150,"spatulagroup",1.25,200,18);
			this.addBGAnimation(250,"spatula",-1.35,160,44);
			this.addBGAnimation(350,"sheep",1.25,200,44);
			this.addBGAnimation(400,"sheep",1.25,200,14);
			this.addBGAnimation(425,"spatulagroup",-1.25,200,14);
			this.addBGAnimation(450,"books",1.25,200,14);
			this.addBGAnimation(460,"books",-1.25,200,14);
			this.addBGAnimation(470,"sheep",1.25,200,14);
			this.addBGAnimation(490,"books",1.25,200,14);
			this.addBGAnimation(510,"sheep",1.25,200,14);
			this.addBGAnimation(530,"books",1.25,200,14);
		}
		this.addPowerup(50,"powerup_pillow",0.3);
		this.addPowerup(75,"ramp_large",0);
		this.addPowerup(100,"hole",-0.3);
		this.addPowerup(110,"clock",0.2);
		this.addPowerup(120,"hole",0.1);
		this.addPowerup(135,"clock",0.3);
		this.addPowerup(145,"clock",0.3);
		this.addPowerup(150,"hole",0);
		this.addPowerup(175,"clock",0.2);
		this.addPowerup(180,"hole",-0.4);
		this.addPowerup(175,"hole",-0.2);
		this.addPowerup(187,"clock",-0.2);
		this.addPowerup(200,"clock",0.3);
		this.addPowerup(210,"hole",0.1);
		this.addPowerup(220,"hole",-0.1);
		this.addPowerup(230,"powerup_pillow",-0.3);
		this.addPowerup(250,"clock",0);
		this.addPowerup(270,"hole",0.4);
		this.addPowerup(280,"hole",-0.1);
		this.addPowerup(290,"hole",0.1);
		this.addPowerup(100,"hole",0.3);
		this.addPowerup(200,"lightning",0.4);
		this.addPowerup(275,"hole",0.3);
		this.addPowerup(325,"lightning",0.3);
		this.addPowerup(365,"lightning",0.3);
		this.addPowerup(275,"hole",-0.5);
		this.addPowerup(105,"clock",0.3);
		this.addPowerup(375,"ramp_large",0.4);
		this.addPowerup(350,"powerup_pillow",0.1);
		this.addPowerup(350,"hole",0.3);
		this.addPowerup(385,"hole",-0.5);
		this.addPowerup(205,"hole",-0.5);
		this.addPowerup(350,"hole",-0.5);
		this.addPowerup(323,"clock",-0.5);
		this.addPowerup(187,"clock",0.6);
		this.finishLine = this.addGraphic(8,"ring_lap2",0);
		if(!flambe_System.get_touch().get_supported()) {
			this.addGraphic(100,"ring",0);
			this.addGraphic(120,"ring",0);
			this.addGraphic(140,"ring",0);
			this.addGraphic(160,"ring",0);
			this.addGraphic(180,"ring",0);
			this.addGraphic(200,"ring",0);
			this.addGraphic(260,"ring",0);
			this.addGraphic(280,"ring",0);
			this.addGraphic(300,"ring",0);
			this.addGraphic(320,"ring",0);
			this.addGraphic(340,"ring",0);
			this.addGraphic(350,"ring",0);
			this.addGraphic(360,"ring",0);
			this.addGraphic(370,"ring",0);
			this.addGraphic(380,"ring",0);
		}
	}
	,resetRacers: function() {
		var i = 0;
		while(i < this.racers.length) {
			if(this.racers[i] == this.ctx.chosenRacer) this.racers.splice(i,1);
			i++;
		}
		this.addNPCRacer(this.racers[0],new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.racers[0] + "/straight_mid")),0,335,this.maxSpeed + this.maxSpeed / 20,4);
		this.addNPCRacer(this.racers[1],new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.racers[1] + "/straight_mid")),-0.15,335,this.maxSpeed + this.maxSpeed / 40,6);
		this.addNPCRacer(this.racers[2],new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.racers[2] + "/straight_mid")),0.30,335,this.maxSpeed,8);
	}
	,findSegment: function(z) {
		var _this = this.segments[Math.floor(z / this.segmentLength) % this.segments.length];
		return _this.getComponent("Segment_19");
	}
	,addSegment: function(curve,y,finishLine,finishLine2) {
		if(finishLine2 == null) finishLine2 = false;
		if(finishLine == null) finishLine = false;
		var n = this.segments.length;
		var thecolor;
		if(n % 2 == 0) thecolor = this.colors.DARK; else thecolor = this.colors.LIGHT;
		var imgpath = "road";
		if(finishLine) imgpath = "finish";
		if(finishLine2) imgpath = "finish_";
		if(flambe_System.get_touch().get_supported()) imgpath = "road_mobile";
		var theroad = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath));
		var images = [];
		if(!flambe_System.get_touch().get_supported()) {
			var theroad1 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice1"));
			var theroad2 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice2"));
			var theroad3 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice3"));
			var theroad4 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice4"));
			var theroad5 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice5"));
			var theroad6 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice6"));
			var theroad7 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice7"));
			var theroad8 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice8"));
			var theroad9 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice9"));
			var theroad10 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice10"));
			var theroad11 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice11"));
			var theroad12 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice12"));
			var theroad13 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice13"));
			var theroad14 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice14"));
			var theroad15 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice15"));
			var theroad16 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice16"));
			var theroad17 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice17"));
			var theroad18 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice18"));
			var theroad19 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice19"));
			var theroad20 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/" + imgpath + "slice20"));
			var theroadleft = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/road_left"));
			var theroadright = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/road_right"));
			var therailleft = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/rail_left"));
			var therailright = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/rail_right"));
			images = [theroad,theroadleft,theroadright,therailleft,therailright,theroad1,theroad2,theroad3,theroad4,theroad5,theroad6,theroad7,theroad8,theroad9,theroad10,theroad11,theroad12,theroad13,theroad14,theroad15,theroad16,theroad17,theroad18,theroad19,theroad20];
		} else {
			var theroadleft1 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/road_left"));
			var theroadright1 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/road_right"));
			var therailleft1 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/rail_left"));
			var therailright1 = new flambe_display_ImageSprite(this.assetPack.getTexture("game/road/rail_right"));
			images = [theroad,theroadleft1,theroadright1,therailleft1,therailright1];
		}
		var newsegment = new flambe_Entity();
		var yVal1 = this.lastY();
		var yVal2 = y;
		var zVal1 = n * this.segmentLength;
		var zVal2 = (n + 1) * this.segmentLength;
		var newP1 = { index : n, world : { y : yVal1, z : zVal1}, camera : { }, screen : { }};
		var newP2 = { index : n, world : { y : yVal2, z : zVal2}, camera : { }, screen : { }};
		this.roadLayer.addChild(newsegment);
		newsegment.add(new flambe_display_Sprite());
		newsegment.add(new threedracer_components_Segment(n,images,newP1,newP2,thecolor,this.width,this.lanes,curve));
		newsegment.getComponent("Segment_19").hide();
		this.segments.push(newsegment);
	}
	,lastY: function() {
		if(this.segments.length == 0) return 0; else return this.segments[this.segments.length - 1].getComponent("Segment_19").p2.world.y;
	}
	,addRoad: function(enter,hold,leave,curve,y) {
		if(y == null) y = 0;
		var startY = this.lastY();
		var endY = startY + y * this.segmentLength;
		var total = enter + hold + leave;
		var n = 0;
		while(n < enter) {
			this.addSegment(com_newwave_utils_GameUtils.easeIn(0,curve,n / enter),com_newwave_utils_GameUtils.easeInOut(startY,endY,n / total));
			n++;
		}
		n = 0;
		while(n < hold) {
			this.addSegment(curve,com_newwave_utils_GameUtils.easeInOut(startY,endY,(enter + n) / total));
			n++;
		}
		n = 0;
		while(n < leave) {
			this.addSegment(com_newwave_utils_GameUtils.easeInOut(curve,0,n / leave),com_newwave_utils_GameUtils.easeInOut(startY,endY,(enter + hold + n) / total));
			n++;
		}
	}
	,addStart: function() {
		this.addStraight(3);
		this.addSegment(0,0,true);
		this.addSegment(0,0,false,true);
		this.addSegment(0,0,true);
	}
	,addStraight: function(num) {
		this.addRoad(num,num,num,0);
	}
	,addCurve: function(num,curve) {
		this.addRoad(num,num,num,curve);
	}
	,addHill: function(num,height) {
		this.addRoad(num,num,num,0,height);
	}
	,addLowRollingHills: function(num,height) {
		this.addRoad(num,num,num,0,height / 2);
		this.addRoad(num,num,num,0,-height);
		this.addRoad(num,num,num,0,height);
		this.addRoad(num,num,num,0,0);
		this.addRoad(num,num,num,0,height / 2);
		this.addRoad(num,num,num,0,0);
	}
	,addDownhillToEnd: function(num) {
		this.addRoad(num,num,num,-this.road.CURVE.EASY,-this.lastY() / this.segmentLength);
	}
	,addPowerup: function(n,type,offset,offsetY) {
		if(offsetY == null) offsetY = 0;
		var newpowerup = new flambe_Entity();
		var image = new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + type));
		image.setAnchor(image.getNaturalWidth() / 2,image.getNaturalHeight());
		newpowerup.add(image);
		newpowerup.add(new threedracer_components_Powerup(type,offset,image,this.segments[n].getComponent("Segment_19"),offsetY));
		this.objectLayer.addChild(newpowerup);
		this.segments[n].getComponent("Segment_19").powerups.push(newpowerup);
	}
	,addGraphic: function(n,type,offset,offsetY) {
		if(offsetY == null) offsetY = 0;
		var newgraphic = new flambe_Entity();
		var image = new flambe_display_Sprite();
		newgraphic.add(image);
		var imgsprite = new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + type));
		imgsprite.setAnchor(imgsprite.getNaturalWidth() / 2,imgsprite.getNaturalHeight());
		newgraphic.addChild(new flambe_Entity().add(imgsprite));
		newgraphic.add(new threedracer_components_Graphic(type,offset,imgsprite,this.segments[n].getComponent("Segment_19"),offsetY));
		this.objectLayer.addChild(newgraphic);
		this.segments[n].getComponent("Segment_19").graphics.push(newgraphic);
		return newgraphic;
	}
	,addBGAnimation: function(n,type,offset,offsetY,numImages) {
		if(offsetY == null) offsetY = 0;
		var images = new Array();
		var _g = 1;
		while(_g < numImages) {
			var i = _g++;
			images.push(new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + type + "/" + i)));
		}
		var newgraphic = new flambe_Entity();
		var image = new flambe_display_Sprite();
		newgraphic.add(image);
		newgraphic.add(new com_newwave_components_display_PngSequence(images,true,1));
		newgraphic.add(new threedracer_components_Graphic(type,offset,image,this.segments[n].getComponent("Segment_19"),offsetY));
		this.bgImageLayer.addChild(newgraphic);
		this.segments[n].getComponent("Segment_19").graphics.push(newgraphic);
	}
	,project: function(p,cameraX,cameraY,cameraZ) {
		if(p.world.x) p.camera.x = p.world.x - cameraX; else p.camera.x = 0 - cameraX;
		if(p.world.y) p.camera.y = p.world.y - cameraY; else p.camera.y = 0 - cameraY;
		var pcamZ = p.world.z - cameraZ;
		p.camera.z = pcamZ;
		if(pcamZ == 0) p.screen.scale = 0; else p.screen.scale = this.cameraDepth / pcamZ;
		p.screen.x = Math.round(this.width / 2 + p.screen.scale * p.camera.x * this.width / 2);
		p.screen.y = Math.round(this.height / 3 - p.screen.scale * p.camera.y * this.height / 2);
		p.screen.w = Math.round(p.screen.scale * this.roadWidth * this.width / 2);
	}
	,gotPillows: function() {
		var sound = this.assetPack.getSound("sounds/pillow_pickup").play(0.9);
		var addedPillows = 3 - this.numPillows;
		this.numPillows = 3;
		while(addedPillows > 0) {
			var startX = 200;
			var startY = 70;
			var spacingY = 20;
			if(this.ctx.device == "phone") {
				startX = 100;
				startY = 35;
				spacingY = 10;
			}
			var cartPillow = new flambe_display_ImageSprite(this.assetPack.getTexture("game/pillow"));
			cartPillow.centerAnchor().setXY(startX,startY + spacingY * addedPillows);
			var pillowentity = new flambe_Entity().add(cartPillow);
			this.player.addChild(pillowentity);
			this.cartPillowArray.push(pillowentity);
			cartPillow.setScale(0.4);
			cartPillow.scaleX.animateTo(1,0.2 * addedPillows,flambe_animation_Ease.bounceOut);
			cartPillow.scaleY.animateTo(1,0.2 * addedPillows,flambe_animation_Ease.bounceOut);
			addedPillows--;
		}
	}
	,shootPillow: function() {
		var _g = this;
		var sound = this.assetPack.getSound("sounds/shotpillow").play(0.9);
		if(!this.unlimitedPillows) {
			this.cartPillowArray[0].dispose();
			this.cartPillowArray.splice(0,1);
			var i = 0;
			while(i < this.cartPillowArray.length) {
				var spacingY = 20;
				if(this.ctx.device == "phone") spacingY = 10;
				if(flambe_System.get_touch().get_supported()) {
					var _g1 = this.cartPillowArray[i].getComponent("Sprite_4").y;
					_g1.set__(_g1.get__() + spacingY);
				} else this.cartPillowArray[i].getComponent("Sprite_4").y.animateTo(this.cartPillowArray[i].getComponent("Sprite_4").y.get__() + spacingY,0.4,flambe_animation_Ease.bounceOut);
				i++;
			}
			this.numPillows--;
		}
		var dir = "straight";
		if(this.keyLeft == true) dir = "left"; else if(this.keyRight == true) dir = "right";
		if(this.angle == "up") this.angle = "mid";
		var script = new flambe_script_Script();
		script.run(new flambe_script_Sequence([new flambe_script_CallFunction(function() {
			if(!flambe_System.get_touch().get_supported()) _g.player = com_newwave_utils_GameUtils.replaceImageSprite(_g.player,new flambe_display_ImageSprite(_g.assetPack.getTexture("game/" + _g.bonusCart + _g.ctx.chosenRacer + "/" + dir + "_" + _g.angle + "_throw1")),true);
		}),new flambe_script_Delay(0.1),new flambe_script_CallFunction(function() {
			if(!flambe_System.get_touch().get_supported()) _g.player = com_newwave_utils_GameUtils.replaceImageSprite(_g.player,new flambe_display_ImageSprite(_g.assetPack.getTexture("game/" + _g.bonusCart + _g.ctx.chosenRacer + "/" + dir + "_" + _g.angle + "_throw2")),true);
		}),new flambe_script_Delay(0.1),new flambe_script_CallFunction(function() {
			if(!flambe_System.get_touch().get_supported()) _g.player = com_newwave_utils_GameUtils.replaceImageSprite(_g.player,new flambe_display_ImageSprite(_g.assetPack.getTexture("game/" + _g.bonusCart + _g.ctx.chosenRacer + "/" + dir + "_" + _g.angle)),true);
		})]));
		this.player.add(script);
		var playerSegment = this.findSegment(this.position + this.playerZ + 100);
		var pillow = new flambe_Entity();
		var image = new flambe_display_ImageSprite(this.assetPack.getTexture("game/pillow"));
		image.setAnchor(image.getNaturalWidth() / 2,image.getNaturalHeight());
		image.setXY(this.width / 2,200);
		pillow.add(image);
		pillow.add(new threedracer_components_Pillow(this.playerX * 0.9,playerSegment.p2.world.z,this.maxSpeed * 2));
		this.objectLayer.addChild(pillow);
		this.pillows.push(pillow);
	}
	,fellInHole: function(xPos,yPos,xOffset) {
		var _g = this;
		if(flambe_System.get_touch().get_supported()) {
			if(!this.inHole) {
				var sound = this.assetPack.getSound("sounds/hole").play(0.9);
				this.speed = 0;
				this.player.getComponent("Gravity_13").disable();
				var script = new flambe_script_Script();
				script.run(new flambe_script_Sequence([new flambe_script_CallFunction(function() {
					_g.player.getComponent("Sprite_4").setAlpha(0);
					_g.player.getComponent("Gravity_13").disable();
				}),new flambe_script_Delay(2),new flambe_script_CallFunction(function() {
					_g.player.getComponent("Sprite_4").setAlpha(1);
					_g.player.getComponent("Gravity_13").enable();
					_g.inHole = false;
				})]));
				this.owner.add(script);
				this.inHole = true;
			}
		} else if(!this.inHole) {
			var sound1 = this.assetPack.getSound("sounds/hole").play(0.9);
			this.speed = 0;
			this.player.getComponent("Gravity_13").disable();
			this.keyLeft = false;
			this.keyRight = false;
			this.keyFaster = false;
			var script1 = new flambe_script_Script();
			script1.run(new flambe_script_Sequence([new flambe_script_Parallel([new flambe_script_AnimateTo(this.player.getComponent("Sprite_4").x,xPos,0.8,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(this.player.getComponent("Sprite_4").y,yPos - 20,0.8,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(this.player.getComponent("Sprite_4").scaleX,0,0.8,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(this.player.getComponent("Sprite_4").scaleY,0,0.8,flambe_animation_Ease.expoOut)]),new flambe_script_Delay(1),new flambe_script_CallFunction(function() {
				_g.player = com_newwave_utils_GameUtils.replaceImageSprite(_g.player,new flambe_display_ImageSprite(_g.assetPack.getTexture("game/" + _g.bonusCart + _g.ctx.chosenRacer + "/straight_mid")),true);
				_g.player.getComponent("Sprite_4").setScale(0);
				_g.player.getComponent("Sprite_4").scaleX.animateTo(1,0.4,flambe_animation_Ease.bounceOut);
				_g.player.getComponent("Sprite_4").scaleY.animateTo(1,0.4,flambe_animation_Ease.bounceOut);
				_g.player.getComponent("Gravity_13").enable();
				_g.inHole = false;
			}),new flambe_script_CallFunction(function() {
				_g.addFeathers(7,_g.player.getComponent("Sprite_4").x.get__(),_g.player.getComponent("Sprite_4").y.get__());
			})]));
			this.owner.add(script1);
			this.inHole = true;
		}
	}
	,doSpinOut: function() {
		var _g = this;
		if(flambe_System.get_touch().get_supported()) {
			if(!this.spinningOut) {
				var sound = this.assetPack.getSound("sounds/spinout").play(0.9);
				this.speed = this.speed / 3;
				var script = new flambe_script_Script();
				script.run(new flambe_script_Sequence([new flambe_script_CallFunction(function() {
					_g.player.add(new com_newwave_components_effects_Blink());
					_g.particleLayer.addChild(new flambe_Entity().add(new com_newwave_components_game_ParticleBurst(_g.ctx,"game/particles/bubbles_spin",_g.player.getComponent("Sprite_4").x.get__(),_g.player.getComponent("Sprite_4").y.get__(),0,0.8)));
				}),new flambe_script_Delay(1.2),new flambe_script_CallFunction(function() {
					_g.spinningOut = false;
					_g.player.remove(_g.player.getComponent("Blink_15"));
					_g.player.getComponent("Sprite_4").alpha.set__(1);
				})]));
				this.owner.add(script);
				this.spinningOut = true;
			}
		} else if(!this.spinningOut) {
			var sound1 = this.assetPack.getSound("sounds/spinout").play(0.9);
			this.speed = this.speed / 3;
			var script1 = new flambe_script_Script();
			script1.run(new flambe_script_Sequence([new flambe_script_CallFunction(function() {
				_g.player.getComponent("Sprite_4").alpha.set__(0);
				_g.playerSpin.getComponent("Sprite_4").alpha.set__(1);
				_g.playerSpin.getComponent("PngSequence_3").play();
				_g.particleLayer.addChild(new flambe_Entity().add(new com_newwave_components_game_ParticleBurst(_g.ctx,"game/particles/bubbles_spin",_g.player.getComponent("Sprite_4").x.get__(),_g.player.getComponent("Sprite_4").y.get__(),0,0.8)));
			}),new flambe_script_Delay(1.2),new flambe_script_CallFunction(function() {
				_g.player = com_newwave_utils_GameUtils.replaceImageSprite(_g.player,new flambe_display_ImageSprite(_g.assetPack.getTexture("game/" + _g.bonusCart + _g.ctx.chosenRacer + "/straight_mid")),true);
				_g.player.getComponent("Sprite_4").alpha.set__(1);
				_g.playerSpin.getComponent("Sprite_4").alpha.set__(0);
				_g.playerSpin.getComponent("PngSequence_3").play();
				_g.keyRight = false;
				_g.keyLeft = false;
				_g.spinningOut = false;
			})]));
			this.playerSpin.add(script1);
			this.spinningOut = true;
		}
	}
	,addNPCRacer: function(name,image,offset,startZ,maxSpeed,intelligence) {
		var racer = new flambe_Entity();
		racer.add(image);
		image.setAnchor(image.getNaturalWidth() / 2,image.getNaturalHeight());
		image.setXY(this.width / 2,200);
		racer.add(new threedracer_components_NPCRacer(this.ctx,name,offset,startZ,maxSpeed,intelligence));
		this.carLayer.addChild(racer);
		this.npcracers.push(racer);
		if(!flambe_System.get_touch().get_supported()) {
			var playerSpinImages = new Array();
			var _g = 0;
			while(_g < 8) {
				var i = _g++;
				playerSpinImages.push(new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + name + "_spin/0000" + i)));
			}
			var playerSpin = new flambe_Entity();
			playerSpin.add(new flambe_display_Sprite().setXY(400,400).setScale(0.4).setAlpha(0));
			playerSpin.add(new com_newwave_components_display_PngSequence(playerSpinImages,true,1));
			this.carLayer.addChild(playerSpin);
			playerSpin.getComponent("PngSequence_3").pause();
			racer.getComponent("NPCRacer_5").playerSpin = playerSpin;
		}
	}
	,updatePlayerSprite: function() {
		if(this.keyLeft == true) this.player = com_newwave_utils_GameUtils.replaceImageSprite(this.player,new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/left_" + this.angle)),true); else if(this.keyRight == true) this.player = com_newwave_utils_GameUtils.replaceImageSprite(this.player,new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/right_" + this.angle)),true); else this.player = com_newwave_utils_GameUtils.replaceImageSprite(this.player,new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/straight_" + this.angle)),true);
	}
	,finishedrace: function() {
		var _g1 = this;
		this.finished = true;
		this.totalTime = this.gameSeconds;
		this.cartMotor.dispose();
		this.owner.remove(this.disposer);
		this.keyLeft = false;
		this.keyRight = false;
		this.keyFaster = false;
		this.ctx.racerData.push({ name : this.ctx.chosenRacer, time : this.totalTime});
		var i = 0;
		while(i < this.npcracers.length) {
			var npcracer = this.npcracers[i].getComponent("NPCRacer_5");
			var time = npcracer.totalTime;
			if(time == 0) time = this.totalTime + (this.trackLength + Math.floor(Math.random() * 1000) - npcracer.playerDist) / 10000;
			this.ctx.racerData.push({ name : npcracer.racername, time : time});
			i++;
		}
		var finished = new flambe_display_ImageSprite(this.assetPack.getTexture("game/text_finished"));
		finished.centerAnchor().setXY(514,300).setScale(0);
		this.owner.addChild(new flambe_Entity().add(finished));
		var script = new flambe_script_Script();
		script.run(new flambe_script_Sequence([new flambe_script_Parallel([new flambe_script_AnimateTo(finished.scaleX,1,0.6,flambe_animation_Ease.expoIn),new flambe_script_AnimateTo(finished.scaleY,1,0.6,flambe_animation_Ease.expoIn)]),new flambe_script_CallFunction(function() {
			var _g = 0;
			while(_g < 20) {
				var i1 = _g++;
				var star = new threedracer_anims_FinishStar(_g1.assetPack,514,300,Math.random() + 0.5);
				_g1.owner.addChild(new flambe_Entity().add(star));
			}
		}),new flambe_script_Delay(3),new flambe_script_CallFunction(function() {
			_g1.ctx.enterEndScene();
		})]));
		this.owner.add(script);
	}
	,addCartBubbles: function() {
		if(this.player.getComponent("Sprite_4").y.get__() > this.playerY - 30 && !this.finished && !this.spinningOut && !this.inHole) {
			var xPos = this.player.getComponent("Sprite_4").x.get__();
			var xVelocity = 0;
			var x1 = xPos - 80;
			var x2 = xPos + 80;
			var fx1 = xPos - 50;
			var fx2 = xPos + 50;
			var y1 = 505;
			var y2 = 505;
			var fy1 = 390;
			var fy2 = 390;
			if(this.keyLeft) {
				xVelocity = 3;
				x1 += 0;
				fx1 -= 40;
				fx2 -= 20;
				y1 += 0;
				y2 -= 5;
			} else if(this.keyRight) {
				xVelocity = -3;
				x1 += 5;
				x2 += 5;
				fx1 += 20;
				fx2 += 40;
				y1 -= 5;
				y2 += 5;
			}
			var particleString = "bubbles";
			if(this.hasTurbo) particleString = "bubbles_turbo";
			this.particleLayer.addChild(new flambe_Entity().add(new com_newwave_components_game_ParticleBurst(this.ctx,"game/particles/" + particleString + "_front",fx1,fy1,xVelocity)));
			this.particleLayer.addChild(new flambe_Entity().add(new com_newwave_components_game_ParticleBurst(this.ctx,"game/particles/" + particleString + "_front",fx2,fy2,xVelocity)));
			this.particleLayer.addChild(new flambe_Entity().add(new com_newwave_components_game_ParticleBurst(this.ctx,"game/particles/" + particleString,x1,y1,xVelocity)));
			this.particleLayer.addChild(new flambe_Entity().add(new com_newwave_components_game_ParticleBurst(this.ctx,"game/particles/" + particleString,x2,y2,xVelocity)));
		}
	}
	,addFeathers: function(num,xPos,yPos,scale) {
		if(scale == null) scale = 1;
		var _g = 0;
		while(_g < num) {
			var i = _g++;
			var feather = new threedracer_anims_Feather(this.assetPack,xPos,yPos,scale);
			this.owner.addChild(new flambe_Entity().add(feather));
		}
	}
	,findPlayerPlace: function() {
		var place = 1;
		var playerPos = this.trackLength * this.lapNum + this.position;
		var p = 0;
		while(p < this.npcracers.length) {
			var currentracer = this.npcracers[p].getComponent("NPCRacer_5");
			var NPCpos = this.trackLength * currentracer.lapNum + currentracer.zPos;
			currentracer.totalPosition = NPCpos;
			if(NPCpos > playerPos) place++; else {
			}
			p++;
		}
		if(place != this.currentPlace) {
			this.currentPlace = place;
			this.placeGraphic = com_newwave_utils_GameUtils.replaceImageSprite(this.placeGraphic,new flambe_display_ImageSprite(this.assetPack.getTexture("game/place_" + place)),false);
			this.placeGraphic.getComponent("Sprite_4").alpha.set__(0);
			this.placeGraphic.getComponent("Sprite_4").alpha.animateTo(1,0.4,flambe_animation_Ease.expoOut);
			var i = 0;
			while(i < this.npcracers.length) {
				var currentracer1 = this.npcracers[i].getComponent("NPCRacer_5");
				if(currentracer1.totalPosition > playerPos) this.carLayer.addChild(currentracer1.owner);
				i++;
			}
			this.carLayer.addChild(this.player);
			i = 0;
			while(i < this.npcracers.length) {
				var currentracer2 = this.npcracers[i].getComponent("NPCRacer_5");
				if(currentracer2.totalPosition < playerPos) this.carLayer.addChild(currentracer2.owner);
				i++;
			}
		}
	}
	,handleKeyDown: function(event) {
		if(!this.inHole && !this.spinningOut) {
			if(event.key == flambe_input_Key.Left) {
				this.keyLeft = true;
				this.player = com_newwave_utils_GameUtils.replaceImageSprite(this.player,new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/left_" + this.angle)),true);
				if(this.cartPillowArray.length > 0) {
					var p = 0;
					while(p < this.cartPillowArray.length) {
						this.cartPillowArray[p] = com_newwave_utils_GameUtils.replaceImageSprite(this.cartPillowArray[p],new flambe_display_ImageSprite(this.assetPack.getTexture("game/pillow_left")),true);
						p++;
					}
				}
			}
			if(event.key == flambe_input_Key.Right) {
				this.keyRight = true;
				this.player = com_newwave_utils_GameUtils.replaceImageSprite(this.player,new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/right_" + this.angle)),true);
				if(this.cartPillowArray.length > 0) {
					var p1 = 0;
					while(p1 < this.cartPillowArray.length) {
						this.cartPillowArray[p1] = com_newwave_utils_GameUtils.replaceImageSprite(this.cartPillowArray[p1],new flambe_display_ImageSprite(this.assetPack.getTexture("game/pillow_right")),true);
						p1++;
					}
				}
			}
			if(event.key == flambe_input_Key.Up) this.keyFaster = true;
			if(event.key == flambe_input_Key.Down) this.keySlower = true;
			if(event.key == flambe_input_Key.Space) {
				if(this.numPillows > 0 || this.unlimitedPillows == true) this.shootPillow();
			}
		}
	}
	,handleKeyUp: function(event) {
		if(!this.inHole && !this.spinningOut) {
			if(event.key == flambe_input_Key.Left) {
				this.keyLeft = false;
				this.player = com_newwave_utils_GameUtils.replaceImageSprite(this.player,new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/straight_" + this.angle)),true);
				if(this.cartPillowArray.length > 0) {
					var p = 0;
					while(p < this.cartPillowArray.length) {
						this.cartPillowArray[p] = com_newwave_utils_GameUtils.replaceImageSprite(this.cartPillowArray[p],new flambe_display_ImageSprite(this.assetPack.getTexture("game/pillow")),true);
						p++;
					}
				}
			}
			if(event.key == flambe_input_Key.Right) {
				this.keyRight = false;
				this.player = com_newwave_utils_GameUtils.replaceImageSprite(this.player,new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/straight_" + this.angle)),true);
				if(this.cartPillowArray.length > 0) {
					var p1 = 0;
					while(p1 < this.cartPillowArray.length) {
						this.cartPillowArray[p1] = com_newwave_utils_GameUtils.replaceImageSprite(this.cartPillowArray[p1],new flambe_display_ImageSprite(this.assetPack.getTexture("game/pillow")),true);
						p1++;
					}
				}
			}
			if(event.key == flambe_input_Key.Up) this.keyFaster = false;
			if(event.key == flambe_input_Key.Down) this.keySlower = false;
			if(event.key == flambe_input_Key.P) this.ctx.showInstructions(this.assetPack);
		}
	}
	,handlePointerDown: function(event) {
		if(this.numPillows > 0 || this.unlimitedPillows == true) this.shootPillow();
	}
	,handlePointerUp: function(event) {
	}
	,onAccelUpdate: function(event) {
		var accelX = event.x;
		var accelY = event.y;
		var accelZ = event.z;
		if(this.isAndroid) accelX = accelX * -1;
		if(accelX < -1.4) {
			this.keyLeft = true;
			this.keyRight = false;
			this.player = com_newwave_utils_GameUtils.replaceImageSprite(this.player,new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/left_" + this.angle)),true);
			if(this.cartPillowArray.length > 0) {
				var p = 0;
				while(p < this.cartPillowArray.length) {
					this.cartPillowArray[p] = com_newwave_utils_GameUtils.replaceImageSprite(this.cartPillowArray[p],new flambe_display_ImageSprite(this.assetPack.getTexture("game/pillow_left")),true);
					p++;
				}
			}
		} else if(accelX > 1.4) {
			this.player = com_newwave_utils_GameUtils.replaceImageSprite(this.player,new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/right_" + this.angle)),true);
			if(this.cartPillowArray.length > 0) {
				var p1 = 0;
				while(p1 < this.cartPillowArray.length) {
					this.cartPillowArray[p1] = com_newwave_utils_GameUtils.replaceImageSprite(this.cartPillowArray[p1],new flambe_display_ImageSprite(this.assetPack.getTexture("game/pillow_right")),true);
					p1++;
				}
			}
			this.keyLeft = false;
			this.keyRight = true;
		} else {
			this.keyRight = false;
			this.keyLeft = false;
			this.player = com_newwave_utils_GameUtils.replaceImageSprite(this.player,new flambe_display_ImageSprite(this.assetPack.getTexture("game/" + this.bonusCart + this.ctx.chosenRacer + "/straight_" + this.angle)),true);
			if(this.cartPillowArray.length > 0) {
				var p2 = 0;
				while(p2 < this.cartPillowArray.length) {
					this.cartPillowArray[p2] = com_newwave_utils_GameUtils.replaceImageSprite(this.cartPillowArray[p2],new flambe_display_ImageSprite(this.assetPack.getTexture("game/pillow")),true);
					p2++;
				}
			}
		}
	}
	,onRemoved: function() {
		this.disposer.dispose();
		this.cartMotor.dispose();
	}
	,__class__: threedracer_components_Game
});
var threedracer_components_Graphic = function(_type,_offset,_img,_parent,_offsetY) {
	if(_offsetY == null) _offsetY = 0;
	this.active = true;
	this.type = _type;
	this.offset = _offset;
	this.img = _img;
	this.parent = _parent;
	this.offsetY = _offsetY;
};
$hxClasses["threedracer.components.Graphic"] = threedracer_components_Graphic;
threedracer_components_Graphic.__name__ = true;
threedracer_components_Graphic.__super__ = flambe_Component;
threedracer_components_Graphic.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Graphic_21";
	}
	,onAdded: function() {
	}
	,onUpdate: function(dt) {
		if(this.parent.p1.camera.z < 0) this.img.alpha.set__(0); else this.img.alpha.set__((10000 - this.parent.p1.camera.z) / 1000);
	}
	,__class__: threedracer_components_Graphic
});
var threedracer_components_NPCRacer = function(_ctx,_name,_offset,_zPos,_maxspeed,_intelligence) {
	this.totalPosition = 0;
	this.bubbleCounter = 0;
	this.bubbleDelay = 30;
	this.jumping = false;
	this.jumpTime = 0;
	this.offsetY = 0;
	this.spinningOut = false;
	this.finished = false;
	this.totalTime = 0;
	this.lapNum = 1;
	this.turboLength = 100;
	this.turboTime = 0;
	this.hasTurbo = false;
	this.currentDecisionTime = 0;
	this.intelligence = 4;
	this.playerX = 0;
	this.playerDist = 0;
	this.active = false;
	this.speed = 0;
	this.xForce = 0;
	this.ctx = _ctx;
	this.racername = _name;
	this.offset = _offset;
	this.zPos = _zPos;
	this.acceleration = 30;
	this.maxSpeed = _maxspeed * 0.94;
	this.baseMaxSpeed = this.maxSpeed;
	this.turboSpeed = this.maxSpeed * 2;
	this.intelligence = _intelligence;
	this.decisionTime = 1000 / this.intelligence;
};
$hxClasses["threedracer.components.NPCRacer"] = threedracer_components_NPCRacer;
threedracer_components_NPCRacer.__name__ = true;
threedracer_components_NPCRacer.__super__ = flambe_Component;
threedracer_components_NPCRacer.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "NPCRacer_5";
	}
	,onAdded: function() {
	}
	,onUpdate: function(dt) {
		if(this.active) {
			this.bubbleCounter += dt * this.speed;
			if(this.bubbleCounter >= this.bubbleDelay) {
				this.addCartBubbles();
				this.bubbleCounter = 0;
			}
			if(!this.spinningOut) {
				this.zPos += dt * this.speed;
				this.speed += this.acceleration;
				if(this.speed >= this.maxSpeed) this.speed = this.maxSpeed;
			} else if(!flambe_System.get_touch().get_supported()) {
				this.playerSpin.getComponent("Sprite_4").x.set__(this.owner.getComponent("Sprite_4").x.get__());
				this.playerSpin.getComponent("Sprite_4").y.set__(this.owner.getComponent("Sprite_4").y.get__());
				var scale = this.owner.getComponent("Sprite_4").scaleX.get__() * 1.3;
				this.playerSpin.getComponent("Sprite_4").setScale(scale);
			}
			this.offset = this.offset + this.xForce;
			if(this.offset < -0.75) {
				this.offset = -0.75;
				this.chooseDirection();
			}
			if(this.offset > 0.75) {
				this.offset = 0.75;
				this.chooseDirection();
			}
			this.currentDecisionTime++;
			if(this.currentDecisionTime >= this.decisionTime) {
				this.chooseDirection();
				this.adjustSpeed();
				this.currentDecisionTime = 0;
			}
			if(this.hasTurbo) {
				this.maxSpeed = this.turboSpeed;
				this.turboTime += 1;
				if(this.turboTime >= this.turboLength) {
					this.hasTurbo = false;
					this.turboTime = 0;
					this.maxSpeed = this.turboSpeed * 0.5;
				}
			}
			if(this.jumping) {
				this.jumpTime += dt;
				console.log(Math.cos(this.jumpTime));
			}
		}
	}
	,chooseDirection: function() {
		if(this.offset == -0.74) this.xForce = this.intelligence * 0.001; else if(this.offset == 0.74) this.xForce = this.intelligence * -0.001; else {
			var dir;
			if(Math.random() > 0.5) dir = 1; else dir = -1;
			this.xForce = this.intelligence * 0.001 * dir;
		}
	}
	,adjustSpeed: function() {
		if(this.playerDist < 0) {
		} else this.maxSpeed = this.baseMaxSpeed;
	}
	,pillowHit: function() {
		this.speed = 0;
		this.doSpinOut();
	}
	,gotTurbo: function() {
		this.speed = this.speed * 1.5;
		this.hasTurbo = true;
	}
	,gotPillows: function() {
	}
	,hitRamp: function() {
		this.jumping = true;
	}
	,doSpinOut: function() {
		var _g = this;
		if(flambe_System.get_touch().get_supported()) {
			if(!this.spinningOut) {
				this.speed = 0;
				var script = new flambe_script_Script();
				script.run(new flambe_script_Sequence([new flambe_script_CallFunction(function() {
					_g.owner.add(new com_newwave_components_effects_Blink());
				}),new flambe_script_Delay(1.2),new flambe_script_CallFunction(function() {
					_g.spinningOut = false;
					_g.owner.remove(_g.owner.getComponent("Blink_15"));
				})]));
				this.owner.add(script);
				this.spinningOut = true;
			}
		} else if(!this.spinningOut) {
			this.speed = 0;
			var script1 = new flambe_script_Script();
			script1.run(new flambe_script_Sequence([new flambe_script_CallFunction(function() {
				_g.playerSpin.getComponent("Sprite_4").alpha.set__(1);
				_g.playerSpin.getComponent("PngSequence_3").play();
			}),new flambe_script_Delay(1.2),new flambe_script_CallFunction(function() {
				_g.playerSpin.getComponent("Sprite_4").alpha.set__(0);
				_g.playerSpin.getComponent("PngSequence_3").play();
				_g.spinningOut = false;
			})]));
			this.playerSpin.add(script1);
			this.spinningOut = true;
		}
	}
	,addCartBubbles: function() {
		if(!this.spinningOut && !flambe_System.get_touch().get_supported()) {
			var x1 = 120;
			var x2 = 280;
			var y1 = 250;
			var y2 = 250;
			this.owner.addChild(new flambe_Entity().add(new com_newwave_components_game_ParticleBurst(this.ctx,"game/particles/bubbles_npc",x1,y1,this.xForce * 10)));
			this.owner.addChild(new flambe_Entity().add(new com_newwave_components_game_ParticleBurst(this.ctx,"game/particles/bubbles_npc",x2,y2,this.xForce * 10)));
		}
	}
	,__class__: threedracer_components_NPCRacer
});
var threedracer_components_Pillow = function(_offset,_zPos,_speed) {
	this.hitPlayer = false;
	this.active = true;
	this.offset = _offset;
	this.zPos = this.startZ = _zPos;
	this.speed = _speed;
};
$hxClasses["threedracer.components.Pillow"] = threedracer_components_Pillow;
threedracer_components_Pillow.__name__ = true;
threedracer_components_Pillow.__super__ = flambe_Component;
threedracer_components_Pillow.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Pillow_23";
	}
	,onAdded: function() {
	}
	,onUpdate: function(dt) {
		if(this.active) this.zPos += dt * this.speed;
	}
	,__class__: threedracer_components_Pillow
});
var threedracer_components_Powerup = function(_type,_offset,_img,_parent,_offsetY) {
	if(_offsetY == null) _offsetY = 0;
	this.respawnTime = 0;
	this.respawnLength = 5;
	this.active = true;
	this.type = _type;
	this.offset = _offset;
	this.img = _img;
	this.parent = _parent;
	this.offsetY = _offsetY;
};
$hxClasses["threedracer.components.Powerup"] = threedracer_components_Powerup;
threedracer_components_Powerup.__name__ = true;
threedracer_components_Powerup.__super__ = flambe_Component;
threedracer_components_Powerup.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Powerup_20";
	}
	,onAdded: function() {
	}
	,onUpdate: function(dt) {
		if(!this.active) {
			this.respawnTime += dt;
			if(this.respawnTime >= this.respawnLength) {
				this.respawnTime = 0;
				this.active = true;
			}
		} else if(this.img.scaleX._ < 0 || this.img.scaleY._ < 0 || this.img.scaleX._ > 1 || this.img.scaleY._ > 1) this.img.alpha._ = 0;
		if(this.parent.p1.camera.z < 0) this.img.alpha._ = 0; else {
		}
	}
	,gotPowerup: function() {
		if(this.active) {
			this.img.alpha._ = 0;
			this.active = false;
		}
	}
	,__class__: threedracer_components_Powerup
});
var threedracer_components_Segment = function(_index,_images,_p1,_p2,_color,_width,_lanes,_curve) {
	if(_curve == null) _curve = 0;
	this.rightRatio = 0;
	this.rightdist = 0;
	this.leftRatio = 0;
	this.leftdist = 0;
	this.maxSubSegments = 20;
	this.subSegmentHeight = 5;
	this.curve = 0;
	this.active = true;
	this.images = _images;
	this.index = _index;
	this.road = this.images[0];
	this.roadleft = this.images[1];
	this.roadright = this.images[2];
	this.railleft = this.images[3];
	this.railright = this.images[4];
	this.p1 = _p1;
	this.p2 = _p2;
	this.color = _color;
	this.width = _width;
	this.lanes = _lanes;
	this.curve = _curve;
	this.powerups = [];
	this.graphics = [];
	this.subsegments = [];
};
$hxClasses["threedracer.components.Segment"] = threedracer_components_Segment;
threedracer_components_Segment.__name__ = true;
threedracer_components_Segment.__super__ = flambe_Component;
threedracer_components_Segment.prototype = $extend(flambe_Component.prototype,{
	get_name: function() {
		return "Segment_19";
	}
	,onAdded: function() {
		this.owner.addChild(new flambe_Entity().add(this.road));
		this.owner.addChild(new flambe_Entity().add(this.roadleft));
		this.roadleft.setAnchor(100,0);
		this.owner.addChild(new flambe_Entity().add(this.roadright));
		this.owner.addChild(new flambe_Entity().add(this.railleft));
		this.owner.addChild(new flambe_Entity().add(this.railright));
		this.railleft.setAnchor(100,0);
		this.parentLayer = this.owner.parent;
		this.sublayer = new flambe_Entity();
		this.owner.addChild(this.sublayer);
	}
	,onUpdate: function(dt) {
		if(this.active) {
			var x1 = this.p1.screen.x;
			var y1 = this.p1.screen.y;
			var w1 = this.p1.screen.w;
			var x2 = this.p2.screen.x;
			var y2 = this.p2.screen.y;
			var w2 = this.p2.screen.w;
			var ratioW = w2 * 2 / 1000;
			var ratioH = (y1 + 1 - y2) / 100;
			this.leftdist = x2 - w2 - (x1 - w1);
			this.leftRatio = this.leftdist / 100;
			this.rightdist = x2 + w2 - (x1 + w1);
			this.rightRatio = this.rightdist / 100;
			this.road.setScaleXY(ratioW,ratioH);
			this.road.setXY(x2 - w2,y2);
			this.roadleft.setScaleXY(this.leftRatio,ratioH);
			this.roadleft.setXY(x2 - w2 + 0.1,y2);
			this.railleft.setScaleXY(this.leftRatio * 1.2,ratioH * 1.2);
			this.railleft.setXY(x2 - w2,y2 - 13 + this.p2.camera.z / 1000);
			this.roadright.setScaleXY(-this.rightRatio,ratioH);
			this.roadright.setXY(x2 + w2 - 0.1,y2);
			this.railright.setScaleXY(-this.rightRatio * 1.2,ratioH * 1.2);
			this.railright.setXY(x2 + w2 - 0.1,y2 - 13 + this.p2.camera.z / 1000);
			if(this.p2.camera.z > 7000) {
				this.railleft.alpha.set__(0);
				this.railright.alpha.set__(0);
			} else {
				this.railleft.alpha.set__(1);
				this.railright.alpha.set__(1);
			}
			if(!flambe_System.get_touch().get_supported()) this.resizeSubSegments(y1,y2);
		}
		if(this.p1.camera.z <= 1) this.hide();
	}
	,hide: function() {
		if(this.active) {
			this.active = false;
			this.road.alpha.set__(0);
			this.roadleft.alpha.set__(0);
			this.roadright.alpha.set__(0);
			this.railleft.alpha.set__(0);
			this.railright.alpha.set__(0);
			var i = 0;
			while(i < this.powerups.length) {
				var powerup = this.powerups[i].getComponent("Powerup_20");
				var img = powerup.owner.getComponent("Sprite_4");
				img.scissor = null;
				img.alpha.set__(0);
				i++;
			}
			this.sublayer.disposeChildren();
			this.subsegments = [];
		}
	}
	,show: function() {
		if(!this.active) {
			this.active = true;
			this.road.alpha.set__(1);
			this.roadleft.alpha.set__(1);
			this.roadright.alpha.set__(1);
			this.railleft.alpha.set__(1);
			this.railright.alpha.set__(1);
		}
	}
	,resizeSubSegments: function(y1,y2) {
		var x1 = this.p1.screen.x;
		var y11 = this.p1.screen.y;
		var w1 = this.p1.screen.w;
		var x2 = this.p2.screen.x;
		var y21 = this.p2.screen.y;
		var w2 = this.p2.screen.w;
		var numSubsegments = Math.ceil((y11 - y21) / this.subSegmentHeight);
		if(numSubsegments > this.maxSubSegments) numSubsegments = this.maxSubSegments;
		if(this.subsegments.length < numSubsegments) while(this.subsegments.length < numSubsegments) {
			var img = this.images[4 + this.subsegments.length + 1];
			this.sublayer.addChild(new flambe_Entity().add(img));
			this.subsegments.push(img);
		}
		if(numSubsegments > 0) {
			var i = 0;
			while(i < this.subsegments.length) {
				var ratioW1 = w1 * 2 / 1000;
				var ratioW2 = w2 * 2 / 1000;
				var ratioW = ratioW2 + (ratioW1 - ratioW2) * (i / numSubsegments);
				var ratioH = (y11 + 1 - y21) / this.subSegmentHeight / numSubsegments;
				if(i == this.subsegments.length - 1) ratioH += 0.1;
				var xPos = x2 - w2 - Math.abs((x1 - w1 - (x2 - w2)) * (i / numSubsegments));
				this.subsegments[i].setScaleXY(ratioW,ratioH + 0.1);
				this.subsegments[i].setXY(xPos,y21 + (y11 - y21) * (i / numSubsegments));
				i++;
			}
		} else {
			this.sublayer.disposeChildren();
			this.subsegments = [];
		}
	}
	,__class__: threedracer_components_Segment
});
var threedracer_scenes_ChooseRacerScene = function() { };
$hxClasses["threedracer.scenes.ChooseRacerScene"] = threedracer_scenes_ChooseRacerScene;
threedracer_scenes_ChooseRacerScene.__name__ = true;
threedracer_scenes_ChooseRacerScene.create = function(ctx) {
	threedracer_scenes_ChooseRacerScene.context = ctx;
	flambe_System.get_external().call("trackFromGame",["game/characters"]);
	var bonusCodes = ["Sleepward","Starrynight","Dreampants"];
	ctx.BGmusic.dispose();
	var BGsound = ctx.pack.getSound("sounds/bgmusic_start").loop(0.7);
	ctx.BGmusic = BGsound;
	var leftposition = new flambe_math_Point(-500,150);
	var centerposition = new flambe_math_Point(490,350);
	var bottomposition = new flambe_math_Point(900,900);
	var lefttextposition = new flambe_math_Point(-300,480);
	var centertextposition = new flambe_math_Point(515,480);
	var righttextposition = new flambe_math_Point(1200,480);
	var scene = new flambe_Entity();
	var imageData = { rows : 1, columns : 2};
	var spriteData = ["home/home_bg1","home/home_bg2"];
	var background = new com_newwave_components_display_TiledImage(ctx.pack,imageData,spriteData);
	var bg_Entity = new flambe_Entity().add(background);
	scene.addChild(bg_Entity);
	if(!flambe_System.get_touch().get_supported()) {
		var images = new Array();
		var _g = 1;
		while(_g < 14) {
			var i = _g++;
			images.push(new flambe_display_ImageSprite(ctx.pack.getTexture("game/books/" + i)));
		}
		var books = new flambe_Entity();
		var sprite = new flambe_display_Sprite();
		sprite.setScale(0.5).setXY(100,180);
		books.add(sprite);
		books.add(new com_newwave_components_display_PngSequence(images,true,1));
		scene.addChild(books);
		var images2 = new Array();
		var _g1 = 1;
		while(_g1 < 36) {
			var i1 = _g1++;
			images2.push(new flambe_display_ImageSprite(ctx.pack.getTexture("game/moon/" + i1)));
		}
		var moon = new flambe_Entity();
		var sprite2 = new flambe_display_Sprite();
		sprite2.setScale(0.6).setXY(930,190);
		moon.add(sprite2);
		moon.add(new com_newwave_components_display_PngSequence(images2,true,1));
		scene.addChild(moon);
	}
	var imageData2 = { rows : 1, columns : 2};
	var spriteData2 = ["home/road1","home/road2"];
	var road = new com_newwave_components_display_TiledImage(ctx.pack,imageData2,spriteData2);
	road.setXY(0,300);
	scene.addChild(new flambe_Entity().add(road));
	var headline = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/headline"));
	headline.centerAnchor().setXY(514,80);
	scene.addChild(new flambe_Entity().add(headline));
	var spongebob = new flambe_Entity();
	var bed_spongebob = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_spongebob"));
	bed_spongebob.centerAnchor().setXY(leftposition.x,leftposition.y).setRotation(-35).setScale(0.1);
	spongebob.add(bed_spongebob);
	var pillow_spongebob = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/pillows"));
	pillow_spongebob.setXY(140,60).setAlpha(0);
	spongebob.addChild(new flambe_Entity().add(pillow_spongebob));
	var char_spongebob = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/spongebob"));
	char_spongebob.setXY(232,0);
	spongebob.addChild(new flambe_Entity().add(char_spongebob));
	var post_spongebob = new flambe_Entity();
	post_spongebob.add(new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_spongebob")).setXY(310,190));
	spongebob.addChild(post_spongebob);
	var spongebob_arm = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/spongebob_arm"));
	spongebob_arm.setXY(322,189);
	spongebob.addChild(new flambe_Entity().add(spongebob_arm));
	scene.addChild(spongebob);
	var spongebob_text = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/spongebob_text"));
	spongebob_text.centerAnchor().setXY(lefttextposition.x,lefttextposition.y);
	scene.addChild(new flambe_Entity().add(spongebob_text));
	var patrick = new flambe_Entity();
	var bed_patrick = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_patrick"));
	bed_patrick.centerAnchor().setXY(leftposition.x,leftposition.y).setRotation(-35);
	patrick.add(bed_patrick);
	var pillow_patrick = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/pillows"));
	pillow_patrick.setXY(140,60).setAlpha(0);
	patrick.addChild(new flambe_Entity().add(pillow_patrick));
	var char_patrick = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/patrick"));
	char_patrick.setXY(250,30);
	patrick.addChild(new flambe_Entity().add(char_patrick));
	var post_patrick = new flambe_Entity();
	post_patrick.add(new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_patrick")).setXY(310,190));
	patrick.addChild(post_patrick);
	scene.addChild(patrick);
	var patrick_text = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/patrick_text"));
	patrick_text.centerAnchor().setXY(lefttextposition.x,lefttextposition.y);
	scene.addChild(new flambe_Entity().add(patrick_text));
	var crab = new flambe_Entity();
	var bed_crab = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_crab"));
	bed_crab.centerAnchor().setXY(leftposition.x,leftposition.y).setRotation(-35);
	crab.add(bed_crab);
	var pillow_crab = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/pillows"));
	pillow_crab.setXY(140,60).setAlpha(0);
	crab.addChild(new flambe_Entity().add(pillow_crab));
	var char_crab = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/crab"));
	char_crab.setXY(280,10);
	crab.addChild(new flambe_Entity().add(char_crab));
	var post_crab = new flambe_Entity();
	post_crab.add(new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_crab")).setXY(310,190));
	crab.addChild(post_crab);
	scene.addChild(crab);
	var crab_text = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/crab_text"));
	crab_text.centerAnchor().setXY(lefttextposition.x,lefttextposition.y);
	scene.addChild(new flambe_Entity().add(crab_text));
	var squidward = new flambe_Entity();
	var bed_squidward = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_squidward"));
	bed_squidward.centerAnchor().setXY(leftposition.x,leftposition.y).setRotation(-35);
	squidward.add(bed_squidward);
	var pillow_squidward = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/pillows"));
	pillow_squidward.setXY(140,60).setAlpha(0);
	squidward.addChild(new flambe_Entity().add(pillow_squidward));
	var char_squidward = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/squidward"));
	char_squidward.setXY(210,-20);
	squidward.addChild(new flambe_Entity().add(char_squidward));
	var post_squidward = new flambe_Entity();
	post_squidward.add(new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_squidward")).setXY(310,190));
	squidward.addChild(post_squidward);
	scene.addChild(squidward);
	var squidward_text = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/squidward_text"));
	squidward_text.centerAnchor().setXY(lefttextposition.x,lefttextposition.y);
	scene.addChild(new flambe_Entity().add(squidward_text));
	var charData = [{ name : "spongebob", entity : spongebob, img : bed_spongebob, textimg : spongebob_text},{ name : "patrick", entity : patrick, img : bed_patrick, textimg : patrick_text},{ name : "crab", entity : crab, img : bed_crab, textimg : crab_text},{ name : "squidward", entity : squidward, img : bed_squidward, textimg : squidward_text}];
	var checkForBonusCodes = function() {
		if(ctx.bonus3) {
			pillow_spongebob.alpha.set__(1);
			pillow_patrick.alpha.set__(1);
			pillow_crab.alpha.set__(1);
			pillow_squidward.alpha.set__(1);
		}
		if(ctx.bonus2) {
			spongebob = com_newwave_utils_GameUtils.replaceImageSprite(spongebob,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_invincible")),true);
			post_spongebob = com_newwave_utils_GameUtils.replaceImageSprite(post_spongebob,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_invincible")),false);
			patrick = com_newwave_utils_GameUtils.replaceImageSprite(patrick,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_invincible")),true);
			post_patrick = com_newwave_utils_GameUtils.replaceImageSprite(post_patrick,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_invincible")),false);
			crab = com_newwave_utils_GameUtils.replaceImageSprite(crab,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_invincible")),true);
			post_crab = com_newwave_utils_GameUtils.replaceImageSprite(post_crab,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_invincible")),false);
			squidward = com_newwave_utils_GameUtils.replaceImageSprite(squidward,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_invincible")),true);
			post_squidward = com_newwave_utils_GameUtils.replaceImageSprite(post_squidward,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_invincible")),false);
			var _g2 = 0;
			while(_g2 < 4) {
				var i2 = _g2++;
				var star1 = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/stars"));
				star1.setXY(60,60);
				charData[i2].entity.addChild(new flambe_Entity().add(star1));
				var star2 = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/stars"));
				star2.setXY(180,20);
				charData[i2].entity.addChild(new flambe_Entity().add(star2));
			}
			charData = [{ name : "spongebob", entity : spongebob, img : spongebob.getComponent("Sprite_4"), textimg : spongebob_text},{ name : "patrick", entity : patrick, img : patrick.getComponent("Sprite_4"), textimg : patrick_text},{ name : "crab", entity : crab, img : crab.getComponent("Sprite_4"), textimg : crab_text},{ name : "squidward", entity : squidward, img : squidward.getComponent("Sprite_4"), textimg : squidward_text}];
		}
		if(ctx.bonus1) {
			spongebob = com_newwave_utils_GameUtils.replaceImageSprite(spongebob,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_hotrod")),true);
			post_spongebob = com_newwave_utils_GameUtils.replaceImageSprite(post_spongebob,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_hotrod")),false);
			patrick = com_newwave_utils_GameUtils.replaceImageSprite(patrick,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_hotrod")),true);
			post_patrick = com_newwave_utils_GameUtils.replaceImageSprite(post_patrick,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_hotrod")),false);
			crab = com_newwave_utils_GameUtils.replaceImageSprite(crab,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_hotrod")),true);
			post_crab = com_newwave_utils_GameUtils.replaceImageSprite(post_crab,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_hotrod")),false);
			squidward = com_newwave_utils_GameUtils.replaceImageSprite(squidward,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bed_hotrod")),true);
			post_squidward = com_newwave_utils_GameUtils.replaceImageSprite(post_squidward,new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/bedpost_hotrod")),false);
			charData = [{ name : "spongebob", entity : spongebob, img : spongebob.getComponent("Sprite_4"), textimg : spongebob_text},{ name : "patrick", entity : patrick, img : patrick.getComponent("Sprite_4"), textimg : patrick_text},{ name : "crab", entity : crab, img : crab.getComponent("Sprite_4"), textimg : crab_text},{ name : "squidward", entity : squidward, img : squidward.getComponent("Sprite_4"), textimg : squidward_text}];
		}
	};
	var currentChar = 0;
	var prevRacer = function() {
		var $char = charData[currentChar];
		currentChar--;
		if(currentChar < 0) currentChar = charData.length - 1;
		var char2 = charData[currentChar];
		ctx.chosenRacer = char2.name;
		char2.img.setXY(bottomposition.x,bottomposition.y).setRotation(35);
		char2.textimg.setXY(righttextposition.x,righttextposition.y);
		var script = new flambe_script_Script();
		script.run(new flambe_script_Sequence([new flambe_script_Parallel([new flambe_script_AnimateTo($char.img.x,leftposition.x,0.8,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo($char.img.y,leftposition.y,0.8,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo($char.img.rotation,-35,0.8,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo($char.textimg.x,lefttextposition.x,1,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char2.img.x,centerposition.x,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char2.img.y,centerposition.y,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char2.img.rotation,0,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char2.textimg.x,centertextposition.x,0.6,flambe_animation_Ease.expoOut)])]));
		scene.add(script);
	};
	var nextRacer = function() {
		var char1 = charData[currentChar];
		currentChar++;
		if(currentChar >= charData.length) currentChar = 0;
		var char21 = charData[currentChar];
		ctx.chosenRacer = char21.name;
		char21.img.setXY(leftposition.x,leftposition.y).setRotation(-35).setScale(0.1);
		char21.textimg.setXY(lefttextposition.x,lefttextposition.y);
		var script1 = new flambe_script_Script();
		script1.run(new flambe_script_Sequence([new flambe_script_Parallel([new flambe_script_AnimateTo(char1.img.x,bottomposition.x,0.8,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char1.img.y,bottomposition.y,0.8,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char1.img.rotation,35,0.8,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char1.textimg.x,righttextposition.x,1,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char21.img.x,centerposition.x,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char21.img.y,centerposition.y,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char21.img.rotation,0,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char21.img.scaleX,1,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char21.img.scaleY,1,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(char21.textimg.x,centertextposition.x,0.6,flambe_animation_Ease.expoOut)])]));
		scene.add(script1);
	};
	var btn_left = new flambe_Entity();
	var btn_leftImg = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/btn_left"));
	btn_leftImg.centerAnchor().setXY(175,315);
	btn_left.add(btn_leftImg);
	btn_left.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("chooseracer/btn_left_over"),function() {
		prevRacer();
	},function() {
		btn_leftImg.y.animateTo(325,0.5,flambe_animation_Ease.expoOut);
	},function() {
		btn_leftImg.y.animateTo(315,0.5,flambe_animation_Ease.expoOut);
	}));
	scene.addChild(btn_left);
	var btn_right = new flambe_Entity();
	var btn_rightImg = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/btn_right"));
	btn_rightImg.centerAnchor().setXY(860,315);
	btn_right.add(btn_rightImg);
	btn_right.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("chooseracer/btn_right_over"),function() {
		nextRacer();
	},function() {
		btn_rightImg.y.animateTo(325,0.5,flambe_animation_Ease.expoOut);
	},function() {
		btn_rightImg.y.animateTo(315,0.5,flambe_animation_Ease.expoOut);
	}));
	scene.addChild(btn_right);
	var startButton = new flambe_Entity();
	var startButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("chooseracer/btn_choose"));
	startButtonImg.centerAnchor().setXY(880,530);
	if(flambe_System.get_touch().get_supported()) startButtonImg.y.set__(490);
	startButton.add(startButtonImg);
	startButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("chooseracer/btn_choose_over"),function() {
		ctx.enterGameScene();
	}));
	scene.addChild(startButton);
	if(ctx.device != "phone") {
		var bonusFeatherHolder = new flambe_Entity();
		scene.addChild(bonusFeatherHolder);
		var bonusCodeConfirm = new flambe_Entity();
		var codeconfirm_bg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/code_success"));
		codeconfirm_bg.centerAnchor().setXY(175,490).setAlpha(0).setScale(0);
		bonusCodeConfirm.add(codeconfirm_bg);
		var txt_bonus1 = new flambe_display_ImageSprite(ctx.pack.getTexture("home/txt_bonus1"));
		txt_bonus1.centerAnchor().setXY(155,110);
		bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonus1));
		var txt_bonus2 = new flambe_display_ImageSprite(ctx.pack.getTexture("home/txt_bonus2"));
		txt_bonus2.centerAnchor().setXY(155,110);
		bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonus2));
		var txt_bonus3 = new flambe_display_ImageSprite(ctx.pack.getTexture("home/txt_bonus3"));
		txt_bonus3.centerAnchor().setXY(155,110);
		bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonus3));
		var txt_bonusRepeat = new flambe_display_ImageSprite(ctx.pack.getTexture("home/powerup_entertwice"));
		txt_bonusRepeat.centerAnchor().setXY(160,110);
		bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonusRepeat));
		scene.addChild(bonusCodeConfirm);
		var bonusCode = new flambe_Entity();
		var code_bg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/code_bg"));
		code_bg.centerAnchor().setXY(165,490);
		bonusCode.add(code_bg);
		scene.addChild(bonusCode);
		var bonusTextField = new flambe_Entity();
		var font = new flambe_display_Font(ctx.pack,"fonts/BonusTxt");
		var theText = new flambe_display_TextSprite(font,"ENTER HERE");
		theText.centerAnchor().setXY(165,145);
		bonusTextField.add(theText);
		bonusTextField.add(new com_newwave_components_ui_text_TextInput(font));
		bonusCode.addChild(bonusTextField);
		theText.get_pointerDown().connect(function(event) {
			bonusTextField.getComponent("TextInput_14").connectToHTMLInput();
		});
		var checkBonusCode = function() {
			var enteredCode = bonusTextField.getComponent("TextInput_14").value;
			var i3 = 0;
			var codeCorrect = false;
			while(i3 < bonusCodes.length) {
				if(enteredCode.toUpperCase() == bonusCodes[i3].toUpperCase()) {
					flambe_System.get_external().call("trackFromGame",["game/code_" + enteredCode.toUpperCase()]);
					codeCorrect = true;
					if(i3 == 0) {
						if(ctx.bonus1 == true) {
							txt_bonus1.alpha.set__(0);
							txt_bonus2.alpha.set__(0);
							txt_bonus3.alpha.set__(0);
							txt_bonusRepeat.alpha.set__(1);
						} else {
							txt_bonus1.alpha.set__(1);
							txt_bonus2.alpha.set__(0);
							txt_bonus3.alpha.set__(0);
							txt_bonusRepeat.alpha.set__(0);
						}
						ctx.bonus1 = true;
						bonusCode.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
						bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
					} else if(i3 == 1) {
						if(ctx.bonus2 == true) {
							txt_bonus1.alpha.set__(0);
							txt_bonus2.alpha.set__(0);
							txt_bonus3.alpha.set__(0);
							txt_bonusRepeat.alpha.set__(1);
						} else {
							txt_bonus1.alpha.set__(0);
							txt_bonus2.alpha.set__(1);
							txt_bonus3.alpha.set__(0);
							txt_bonusRepeat.alpha.set__(0);
						}
						ctx.bonus2 = true;
						bonusCode.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
						bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
					} else if(i3 == 2) {
						if(ctx.bonus3 == true) {
							txt_bonus1.alpha.set__(0);
							txt_bonus2.alpha.set__(0);
							txt_bonus3.alpha.set__(0);
							txt_bonusRepeat.alpha.set__(1);
						} else {
							txt_bonus1.alpha.set__(0);
							txt_bonus2.alpha.set__(0);
							txt_bonus3.alpha.set__(1);
							txt_bonusRepeat.alpha.set__(0);
						}
						ctx.bonus3 = true;
						bonusCode.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
						bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
					}
					var f = 0;
					while(f < 10) {
						var feather = new threedracer_anims_Feather(ctx.pack,165,390,0.7);
						bonusFeatherHolder.addChild(new flambe_Entity().add(feather));
						f++;
					}
					checkForBonusCodes();
				}
				++i3;
			}
			if(!codeCorrect) {
				var errorFont = new flambe_display_Font(ctx.pack,"fonts/BonusTxtErr");
				theText.set_font(errorFont);
				bonusTextField.getComponent("TextInput_14").onTextUpdate("WRONG CODE");
				theText.centerAnchor();
			}
		};
		flambe_System.get_external().bind("flambe_submitBonusCode",function() {
			checkBonusCode();
		});
		var codeButton = new flambe_Entity();
		var codeButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_code"));
		codeButtonImg.centerAnchor().setXY(165,193);
		codeButton.add(codeButtonImg);
		codeButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("home/btn_code_over"),function() {
			checkBonusCode();
		}));
		bonusCode.addChild(codeButton);
		var btn_enteragain = new flambe_Entity();
		var btn_enteragain_img = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_enteragain"));
		btn_enteragain_img.centerAnchor().setXY(175,193);
		btn_enteragain.add(btn_enteragain_img);
		btn_enteragain.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("home/btn_enteragain_over"),function() {
			bonusTextField.getComponent("TextInput_14").onTextUpdate("");
			bonusTextField.getComponent("TextInput_14").connectToHTMLInput();
			theText.centerAnchor();
			bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
			bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
			bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
			bonusCode.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
			bonusCode.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
			bonusCode.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
		}));
		bonusCodeConfirm.addChild(btn_enteragain);
	}
	var soundButton = new flambe_Entity();
	var soundButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_sound_on"));
	soundButtonImg.setXY(0,-18);
	soundButton.add(soundButtonImg);
	soundButton.add(new com_newwave_components_ui_button_SoundButton(ctx,ctx.pack.getTexture("home/btn_sound_on_over"),function() {
	}));
	scene.addChild(soundButton);
	if(flambe_System.get_touch().get_supported()) soundButtonImg.setXY(0,40);
	checkForBonusCodes();
	var script2 = new flambe_script_Script();
	script2.run(new flambe_script_Sequence([new flambe_script_Parallel([new flambe_script_AnimateTo(charData[0].img.x,centerposition.x,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(charData[0].img.y,centerposition.y,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(charData[0].img.rotation,0,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(charData[0].img.scaleX,1,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(charData[0].img.scaleY,1,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(charData[0].textimg.x,centertextposition.x,0.6,flambe_animation_Ease.backOut)])]));
	scene.add(script2);
	return scene;
};
var threedracer_scenes_CloseConfirmScene = function() { };
$hxClasses["threedracer.scenes.CloseConfirmScene"] = threedracer_scenes_CloseConfirmScene;
threedracer_scenes_CloseConfirmScene.__name__ = true;
threedracer_scenes_CloseConfirmScene.create = function(ctx) {
	flambe_System.get_external().call("trackFromGame",["game/leave"]);
	threedracer_scenes_CloseConfirmScene.assetPack = ctx.pack_mobileGame;
	var disposer;
	var scene = new flambe_Entity();
	scene.add(new flambe_scene_Scene(false));
	var fade = new flambe_display_FillSprite(0,1028,620);
	fade.alpha.animate(0,0.8,0.5);
	scene.addChild(new flambe_Entity().add(fade));
	var holder = new flambe_Entity();
	var imgPath = "closeconfirm/background";
	var instructions = new flambe_Entity();
	var background = new flambe_display_ImageSprite(threedracer_scenes_CloseConfirmScene.assetPack.getTexture(imgPath));
	background.x.set__(150);
	background.y.set__(-550);
	background.y.animateTo(50,0.6,flambe_animation_Ease.expoOut);
	instructions.add(background);
	scene.addChild(instructions);
	var yesButton = new flambe_Entity();
	var yesButtonImg = new flambe_display_ImageSprite(threedracer_scenes_CloseConfirmScene.assetPack.getTexture("closeconfirm/btn_yes"));
	yesButtonImg.centerAnchor().setXY(280,310);
	yesButton.add(yesButtonImg);
	yesButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,threedracer_scenes_CloseConfirmScene.assetPack.getTexture("closeconfirm/btn_yes_over"),function() {
		flambe_System.get_external().call("trackFromGame",["game/leave/clicked_yes"]);
		ctx.enterHomeScene();
	}));
	background.owner.addChild(yesButton);
	var noButton = new flambe_Entity();
	var noButtonImg = new flambe_display_ImageSprite(threedracer_scenes_CloseConfirmScene.assetPack.getTexture("closeconfirm/btn_no"));
	noButtonImg.centerAnchor().setXY(485,310);
	noButton.add(noButtonImg);
	noButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,threedracer_scenes_CloseConfirmScene.assetPack.getTexture("closeconfirm/btn_no_over"),function() {
		flambe_System.get_external().call("trackFromGame",["game/leave/clicked_no"]);
		ctx.unpauseGame();
	}));
	background.owner.addChild(noButton);
	var closeButton = new flambe_Entity();
	var closeButtonImg = new flambe_display_ImageSprite(threedracer_scenes_CloseConfirmScene.assetPack.getTexture("instructions/btn_close"));
	closeButtonImg.centerAnchor().setXY(680,55);
	closeButton.add(closeButtonImg);
	closeButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,threedracer_scenes_CloseConfirmScene.assetPack.getTexture("instructions/btn_close"),function() {
		ctx.unpauseGame();
	}));
	background.owner.addChild(closeButton);
	scene.addChild(holder);
	return scene;
};
var threedracer_scenes_EndScene = function() { };
$hxClasses["threedracer.scenes.EndScene"] = threedracer_scenes_EndScene;
threedracer_scenes_EndScene.__name__ = true;
threedracer_scenes_EndScene.create = function(ctx) {
	flambe_System.get_external().call("trackFromGame",["game/rankings"]);
	var racerdata = [];
	racerdata.push(ctx.racerData[0]);
	var i = 1;
	while(i < ctx.racerData.length) {
		var position = 0;
		var r = 0;
		while(r < racerdata.length) {
			if(ctx.racerData[i].time > racerdata[r].time) position = r + 1;
			r++;
		}
		racerdata.splice(position,0,ctx.racerData[i]);
		i++;
	}
	var lastime = 0;
	i = 0;
	while(i < racerdata.length) {
		if(i == 0) lastime = racerdata[i].time; else {
			if(Math.floor(racerdata[i].time) <= Math.round(lastime)) racerdata[i].time = lastime + Math.ceil(Math.random() * 5);
			lastime = racerdata[i].time;
		}
		i++;
	}
	var BGsound = ctx.pack.getSound("sounds/bgmusic_start").loop(0.7);
	ctx.BGmusic = BGsound;
	var scene = new flambe_Entity();
	var imageData = { rows : 1, columns : 2};
	var spriteData = ["end/end_bg1","end/end_bg2"];
	var background = new com_newwave_components_display_TiledImage(ctx.pack,imageData,spriteData);
	var bg_Entity = new flambe_Entity().add(background);
	scene.addChild(bg_Entity);
	if(!flambe_System.get_touch().get_supported()) {
		var images = new Array();
		var _g = 1;
		while(_g < 18) {
			var i1 = _g++;
			images.push(new flambe_display_ImageSprite(ctx.pack.getTexture("game/spatulagroup/" + i1)));
		}
		var spatula = new flambe_Entity();
		var sprite = new flambe_display_Sprite();
		sprite.setScale(0.7).setXY(80,260);
		spatula.add(sprite);
		spatula.add(new com_newwave_components_display_PngSequence(images,true,1));
		scene.addChild(spatula);
		var images2 = new Array();
		var _g1 = 1;
		while(_g1 < 36) {
			var i2 = _g1++;
			images2.push(new flambe_display_ImageSprite(ctx.pack.getTexture("game/moon/" + i2)));
		}
		var moon = new flambe_Entity();
		var sprite2 = new flambe_display_Sprite();
		sprite2.setScale(0.7).setXY(920,100);
		moon.add(sprite2);
		moon.add(new com_newwave_components_display_PngSequence(images2,true,1));
		scene.addChild(moon);
	}
	var headline = new flambe_display_ImageSprite(ctx.pack.getTexture("end/headline"));
	headline.centerAnchor().setXY(410,-200);
	scene.addChild(new flambe_Entity().add(headline));
	var startButton = new flambe_Entity();
	var startButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("end/btn_play"));
	startButtonImg.centerAnchor().setXY(400,530);
	startButton.add(startButtonImg);
	startButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("end/btn_play_over"),function() {
		if(ctx.device == "phone") ctx.enterHomeScene(); else ctx.enterChooseRacerScene();
	}));
	scene.addChild(startButton);
	var yfirst = 220;
	var ysecond = 280;
	var ythird = 340;
	var yfourth = 400;
	var first = new flambe_display_FillSprite(9964950,405,50);
	first.setXY(185,220).setAlpha(0.35);
	scene.addChild(new flambe_Entity().add(first));
	first.alpha.set__(0);
	var highlight = first;
	var second = new flambe_display_FillSprite(9964950,405,50);
	second.setXY(185,280).setAlpha(0.35);
	scene.addChild(new flambe_Entity().add(second));
	second.alpha.set__(0);
	if(racerdata[1].name == ctx.chosenRacer) highlight = second;
	var third = new flambe_display_FillSprite(9964950,405,50);
	third.setXY(185,340).setAlpha(0.35);
	scene.addChild(new flambe_Entity().add(third));
	third.alpha.set__(0);
	if(racerdata[2].name == ctx.chosenRacer) highlight = third;
	var fourth = new flambe_display_FillSprite(9964950,405,50);
	fourth.setXY(185,400).setAlpha(0.35);
	scene.addChild(new flambe_Entity().add(fourth));
	fourth.alpha.set__(0);
	if(racerdata[3].name == ctx.chosenRacer) highlight = fourth;
	var firsttext = new flambe_display_ImageSprite(ctx.pack.getTexture("end/first_score"));
	if(racerdata[0].name == ctx.chosenRacer) firsttext = new flambe_display_ImageSprite(ctx.pack.getTexture("end/first_score_me"));
	firsttext.setXY(200,yfirst).setAlpha(0);
	scene.addChild(new flambe_Entity().add(firsttext));
	var secondtext = new flambe_display_ImageSprite(ctx.pack.getTexture("end/second_score"));
	if(racerdata[1].name == ctx.chosenRacer) secondtext = new flambe_display_ImageSprite(ctx.pack.getTexture("end/second_score_me"));
	secondtext.setXY(200,ysecond).setAlpha(0);
	scene.addChild(new flambe_Entity().add(secondtext));
	var thirdtext = new flambe_display_ImageSprite(ctx.pack.getTexture("end/third_score"));
	if(racerdata[2].name == ctx.chosenRacer) thirdtext = new flambe_display_ImageSprite(ctx.pack.getTexture("end/third_score_me"));
	thirdtext.setXY(200,ythird).setAlpha(0);
	scene.addChild(new flambe_Entity().add(thirdtext));
	var fourthtext = new flambe_display_ImageSprite(ctx.pack.getTexture("end/fourth_score"));
	if(racerdata[3].name == ctx.chosenRacer) fourthtext = new flambe_display_ImageSprite(ctx.pack.getTexture("end/fourth_score_me"));
	fourthtext.setXY(200,yfourth).setAlpha(0);
	scene.addChild(new flambe_Entity().add(fourthtext));
	var first_name = new flambe_display_ImageSprite(ctx.pack.getTexture("end/" + racerdata[0].name + "_score"));
	first_name.setXY(265,yfirst).setAlpha(0);
	scene.addChild(new flambe_Entity().add(first_name));
	var second_name = new flambe_display_ImageSprite(ctx.pack.getTexture("end/" + racerdata[1].name + "_score"));
	second_name.setXY(265,ysecond).setAlpha(0);
	scene.addChild(new flambe_Entity().add(second_name));
	var third_name = new flambe_display_ImageSprite(ctx.pack.getTexture("end/" + racerdata[2].name + "_score"));
	third_name.setXY(265,ythird).setAlpha(0);
	scene.addChild(new flambe_Entity().add(third_name));
	var fourth_name = new flambe_display_ImageSprite(ctx.pack.getTexture("end/" + racerdata[3].name + "_score"));
	fourth_name.setXY(265,yfourth).setAlpha(0);
	scene.addChild(new flambe_Entity().add(fourth_name));
	var font = new flambe_display_Font(ctx.pack,"fonts/endscore");
	var font2 = new flambe_display_Font(ctx.pack,"fonts/endscore_yellow");
	var firstfont;
	if(racerdata[0].name == ctx.chosenRacer) firstfont = font2; else firstfont = font;
	var time_first = new flambe_display_TextSprite(firstfont,com_newwave_utils_GameUtils.convertTime(racerdata[0].time)).setLetterSpacing(2);
	time_first.setXY(490,yfirst + 6).setAlpha(0);
	scene.addChild(new flambe_Entity().add(time_first));
	var secondfont;
	if(racerdata[1].name == ctx.chosenRacer) secondfont = font2; else secondfont = font;
	var time_second = new flambe_display_TextSprite(secondfont,com_newwave_utils_GameUtils.convertTime(racerdata[1].time)).setLetterSpacing(2);
	time_second.setXY(490,ysecond + 6).setAlpha(0);
	scene.addChild(new flambe_Entity().add(time_second));
	var thirdfont;
	if(racerdata[2].name == ctx.chosenRacer) thirdfont = font2; else thirdfont = font;
	var time_third = new flambe_display_TextSprite(thirdfont,com_newwave_utils_GameUtils.convertTime(racerdata[2].time)).setLetterSpacing(2);
	time_third.setXY(490,ythird + 6).setAlpha(0);
	scene.addChild(new flambe_Entity().add(time_third));
	var fourthfont;
	if(racerdata[3].name == ctx.chosenRacer) fourthfont = font2; else fourthfont = font;
	var time_fourth = new flambe_display_TextSprite(fourthfont,com_newwave_utils_GameUtils.convertTime(racerdata[3].time)).setLetterSpacing(2);
	time_fourth.setXY(490,yfourth + 6).setAlpha(0);
	scene.addChild(new flambe_Entity().add(time_fourth));
	var featherHolder = new flambe_Entity();
	scene.addChild(featherHolder);
	var bonusCart = "";
	if(ctx.bonus2 == true) bonusCart = "_star";
	if(ctx.bonus1 == true) bonusCart = "_hotrod";
	var character = new flambe_display_ImageSprite(ctx.pack.getTexture("end/" + ctx.chosenRacer + bonusCart));
	character.centerAnchor().setXY(800,340).setScale(0.5).setAlpha(0);
	scene.addChild(new flambe_Entity().add(character));
	var soundButton = new flambe_Entity();
	var soundButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_sound_on"));
	soundButtonImg.setXY(0,-18);
	soundButton.add(soundButtonImg);
	soundButton.add(new com_newwave_components_ui_button_SoundButton(ctx,ctx.pack.getTexture("home/btn_sound_on_over"),function() {
	}));
	scene.addChild(soundButton);
	if(flambe_System.get_touch().get_supported()) soundButtonImg.setXY(0,40);
	var script = new flambe_script_Script();
	script.run(new flambe_script_Sequence([new flambe_script_AnimateTo(background.alpha,1,1.5,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(headline.y,70,0.5,flambe_animation_Ease.expoOut),new flambe_script_Parallel([new flambe_script_AnimateTo(character.alpha,1,0.5,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(character.scaleX,1,0.5,flambe_animation_Ease.backOut),new flambe_script_AnimateTo(character.scaleY,1,0.5,flambe_animation_Ease.backOut)]),new flambe_script_CallFunction(function() {
		var timer = new haxe_Timer(1000);
		timer.run = function() {
			if(Std.string(flambe_System.hidden.toString()) == "false") {
				var feather = new threedracer_anims_Feather(ctx.pack,800,350,0.9);
				featherHolder.addChild(new flambe_Entity().add(feather));
			}
		};
	}),new flambe_script_Parallel([new flambe_script_CallFunction(function() {
		var sound = ctx.pack.getSound("sounds/rank").play(0.7);
	}),new flambe_script_AnimateTo(firsttext.alpha,1,0.2,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(first_name.alpha,1,0.2,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(time_first.alpha,1,0.2,flambe_animation_Ease.expoOut)]),new flambe_script_Delay(0.1),new flambe_script_Parallel([new flambe_script_CallFunction(function() {
		var sound1 = ctx.pack.getSound("sounds/rank").play(0.7);
	}),new flambe_script_AnimateTo(secondtext.alpha,1,0.2,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(second_name.alpha,1,0.2,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(time_second.alpha,1,0.2,flambe_animation_Ease.expoOut)]),new flambe_script_Delay(0.1),new flambe_script_Parallel([new flambe_script_CallFunction(function() {
		var sound2 = ctx.pack.getSound("sounds/rank").play(0.7);
	}),new flambe_script_AnimateTo(thirdtext.alpha,1,0.2,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(third_name.alpha,1,0.2,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(time_third.alpha,1,0.2,flambe_animation_Ease.expoOut)]),new flambe_script_Delay(0.1),new flambe_script_Parallel([new flambe_script_CallFunction(function() {
		var sound3 = ctx.pack.getSound("sounds/rank").play(0.7);
	}),new flambe_script_AnimateTo(fourthtext.alpha,1,0.2,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(fourth_name.alpha,1,0.2,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(time_fourth.alpha,1,0.2,flambe_animation_Ease.expoOut)]),new flambe_script_AnimateTo(highlight.alpha,1,0.2,flambe_animation_Ease.expoOut)]));
	scene.add(script);
	return scene;
};
var threedracer_scenes_EnterCodeScene = function() { };
$hxClasses["threedracer.scenes.EnterCodeScene"] = threedracer_scenes_EnterCodeScene;
threedracer_scenes_EnterCodeScene.__name__ = true;
threedracer_scenes_EnterCodeScene.create = function(ctx) {
	threedracer_scenes_EnterCodeScene.context = ctx;
	var bonusCodes = ["Sleepward","Starrynight","Dreampants"];
	var scene = new flambe_Entity();
	var imageData = { rows : 1, columns : 2};
	var spriteData = ["home/home_bg1","home/home_bg2"];
	var background = new com_newwave_components_display_TiledImage(ctx.pack,imageData,spriteData);
	var bg_Entity = new flambe_Entity().add(background);
	scene.addChild(bg_Entity);
	var imageData2 = { rows : 1, columns : 2};
	var spriteData2 = ["home/road1","home/road2"];
	var road = new com_newwave_components_display_TiledImage(ctx.pack,imageData2,spriteData2);
	road.setXY(0,300);
	scene.addChild(new flambe_Entity().add(road));
	var startButton = new flambe_Entity();
	var startButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_start"));
	startButtonImg.centerAnchor().setXY(890,480);
	startButton.add(startButtonImg);
	startButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("home/btn_start_over"),function() {
		ctx.enterChooseRacerScene();
	}));
	scene.addChild(startButton);
	var bonusFeatherHolder = new flambe_Entity();
	scene.addChild(bonusFeatherHolder);
	var bonusCodeConfirm = new flambe_Entity();
	var codeconfirm_bg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/code_success_large"));
	codeconfirm_bg.centerAnchor().setXY(520,250).setAlpha(0).setScale(0);
	bonusCodeConfirm.add(codeconfirm_bg);
	var txt_bonus1 = new flambe_display_ImageSprite(ctx.pack.getTexture("home/txt_bonus1_large"));
	txt_bonus1.centerAnchor().setXY(300,210);
	bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonus1));
	var txt_bonus2 = new flambe_display_ImageSprite(ctx.pack.getTexture("home/txt_bonus2_large"));
	txt_bonus2.centerAnchor().setXY(300,210);
	bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonus2));
	var txt_bonus3 = new flambe_display_ImageSprite(ctx.pack.getTexture("home/txt_bonus3_large"));
	txt_bonus3.centerAnchor().setXY(300,210);
	bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonus3));
	var txt_bonusRepeat = new flambe_display_ImageSprite(ctx.pack.getTexture("home/powerup_entertwice_large"));
	txt_bonusRepeat.centerAnchor().setXY(320,210);
	bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonusRepeat));
	scene.addChild(bonusCodeConfirm);
	var bonusCode = new flambe_Entity();
	var code_bg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/code_bg_large"));
	code_bg.centerAnchor().setXY(520,250);
	bonusCode.add(code_bg);
	scene.addChild(bonusCode);
	var bonusTextField = new flambe_Entity();
	var font = new flambe_display_Font(ctx.pack,"fonts/BonusTxtLarge");
	var theText = new flambe_display_TextSprite(font,"ENTER HERE");
	theText.centerAnchor().setXY(320,280);
	bonusTextField.add(theText);
	bonusTextField.add(new com_newwave_components_ui_text_TextInput(font,48));
	bonusCode.addChild(bonusTextField);
	theText.get_pointerDown().connect(function(event) {
		bonusTextField.getComponent("TextInput_14").connectToHTMLInput();
	});
	var checkBonusCode = function() {
		var enteredCode = bonusTextField.getComponent("TextInput_14").value;
		var i = 0;
		var codeCorrect = false;
		while(i < bonusCodes.length) {
			if(enteredCode.toUpperCase() == bonusCodes[i].toUpperCase()) {
				codeCorrect = true;
				flambe_System.get_external().call("trackFromGame",["game/code_" + enteredCode.toUpperCase()]);
				if(i == 0) {
					console.log(ctx.bonus1);
					if(ctx.bonus1 == true) {
						txt_bonus1.alpha.set__(0);
						txt_bonus2.alpha.set__(0);
						txt_bonus3.alpha.set__(0);
						txt_bonusRepeat.alpha.set__(1);
					} else {
						txt_bonus1.alpha.set__(1);
						txt_bonus2.alpha.set__(0);
						txt_bonus3.alpha.set__(0);
						txt_bonusRepeat.alpha.set__(0);
					}
					ctx.bonus1 = true;
					bonusCode.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
					bonusCode.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
					bonusCode.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
					bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
					bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
					bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
				} else if(i == 1) {
					console.log(ctx.bonus2);
					if(ctx.bonus2 == true) {
						txt_bonus1.alpha.set__(0);
						txt_bonus2.alpha.set__(0);
						txt_bonus3.alpha.set__(0);
						txt_bonusRepeat.alpha.set__(1);
					} else {
						txt_bonus1.alpha.set__(0);
						txt_bonus2.alpha.set__(1);
						txt_bonus3.alpha.set__(0);
						txt_bonusRepeat.alpha.set__(0);
					}
					ctx.bonus2 = true;
					bonusCode.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
					bonusCode.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
					bonusCode.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
					bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
					bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
					bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
				} else if(i == 2) {
					console.log(ctx.bonus3);
					if(ctx.bonus3 == true) {
						txt_bonus1.alpha.set__(0);
						txt_bonus2.alpha.set__(0);
						txt_bonus3.alpha.set__(0);
						txt_bonusRepeat.alpha.set__(1);
					} else {
						txt_bonus1.alpha.set__(0);
						txt_bonus2.alpha.set__(0);
						txt_bonus3.alpha.set__(1);
						txt_bonusRepeat.alpha.set__(0);
					}
					ctx.bonus3 = true;
					bonusCode.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
					bonusCode.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
					bonusCode.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
					bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
					bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
					bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
				}
				var f = 0;
				while(f < 10) {
					var feather = new threedracer_anims_Feather(ctx.pack,500,250,0.7);
					bonusFeatherHolder.addChild(new flambe_Entity().add(feather));
					f++;
				}
			}
			++i;
		}
		if(!codeCorrect) {
			var errorFont = new flambe_display_Font(ctx.pack,"fonts/BonusTxtErrLarge");
			theText.set_font(errorFont);
			bonusTextField.getComponent("TextInput_14").onTextUpdate("WRONG CODE");
			theText.centerAnchor();
		}
	};
	flambe_System.get_external().bind("flambe_submitBonusCode",function() {
		checkBonusCode();
	});
	var codeButton = new flambe_Entity();
	var codeButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_code_large"));
	codeButtonImg.centerAnchor().setXY(320,380);
	codeButton.add(codeButtonImg);
	codeButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("home/btn_code_large_over"),function() {
		checkBonusCode();
	}));
	bonusCode.addChild(codeButton);
	var btn_enteragain = new flambe_Entity();
	var btn_enteragain_img = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_enteragain_large"));
	btn_enteragain_img.centerAnchor().setXY(334,380);
	btn_enteragain.add(btn_enteragain_img);
	btn_enteragain.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("home/btn_enteragain_large_over"),function() {
		bonusTextField.getComponent("TextInput_14").onTextUpdate("");
		bonusTextField.getComponent("TextInput_14").connectToHTMLInput();
		theText.centerAnchor();
		bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
		bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
		bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
		bonusCode.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
		bonusCode.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
		bonusCode.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
	}));
	bonusCodeConfirm.addChild(btn_enteragain);
	var soundButton = new flambe_Entity();
	var soundButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_sound_on"));
	soundButtonImg.setXY(0,-18);
	soundButton.add(soundButtonImg);
	soundButton.add(new com_newwave_components_ui_button_SoundButton(ctx,ctx.pack.getTexture("home/btn_sound_on_over"),function() {
	}));
	scene.addChild(soundButton);
	if(flambe_System.get_touch().get_supported()) soundButtonImg.setXY(0,40);
	return scene;
};
var threedracer_scenes_GameScene = function() { };
$hxClasses["threedracer.scenes.GameScene"] = threedracer_scenes_GameScene;
threedracer_scenes_GameScene.__name__ = true;
threedracer_scenes_GameScene.create = function(ctx) {
	flambe_System.get_external().call("trackFromGame",["game/play_as_" + ctx.chosenRacer]);
	threedracer_scenes_GameScene.assetPack = ctx.pack_mobileGame;
	var BGsound = threedracer_scenes_GameScene.assetPack.getSound("sounds/bgmusic_game").loop(0.6);
	ctx.BGmusic = BGsound;
	var scene = new flambe_Entity();
	var game = new threedracer_components_Game(ctx);
	scene.addChild(new flambe_Entity().add(game));
	if(!flambe_System.get_touch().get_supported()) {
		var helpButton = new flambe_Entity();
		var helpButtonImg = new flambe_display_ImageSprite(threedracer_scenes_GameScene.assetPack.getTexture("game/btn_help"));
		helpButtonImg.centerAnchor().setXY(107,22);
		helpButton.add(helpButtonImg);
		helpButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,threedracer_scenes_GameScene.assetPack.getTexture("game/btn_help_over"),function() {
			ctx.showInstructions(threedracer_scenes_GameScene.assetPack);
		}));
		scene.addChild(helpButton);
		var soundButton = new flambe_Entity();
		var soundButtonImg = new flambe_display_ImageSprite(threedracer_scenes_GameScene.assetPack.getTexture("game/btn_sound_on"));
		soundButtonImg.centerAnchor().setXY(115,53);
		soundButton.add(soundButtonImg);
		soundButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,threedracer_scenes_GameScene.assetPack.getTexture("game/btn_sound_on_over"),function() {
			flambe_System.volume.set__(flambe_System.volume.get__() == 1?0:1);
			threedracer_scenes_GameScene.updateSoundBtn(ctx,soundButton);
		}));
		threedracer_scenes_GameScene.updateSoundBtn(ctx,soundButton);
		scene.addChild(soundButton);
	} else {
		var mobileUI = new flambe_display_ImageSprite(threedracer_scenes_GameScene.assetPack.getTexture("game/mobile_ui"));
		mobileUI.setXY(0,480);
		scene.addChild(new flambe_Entity().add(mobileUI));
		var helpButton1 = new flambe_Entity();
		var helpButtonImg1 = new flambe_display_ImageSprite(threedracer_scenes_GameScene.assetPack.getTexture("game/mobile_btn_help"));
		helpButtonImg1.centerAnchor().setXY(45,525);
		helpButton1.add(helpButtonImg1);
		helpButton1.add(new com_newwave_components_ui_button_RolloverButton(ctx,threedracer_scenes_GameScene.assetPack.getTexture("game/mobile_btn_help_over"),function() {
			ctx.showInstructions(threedracer_scenes_GameScene.assetPack);
		}));
		scene.addChild(helpButton1);
		var soundButton1 = new flambe_Entity();
		var soundButtonImg1 = new flambe_display_ImageSprite(threedracer_scenes_GameScene.assetPack.getTexture("game/mobile_btn_sound_on"));
		soundButtonImg1.centerAnchor().setXY(115,525);
		soundButton1.add(soundButtonImg1);
		soundButton1.add(new com_newwave_components_ui_button_RolloverButton(ctx,threedracer_scenes_GameScene.assetPack.getTexture("game/mobile_btn_sound_on_over"),function() {
			flambe_System.volume.set__(flambe_System.volume.get__() == 1?0:1);
			threedracer_scenes_GameScene.updateSoundBtn(ctx,soundButton1);
		}));
		threedracer_scenes_GameScene.updateSoundBtn(ctx,soundButton1);
		scene.addChild(soundButton1);
	}
	var closeButton = new flambe_Entity();
	var closeButtonImg = new flambe_display_ImageSprite(threedracer_scenes_GameScene.assetPack.getTexture("game/btn_close"));
	closeButtonImg.setXY(978,0);
	if(ctx.device == "phone") closeButtonImg.y.set__(30);
	closeButton.add(closeButtonImg);
	closeButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,threedracer_scenes_GameScene.assetPack.getTexture("game/btn_close"),function() {
		ctx.enterCloseConfirm();
	}));
	scene.addChild(closeButton);
	return scene;
};
threedracer_scenes_GameScene.updateSoundBtn = function(ctx,soundButton) {
	var texture;
	var rollTexture;
	if(flambe_System.volume.get__() == 1) {
		if(!flambe_System.get_touch().get_supported()) {
			texture = threedracer_scenes_GameScene.assetPack.getTexture("game/btn_sound_on");
			rollTexture = threedracer_scenes_GameScene.assetPack.getTexture("game/btn_sound_on_over");
		} else {
			texture = threedracer_scenes_GameScene.assetPack.getTexture("game/mobile_btn_sound_on");
			rollTexture = threedracer_scenes_GameScene.assetPack.getTexture("game/mobile_btn_sound_on_over");
		}
	} else if(!flambe_System.get_touch().get_supported()) {
		texture = threedracer_scenes_GameScene.assetPack.getTexture("game/btn_sound_off");
		rollTexture = threedracer_scenes_GameScene.assetPack.getTexture("game/btn_sound_off_over");
	} else {
		texture = threedracer_scenes_GameScene.assetPack.getTexture("game/mobile_btn_sound_off");
		rollTexture = threedracer_scenes_GameScene.assetPack.getTexture("game/mobile_btn_sound_off_over");
	}
	soundButton.getComponent("Sprite_4").texture = texture;
	soundButton.getComponent("RolloverButton_4").rollSprite.texture = rollTexture;
};
var threedracer_scenes_HomeScene = function() { };
$hxClasses["threedracer.scenes.HomeScene"] = threedracer_scenes_HomeScene;
threedracer_scenes_HomeScene.__name__ = true;
threedracer_scenes_HomeScene.create = function(ctx) {
	threedracer_scenes_HomeScene.context = ctx;
	var bonusCodes = ["Sleepward","Starrynight","Dreampants"];
	if(ctx.BGmusic == null) flambe_System.volume.set__(0); else {
		ctx.BGmusic.dispose();
		var BGsound = ctx.pack.getSound("sounds/bgmusic_start").loop(0.7);
		ctx.BGmusic = BGsound;
	}
	var scene = new flambe_Entity();
	var imageData = { rows : 1, columns : 2};
	var spriteData = ["home/home_bg1","home/home_bg2"];
	var background = new com_newwave_components_display_TiledImage(ctx.pack,imageData,spriteData);
	var bg_Entity = new flambe_Entity().add(background);
	scene.addChild(bg_Entity);
	if(!flambe_System.get_touch().get_supported()) {
		var images = new Array();
		var _g = 1;
		while(_g < 14) {
			var i = _g++;
			images.push(new flambe_display_ImageSprite(ctx.pack.getTexture("game/books/" + i)));
		}
		var books = new flambe_Entity();
		var sprite = new flambe_display_Sprite();
		sprite.setScale(0.4).setXY(220,60);
		books.add(sprite);
		books.add(new com_newwave_components_display_PngSequence(images,true,1));
		scene.addChild(books);
	}
	var featherHolder = new flambe_Entity();
	scene.addChild(featherHolder);
	var timer = new haxe_Timer(1000);
	timer.run = function() {
		if(Std.string(flambe_System.hidden.toString()) == "false") {
			var feather = new threedracer_anims_Feather(ctx.pack,780,200,0.7);
			featherHolder.addChild(new flambe_Entity().add(feather));
		}
	};
	var imageData2 = { rows : 1, columns : 2};
	var spriteData2 = ["home/road1","home/road2"];
	var road = new com_newwave_components_display_TiledImage(ctx.pack,imageData2,spriteData2);
	road.setXY(0,300);
	scene.addChild(new flambe_Entity().add(road));
	var headline = new flambe_display_ImageSprite(ctx.pack.getTexture("home/headline"));
	headline.centerAnchor().setXY(780,-360);
	var headlineEnt = new flambe_Entity().add(headline);
	scene.addChild(headlineEnt);
	headline.y.animateTo(200,1,flambe_animation_Ease.backOut);
	var patrick = new flambe_display_ImageSprite(ctx.pack.getTexture("home/patrick"));
	patrick.centerAnchor().setXY(-100,200).setScale(0.1);
	scene.addChild(new flambe_Entity().add(patrick));
	var spongebob = new flambe_display_ImageSprite(ctx.pack.getTexture("home/spongebob"));
	spongebob.setXY(-500,80).setScale(0.1);
	scene.addChild(new flambe_Entity().add(spongebob));
	var startButton = new flambe_Entity();
	var startButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_start"));
	startButtonImg.centerAnchor().setXY(890,480);
	startButton.add(startButtonImg);
	startButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("home/btn_start_over"),function() {
		timer.stop();
		if(ctx.BGmusic == null) threedracer_scenes_HomeScene.startBGmusic(ctx);
		if(ctx.device == "phone") ctx.enterCodeScene(); else ctx.enterChooseRacerScene();
	}));
	scene.addChild(startButton);
	if(ctx.device != "phone") {
		var bonusFeatherHolder = new flambe_Entity();
		scene.addChild(bonusFeatherHolder);
		var bonusCodeConfirm = new flambe_Entity();
		var codeconfirm_bg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/code_success"));
		codeconfirm_bg.centerAnchor().setXY(175,490).setAlpha(0).setScale(0);
		bonusCodeConfirm.add(codeconfirm_bg);
		var txt_bonus1 = new flambe_display_ImageSprite(ctx.pack.getTexture("home/txt_bonus1"));
		txt_bonus1.centerAnchor().setXY(155,110);
		bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonus1));
		var txt_bonus2 = new flambe_display_ImageSprite(ctx.pack.getTexture("home/txt_bonus2"));
		txt_bonus2.centerAnchor().setXY(155,110);
		bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonus2));
		var txt_bonus3 = new flambe_display_ImageSprite(ctx.pack.getTexture("home/txt_bonus3"));
		txt_bonus3.centerAnchor().setXY(155,110);
		bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonus3));
		var txt_bonusRepeat = new flambe_display_ImageSprite(ctx.pack.getTexture("home/powerup_entertwice"));
		txt_bonusRepeat.centerAnchor().setXY(160,110);
		bonusCodeConfirm.addChild(new flambe_Entity().add(txt_bonusRepeat));
		scene.addChild(bonusCodeConfirm);
		var bonusCode = new flambe_Entity();
		var code_bg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/code_bg"));
		code_bg.centerAnchor().setXY(165,490);
		bonusCode.add(code_bg);
		scene.addChild(bonusCode);
		var bonusTextField = new flambe_Entity();
		var font = new flambe_display_Font(ctx.pack,"fonts/BonusTxt");
		var theText = new flambe_display_TextSprite(font,"ENTER HERE");
		theText.centerAnchor().setXY(165,145);
		bonusTextField.add(theText);
		bonusTextField.add(new com_newwave_components_ui_text_TextInput(font));
		bonusCode.addChild(bonusTextField);
		theText.get_pointerDown().connect(function(event) {
			bonusTextField.getComponent("TextInput_14").connectToHTMLInput();
		});
		var checkBonusCode = function() {
			var enteredCode = bonusTextField.getComponent("TextInput_14").value;
			var i1 = 0;
			var codeCorrect = false;
			while(i1 < bonusCodes.length) {
				if(enteredCode.toUpperCase() == bonusCodes[i1].toUpperCase()) {
					codeCorrect = true;
					flambe_System.get_external().call("trackFromGame",["game/code_" + enteredCode.toUpperCase()]);
					if(i1 == 0) {
						console.log(ctx.bonus1);
						if(ctx.bonus1) {
							txt_bonus1.alpha.set__(0);
							txt_bonus2.alpha.set__(0);
							txt_bonus3.alpha.set__(0);
							txt_bonusRepeat.alpha.set__(1);
						} else {
							txt_bonus1.alpha.set__(1);
							txt_bonus2.alpha.set__(0);
							txt_bonus3.alpha.set__(0);
							txt_bonusRepeat.alpha.set__(0);
						}
						ctx.bonus1 = true;
						bonusCode.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
						bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
					} else if(i1 == 1) {
						console.log(ctx.bonus2);
						if(ctx.bonus2 == true) {
							txt_bonus1.alpha.set__(0);
							txt_bonus2.alpha.set__(0);
							txt_bonus3.alpha.set__(0);
							txt_bonusRepeat.alpha.set__(1);
						} else {
							txt_bonus1.alpha.set__(0);
							txt_bonus2.alpha.set__(1);
							txt_bonus3.alpha.set__(0);
							txt_bonusRepeat.alpha.set__(0);
						}
						ctx.bonus2 = true;
						bonusCode.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
						bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
					} else if(i1 == 2) {
						console.log(ctx.bonus3);
						if(ctx.bonus3 == true) {
							txt_bonus1.alpha.set__(0);
							txt_bonus2.alpha.set__(0);
							txt_bonus3.alpha.set__(0);
							txt_bonusRepeat.alpha.set__(1);
						} else {
							txt_bonus1.alpha.set__(0);
							txt_bonus2.alpha.set__(0);
							txt_bonus3.alpha.set__(1);
							txt_bonusRepeat.alpha.set__(0);
						}
						ctx.bonus3 = true;
						bonusCode.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
						bonusCode.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
						bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
						bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
					}
					var f = 0;
					while(f < 10) {
						var feather1 = new threedracer_anims_Feather(ctx.pack,165,390,0.7);
						bonusFeatherHolder.addChild(new flambe_Entity().add(feather1));
						f++;
					}
				}
				++i1;
			}
			if(!codeCorrect) {
				var errorFont = new flambe_display_Font(ctx.pack,"fonts/BonusTxtErr");
				theText.set_font(errorFont);
				bonusTextField.getComponent("TextInput_14").onTextUpdate("WRONG CODE");
				theText.centerAnchor();
			}
		};
		flambe_System.get_external().bind("flambe_submitBonusCode",function() {
			checkBonusCode();
		});
		var codeButton = new flambe_Entity();
		var codeButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_code"));
		codeButtonImg.centerAnchor().setXY(165,193);
		codeButton.add(codeButtonImg);
		codeButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("home/btn_code_over"),function() {
			checkBonusCode();
		}));
		bonusCode.addChild(codeButton);
		var btn_enteragain = new flambe_Entity();
		var btn_enteragain_img = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_enteragain"));
		btn_enteragain_img.centerAnchor().setXY(175,193);
		btn_enteragain.add(btn_enteragain_img);
		btn_enteragain.add(new com_newwave_components_ui_button_RolloverButton(ctx,ctx.pack.getTexture("home/btn_enteragain_over"),function() {
			bonusTextField.getComponent("TextInput_14").onTextUpdate("");
			bonusTextField.getComponent("TextInput_14").connectToHTMLInput();
			theText.centerAnchor();
			bonusCodeConfirm.getComponent("Sprite_4").scaleX.animateTo(0,0.3,flambe_animation_Ease.backIn);
			bonusCodeConfirm.getComponent("Sprite_4").scaleY.animateTo(0,0.3,flambe_animation_Ease.backIn);
			bonusCodeConfirm.getComponent("Sprite_4").alpha.animateTo(0,0.2,flambe_animation_Ease.backIn);
			bonusCode.getComponent("Sprite_4").scaleX.animateTo(1,0.3,flambe_animation_Ease.backOut);
			bonusCode.getComponent("Sprite_4").scaleY.animateTo(1,0.3,flambe_animation_Ease.backOut);
			bonusCode.getComponent("Sprite_4").alpha.animateTo(1,0.2,flambe_animation_Ease.backOut);
		}));
		bonusCodeConfirm.addChild(btn_enteragain);
	}
	var soundButton = new flambe_Entity();
	var soundButtonImg = new flambe_display_ImageSprite(ctx.pack.getTexture("home/btn_sound_on"));
	soundButtonImg.setXY(0,-18);
	soundButton.add(soundButtonImg);
	soundButton.add(new com_newwave_components_ui_button_SoundButton(ctx,ctx.pack.getTexture("home/btn_sound_on_over"),function() {
		if(ctx.BGmusic == null) threedracer_scenes_HomeScene.startBGmusic(ctx);
	}));
	scene.addChild(soundButton);
	if(flambe_System.get_touch().get_supported()) soundButtonImg.setXY(0,40);
	var script = new flambe_script_Script();
	script.run(new flambe_script_Sequence([new flambe_script_Delay(0.5),new flambe_script_Parallel([new flambe_script_AnimateTo(patrick.x,645,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(patrick.y,445,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(patrick.rotation,0,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(patrick.scaleX,1,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(patrick.scaleY,1,0.6,flambe_animation_Ease.expoOut)]),new flambe_script_Parallel([new flambe_script_AnimateTo(spongebob.x,0,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(spongebob.y,0,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(spongebob.rotation,0,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(spongebob.scaleX,1,0.6,flambe_animation_Ease.expoOut),new flambe_script_AnimateTo(spongebob.scaleY,1,0.6,flambe_animation_Ease.expoOut)])]));
	scene.add(script);
	return scene;
};
threedracer_scenes_HomeScene.startBGmusic = function(ctx) {
	flambe_System.volume.set__(1);
	var BGsound = ctx.pack.getSound("sounds/bgmusic_start").loop(0.7);
	BGsound.volume.set__(0);
	BGsound.volume.animateTo(0.85,3);
	ctx.BGmusic = BGsound;
};
var threedracer_scenes_InstructionsScene = function() { };
$hxClasses["threedracer.scenes.InstructionsScene"] = threedracer_scenes_InstructionsScene;
threedracer_scenes_InstructionsScene.__name__ = true;
threedracer_scenes_InstructionsScene.create = function(ctx,pack) {
	var disposer;
	var scene = new flambe_Entity();
	scene.add(new flambe_scene_Scene(false));
	var fade = new flambe_display_FillSprite(0,1028,620);
	fade.alpha.animate(0,0.8,0.5);
	scene.addChild(new flambe_Entity().add(fade));
	var holder = new flambe_Entity();
	var imgPath = "instructions/instructions";
	if(flambe_System.get_touch().get_supported()) imgPath = "instructions/instructions_mobile";
	var instructions = new flambe_Entity();
	var background = new flambe_display_ImageSprite(pack.getTexture(imgPath));
	background.x.set__(150);
	background.y.set__(-550);
	if(flambe_System.get_touch().get_supported()) background.y.animateTo(25,0.6,flambe_animation_Ease.expoOut); else background.y.animateTo(50,0.6,flambe_animation_Ease.expoOut);
	instructions.add(background);
	scene.addChild(instructions);
	if(!ctx.seenInstructions) {
		flambe_System.get_external().call("trackFromGame",["game/intro"]);
		var startButton = new flambe_Entity();
		var startButtonImg = new flambe_display_ImageSprite(pack.getTexture("instructions/btn_start"));
		startButtonImg.centerAnchor().setXY(400,480);
		if(flambe_System.get_touch().get_supported()) startButtonImg.y.set__(470);
		startButton.add(startButtonImg);
		startButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,pack.getTexture("instructions/btn_start_over"),function() {
			ctx.seenInstructions = true;
			ctx.enterGameScene();
		}));
		background.owner.addChild(startButton);
	} else {
		flambe_System.get_external().call("trackFromGame",["game/how_to_play"]);
		var closeButton = new flambe_Entity();
		var closeButtonImg = new flambe_display_ImageSprite(pack.getTexture("instructions/btn_close"));
		closeButtonImg.centerAnchor().setXY(680,55);
		closeButton.add(closeButtonImg);
		closeButton.add(new com_newwave_components_ui_button_RolloverButton(ctx,pack.getTexture("instructions/btn_close"),function() {
			ctx.removeInstructions();
		}));
		background.owner.addChild(closeButton);
	}
	scene.addChild(holder);
	return scene;
};
var threedracer_scenes_PreloaderScene = function() { };
$hxClasses["threedracer.scenes.PreloaderScene"] = threedracer_scenes_PreloaderScene;
threedracer_scenes_PreloaderScene.__name__ = true;
threedracer_scenes_PreloaderScene.create = function(pack,loader,messageNum) {
	if(messageNum == null) messageNum = 1;
	var scene = new flambe_Entity();
	var sW = 1028;
	var sH = 620;
	var font = new flambe_display_Font(pack,"font_preload");
	var myTextSprite = new flambe_display_TextSprite(font,"0");
	var oldPercent = 0;
	var newPercent = 0;
	myTextSprite.set_align(flambe_display_TextAlign.Right);
	myTextSprite.setXY(110,40);
	var bg = new flambe_display_PatternSprite(pack.getTexture("bg_gradient"),sW,sH);
	var pillow = new flambe_display_ImageSprite(pack.getTexture("pillow"));
	pillow.centerAnchor().setXY(sW / 2,sH / 2);
	var pillEnt = new flambe_Entity().add(pillow);
	var featherHolder = new flambe_Entity();
	scene.addChild(new flambe_Entity().add(bg));
	scene.addChild(featherHolder);
	scene.addChild(pillEnt);
	pillEnt.addChild(new flambe_Entity().add(myTextSprite));
	loader.progressChanged.connect(function() {
		newPercent = Math.round(loader.get_progress() / loader.get_total() * 100);
		if(oldPercent != newPercent) {
			myTextSprite.set_text(Std.string(newPercent));
			if(newPercent % 3 == 0) {
				var feather = new threedracer_anims_Feather(pack,sW / 2,sH / 2);
				featherHolder.addChild(new flambe_Entity().add(feather));
			}
			oldPercent = newPercent;
		}
	});
	var clickedUp = function(event) {
		var feather1 = new threedracer_anims_Feather(pack,sW / 2,sH / 2);
		featherHolder.addChild(new flambe_Entity().add(feather1));
	};
	pillow.get_pointerIn().connect(clickedUp);
	var headline = new flambe_display_ImageSprite(pack.getTexture("txt_" + messageNum));
	headline.centerAnchor().setXY(507,220).setScale(0);
	scene.addChild(new flambe_Entity().add(headline));
	headline.scaleX.animateTo(1,0.8,flambe_animation_Ease.backOut);
	headline.scaleY.animateTo(1,0.8,flambe_animation_Ease.backOut);
	var path = "preloader_roll";
	if(flambe_System.get_touch().get_supported()) path = "preloader_tap";
	var subheadline = new flambe_display_ImageSprite(pack.getTexture(path));
	subheadline.centerAnchor().setXY(507,380);
	scene.addChild(new flambe_Entity().add(subheadline));
	return scene;
};
function $iterator(o) { if( o instanceof Array ) return function() { return HxOverrides.iter(o); }; return typeof(o.iterator) == 'function' ? $bind(o,o.iterator) : o.iterator; }
var $_, $fid = 0;
function $bind(o,m) { if( m == null ) return null; if( m.__id__ == null ) m.__id__ = $fid++; var f; if( o.hx__closures__ == null ) o.hx__closures__ = {}; else f = o.hx__closures__[m.__id__]; if( f == null ) { f = function(){ return f.method.apply(f.scope, arguments); }; f.scope = o; f.method = m; o.hx__closures__[m.__id__] = f; } return f; }
Math.NaN = Number.NaN;
Math.NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
Math.POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
$hxClasses.Math = Math;
Math.isFinite = function(i) {
	return isFinite(i);
};
Math.isNaN = function(i1) {
	return isNaN(i1);
};
String.prototype.__class__ = $hxClasses.String = String;
String.__name__ = true;
$hxClasses.Array = Array;
Array.__name__ = true;
Date.prototype.__class__ = $hxClasses.Date = Date;
Date.__name__ = ["Date"];
var Int = $hxClasses.Int = { __name__ : ["Int"]};
var Dynamic = $hxClasses.Dynamic = { __name__ : ["Dynamic"]};
var Float = $hxClasses.Float = Number;
Float.__name__ = ["Float"];
var Bool = $hxClasses.Bool = Boolean;
Bool.__ename__ = ["Bool"];
var Class = $hxClasses.Class = { __name__ : ["Class"]};
var Enum = { };
Xml.Element = "element";
Xml.PCData = "pcdata";
Xml.CData = "cdata";
Xml.Comment = "comment";
Xml.DocType = "doctype";
Xml.ProcessingInstruction = "processingInstruction";
Xml.Document = "document";
flambe_display_Sprite._scratchPoint = new flambe_math_Point();
flambe_platform_html_HtmlPlatform.instance = new flambe_platform_html_HtmlPlatform();
flambe_util_SignalBase.DISPATCHING_SENTINEL = new flambe_util_SignalConnection(null,null);
flambe_System.root = new flambe_Entity();
flambe_System.uncaughtError = new flambe_util_Signal1();
flambe_System.hidden = new flambe_util_Value(false);
flambe_System.volume = new flambe_animation_AnimatedFloat(1);
flambe_System._platform = flambe_platform_html_HtmlPlatform.instance;
flambe_System._calledInit = false;
flambe_Log.logger = flambe_System.createLogger("flambe");
flambe_asset_Manifest.__meta__ = { obj : { assets : [{ mobile : [{ bytes : 141190, md5 : "cd05a0849852412b886b317de815ac79", name : "chooseracer/bed_crab.png"},{ bytes : 159909, md5 : "436dcd3692bee02c33c1348c114482a1", name : "chooseracer/bed_hotrod.png"},{ bytes : 148608, md5 : "56cb4f079295ae3906d0d7fb9c49b8dc", name : "chooseracer/bed_invincible.png"},{ bytes : 138692, md5 : "5dd28f1aecd2a9a19def9dec9794006d", name : "chooseracer/bed_patrick.png"},{ bytes : 142257, md5 : "5cde1b69a58354ca66caeff3dd7fc011", name : "chooseracer/bed_spongebob.png"},{ bytes : 134187, md5 : "b7309b422becfec334d991b20c5514db", name : "chooseracer/bed_squidward.png"},{ bytes : 17996, md5 : "1574478cb7d42990ad781046c8023c7c", name : "chooseracer/bedpost_crab.png"},{ bytes : 26176, md5 : "f8513cc99855f36b640ac916aba5d022", name : "chooseracer/bedpost_hotrod.png"},{ bytes : 17771, md5 : "98b29686a30e1e244736dfb88024219c", name : "chooseracer/bedpost_invincible.png"},{ bytes : 17566, md5 : "4ecd65d857a074ff62f43e2aef4df03f", name : "chooseracer/bedpost_patrick.png"},{ bytes : 20456, md5 : "9e76b70df75123d6c139ecdafbb3ad48", name : "chooseracer/bedpost_spongebob.png"},{ bytes : 17612, md5 : "24bf38b8d185f53d37fb6e7446a6baff", name : "chooseracer/bedpost_squidward.png"},{ bytes : 19085, md5 : "c55b9fc20426cdf1b029decd4665102a", name : "chooseracer/btn_choose.png"},{ bytes : 27423, md5 : "415fe2fc12826053451ca2b815622991", name : "chooseracer/btn_choose_over.png"},{ bytes : 10207, md5 : "b245848686ef7e8374d54aefc1d72a8b", name : "chooseracer/btn_left.png"},{ bytes : 8124, md5 : "222fcca0ef53e914c1656c2d0b0fe9ff", name : "chooseracer/btn_left_over.png"},{ bytes : 10297, md5 : "a4a488b212a7e9ce0033c1e2543d4291", name : "chooseracer/btn_right.png"},{ bytes : 8122, md5 : "39599fffea7966bd033f2e2ded6d4ea8", name : "chooseracer/btn_right_over.png"},{ bytes : 53588, md5 : "2d021061628a6a8a28253d5ac1f6fdd3", name : "chooseracer/crab.png"},{ bytes : 9133, md5 : "9413ad57608f7f58a15f1ae1af551baa", name : "chooseracer/crab_text.png"},{ bytes : 3810, md5 : "8203f8caaf2b4f58bc4d6ed94ce92aa5", name : "chooseracer/flags.png"},{ bytes : 90819, md5 : "8e735bb5e223c91256db21de0da09a74", name : "chooseracer/headline.png"},{ bytes : 44045, md5 : "0dc64f3a167652dc63cd2cd509342e02", name : "chooseracer/patrick.png"},{ bytes : 7560, md5 : "5f16ec1de62c0dcca0404b76ef342399", name : "chooseracer/patrick_text.png"},{ bytes : 40192, md5 : "6dbec21d03bd52a5551d07c5a9895588", name : "chooseracer/pillows.png"},{ bytes : 59046, md5 : "1b00f3697ed0ee747f4789e3fe7ff448", name : "chooseracer/spongebob.png"},{ bytes : 5697, md5 : "f47a5448181f027f6fc5163030e2cda6", name : "chooseracer/spongebob_arm.png"},{ bytes : 9944, md5 : "1ca9a887cbac72acccec992d066b94d1", name : "chooseracer/spongebob_text.png"},{ bytes : 41484, md5 : "13dd11193ca7345045e2332437e68ea3", name : "chooseracer/squidward.png"},{ bytes : 9806, md5 : "b13ccb5459bd1bb94adb5e10e5e4462e", name : "chooseracer/squidward_text.png"},{ bytes : 9454, md5 : "46d286249661f245c4afc27e9b8a36a9", name : "chooseracer/stars.png"},{ bytes : 14774, md5 : "00d27059fb7f1e77f00d2bd8d5562fdc", name : "end/btn_play.png"},{ bytes : 21767, md5 : "7d8086ff76fa9cf3ae2aca09b3285932", name : "end/btn_play_over.png"},{ bytes : 135170, md5 : "b58ef16bc6269480e8fa108d01964c38", name : "end/crab.png"},{ bytes : 185159, md5 : "a20b015731187893ec31644cbcf78f10", name : "end/crab_hotrod.png"},{ bytes : 6143, md5 : "0e8312a24007baa0e934d15d94f29922", name : "end/crab_score.png"},{ bytes : 146293, md5 : "3c55b4a07ab23d433ef8040526c2b19f", name : "end/crab_star.png"},{ bytes : 170395, md5 : "8062f5a2b9dcef6a70fbc8658dbec38c", name : "end/end_bg1.png"},{ bytes : 162854, md5 : "01b4323595bc83f830d762538867172b", name : "end/end_bg2.png"},{ bytes : 1359, md5 : "4996791c44b28f58bf142869ef17ab4b", name : "end/first_score.png"},{ bytes : 1360, md5 : "91ea35f70472de23bdf49795e05135ab", name : "end/first_score_me.png"},{ bytes : 1369, md5 : "cd3eb5be8640f94ba988cc1ba294d22a", name : "end/fourth_score.png"},{ bytes : 1367, md5 : "52fa2180dab0bab8da180409418607e7", name : "end/fourth_score_me.png"},{ bytes : 72766, md5 : "a8bd7809d854ca51406fa0e2fd62070a", name : "end/headline.png"},{ bytes : 121691, md5 : "da99e5842009039d75cb578dbfbf7d26", name : "end/patrick.png"},{ bytes : 165015, md5 : "dc85afa5818b9cfece7cef4521efe2da", name : "end/patrick_hotrod.png"},{ bytes : 4997, md5 : "96cb0bd3904f1ebbbd2f2ecd23ce1aa2", name : "end/patrick_score.png"},{ bytes : 144831, md5 : "e9c8a3409899721aae5122fecd991f8b", name : "end/patrick_star.png"},{ bytes : 1505, md5 : "15dafc2383273c982ccf88cae7fab7cd", name : "end/second_score.png"},{ bytes : 1504, md5 : "0a86b5e2d772975b90ce8164e19ff9f1", name : "end/second_score_me.png"},{ bytes : 152542, md5 : "ffccdbe5ddfff104712786fca59ebb3e", name : "end/spongebob.png"},{ bytes : 206583, md5 : "d3802015ba88fce86d736b1bbec692c9", name : "end/spongebob_hotrod.png"},{ bytes : 6864, md5 : "43eb32919748e16b2de322d5e42c3917", name : "end/spongebob_score.png"},{ bytes : 166849, md5 : "ba62cf6ed14a4f46caec90a79d2bb692", name : "end/spongebob_star.png"},{ bytes : 131541, md5 : "691257d4d6645c16be760c11da0c808d", name : "end/squidward.png"},{ bytes : 189824, md5 : "86c4d525e6592649c0cb7bce83fdc07c", name : "end/squidward_hotrod.png"},{ bytes : 4982, md5 : "51a4f31465ab7b287e2084bee78ffbed", name : "end/squidward_score.png"},{ bytes : 147938, md5 : "00fe4d19b710504ab7dec792399e3ea0", name : "end/squidward_star.png"},{ bytes : 1600, md5 : "d9c666db70a6ea1aadc9cca47318142d", name : "end/third_score.png"},{ bytes : 1600, md5 : "15f572b933822e8d0b162cd39914314a", name : "end/third_score_me.png"},{ bytes : 2023, md5 : "340fccf4bc4843dad65011dfb7974fa2", name : "feather-1.png"},{ bytes : 1699, md5 : "239c3a21dd0e96147560c3412382a8b2", name : "feather-2.png"},{ bytes : 3120, md5 : "93f472bc04753f6d640d503352e05d48", name : "finishstar.png"},{ bytes : 12020, md5 : "41c9651f17260e54dfa1714f85d947a2", name : "fonts/BonusTxt.fnt"},{ bytes : 30036, md5 : "7431cc42c16824474ad9d13d22f2299c", name : "fonts/BonusTxt.png"},{ bytes : 12023, md5 : "f1085f9ecf08af337b2360b21e055dff", name : "fonts/BonusTxtErr.fnt"},{ bytes : 32284, md5 : "02baeae8936b0bca50469b34b80caecd", name : "fonts/BonusTxtErr.png"},{ bytes : 12028, md5 : "b32e8ebaa230a2a72894b55541cab9d4", name : "fonts/BonusTxtErrLarge.fnt"},{ bytes : 54011, md5 : "eb1ea4b3c748a00169726ba14ede84c8", name : "fonts/BonusTxtErrLarge.png"},{ bytes : 12025, md5 : "54db9f2a2e830c3fb601690c318298e0", name : "fonts/BonusTxtLarge.fnt"},{ bytes : 50756, md5 : "88b42e6650bd3523b4f524619627cda1", name : "fonts/BonusTxtLarge.png"},{ bytes : 2348, md5 : "e9f8f7153af0d66c00032c52e3023d21", name : "fonts/endscore.fnt"},{ bytes : 7117, md5 : "85e23213e3fccc67db47a0a7c92aeb90", name : "fonts/endscore.png"},{ bytes : 2355, md5 : "fee429c3385ddb62aea095b71fbcaf77", name : "fonts/endscore_yellow.fnt"},{ bytes : 10298, md5 : "82089e4fe2c65c2336691f1f34cd3f81", name : "fonts/endscore_yellow.png"},{ bytes : 2470, md5 : "26aba01678f91b7d5bda227a4b56275e", name : "fonts/LapTxt.fnt"},{ bytes : 8699, md5 : "52cc19360fbf6d0c67d621b3de602683", name : "fonts/LapTxt.png"},{ bytes : 2348, md5 : "205d4eaed7f981d891eeecdc8c37d508", name : "fonts/TimerTxt.fnt"},{ bytes : 14013, md5 : "c2d1aeb60917ed8a3560ca4e916f5f60", name : "fonts/TimerTxt.png"},{ bytes : 7154, md5 : "66db5a4fb995733d488bec28e1e217d9", name : "home/btn_code.png"},{ bytes : 16075, md5 : "81797e761acbeb8837282137f0ecc310", name : "home/btn_code_large.png"},{ bytes : 16736, md5 : "c1a96d513e6db05e5652440102ee94f1", name : "home/btn_code_large_over.png"},{ bytes : 7466, md5 : "1f149ae2a09fc038e6f67dbfc91a7f7c", name : "home/btn_code_over.png"},{ bytes : 17640, md5 : "b3b90f9b5cb81e47f1ee0b287eb12769", name : "home/btn_enteragain.png"},{ bytes : 45423, md5 : "89f5f68e7f0e5c97d1091c9da4c37e01", name : "home/btn_enteragain_large.png"},{ bytes : 46354, md5 : "c4a3e3ea5529218636edb339f7ad50d5", name : "home/btn_enteragain_large_over.png"},{ bytes : 17997, md5 : "dbd661d3ac07c586608b597c66419cb8", name : "home/btn_enteragain_over.png"},{ bytes : 3189, md5 : "1681d71b6ec8d2e223f8597a615d182e", name : "home/btn_sound_off.png"},{ bytes : 3145, md5 : "6bb19dcac3911731d221e3ddde64ca9c", name : "home/btn_sound_off_over.png"},{ bytes : 3765, md5 : "75981b9d0c0e14a0f7af96605566886a", name : "home/btn_sound_on.png"},{ bytes : 3613, md5 : "27ba4380e86c4e189cb7af76dfd02c3c", name : "home/btn_sound_on_over.png"},{ bytes : 26918, md5 : "fb525d14c07967270491b05e3cd4f1e5", name : "home/btn_start.png"},{ bytes : 28268, md5 : "1e11b382514aded37228c8400a60f2c6", name : "home/btn_start_over.png"},{ bytes : 36424, md5 : "f5a84e099546111d97d2f79f37a1830e", name : "home/code_bg.png"},{ bytes : 71049, md5 : "0e1058a2eda41952bb8ad58ac7644923", name : "home/code_bg_large.png"},{ bytes : 23877, md5 : "0f625243311438ddde454eebcd4fd417", name : "home/code_success.png"},{ bytes : 54695, md5 : "c2b7b75638a144029d5d0539f5a7adb0", name : "home/code_success_large.png"},{ bytes : 192069, md5 : "20429ca967c1842f1d7e73d9dbda231e", name : "home/headline.png"},{ bytes : 247478, md5 : "c08eff1ed3868e77a4fb21d1f5d7cc01", name : "home/home_bg1.png"},{ bytes : 248136, md5 : "5fd195594dc1a513243e47ac820ada0b", name : "home/home_bg2.png"},{ bytes : 44398, md5 : "b6d33351cc9360e74f83ecb73f6e4aa9", name : "home/patrick.png"},{ bytes : 7164, md5 : "8474c2943205cb5510287d8482be24c3", name : "home/powerup_entertwice.png"},{ bytes : 14654, md5 : "5bb6882ed2b5103645946173c5873da5", name : "home/powerup_entertwice_large.png"},{ bytes : 154852, md5 : "bf40d179feba8bb38dd3f4ae3c23440c", name : "home/road1.png"},{ bytes : 92227, md5 : "c014bfd948a75058c33eaea0959ec300", name : "home/road2.png"},{ bytes : 190161, md5 : "78ae1386950f95379e53266c8e965825", name : "home/spongebob.png"},{ bytes : 10103, md5 : "d10b6cdce10eba31e4f7a2693e38351f", name : "home/txt_bonus1.png"},{ bytes : 19941, md5 : "5c9badeea76481252c3ee2845929fdf0", name : "home/txt_bonus1_large.png"},{ bytes : 10274, md5 : "838c28c7e9db1af6b7e7b0ca35734eaf", name : "home/txt_bonus2.png"},{ bytes : 20228, md5 : "47628ba1e316578af83b41db087c2dbd", name : "home/txt_bonus2_large.png"},{ bytes : 10470, md5 : "c086f2d7c7dffeac7e8c142d98e97ae3", name : "home/txt_bonus3.png"},{ bytes : 20572, md5 : "0cd51aa1d06ade6a37cc7ddec7616e35", name : "home/txt_bonus3_large.png"},{ bytes : 2070, md5 : "b49c0e6435aea7b05e036963acff5785", name : "instructions/btn_close.png"},{ bytes : 30167, md5 : "f09ab664ec0b49958cd33620fbce2083", name : "instructions/btn_start.png"},{ bytes : 31592, md5 : "25d1b5eea5fe40fec8d7adcb09ed0305", name : "instructions/btn_start_over.png"},{ bytes : 73001, md5 : "ca0db47526400205d5d8adad594aa810", name : "instructions/instructions.png"},{ bytes : 78477, md5 : "da469b1e75a8d4b237b490453429ad3f", name : "instructions/instructions_mobile.png"},{ bytes : 734405, md5 : "87267b9b5d9ff2cf2ee95c9dc045a5d3", name : "sounds/bgmusic_start.mp3"},{ bytes : 10577, md5 : "897de292110800dec8d8c85a35beb0ac", name : "sounds/buttonclick.mp3"},{ bytes : 18427, md5 : "069287ee65b1652fa15ebfdffa332eb3", name : "sounds/buttonclick2.mp3"},{ bytes : 21302, md5 : "02aa02a6c254787abeecbf79a638114c", name : "sounds/rank.mp3"}], mobile_game50 : [{ bytes : 21252, md5 : "5877b1d4a01b8121aabe67941261b04b", name : "closeconfirm/background.png"},{ bytes : 15095, md5 : "c33c8b44382c57ffc9c38a9d4c9dda76", name : "closeconfirm/btn_no.png"},{ bytes : 15995, md5 : "0121a6cafd0a1a6be83b470c38d05d53", name : "closeconfirm/btn_no_over.png"},{ bytes : 17034, md5 : "7dfafbb5a21377d4475e4629bac9c2dd", name : "closeconfirm/btn_yes.png"},{ bytes : 17986, md5 : "6b2fc243f1c277481122f872bdd8f772", name : "closeconfirm/btn_yes_over.png"},{ bytes : 3323, md5 : "8e57105fb868e34f74c9f3f47f512c55", name : "feather-1.png"},{ bytes : 3175, md5 : "3174ac8a3452d61eeb13c3fc93782e1a", name : "feather-2.png"},{ bytes : 3737, md5 : "868ff1d44ccb1683bf41bead47d9b841", name : "finishstar.png"},{ bytes : 12020, md5 : "41c9651f17260e54dfa1714f85d947a2", name : "fonts/BonusTxt.fnt"},{ bytes : 30036, md5 : "7431cc42c16824474ad9d13d22f2299c", name : "fonts/BonusTxt.png"},{ bytes : 12023, md5 : "f1085f9ecf08af337b2360b21e055dff", name : "fonts/BonusTxtErr.fnt"},{ bytes : 32284, md5 : "02baeae8936b0bca50469b34b80caecd", name : "fonts/BonusTxtErr.png"},{ bytes : 12028, md5 : "b32e8ebaa230a2a72894b55541cab9d4", name : "fonts/BonusTxtErrLarge.fnt"},{ bytes : 54011, md5 : "eb1ea4b3c748a00169726ba14ede84c8", name : "fonts/BonusTxtErrLarge.png"},{ bytes : 12025, md5 : "54db9f2a2e830c3fb601690c318298e0", name : "fonts/BonusTxtLarge.fnt"},{ bytes : 50756, md5 : "88b42e6650bd3523b4f524619627cda1", name : "fonts/BonusTxtLarge.png"},{ bytes : 2348, md5 : "e9f8f7153af0d66c00032c52e3023d21", name : "fonts/endscore.fnt"},{ bytes : 7117, md5 : "85e23213e3fccc67db47a0a7c92aeb90", name : "fonts/endscore.png"},{ bytes : 2355, md5 : "fee429c3385ddb62aea095b71fbcaf77", name : "fonts/endscore_yellow.fnt"},{ bytes : 10298, md5 : "82089e4fe2c65c2336691f1f34cd3f81", name : "fonts/endscore_yellow.png"},{ bytes : 2470, md5 : "26aba01678f91b7d5bda227a4b56275e", name : "fonts/LapTxt.fnt"},{ bytes : 8699, md5 : "52cc19360fbf6d0c67d621b3de602683", name : "fonts/LapTxt.png"},{ bytes : 2348, md5 : "205d4eaed7f981d891eeecdc8c37d508", name : "fonts/TimerTxt.fnt"},{ bytes : 14013, md5 : "c2d1aeb60917ed8a3560ca4e916f5f60", name : "fonts/TimerTxt.png"},{ bytes : 93380, md5 : "7ec0b728b575bddd6905b1ca5a3251be", name : "game/bg_hills.png"},{ bytes : 89407, md5 : "0c493f298bae15db853aec72ed7d7827", name : "game/bg_sky_left.png"},{ bytes : 88828, md5 : "d509d9160b304a0c21a0cbafd4acac18", name : "game/bg_sky_mid.png"},{ bytes : 90835, md5 : "2d146db3b2a46f3254b02c3597fb44c0", name : "game/bg_sky_right.png"},{ bytes : 45173, md5 : "dcbf8169ddf4323eac98204be5015e45", name : "game/bg_trees.png"},{ bytes : 12789, md5 : "6de5166c4106f3c1300ba9a471a9ed81", name : "game/books.png"},{ bytes : 2916, md5 : "7650ff1d258274108c5cb51d06184ba0", name : "game/btn_close.png"},{ bytes : 11348, md5 : "d11cb8863363a58f331c30223e160afa", name : "game/clock.png"},{ bytes : 20213, md5 : "49a7c43f652d8b67eddc159317694904", name : "game/crab/left_down.png"},{ bytes : 22202, md5 : "f32a51c5826f80788fdc8ca5deca153e", name : "game/crab/left_mid.png"},{ bytes : 24113, md5 : "6b74916436986059117be322e6588842", name : "game/crab/left_up.png"},{ bytes : 20645, md5 : "d7fa799e9b02413522e81d5e5d63bb74", name : "game/crab/right_down.png"},{ bytes : 22091, md5 : "01f65f49a48fe4112d62d5e1f1759cee", name : "game/crab/right_mid.png"},{ bytes : 23800, md5 : "3167243f8b96b9756d68f23c1884407d", name : "game/crab/right_up.png"},{ bytes : 20821, md5 : "f1d7a20d6fb370036068cacd69ca8f12", name : "game/crab/straight_down.png"},{ bytes : 22542, md5 : "5c233974adecce4d7e25f69aa442abe2", name : "game/crab/straight_mid.png"},{ bytes : 24319, md5 : "c7b0568f4ce3cbab0a884fdc1c135709", name : "game/crab/straight_up.png"},{ bytes : 3344, md5 : "a9cf332dbd503d9c805407bf15c26b3c", name : "game/flag.png"},{ bytes : 10730, md5 : "0600fffbf1ab969f21f247b38f345611", name : "game/hole.png"},{ bytes : 21943, md5 : "e86f3ccc6cdcfee9db9e5c2e112a1149", name : "game/hotrod_crab/left_down.png"},{ bytes : 23695, md5 : "8e2f0f08330df3bb367d98401a70d0e1", name : "game/hotrod_crab/left_mid.png"},{ bytes : 25453, md5 : "fb97796626541257f2ad5db559b79d02", name : "game/hotrod_crab/left_up.png"},{ bytes : 22067, md5 : "4f006b067bdc82c1754c779cf294cb28", name : "game/hotrod_crab/right_down.png"},{ bytes : 23918, md5 : "196628877d8a49096a040a64dcb8e845", name : "game/hotrod_crab/right_mid.png"},{ bytes : 25854, md5 : "def93192303531f7aed94202f2654754", name : "game/hotrod_crab/right_up.png"},{ bytes : 22015, md5 : "0f111eddbe5db827b8ed6d61459478ff", name : "game/hotrod_crab/straight_down.png"},{ bytes : 24029, md5 : "5cd0af9d75b9b475eb5c5d3e5f165ad1", name : "game/hotrod_crab/straight_mid.png"},{ bytes : 25571, md5 : "4be6ec2e664f024f7002e8ed71cd4718", name : "game/hotrod_crab/straight_up.png"},{ bytes : 20274, md5 : "76cb8117e0b6d90116cdd192f5653310", name : "game/hotrod_patrick/left_down.png"},{ bytes : 22136, md5 : "6fc6a774f85b5d2c5fccc00d4faf939f", name : "game/hotrod_patrick/left_mid.png"},{ bytes : 23781, md5 : "84d34eac9575871067ec8c9b01981557", name : "game/hotrod_patrick/left_up.png"},{ bytes : 20442, md5 : "2a8d00da0b1b2ec872df4439b126e6cd", name : "game/hotrod_patrick/right_down.png"},{ bytes : 22162, md5 : "f7278db00bdab2877c1a8797724b5901", name : "game/hotrod_patrick/right_mid.png"},{ bytes : 24085, md5 : "9719be094344bb9be83aef2de7c05c37", name : "game/hotrod_patrick/right_up.png"},{ bytes : 20431, md5 : "9f0a5629c34b8ed40e2d62aff0aec0bb", name : "game/hotrod_patrick/straight_down.png"},{ bytes : 22188, md5 : "e7d52bbd18fab28f72d84ffbc5c2873b", name : "game/hotrod_patrick/straight_mid.png"},{ bytes : 23674, md5 : "80ebbf499f1420d8394f184f984a59e8", name : "game/hotrod_patrick/straight_up.png"},{ bytes : 20843, md5 : "382e53fd57529357ff26ff4a51e5785e", name : "game/hotrod_spongebob/left_down.png"},{ bytes : 22513, md5 : "9a398dadd51cfdb97afcc81f526ab6af", name : "game/hotrod_spongebob/left_mid.png"},{ bytes : 23615, md5 : "bd0abfd7f3b2b2054b6ee4eae08e35aa", name : "game/hotrod_spongebob/left_up.png"},{ bytes : 20953, md5 : "e6037d8dbefd459525a0e84d328c6271", name : "game/hotrod_spongebob/right_down.png"},{ bytes : 22559, md5 : "46f95ce29753da8f1267e0c0dc45a16a", name : "game/hotrod_spongebob/right_mid.png"},{ bytes : 23907, md5 : "a01108c3da823927b65aa880b621d568", name : "game/hotrod_spongebob/right_up.png"},{ bytes : 20622, md5 : "af06f2ab25faf469b764d5094ef14f5d", name : "game/hotrod_spongebob/straight_down.png"},{ bytes : 22556, md5 : "92902e2dcb317a1f046c306a4af9c359", name : "game/hotrod_spongebob/straight_mid.png"},{ bytes : 23529, md5 : "416bc3ff5dce0478c8a32e8e02c89d64", name : "game/hotrod_spongebob/straight_up.png"},{ bytes : 22164, md5 : "58af332d1701dfa680be3921f1d8f3bc", name : "game/hotrod_squidward/left_down.png"},{ bytes : 24034, md5 : "cdf12233193f7095723f492f9ffca32d", name : "game/hotrod_squidward/left_mid.png"},{ bytes : 25776, md5 : "1baa3ea2693d1213f798aee20bc9bf2e", name : "game/hotrod_squidward/left_up.png"},{ bytes : 22233, md5 : "8708bf72a3b11eb6573534772e524a8d", name : "game/hotrod_squidward/right_down.png"},{ bytes : 24013, md5 : "8da3ce9c4103c7d50652935651c34baf", name : "game/hotrod_squidward/right_mid.png"},{ bytes : 26004, md5 : "95a1a932a99bb98ab25134efb771694e", name : "game/hotrod_squidward/right_up.png"},{ bytes : 22156, md5 : "747ba8812a853f5e6f60454df5c78b0c", name : "game/hotrod_squidward/straight_down.png"},{ bytes : 24136, md5 : "70a458a628b3b0ef5926685aadb0bf08", name : "game/hotrod_squidward/straight_mid.png"},{ bytes : 25542, md5 : "ea0b409188f11803bf5009e3574408ce", name : "game/hotrod_squidward/straight_up.png"},{ bytes : 8167, md5 : "6b3187fe76c7e2434550f51637439812", name : "game/lightning.png"},{ bytes : 1532, md5 : "c02b6e635716051c28470b436b275a63", name : "game/mobile_btn_help.png"},{ bytes : 1475, md5 : "f1e95282067d828f33400b0a2f9950e9", name : "game/mobile_btn_help_over.png"},{ bytes : 1229, md5 : "021841e01c7011b83ab65aeab7325fda", name : "game/mobile_btn_sound_off.png"},{ bytes : 1218, md5 : "5cb17da0d9b243813e4d1f796de0757a", name : "game/mobile_btn_sound_off_over.png"},{ bytes : 1659, md5 : "712cf2f26c6e2e14716713a7f6457e5d", name : "game/mobile_btn_sound_on.png"},{ bytes : 1578, md5 : "79fa20839298354ebac39bd1b50f7433", name : "game/mobile_btn_sound_on_over.png"},{ bytes : 16236, md5 : "dab88afe2fb29c5c2b1ea35f1446ec08", name : "game/mobile_ui.png"},{ bytes : 19112, md5 : "941a2f0e780cd9515a2a7522e7c20f27", name : "game/moon.png"},{ bytes : 410, md5 : "7c3e0bd4d41b94f559c6c99eee11882d", name : "game/particles/bubble.png"},{ bytes : 1369, md5 : "9280e2001c21a4da81a8d56895bf090a", name : "game/particles/bubbles.pex"},{ bytes : 1366, md5 : "df3e96b6b48cab515988fc92558d62e0", name : "game/particles/bubbles_front.pex"},{ bytes : 1370, md5 : "8a3a3c86a589cbc35f681a427083f927", name : "game/particles/bubbles_npc.pex"},{ bytes : 1365, md5 : "b3298b37a1bf7fe1817dddd3c30406cf", name : "game/particles/bubbles_spin.pex"},{ bytes : 1376, md5 : "7842676766feaf7ed1e8a2fafe2f2ab8", name : "game/particles/bubbles_turbo.pex"},{ bytes : 1372, md5 : "a3d55daac869940f797341351093c780", name : "game/particles/bubbles_turbo_front.pex"},{ bytes : 1308, md5 : "af708314cc05e80c56cef89c1c2bacc8", name : "game/particles/bubbleYellow.png"},{ bytes : 18676, md5 : "0a3667ba3eebb94fa891232760f5f59a", name : "game/patrick/left_down.png"},{ bytes : 20554, md5 : "10d14f550f9361a8fb7d8fe2b5057a63", name : "game/patrick/left_mid.png"},{ bytes : 22465, md5 : "858dfd0468c20133529a1c68be9b7fdc", name : "game/patrick/left_up.png"},{ bytes : 19040, md5 : "901766e01f1da9ea8aad5cc5be0ba03a", name : "game/patrick/right_down.png"},{ bytes : 20276, md5 : "a03be565920ee62dcbe74f04c6fdacf6", name : "game/patrick/right_mid.png"},{ bytes : 22134, md5 : "085ecf87ecfba1efba1fc396883f859a", name : "game/patrick/right_up.png"},{ bytes : 19080, md5 : "0397daf9c60c925f9a203e06b704af4c", name : "game/patrick/straight_down.png"},{ bytes : 20727, md5 : "9cf4c13792de7928b9c648867a62033c", name : "game/patrick/straight_mid.png"},{ bytes : 22283, md5 : "cf86fdbe7770c3d41dbd8682b2f1449b", name : "game/patrick/straight_up.png"},{ bytes : 5324, md5 : "93ecc6d63f961c80fda7c67fa4a3b113", name : "game/pillow.png"},{ bytes : 5526, md5 : "85942d8f775b1b56caf1e4b5f7a73f7e", name : "game/pillow_left.png"},{ bytes : 5500, md5 : "e894721825be52a22ab0134854d0059e", name : "game/pillow_right.png"},{ bytes : 7515, md5 : "cf22990fbe6833f945091d657d93024b", name : "game/place_1.png"},{ bytes : 8279, md5 : "3f57b67b93b284f184504b70783ad578", name : "game/place_2.png"},{ bytes : 8812, md5 : "0f38b710c7ea598757c0bb574fa6edd2", name : "game/place_3.png"},{ bytes : 7133, md5 : "4710f886c8e3a8bbfda1d0a9707cae26", name : "game/place_4.png"},{ bytes : 5508, md5 : "2b57b25292128c86ed3b2664ca131ac7", name : "game/place_empty.png"},{ bytes : 9642, md5 : "95007be51f041f0cb8f7e6979f5b737a", name : "game/powerup_pillow.png"},{ bytes : 19038, md5 : "6ee116deaf3fcfa9568f2d32954d5763", name : "game/ramp_large.png"},{ bytes : 10739, md5 : "d61655d60e1e1dd82ae01f5bd10f5985", name : "game/ramp_small.png"},{ bytes : 25560, md5 : "f4960ee9864242a048f1759b888231cc", name : "game/ring.png"},{ bytes : 39021, md5 : "a5c552cf4a891ba07498ce2893d04f07", name : "game/ring_finish.png"},{ bytes : 35779, md5 : "229f0edde05ad86f48a6bdcadfe653a0", name : "game/ring_lap1.png"},{ bytes : 36418, md5 : "d9f849878a362ed2d41b03db54e77816", name : "game/ring_lap2.png"},{ bytes : 36650, md5 : "fac687b5eab67b49e0de71a2febf932c", name : "game/ring_lap3.png"},{ bytes : 38181, md5 : "b8d365bc8cc83a2f1f8c84a61652e48b", name : "game/ring_start.png"},{ bytes : 2551, md5 : "d467d6c9a2a900acdb2bfcd3e71b8a7e", name : "game/road/rail_left.png"},{ bytes : 2472, md5 : "3cb70ca0a719ebda02117fde864dd2d3", name : "game/road/rail_right.png"},{ bytes : 1314, md5 : "8bf795593ccec0d5b337fc48abf7163c", name : "game/road/road_left.png"},{ bytes : 2221, md5 : "ab31169be696dd97922f8f5096ab08fb", name : "game/road/road_mobile.png"},{ bytes : 1347, md5 : "7435b42e341c87ce2b4339f6bc632156", name : "game/road/road_right.png"},{ bytes : 14674, md5 : "0b3dda4d20ea5103286a6ccf6bb3deae", name : "game/scoreboard.png"},{ bytes : 11318, md5 : "a09ef9e3adc3a584e9e2a74a0c79b7c8", name : "game/sheep.png"},{ bytes : 10446, md5 : "763ce2b8ce22fb376865015623ecd485", name : "game/spatula.png"},{ bytes : 14786, md5 : "bd1cf0426ff86a407ed46eac143535aa", name : "game/spatulagroup.png"},{ bytes : 19294, md5 : "b9fd8dfcbd67507cb7fb20113a90479e", name : "game/spongebob/left_down.png"},{ bytes : 18742, md5 : "5876f4e61840795b5a4446890d4cd534", name : "game/spongebob/left_down2.png"},{ bytes : 20734, md5 : "221e8979653122be840ccb4e4e5918a0", name : "game/spongebob/left_mid.png"},{ bytes : 21912, md5 : "e8abdb201504e721b36651c0666cf270", name : "game/spongebob/left_mid2.png"},{ bytes : 21171, md5 : "fd1f01869f4daa263f982e5e5b398a15", name : "game/spongebob/left_up.png"},{ bytes : 22411, md5 : "0c85cce1b0080c2fb8f0d9eb8f84f53a", name : "game/spongebob/left_up2.png"},{ bytes : 19476, md5 : "0aa651e92e4fe61ffcdc2eab751c0ff0", name : "game/spongebob/right_down.png"},{ bytes : 19211, md5 : "856161e539f76528573d309a43b7f006", name : "game/spongebob/right_down2.png"},{ bytes : 20427, md5 : "b74954d42872fa932c76b1626f430147", name : "game/spongebob/right_mid.png"},{ bytes : 21943, md5 : "94c1f1dac48e111c392b04a4b7c4de0c", name : "game/spongebob/right_mid2.png"},{ bytes : 21532, md5 : "2c8fdb69b67dd3b628cfd0909fc53ff1", name : "game/spongebob/right_up.png"},{ bytes : 23140, md5 : "1068f61caddb50577f54b0c5b72cd12b", name : "game/spongebob/right_up2.png"},{ bytes : 19232, md5 : "d0580af5ce85dfe7ad2769f50933dfa8", name : "game/spongebob/straight_down.png"},{ bytes : 20543, md5 : "d4d81db7f0155eeb1910a1a26bc5ff8b", name : "game/spongebob/straight_mid.png"},{ bytes : 21497, md5 : "a4c45b33a1c13700a2b3ff98a2cbbe96", name : "game/spongebob/straight_up.png"},{ bytes : 19758, md5 : "02c9df5b908a4ea03d1119bb71b538c5", name : "game/squidward/left_down.png"},{ bytes : 21637, md5 : "35545a5ea88b3991c435eea55df623c7", name : "game/squidward/left_mid.png"},{ bytes : 23493, md5 : "bd1a87c8acb434752102a10467f6f170", name : "game/squidward/left_up.png"},{ bytes : 19893, md5 : "1ff2c06263b9ed583c16c1636059f786", name : "game/squidward/right_down.png"},{ bytes : 21205, md5 : "516a19ddb0a6c72515d2f037161490e6", name : "game/squidward/right_mid.png"},{ bytes : 23148, md5 : "92cd27f0649853584659e1ea41e97e6f", name : "game/squidward/right_up.png"},{ bytes : 20091, md5 : "d5e6d9c52f021d4ccb036190e2a38d58", name : "game/squidward/straight_down.png"},{ bytes : 21711, md5 : "f6467c54563e9f6beb3aaf7ae5629404", name : "game/squidward/straight_mid.png"},{ bytes : 23270, md5 : "2b40353c721e9fecbf8f067ecba3363b", name : "game/squidward/straight_up.png"},{ bytes : 4111, md5 : "b1b3f9dfb5ad9dc7995a83aa0599bb04", name : "game/star1.png"},{ bytes : 4465, md5 : "39f3d5f9bb62c4620d88dfda77647e2a", name : "game/star2.png"},{ bytes : 4626, md5 : "d0488211c81f3185d8d1b9c8667d3bff", name : "game/star3.png"},{ bytes : 24979, md5 : "d9ba84ed42f8d295559e6253a4a73e75", name : "game/star_crab/left_down.png"},{ bytes : 27779, md5 : "3d4cc52ba1535c21a34a3852a15b9499", name : "game/star_crab/left_mid.png"},{ bytes : 29824, md5 : "4d55b24cd6a6db8d9383ea0febc8519d", name : "game/star_crab/left_up.png"},{ bytes : 25257, md5 : "c4885a20d6f1ee1d9c58e8effd70eff7", name : "game/star_crab/right_down.png"},{ bytes : 27897, md5 : "f29b8b4477797ceeccb64d10a1a836fa", name : "game/star_crab/right_mid.png"},{ bytes : 29840, md5 : "d6835bf84482e7dc6cc43be5943c4ad4", name : "game/star_crab/right_up.png"},{ bytes : 23612, md5 : "cdf0e669a5b1cf231a461595da654234", name : "game/star_crab/straight_down.png"},{ bytes : 26560, md5 : "5a9529fb8f2571734679c0e1d5dc5498", name : "game/star_crab/straight_mid.png"},{ bytes : 28701, md5 : "d95f5179268b3c2710c5f2639c77b1ba", name : "game/star_crab/straight_up.png"},{ bytes : 23020, md5 : "bbc786031f19ad1af50001752ffaf228", name : "game/star_patrick/left_down.png"},{ bytes : 25576, md5 : "80ee78fe47f18e43d35bfaa0ad8c3adc", name : "game/star_patrick/left_mid.png"},{ bytes : 27332, md5 : "9db1837c98686c3a1b648c2384877fd6", name : "game/star_patrick/left_up.png"},{ bytes : 23180, md5 : "cd4119bdec58865c8b5097fe6f627beb", name : "game/star_patrick/right_down.png"},{ bytes : 25586, md5 : "c5b407312253832b2f72545f565f75ad", name : "game/star_patrick/right_mid.png"},{ bytes : 27382, md5 : "9c6ff2a53158004f899ebee0783536ff", name : "game/star_patrick/right_up.png"},{ bytes : 21397, md5 : "f9b6d3effcad1cdfb57c5ed176f155d1", name : "game/star_patrick/straight_down.png"},{ bytes : 24188, md5 : "3c2a4261d38033d089527e3e54a9028e", name : "game/star_patrick/straight_mid.png"},{ bytes : 26226, md5 : "384c671bc19b5331c08ec2dc90bdf702", name : "game/star_patrick/straight_up.png"},{ bytes : 23903, md5 : "a65d3dc1171b44cf34c0467419554c51", name : "game/star_spongebob/left_down.png"},{ bytes : 25742, md5 : "6c56c0e6197df1ac3ab9a3fac9060dbf", name : "game/star_spongebob/left_mid.png"},{ bytes : 27688, md5 : "2ef9dcfaa877041d12504b24fa87751b", name : "game/star_spongebob/left_up.png"},{ bytes : 23938, md5 : "d97ec281debebb4fc2d4e58e6f079d4c", name : "game/star_spongebob/right_down.png"},{ bytes : 25939, md5 : "9ae1d29bb80d366060f3ee1dd8e0e1c2", name : "game/star_spongebob/right_mid.png"},{ bytes : 27475, md5 : "4827391b3ba2e6ee8faced09d85f8a74", name : "game/star_spongebob/right_up.png"},{ bytes : 22098, md5 : "b6e84e298e69c191a5846bcbe0efe58f", name : "game/star_spongebob/straight_down.png"},{ bytes : 24201, md5 : "d969e4ef4fa87dff4a1d32b1b6e2c855", name : "game/star_spongebob/straight_mid.png"},{ bytes : 26082, md5 : "808de409d9b39e8ddd2584fb43e5c6cb", name : "game/star_spongebob/straight_up.png"},{ bytes : 25427, md5 : "c7512b16d73365d953378164088c9be8", name : "game/star_squidward/left_down.png"},{ bytes : 27748, md5 : "2929c6edf90100b8908bdc10d8bd8772", name : "game/star_squidward/left_mid.png"},{ bytes : 29210, md5 : "a06afb4cba0b5c08c0da0d623436d915", name : "game/star_squidward/left_up.png"},{ bytes : 25418, md5 : "ab1494e739b969470260e0e8e55fef22", name : "game/star_squidward/right_down.png"},{ bytes : 27770, md5 : "41a60c9ea4cd5177e7865f65c9c672cf", name : "game/star_squidward/right_mid.png"},{ bytes : 29242, md5 : "a7050e661de2bd9edea7367600c84b0c", name : "game/star_squidward/right_up.png"},{ bytes : 24063, md5 : "236a81c4f8344dc7f179011ed2624d99", name : "game/star_squidward/straight_down.png"},{ bytes : 26653, md5 : "69056a3adf7d0cf9b7c10005a19f23b1", name : "game/star_squidward/straight_mid.png"},{ bytes : 28307, md5 : "d1475149e6eab3895462363f597610e5", name : "game/star_squidward/straight_up.png"},{ bytes : 5882, md5 : "f3e5c93f35001eb75acaf2dc40e74921", name : "game/stars.png"},{ bytes : 20664, md5 : "692832fa859b8a435962531609a72b87", name : "game/stoplight.png"},{ bytes : 12885, md5 : "11cd263b9cc1c4d1882018136edf4a43", name : "game/text_finished.png"},{ bytes : 7864, md5 : "87441aef0d00bcaa52f4fbfd1cc804ab", name : "game/text_go.png"},{ bytes : 2070, md5 : "b49c0e6435aea7b05e036963acff5785", name : "instructions/btn_close.png"},{ bytes : 30167, md5 : "f09ab664ec0b49958cd33620fbce2083", name : "instructions/btn_start.png"},{ bytes : 31592, md5 : "25d1b5eea5fe40fec8d7adcb09ed0305", name : "instructions/btn_start_over.png"},{ bytes : 73001, md5 : "ca0db47526400205d5d8adad594aa810", name : "instructions/instructions.png"},{ bytes : 78477, md5 : "da469b1e75a8d4b237b490453429ad3f", name : "instructions/instructions_mobile.png"},{ bytes : 1515553, md5 : "102bb5b512f51b0cdc59306d69d31a76", name : "sounds/bgmusic_game.mp3"},{ bytes : 10577, md5 : "897de292110800dec8d8c85a35beb0ac", name : "sounds/buttonclick.mp3"},{ bytes : 18427, md5 : "069287ee65b1652fa15ebfdffa332eb3", name : "sounds/buttonclick2.mp3"},{ bytes : 15981, md5 : "e34d4c6a3c4fa4955f83669db4d69b9e", name : "sounds/countdown1.mp3"},{ bytes : 38302, md5 : "672865762c56691c1e674a6a90343d96", name : "sounds/countdown2.mp3"},{ bytes : 27583, md5 : "dff59e2493735a73e924dae8df3c9a8f", name : "sounds/finishedlap.mp3"},{ bytes : 39844, md5 : "b814f9b39c48da483be75cef04291ce4", name : "sounds/hitracer.mp3"},{ bytes : 33662, md5 : "ad736a4edb365a6a9bece9c61d34ab73", name : "sounds/hole.mp3"},{ bytes : 50217, md5 : "bb5b045d69548b4f1f94c260dd44cac7", name : "sounds/motor_together.mp3"},{ bytes : 25317, md5 : "4680385df8c47f2dee14ff26589db392", name : "sounds/pillow_pickup.mp3"},{ bytes : 10556, md5 : "8a6c0ae8258e57d7cd7ef32d79a8095a", name : "sounds/shotpillow.mp3"},{ bytes : 20662, md5 : "8a54ec7e66e0da4aaafd71ba45a94cf5", name : "sounds/spinout.mp3"},{ bytes : 26370, md5 : "9b278e06401e6053a25172be125ebf69", name : "sounds/turbo.mp3"},{ bytes : 24771, md5 : "235c53047fed2abc56ac55231d3c61e2", name : "sounds/woosh.mp3"}], main_game : [{ bytes : 21252, md5 : "5877b1d4a01b8121aabe67941261b04b", name : "closeconfirm/background.png"},{ bytes : 15095, md5 : "c33c8b44382c57ffc9c38a9d4c9dda76", name : "closeconfirm/btn_no.png"},{ bytes : 15995, md5 : "0121a6cafd0a1a6be83b470c38d05d53", name : "closeconfirm/btn_no_over.png"},{ bytes : 17034, md5 : "7dfafbb5a21377d4475e4629bac9c2dd", name : "closeconfirm/btn_yes.png"},{ bytes : 17986, md5 : "6b2fc243f1c277481122f872bdd8f772", name : "closeconfirm/btn_yes_over.png"},{ bytes : 2023, md5 : "340fccf4bc4843dad65011dfb7974fa2", name : "feather-1.png"},{ bytes : 1699, md5 : "239c3a21dd0e96147560c3412382a8b2", name : "feather-2.png"},{ bytes : 3120, md5 : "93f472bc04753f6d640d503352e05d48", name : "finishstar.png"},{ bytes : 12020, md5 : "41c9651f17260e54dfa1714f85d947a2", name : "fonts/BonusTxt.fnt"},{ bytes : 30036, md5 : "7431cc42c16824474ad9d13d22f2299c", name : "fonts/BonusTxt.png"},{ bytes : 12023, md5 : "f1085f9ecf08af337b2360b21e055dff", name : "fonts/BonusTxtErr.fnt"},{ bytes : 32284, md5 : "02baeae8936b0bca50469b34b80caecd", name : "fonts/BonusTxtErr.png"},{ bytes : 2348, md5 : "e9f8f7153af0d66c00032c52e3023d21", name : "fonts/endscore.fnt"},{ bytes : 7117, md5 : "85e23213e3fccc67db47a0a7c92aeb90", name : "fonts/endscore.png"},{ bytes : 2355, md5 : "fee429c3385ddb62aea095b71fbcaf77", name : "fonts/endscore_yellow.fnt"},{ bytes : 10298, md5 : "82089e4fe2c65c2336691f1f34cd3f81", name : "fonts/endscore_yellow.png"},{ bytes : 2470, md5 : "26aba01678f91b7d5bda227a4b56275e", name : "fonts/LapTxt.fnt"},{ bytes : 8699, md5 : "52cc19360fbf6d0c67d621b3de602683", name : "fonts/LapTxt.png"},{ bytes : 2348, md5 : "205d4eaed7f981d891eeecdc8c37d508", name : "fonts/TimerTxt.fnt"},{ bytes : 14013, md5 : "c2d1aeb60917ed8a3560ca4e916f5f60", name : "fonts/TimerTxt.png"},{ bytes : 326124, md5 : "ebae99f69a69cf7e592e09a93968b3b2", name : "game/bg_hills.png"},{ bytes : 292076, md5 : "3a64991c706a5db482e7683e7fe1514d", name : "game/bg_sky_left.png"},{ bytes : 289483, md5 : "b6e074cdea33cd3e50da53ee53897ee2", name : "game/bg_sky_mid.png"},{ bytes : 70991, md5 : "dee3db288f73e46211b421f6d3bcbca7", name : "game/bg_sky_right.png"},{ bytes : 160125, md5 : "962c6da970416b1d99093a63c87c8429", name : "game/bg_trees.png"},{ bytes : 21534, md5 : "e28bc37d11b9e2b6db1b5cb6d2726a22", name : "game/books/1.png"},{ bytes : 21015, md5 : "db747ffb0fc8bf256b46ca06f92ff60f", name : "game/books/10.png"},{ bytes : 21292, md5 : "3e3e1bf7b6cf0d33ae0a0092aa9a0ee2", name : "game/books/11.png"},{ bytes : 21610, md5 : "63d270727bed15d9f13623983319403d", name : "game/books/12.png"},{ bytes : 21772, md5 : "ca0231abc75ee39fa9ce5d312e9e7b5b", name : "game/books/13.png"},{ bytes : 21331, md5 : "7a6c53654ee7195664248b91745b1000", name : "game/books/14.png"},{ bytes : 21584, md5 : "b71fbe41724140ff9cd8d263f4e8c9c2", name : "game/books/2.png"},{ bytes : 21129, md5 : "9638a0149094c45d3d05a0b172636266", name : "game/books/3.png"},{ bytes : 19758, md5 : "6977c34d531882ea4c095f6dfb262936", name : "game/books/4.png"},{ bytes : 20062, md5 : "abd574670c1ab18639915091b4376516", name : "game/books/5.png"},{ bytes : 21103, md5 : "d5af76453d30bf6621934143e60d5782", name : "game/books/6.png"},{ bytes : 21150, md5 : "9a9f50185e237586fd9896825bfc67db", name : "game/books/7.png"},{ bytes : 21063, md5 : "bc870a4f1729ebbadb9b3e9631e56396", name : "game/books/8.png"},{ bytes : 21290, md5 : "da91a4310bc0f2091083096a054d43e0", name : "game/books/9.png"},{ bytes : 2752, md5 : "a05512b0b8d7053b05f100684b635c90", name : "game/btn_close.png"},{ bytes : 1314, md5 : "369ce678c3138042e375ab1dafcd2b17", name : "game/btn_help.png"},{ bytes : 1275, md5 : "5d0e30cd2cff85e4e3f379a0e559a394", name : "game/btn_help_over.png"},{ bytes : 1106, md5 : "e63353f7f31c365517e4a14c2d7e10c5", name : "game/btn_sound_off.png"},{ bytes : 1090, md5 : "c1edcc7d8d62370505f0167e29f45a95", name : "game/btn_sound_off_over.png"},{ bytes : 1416, md5 : "44099ef9070e8e9a461c4c6f79a02478", name : "game/btn_sound_on.png"},{ bytes : 1379, md5 : "19794eaea3cdcce3a4d3b48fa998ecca", name : "game/btn_sound_on_over.png"},{ bytes : 15019, md5 : "66275ff02d01a06aa67dfa145cc29f00", name : "game/clock.png"},{ bytes : 44393, md5 : "c7c7261c0f7cd59c8c0f778a43ba3d11", name : "game/crab/left_mid.png"},{ bytes : 50621, md5 : "03dbfea9010947f407e5e0ae14e60fd3", name : "game/crab/left_mid_throw1.png"},{ bytes : 44886, md5 : "e6844d59c0ee7f911f9b4796596f8c4e", name : "game/crab/left_mid_throw2.png"},{ bytes : 44922, md5 : "b119074d65a387f1b99f98b85565d64e", name : "game/crab/right_mid.png"},{ bytes : 48887, md5 : "532ef30f38bf1289cc470077d87ebc10", name : "game/crab/right_mid_throw1.png"},{ bytes : 46063, md5 : "20fee434176c6c98080044baec1ef8cb", name : "game/crab/right_mid_throw2.png"},{ bytes : 45378, md5 : "732a674cd58dcff64906a2b1b8e66b44", name : "game/crab/straight_mid.png"},{ bytes : 49402, md5 : "16115d1cfc5ee426469926d28294d768", name : "game/crab/straight_mid_throw1.png"},{ bytes : 46091, md5 : "04e678f4fe562fb17d38e9009bb19f58", name : "game/crab/straight_mid_throw2.png"},{ bytes : 70738, md5 : "4f146b6dc496f1ae14365100f312d224", name : "game/crab_spin/00000.png"},{ bytes : 64827, md5 : "710b277e1c9ffc6763a1d85486e6747a", name : "game/crab_spin/00001.png"},{ bytes : 73291, md5 : "36680fbce1a1bb31c7bf4db06c0e1798", name : "game/crab_spin/00002.png"},{ bytes : 63707, md5 : "c8a12c91837da97a5b141d60138eb485", name : "game/crab_spin/00003.png"},{ bytes : 70716, md5 : "5b82e96b9a2ef7447fd58460edbfe43f", name : "game/crab_spin/00004.png"},{ bytes : 62482, md5 : "fadec5f21a7af9a3c3dcf83c902804de", name : "game/crab_spin/00005.png"},{ bytes : 73251, md5 : "b346e539a6883bb16ef4200dbe0dbfc3", name : "game/crab_spin/00006.png"},{ bytes : 65475, md5 : "0c34b55a4ff51198a1cd58dc242df874", name : "game/crab_spin/00007.png"},{ bytes : 70726, md5 : "c433e09fd0ec2488671f2f275d44c3c8", name : "game/crab_spin/00008.png"},{ bytes : 1216, md5 : "b2e04d964572159f8d71dd6572d10452", name : "game/flag/1.png"},{ bytes : 1184, md5 : "84ec500bc61a7faa45408a1ef5b796be", name : "game/flag/10.png"},{ bytes : 1193, md5 : "7d13c86b12ee94897e3d9218cedc5f4b", name : "game/flag/11.png"},{ bytes : 1184, md5 : "05c3c097c326f6789d5f88f8f522f823", name : "game/flag/12.png"},{ bytes : 1224, md5 : "02b7266e6047260823e365753e78e5d9", name : "game/flag/13.png"},{ bytes : 1229, md5 : "204d6916169b289ccbee21a7030e84d5", name : "game/flag/14.png"},{ bytes : 1248, md5 : "43d2e7c8273d3be6b6394b45a4b7837b", name : "game/flag/15.png"},{ bytes : 1197, md5 : "a3bc9763ca54d41920d68dcdea080020", name : "game/flag/2.png"},{ bytes : 1191, md5 : "22a8f81b115b53104138b0c9ca89c030", name : "game/flag/3.png"},{ bytes : 1187, md5 : "326923534ceeee7ecf7ee9f91655d661", name : "game/flag/4.png"},{ bytes : 1178, md5 : "d59816f59f90da4eec52571d4e2fdc53", name : "game/flag/5.png"},{ bytes : 1205, md5 : "9935b2da5c64a81441a0b9e1d543492b", name : "game/flag/6.png"},{ bytes : 1235, md5 : "bb9e860ce444cee265fcbc3d8e1760ef", name : "game/flag/7.png"},{ bytes : 1239, md5 : "860e01559ead2a86ed5d132c53b4758f", name : "game/flag/8.png"},{ bytes : 1213, md5 : "4362ff4242cd6c3e58d36c10190633db", name : "game/flag/9.png"},{ bytes : 20332, md5 : "019fc6313db24ce6cc940ead932048d4", name : "game/hole.png"},{ bytes : 45883, md5 : "0412227275d38362ddbc2acf9ad0399c", name : "game/hotrod_crab/left_mid.png"},{ bytes : 52245, md5 : "f7239fa76496e61dacbecba219cea29a", name : "game/hotrod_crab/left_mid_throw1.png"},{ bytes : 46296, md5 : "8729fb5299dc63b82aff9eeaacd5a722", name : "game/hotrod_crab/left_mid_throw2.png"},{ bytes : 46674, md5 : "168121051885c7cad6c2d1dc4f3f2af2", name : "game/hotrod_crab/right_mid.png"},{ bytes : 50798, md5 : "e63dcee4a79bcb2553cbdd92fff1a8bb", name : "game/hotrod_crab/right_mid_throw1.png"},{ bytes : 47663, md5 : "0c73e73a168366c2e2b38cace1b2c889", name : "game/hotrod_crab/right_mid_throw2.png"},{ bytes : 46569, md5 : "da5aedb0eaac4b710b763f79655f0850", name : "game/hotrod_crab/straight_mid.png"},{ bytes : 50755, md5 : "d319f547aef8128d005dc39e141affac", name : "game/hotrod_crab/straight_mid_throw1.png"},{ bytes : 47221, md5 : "776e8186fac3a35c290c9835afb6a4f9", name : "game/hotrod_crab/straight_mid_throw2.png"},{ bytes : 75507, md5 : "8210f8b4b933ea8434b7c83c0bed8984", name : "game/hotrod_crab_spin/00000.png"},{ bytes : 72303, md5 : "af6c507308f4042d5df475e854be269a", name : "game/hotrod_crab_spin/00001.png"},{ bytes : 82087, md5 : "f412c4ec60f1f9b539f3a40f03dc5558", name : "game/hotrod_crab_spin/00002.png"},{ bytes : 70620, md5 : "19dc02eccd88472a95ca401b14000149", name : "game/hotrod_crab_spin/00003.png"},{ bytes : 75350, md5 : "45231cc304c805958e16aa0d002e908c", name : "game/hotrod_crab_spin/00004.png"},{ bytes : 68759, md5 : "39a504276f2afd27a252f6f8e63341e7", name : "game/hotrod_crab_spin/00005.png"},{ bytes : 82087, md5 : "c77f96cb01c660093ca10ef43dbf6ac7", name : "game/hotrod_crab_spin/00006.png"},{ bytes : 73084, md5 : "a9d53af48cb68c1ab3c5a215a0323a2e", name : "game/hotrod_crab_spin/00007.png"},{ bytes : 76660, md5 : "f870823b314ef28c1c77efbdc3b64265", name : "game/hotrod_crab_spin/00008.png"},{ bytes : 41749, md5 : "6a2b152220f4b73bfe6fdc298bb4d6f0", name : "game/hotrod_patrick/left_mid.png"},{ bytes : 50094, md5 : "c19b4b7bd6abdf7aa3c4b38edb1994ef", name : "game/hotrod_patrick/left_mid_throw1.png"},{ bytes : 43505, md5 : "5cdf04713fc287cc4d262dedfe79b1d7", name : "game/hotrod_patrick/left_mid_throw2.png"},{ bytes : 42406, md5 : "132a5f5792b3a298365148f09d8ff448", name : "game/hotrod_patrick/right_mid.png"},{ bytes : 47937, md5 : "18c08fa749d44f24344b9262fef03f10", name : "game/hotrod_patrick/right_mid_throw1.png"},{ bytes : 44282, md5 : "58752e14d9841432b0af2e133b240c35", name : "game/hotrod_patrick/right_mid_throw2.png"},{ bytes : 42982, md5 : "0f046f6fa3eefc2de7c54c22920bf485", name : "game/hotrod_patrick/straight_mid.png"},{ bytes : 49817, md5 : "a978280366fd4b66df3cc0a86f0b9a20", name : "game/hotrod_patrick/straight_mid_throw1.png"},{ bytes : 44482, md5 : "dfc16383b5fc71ee62a78683f50658d2", name : "game/hotrod_patrick/straight_mid_throw2.png"},{ bytes : 71796, md5 : "1a6676073dc1490725bbff48e41efc2a", name : "game/hotrod_patrick_spin/00000.png"},{ bytes : 69665, md5 : "2b1697a05f5d2a1c9fefa12c9d2f0633", name : "game/hotrod_patrick_spin/00001.png"},{ bytes : 76391, md5 : "0be91aa6af5ece399c8702e40c9478cc", name : "game/hotrod_patrick_spin/00002.png"},{ bytes : 65478, md5 : "64b52bc05c16711beeeb1184ab4973d8", name : "game/hotrod_patrick_spin/00003.png"},{ bytes : 71339, md5 : "32ef3b4215640c5edfbd7f71061eedd4", name : "game/hotrod_patrick_spin/00004.png"},{ bytes : 65776, md5 : "98d7ac68e1da6c90c2cf93b1ac9eb8a6", name : "game/hotrod_patrick_spin/00005.png"},{ bytes : 75741, md5 : "dee146472c490a22a0f61dbe20a3f597", name : "game/hotrod_patrick_spin/00006.png"},{ bytes : 71825, md5 : "a1d9add64ffb942a30e5fc442556ae93", name : "game/hotrod_patrick_spin/00007.png"},{ bytes : 70471, md5 : "342d9d36246ccae47666702c421cd55d", name : "game/hotrod_patrick_spin/00008.png"},{ bytes : 44247, md5 : "f79d3032420e070ed9fcacd88c6e8062", name : "game/hotrod_spongebob/left_mid.png"},{ bytes : 49470, md5 : "5b5a71f1ea52e1568d513c46fbded3e4", name : "game/hotrod_spongebob/left_mid_throw1.png"},{ bytes : 44331, md5 : "b6705e4110bb4216064891cb0d609a2d", name : "game/hotrod_spongebob/left_mid_throw2.png"},{ bytes : 44274, md5 : "008cbeef95c0d12d84badd57d6154415", name : "game/hotrod_spongebob/right_mid.png"},{ bytes : 49818, md5 : "4dc0a108c0eea8d43ee0d96a495afcdc", name : "game/hotrod_spongebob/right_mid_throw1.png"},{ bytes : 45854, md5 : "c40bc3be05529ece09a1dc0861185cff", name : "game/hotrod_spongebob/right_mid_throw2.png"},{ bytes : 43173, md5 : "ec33207ba0ca9b2e145bdee20eec689b", name : "game/hotrod_spongebob/straight_mid.png"},{ bytes : 48323, md5 : "56616a0097317a20a75080608380a195", name : "game/hotrod_spongebob/straight_mid_throw1.png"},{ bytes : 44453, md5 : "c0d4f4a385410c084fa1f3410f19ac07", name : "game/hotrod_spongebob/straight_mid_throw2.png"},{ bytes : 73039, md5 : "f05d8ab3e43061ec5464bb63882abfa1", name : "game/hotrod_spongebob_spin/00000.png"},{ bytes : 73847, md5 : "8443e32009fe5ed522135734de895a03", name : "game/hotrod_spongebob_spin/00001.png"},{ bytes : 81427, md5 : "44464fb1702a996a38b1d8fa930d0175", name : "game/hotrod_spongebob_spin/00002.png"},{ bytes : 65543, md5 : "a49698b5f30dc1bdb8e2515f41dbf82d", name : "game/hotrod_spongebob_spin/00003.png"},{ bytes : 72706, md5 : "275897a977710dc96b6f5b1a15172711", name : "game/hotrod_spongebob_spin/00004.png"},{ bytes : 64771, md5 : "9eec5256b3b55c6b0299e40308a12e39", name : "game/hotrod_spongebob_spin/00005.png"},{ bytes : 80673, md5 : "84ac6df7394c241137ca8dc274810f20", name : "game/hotrod_spongebob_spin/00006.png"},{ bytes : 66182, md5 : "f8198b139d9650a1414f7f454950562e", name : "game/hotrod_spongebob_spin/00007.png"},{ bytes : 73232, md5 : "00c88d4c63e82d02a18ef16d973ec18a", name : "game/hotrod_spongebob_spin/00008.png"},{ bytes : 45397, md5 : "3ceb86490bb76bd0d9f77219af51a02e", name : "game/hotrod_squidward/left_mid.png"},{ bytes : 48855, md5 : "89b8be3e4cb469acc2c133ce08a01d0d", name : "game/hotrod_squidward/left_mid_throw1.png"},{ bytes : 46004, md5 : "004df6f3cc36d5ba5f67467025c4ffae", name : "game/hotrod_squidward/left_mid_throw2.png"},{ bytes : 45281, md5 : "64d7ac510db20d771836005c853516b6", name : "game/hotrod_squidward/right_mid.png"},{ bytes : 47356, md5 : "33497c6ece855ac9fa693314837b246a", name : "game/hotrod_squidward/right_mid_throw1.png"},{ bytes : 46378, md5 : "f44be998981514b2a6e94eda8ace4bf6", name : "game/hotrod_squidward/right_mid_throw2.png"},{ bytes : 45118, md5 : "34367c512d0ce9d493255240706fce07", name : "game/hotrod_squidward/straight_mid.png"},{ bytes : 48389, md5 : "e856a52a1ccd6cf6e0a78a9070fbd0c4", name : "game/hotrod_squidward/straight_mid_throw1.png"},{ bytes : 45655, md5 : "0d0b319aab49138b17178c75967b0fe7", name : "game/hotrod_squidward/straight_mid_throw2.png"},{ bytes : 76910, md5 : "db7e272aa6c0e884a8cc1a033c09d0c0", name : "game/hotrod_squidward_spin/00000.png"},{ bytes : 71049, md5 : "bb5dee330011f503a2713937faaece19", name : "game/hotrod_squidward_spin/00001.png"},{ bytes : 81528, md5 : "bc599b5dc6eef7f2141d1dfe4e23f699", name : "game/hotrod_squidward_spin/00002.png"},{ bytes : 69205, md5 : "319432604a616de1471fcbd5e6115984", name : "game/hotrod_squidward_spin/00003.png"},{ bytes : 76451, md5 : "896213dac6bfd1ef1be09b4022a91875", name : "game/hotrod_squidward_spin/00004.png"},{ bytes : 67046, md5 : "e08fd0380c13024bcf232c478e5f06bd", name : "game/hotrod_squidward_spin/00005.png"},{ bytes : 80202, md5 : "81b718098475195f2f6e7c68c86b87de", name : "game/hotrod_squidward_spin/00006.png"},{ bytes : 73452, md5 : "15b813a702e4e3f5bece5bdc4211dd50", name : "game/hotrod_squidward_spin/00007.png"},{ bytes : 75309, md5 : "2124c07af3d1736994bcd95e6d744c67", name : "game/hotrod_squidward_spin/00008.png"},{ bytes : 8214, md5 : "eab011678c23a800e0738f28c9039a65", name : "game/lightning.png"},{ bytes : 1532, md5 : "c02b6e635716051c28470b436b275a63", name : "game/mobile_btn_help.png"},{ bytes : 1475, md5 : "f1e95282067d828f33400b0a2f9950e9", name : "game/mobile_btn_help_over.png"},{ bytes : 1229, md5 : "021841e01c7011b83ab65aeab7325fda", name : "game/mobile_btn_sound_off.png"},{ bytes : 1218, md5 : "5cb17da0d9b243813e4d1f796de0757a", name : "game/mobile_btn_sound_off_over.png"},{ bytes : 1659, md5 : "712cf2f26c6e2e14716713a7f6457e5d", name : "game/mobile_btn_sound_on.png"},{ bytes : 1578, md5 : "79fa20839298354ebac39bd1b50f7433", name : "game/mobile_btn_sound_on_over.png"},{ bytes : 4993, md5 : "a4fb63f5d599f28ff224537872b44a8e", name : "game/mobile_ui.png"},{ bytes : 33260, md5 : "8dda896866f44e6502425a68ba8bab5c", name : "game/moon/1.png"},{ bytes : 36182, md5 : "6150e34bf42519118f959340ad44b241", name : "game/moon/10.png"},{ bytes : 36395, md5 : "503a40751826a7ffec5545ba3c2fcf70", name : "game/moon/11.png"},{ bytes : 36810, md5 : "5df077440e4173654fc002f841d6dad0", name : "game/moon/12.png"},{ bytes : 36809, md5 : "2973c5a1c381459aecdc3760ed778a2f", name : "game/moon/13.png"},{ bytes : 36901, md5 : "336786e4b240910d45a1090bd41ad024", name : "game/moon/14.png"},{ bytes : 36953, md5 : "9057def31c3191431809de2b028aaa92", name : "game/moon/15.png"},{ bytes : 36951, md5 : "38d02e5ab1879daf69c0fbd58857b747", name : "game/moon/16.png"},{ bytes : 36945, md5 : "2baf60b6d40eccf790684258962acb5e", name : "game/moon/17.png"},{ bytes : 37041, md5 : "eb127019ba50bea5126201584d367ac6", name : "game/moon/18.png"},{ bytes : 37049, md5 : "3740cc7f81694c03a96f63d8e1e808e2", name : "game/moon/19.png"},{ bytes : 34045, md5 : "4426e7c991c173a259eb12ed1e94c8e5", name : "game/moon/2.png"},{ bytes : 37066, md5 : "4b8aa2b52bdd93647c38e03d38e1b4b7", name : "game/moon/20.png"},{ bytes : 36923, md5 : "a935ca06ba65955c9cdec7c208e73d3d", name : "game/moon/21.png"},{ bytes : 36884, md5 : "f7ae22c1e328afa96ea69d56c5577789", name : "game/moon/22.png"},{ bytes : 36851, md5 : "0b1044d0179d80e4587e07069fb53b2a", name : "game/moon/23.png"},{ bytes : 36838, md5 : "73080fe3ab22031411464d2346ea8e6a", name : "game/moon/24.png"},{ bytes : 36550, md5 : "090b8ad1e23d1cebc929c38cd3d3a6f7", name : "game/moon/25.png"},{ bytes : 35945, md5 : "96e9fa95e09080b764c29c8b26df6da1", name : "game/moon/26.png"},{ bytes : 35935, md5 : "a6716696fdc1995073f2371896a64d17", name : "game/moon/27.png"},{ bytes : 35531, md5 : "f4fdcdb94f2b5fc35cf58113a361e697", name : "game/moon/28.png"},{ bytes : 34930, md5 : "f4cc05683f386743a6310d1a9b499a18", name : "game/moon/29.png"},{ bytes : 34187, md5 : "4febaab2a980677d1c3eb8a308570c9b", name : "game/moon/3.png"},{ bytes : 34726, md5 : "801939afc4b70fec62c434184947b3d7", name : "game/moon/30.png"},{ bytes : 34335, md5 : "8fd474cd2ceeb0b97fd3d72c99d8ed25", name : "game/moon/31.png"},{ bytes : 34197, md5 : "cfd4c83c2e84b5bfe7fea0117197d94d", name : "game/moon/32.png"},{ bytes : 34004, md5 : "efcb58b28e55503cfd415f29432e019c", name : "game/moon/33.png"},{ bytes : 33690, md5 : "e59e026060b35950e7fbdc50b843afac", name : "game/moon/34.png"},{ bytes : 33669, md5 : "3701fa58d88536158b37ee2b0f845b09", name : "game/moon/35.png"},{ bytes : 33172, md5 : "3818bf756fe96eb63c4c0d36efe198bf", name : "game/moon/36.png"},{ bytes : 34167, md5 : "8e98fb631865b899eecb73814ecfb596", name : "game/moon/4.png"},{ bytes : 34834, md5 : "be1a9e4521584ae1b351a9c8ee313e46", name : "game/moon/5.png"},{ bytes : 34998, md5 : "b69d648888cb56b7e937fe1a97871a9c", name : "game/moon/6.png"},{ bytes : 35445, md5 : "25b8cba9d0a29ae51a23dc36653b373e", name : "game/moon/7.png"},{ bytes : 35602, md5 : "68495ccc17b0a2733dc45fe45fe1b151", name : "game/moon/8.png"},{ bytes : 35711, md5 : "4443ee6f9bbd346fcee039ae45effe03", name : "game/moon/9.png"},{ bytes : 410, md5 : "7c3e0bd4d41b94f559c6c99eee11882d", name : "game/particles/bubble.png"},{ bytes : 1369, md5 : "9280e2001c21a4da81a8d56895bf090a", name : "game/particles/bubbles.pex"},{ bytes : 1366, md5 : "df3e96b6b48cab515988fc92558d62e0", name : "game/particles/bubbles_front.pex"},{ bytes : 1370, md5 : "8a3a3c86a589cbc35f681a427083f927", name : "game/particles/bubbles_npc.pex"},{ bytes : 1365, md5 : "b3298b37a1bf7fe1817dddd3c30406cf", name : "game/particles/bubbles_spin.pex"},{ bytes : 1376, md5 : "7842676766feaf7ed1e8a2fafe2f2ab8", name : "game/particles/bubbles_turbo.pex"},{ bytes : 1372, md5 : "a3d55daac869940f797341351093c780", name : "game/particles/bubbles_turbo_front.pex"},{ bytes : 1308, md5 : "af708314cc05e80c56cef89c1c2bacc8", name : "game/particles/bubbleYellow.png"},{ bytes : 40864, md5 : "ef1292ec5927ab7a38f9dff92937c83d", name : "game/patrick/left_mid.png"},{ bytes : 49293, md5 : "78a2ba08c5e38b9b934ec97796317013", name : "game/patrick/left_mid_throw1.png"},{ bytes : 42475, md5 : "efec3c26ca469bca716c4833bf5e673f", name : "game/patrick/left_mid_throw2.png"},{ bytes : 40630, md5 : "9560be6187e8c395a8b455b57bc18f6c", name : "game/patrick/right_mid.png"},{ bytes : 46480, md5 : "0cb157790eb34d48949455f60255159f", name : "game/patrick/right_mid_throw1.png"},{ bytes : 42628, md5 : "dc0888a0eb956d89a642315dcbd68238", name : "game/patrick/right_mid_throw2.png"},{ bytes : 41705, md5 : "d5c13165b754884c1276d83346669e77", name : "game/patrick/straight_mid.png"},{ bytes : 48698, md5 : "cecece7588cdb7c2cf8ffb5d7c5120ba", name : "game/patrick/straight_mid_throw1.png"},{ bytes : 43282, md5 : "ba92545f665195d9a10099f3c2b29ab9", name : "game/patrick/straight_mid_throw2.png"},{ bytes : 65353, md5 : "a66a614004499aa1cd8125bb4bd93784", name : "game/patrick_spin/00000.png"},{ bytes : 62070, md5 : "b9e96f77758dce4a2278053df7ad836c", name : "game/patrick_spin/00001.png"},{ bytes : 66279, md5 : "2d9b4570882ae1add76fa25d54cdc040", name : "game/patrick_spin/00002.png"},{ bytes : 56838, md5 : "29db8b936b9622dc0879876939a37161", name : "game/patrick_spin/00003.png"},{ bytes : 65352, md5 : "d336c908ddc33515cad88e63cfd14b7e", name : "game/patrick_spin/00004.png"},{ bytes : 59449, md5 : "6e1054feea88c486c81af527da5d9320", name : "game/patrick_spin/00005.png"},{ bytes : 65798, md5 : "eb6467c742f7d6642daf4ed39b048174", name : "game/patrick_spin/00006.png"},{ bytes : 63450, md5 : "38de8b270df904eec93398f026eb8ab1", name : "game/patrick_spin/00007.png"},{ bytes : 62976, md5 : "2353508fe6127a98996176d731844b70", name : "game/patrick_spin/00008.png"},{ bytes : 6898, md5 : "3c9765d3309384feb7d2daf55133d97a", name : "game/pillow.png"},{ bytes : 7403, md5 : "9c430918dae34ac2c0269f3fe20b2336", name : "game/pillow_left.png"},{ bytes : 7477, md5 : "5618339c3dcaf0e1e435f5befb911015", name : "game/pillow_right.png"},{ bytes : 7515, md5 : "cf22990fbe6833f945091d657d93024b", name : "game/place_1.png"},{ bytes : 8279, md5 : "3f57b67b93b284f184504b70783ad578", name : "game/place_2.png"},{ bytes : 8812, md5 : "0f38b710c7ea598757c0bb574fa6edd2", name : "game/place_3.png"},{ bytes : 7133, md5 : "4710f886c8e3a8bbfda1d0a9707cae26", name : "game/place_4.png"},{ bytes : 5508, md5 : "2b57b25292128c86ed3b2664ca131ac7", name : "game/place_empty.png"},{ bytes : 16122, md5 : "0b5999d5b839cf04360544b3c4da9cbe", name : "game/powerup_pillow.png"},{ bytes : 47431, md5 : "c1b27f688bfc676ac8aa6d3f002fde27", name : "game/ramp_large.png"},{ bytes : 20240, md5 : "a372a2cfb4003ddc6cc27df3b0f628c7", name : "game/ramp_small.png"},{ bytes : 64894, md5 : "d8f15738655623b8393ef80c94fe51f7", name : "game/ring.png"},{ bytes : 92497, md5 : "2225c7ecac32f67ee448743592b6a5d1", name : "game/ring_finish.png"},{ bytes : 75810, md5 : "c9618cce73701eb756a42d72183a750d", name : "game/ring_lap1.png"},{ bytes : 76229, md5 : "4d1c831863398354294178651f6d30c1", name : "game/ring_lap2.png"},{ bytes : 76483, md5 : "2e4f46f1940c363d4ce4d5efaef9b8dd", name : "game/ring_lap3.png"},{ bytes : 77193, md5 : "84cc79cb9184bb65688515dfa7cf091b", name : "game/ring_start.png"},{ bytes : 36153, md5 : "dbf1344390214e34e8f6bc88beb70a97", name : "game/road/finish.png"},{ bytes : 34786, md5 : "937ad3fd09d7474f97156ed01bd9ee12", name : "game/road/finish_.png"},{ bytes : 3083, md5 : "5cf94f2ca45b404015154da098e5411b", name : "game/road/finish_slice1.png"},{ bytes : 3177, md5 : "5e8880f43ff77f73137d3378a4d23dea", name : "game/road/finish_slice10.png"},{ bytes : 3109, md5 : "d88195c89db199b8c96d72704de19b05", name : "game/road/finish_slice11.png"},{ bytes : 3136, md5 : "fb8dfe6bcda13b36e3decfa92085923d", name : "game/road/finish_slice12.png"},{ bytes : 3048, md5 : "2bad9f4940b5b093f73b0bcd08151434", name : "game/road/finish_slice13.png"},{ bytes : 3065, md5 : "31e2519c9c41db822400c1a8d3082c1a", name : "game/road/finish_slice14.png"},{ bytes : 3066, md5 : "e70e1368c3c111c248c93246c15182ff", name : "game/road/finish_slice15.png"},{ bytes : 3041, md5 : "5b0fb57f0c8b8fca48bc155cb6b56aa3", name : "game/road/finish_slice16.png"},{ bytes : 3036, md5 : "b5f61a67dc1ef0ad3e050a1af0701c3e", name : "game/road/finish_slice17.png"},{ bytes : 3014, md5 : "e4d63b7eb7f59df44431e80b75e5cb5e", name : "game/road/finish_slice18.png"},{ bytes : 2958, md5 : "c5e1b0a42e4da0e46fffb03abad04e57", name : "game/road/finish_slice19.png"},{ bytes : 3092, md5 : "6608f3efb65639664a010e7c21ff944f", name : "game/road/finish_slice2.png"},{ bytes : 2883, md5 : "f64330e0e8cd0979452018fd6cb42e92", name : "game/road/finish_slice20.png"},{ bytes : 3046, md5 : "5269fa3561a78f83277d2957f8de178d", name : "game/road/finish_slice3.png"},{ bytes : 3081, md5 : "37dd42138553e01bb5cd5b33918b5b98", name : "game/road/finish_slice4.png"},{ bytes : 3070, md5 : "ab8176ec3c81ec9e8b03c91bad423b2e", name : "game/road/finish_slice5.png"},{ bytes : 3064, md5 : "332f24411df86ec84a39fb9960c146cb", name : "game/road/finish_slice6.png"},{ bytes : 3099, md5 : "ab450a1dfe6e62cc6e9c7ab702b9e6cf", name : "game/road/finish_slice7.png"},{ bytes : 3121, md5 : "1ccf8d268a3c61ea87fb361c47335738", name : "game/road/finish_slice8.png"},{ bytes : 3115, md5 : "4d0dde01160f4c4b61b839ab1748a529", name : "game/road/finish_slice9.png"},{ bytes : 3187, md5 : "d5c3cdf2e2c9be77bc8898d070f7c8c0", name : "game/road/finishslice1.png"},{ bytes : 3166, md5 : "377845ce9949e49908abfbf3782ef08c", name : "game/road/finishslice10.png"},{ bytes : 3101, md5 : "771c6a519ebdebe424008ee76d6fcb41", name : "game/road/finishslice11.png"},{ bytes : 3105, md5 : "99759cf6168cec39ff49e55f43b89bd2", name : "game/road/finishslice12.png"},{ bytes : 3093, md5 : "307519ed3f63f094b86dc96ea8ad3263", name : "game/road/finishslice13.png"},{ bytes : 3139, md5 : "8feee9095191ce944f96de70b2b9b5e4", name : "game/road/finishslice14.png"},{ bytes : 3187, md5 : "3da577fe9eb229a9363463ef7e00bf60", name : "game/road/finishslice15.png"},{ bytes : 3239, md5 : "92e15a52809eb872a5d12db029b7a60a", name : "game/road/finishslice16.png"},{ bytes : 3288, md5 : "301931dcbeb1f7d75a4d96efcb35c704", name : "game/road/finishslice17.png"},{ bytes : 3246, md5 : "f6834788213ddbb9d7ed805dd1a2ea66", name : "game/road/finishslice18.png"},{ bytes : 3161, md5 : "d049344e3759c22ce9ea724dcdb59599", name : "game/road/finishslice19.png"},{ bytes : 3173, md5 : "8465f8eff99267d4710fa01729bb6864", name : "game/road/finishslice2.png"},{ bytes : 3149, md5 : "4154cc25881061551880bb434540e653", name : "game/road/finishslice20.png"},{ bytes : 3117, md5 : "70693b322583325a844348bfe477ee32", name : "game/road/finishslice3.png"},{ bytes : 3081, md5 : "7c3bbfff56883cb899b854418134ece6", name : "game/road/finishslice4.png"},{ bytes : 3115, md5 : "e579a0ab256745b1d7003c435bd25dba", name : "game/road/finishslice5.png"},{ bytes : 3179, md5 : "9a1272b5a9693076c7319bd0feb7b712", name : "game/road/finishslice6.png"},{ bytes : 3068, md5 : "2419d0b37b770c068097aa9578e63374", name : "game/road/finishslice7.png"},{ bytes : 3108, md5 : "0b2fc18ad03ea063e289ba866a7f400e", name : "game/road/finishslice8.png"},{ bytes : 3239, md5 : "e6b535dec80162db58fec9025e59f0f3", name : "game/road/finishslice9.png"},{ bytes : 2551, md5 : "d467d6c9a2a900acdb2bfcd3e71b8a7e", name : "game/road/rail_left.png"},{ bytes : 2472, md5 : "3cb70ca0a719ebda02117fde864dd2d3", name : "game/road/rail_right.png"},{ bytes : 62442, md5 : "8767a32fbe3cd32ceb6a3badab98738b", name : "game/road/road.png"},{ bytes : 1314, md5 : "8bf795593ccec0d5b337fc48abf7163c", name : "game/road/road_left.png"},{ bytes : 2221, md5 : "ab31169be696dd97922f8f5096ab08fb", name : "game/road/road_mobile.png"},{ bytes : 1347, md5 : "7435b42e341c87ce2b4339f6bc632156", name : "game/road/road_right.png"},{ bytes : 4785, md5 : "1c8d4ee3cf1c5ca210e05a1bff7d21f2", name : "game/road/roadslice1.png"},{ bytes : 4856, md5 : "2fc32916a8ee69b5fc5b49efe1ad2c42", name : "game/road/roadslice10.png"},{ bytes : 4722, md5 : "56adb3ceacb4c366d38b9efdaeb5cf25", name : "game/road/roadslice11.png"},{ bytes : 4763, md5 : "422776eace42be5a59f44d3f10de2aea", name : "game/road/roadslice12.png"},{ bytes : 4779, md5 : "a7d5023403b4bc6ff27da2ee31c38ff5", name : "game/road/roadslice13.png"},{ bytes : 4779, md5 : "78ef366f9e316547b4569ea72f9ea181", name : "game/road/roadslice14.png"},{ bytes : 4727, md5 : "f82df4375bbfb9da881e498b81dc5945", name : "game/road/roadslice15.png"},{ bytes : 4593, md5 : "1c354a1e9c7d768c12cec28fa7ad4371", name : "game/road/roadslice16.png"},{ bytes : 4813, md5 : "48b7d92c2bf2f36038eb7b998fbc9393", name : "game/road/roadslice17.png"},{ bytes : 4815, md5 : "9d5159cc9db50ee0252d9bcd073eee7f", name : "game/road/roadslice18.png"},{ bytes : 4874, md5 : "2cad0cfd41b9076fc3ab1559db2a7225", name : "game/road/roadslice19.png"},{ bytes : 4785, md5 : "bd65d81538ed03184b604d3a455fb705", name : "game/road/roadslice2.png"},{ bytes : 4762, md5 : "f7fab3befe8e300c899e5df40ee7747f", name : "game/road/roadslice20.png"},{ bytes : 4652, md5 : "ae5c69ea27659d45d8b851acfefa613c", name : "game/road/roadslice3.png"},{ bytes : 4659, md5 : "8359da40260e7a035734cc7dcd55747f", name : "game/road/roadslice4.png"},{ bytes : 4736, md5 : "9430b50f2108c4b7601ae7335a583d18", name : "game/road/roadslice5.png"},{ bytes : 4783, md5 : "9ab825a9a2a6dd48aa4fdf866730efd1", name : "game/road/roadslice6.png"},{ bytes : 4695, md5 : "39e177e33f02dff438afaa86aa113515", name : "game/road/roadslice7.png"},{ bytes : 4754, md5 : "45c669d69e3cc1fdf6abbbe12a745300", name : "game/road/roadslice8.png"},{ bytes : 4874, md5 : "b4af4dfdf0996439a669331ded709509", name : "game/road/roadslice9.png"},{ bytes : 14674, md5 : "0b3dda4d20ea5103286a6ccf6bb3deae", name : "game/scoreboard.png"},{ bytes : 5262, md5 : "14cb260d9a48c1b25ebd42a495592ba3", name : "game/sheep/1.png"},{ bytes : 10534, md5 : "fb6ca93ab7c420ba61063a84034a435c", name : "game/sheep/10.png"},{ bytes : 11048, md5 : "56915e2e0d00c85fab853be3818abd88", name : "game/sheep/11.png"},{ bytes : 11505, md5 : "0f28aa9c91df121bf3cd01914b593a1b", name : "game/sheep/12.png"},{ bytes : 11949, md5 : "437841ff75382eaf4392b3a32907d90d", name : "game/sheep/13.png"},{ bytes : 12416, md5 : "82bb0590d9e7a8ccde710b9175ca5e3f", name : "game/sheep/14.png"},{ bytes : 12928, md5 : "5b2f0be8bc5240d6f15373d684a2fc7d", name : "game/sheep/15.png"},{ bytes : 13400, md5 : "73a381862466d619fa2c86f130536dc8", name : "game/sheep/16.png"},{ bytes : 13839, md5 : "fa9f75c202d451d5a49a6d5ac027c2db", name : "game/sheep/17.png"},{ bytes : 14205, md5 : "34287e59fe11d7b69fa4a8095a1cfaab", name : "game/sheep/18.png"},{ bytes : 14595, md5 : "9323dadbf07cd0629489bd328b842ba7", name : "game/sheep/19.png"},{ bytes : 6000, md5 : "b127337a1baa9d4bd8db8522f8bea75f", name : "game/sheep/2.png"},{ bytes : 14847, md5 : "652c247a393498a91065a74cac393ea5", name : "game/sheep/20.png"},{ bytes : 15204, md5 : "efd6f195fa9ab60a48bf91f1242ae200", name : "game/sheep/21.png"},{ bytes : 15190, md5 : "a35abdaab8e20466d23d142cf8a7dca8", name : "game/sheep/22.png"},{ bytes : 15301, md5 : "109d4ce1b4ba4358b83ad4bc50adcf10", name : "game/sheep/23.png"},{ bytes : 15324, md5 : "569dee24fb3350bfa4e9bef69fa17b73", name : "game/sheep/24.png"},{ bytes : 15231, md5 : "7e1030363e0f6e3459e9a4777f4a6cc8", name : "game/sheep/25.png"},{ bytes : 14965, md5 : "858ea3da70473af0527a14ec7438b49f", name : "game/sheep/26.png"},{ bytes : 14584, md5 : "15f5d8caf52822f3010a76fa64ad99ef", name : "game/sheep/27.png"},{ bytes : 14347, md5 : "c9514df875ba9ea09f165ae1f65b3d1e", name : "game/sheep/28.png"},{ bytes : 13860, md5 : "ba1181959cfff09ddb3d90a8fd473774", name : "game/sheep/29.png"},{ bytes : 6985, md5 : "852e9ede527b98ed93efd3025edb1207", name : "game/sheep/3.png"},{ bytes : 13366, md5 : "d0be7f8433dcdd1e30539b786f7b3ff4", name : "game/sheep/30.png"},{ bytes : 12765, md5 : "951d0ce2caecb83318922b0250b4dc7f", name : "game/sheep/31.png"},{ bytes : 12097, md5 : "41e7df4a47cdaaa025b69c2903ac8e4d", name : "game/sheep/32.png"},{ bytes : 11249, md5 : "f4dedbdb47de671cfb7e4d676fb2eeac", name : "game/sheep/33.png"},{ bytes : 10574, md5 : "56f034b9866cd7dab9130b98bf31741a", name : "game/sheep/34.png"},{ bytes : 9683, md5 : "b328f5f6a1b24adcdcbfdbf674d25d38", name : "game/sheep/35.png"},{ bytes : 8971, md5 : "89a7029f5268f0ef3c19b0e4e8534464", name : "game/sheep/36.png"},{ bytes : 8179, md5 : "ed79ee8ef1a8374d80d6f99953b71836", name : "game/sheep/37.png"},{ bytes : 7464, md5 : "6d018f4a766d7cbf61aef5b87f6bb8a0", name : "game/sheep/38.png"},{ bytes : 6902, md5 : "dd714d7ac0443b66f24696a0b5035fa2", name : "game/sheep/39.png"},{ bytes : 7703, md5 : "77a3b9d3b9b26e594da07457b1ecca51", name : "game/sheep/4.png"},{ bytes : 6492, md5 : "d974b90f48e23edb064920a6a858f9e4", name : "game/sheep/40.png"},{ bytes : 6104, md5 : "553ed080fceecef757b51bdb8b34080e", name : "game/sheep/41.png"},{ bytes : 5712, md5 : "2da5d92cd43bd2f1dd04ee2e14cc67f8", name : "game/sheep/42.png"},{ bytes : 5330, md5 : "77774fc7b24aca78e0fe0bab1340f37f", name : "game/sheep/43.png"},{ bytes : 5261, md5 : "4b635779f6bdf7a476c39423b9b57dfb", name : "game/sheep/44.png"},{ bytes : 8429, md5 : "574735b6d7275de1531a3681263c9206", name : "game/sheep/5.png"},{ bytes : 9014, md5 : "d3b7a787af569eb914e4d4fa357cf6c5", name : "game/sheep/6.png"},{ bytes : 9464, md5 : "00ba9d61a4c575a835a819a4146e655b", name : "game/sheep/7.png"},{ bytes : 9856, md5 : "e7b2d44444618489b003d02423170054", name : "game/sheep/8.png"},{ bytes : 10205, md5 : "9882796ea723104085c13d59aa8a9747", name : "game/sheep/9.png"},{ bytes : 12662, md5 : "3dfbb471cbf1a5edc3c5a4a2c0c02491", name : "game/spatula/1.png"},{ bytes : 14209, md5 : "f25f88631d238eff2f3c452fb7dc4dcf", name : "game/spatula/10.png"},{ bytes : 14363, md5 : "cbc8339c0d4f540014d03e8b5b4f33be", name : "game/spatula/11.png"},{ bytes : 14421, md5 : "e2066142882a4407a3b0b21c34bf1649", name : "game/spatula/12.png"},{ bytes : 14304, md5 : "41f7c7daee8cb8aa6aa447438485c455", name : "game/spatula/13.png"},{ bytes : 14011, md5 : "052c6ea9d0646fce8442c5cad66345c6", name : "game/spatula/14.png"},{ bytes : 13899, md5 : "cd9d8284d3af82fc238eda5505ef93da", name : "game/spatula/15.png"},{ bytes : 13779, md5 : "8937b7eecbf6be48cb3df9c75cbeba38", name : "game/spatula/16.png"},{ bytes : 13593, md5 : "169af1e8e0e26be7c15d0bae639914bf", name : "game/spatula/17.png"},{ bytes : 13433, md5 : "15f31426e9d3a04ac37ff5dcc0c0f7f5", name : "game/spatula/18.png"},{ bytes : 13192, md5 : "bbbb426a38093cf52fd651ead05b060b", name : "game/spatula/19.png"},{ bytes : 12825, md5 : "84b3ad0a0726542beaaf21c79391bcfb", name : "game/spatula/2.png"},{ bytes : 13138, md5 : "daef0f2095f72f035b80e3f5c7fe2b3f", name : "game/spatula/20.png"},{ bytes : 13286, md5 : "8d508145c9880f03c8be0fac5892b37c", name : "game/spatula/21.png"},{ bytes : 13009, md5 : "c63b495269ee737efe8266069ee9c767", name : "game/spatula/22.png"},{ bytes : 12957, md5 : "c5409850df75bc6fd8d4491daf9dcd88", name : "game/spatula/23.png"},{ bytes : 13061, md5 : "df725c0171a2ab5ce7d20f20e34824b9", name : "game/spatula/24.png"},{ bytes : 13235, md5 : "fd08aa74ecd81256f733a52c8faa1a13", name : "game/spatula/25.png"},{ bytes : 13585, md5 : "c28dc82e013eb68caf99b3aac0086762", name : "game/spatula/26.png"},{ bytes : 14007, md5 : "ed34d164b3cf5eccd83d8ae77d60b176", name : "game/spatula/27.png"},{ bytes : 14621, md5 : "47bca230ed3e1c2c56da7757b6f098d6", name : "game/spatula/28.png"},{ bytes : 15042, md5 : "5a457288c8cf717d649dbe21fafd63d8", name : "game/spatula/29.png"},{ bytes : 13017, md5 : "bfa17313e1dadc263a6a534c65d642fd", name : "game/spatula/3.png"},{ bytes : 15528, md5 : "d94e8c5b28a5cef5e96846b237ea3909", name : "game/spatula/30.png"},{ bytes : 16159, md5 : "0a5f05620f8d8c06ff9cc2417761a889", name : "game/spatula/31.png"},{ bytes : 16700, md5 : "cef672e89deaee8dbc24be721120ac4e", name : "game/spatula/32.png"},{ bytes : 17076, md5 : "51e3a7025d354cfecca1227990eec9bf", name : "game/spatula/33.png"},{ bytes : 17240, md5 : "951ebec4c738ff9fcba4ce8ad6b036f7", name : "game/spatula/34.png"},{ bytes : 17152, md5 : "72c6c21ef9f1a64b07e67239a9ff9e61", name : "game/spatula/35.png"},{ bytes : 16673, md5 : "19cbfe379ec91b42092750036880f316", name : "game/spatula/36.png"},{ bytes : 16368, md5 : "b29d7fb26b72e4398ec618be50dec8b2", name : "game/spatula/37.png"},{ bytes : 16012, md5 : "0c48ebadc57edabbe00064702e9ffe7c", name : "game/spatula/38.png"},{ bytes : 15748, md5 : "01754bed716f2e08b18c01194d9413cd", name : "game/spatula/39.png"},{ bytes : 13189, md5 : "0a90b753533f1d88aa7672b84699f319", name : "game/spatula/4.png"},{ bytes : 15189, md5 : "4b9e74f57847a7d7e8d19be6096b1d2f", name : "game/spatula/40.png"},{ bytes : 14878, md5 : "e4c7bf86be9c9bfc524c665691ff4155", name : "game/spatula/41.png"},{ bytes : 14698, md5 : "bc078901edef69418a41bc437acc3505", name : "game/spatula/42.png"},{ bytes : 14523, md5 : "12542b26541875454ad632d97981dc5f", name : "game/spatula/43.png"},{ bytes : 14139, md5 : "632bb075b0010c324df01c29428888ce", name : "game/spatula/44.png"},{ bytes : 13228, md5 : "caa59c78991332b6144a963c06bb609a", name : "game/spatula/5.png"},{ bytes : 13300, md5 : "6b20f9437916a42c9a6e6960b537f049", name : "game/spatula/6.png"},{ bytes : 13511, md5 : "29e1899388c25fa01b3dd0ff4071afb4", name : "game/spatula/7.png"},{ bytes : 13633, md5 : "e9820bf819f08fc172ed12e3ddad32a9", name : "game/spatula/8.png"},{ bytes : 13958, md5 : "5287bce481841a8e3019de5caf2b5dba", name : "game/spatula/9.png"},{ bytes : 15549, md5 : "0765a62c6e982711a71ab11b7971b22b", name : "game/spatulagroup/1.png"},{ bytes : 15533, md5 : "4043f5e5b5f9f2d2639b46019d49628c", name : "game/spatulagroup/10.png"},{ bytes : 15515, md5 : "f2b9dde6e8e92ca3e1b238576103134c", name : "game/spatulagroup/11.png"},{ bytes : 16084, md5 : "f1702b6b20e6f03c818ceaafdda068ab", name : "game/spatulagroup/12.png"},{ bytes : 16741, md5 : "eea2e86db701cd1a4dbe9614e7f1adbd", name : "game/spatulagroup/13.png"},{ bytes : 17141, md5 : "cc538e8f5cbbfce1e50e170199edfd30", name : "game/spatulagroup/14.png"},{ bytes : 16768, md5 : "d0fe04cad453ae2840d8ddcbd13fd937", name : "game/spatulagroup/15.png"},{ bytes : 16483, md5 : "a73dd96ff5b97a4a04845e8597616871", name : "game/spatulagroup/16.png"},{ bytes : 16095, md5 : "443edb4501f66793ae59716530c97d03", name : "game/spatulagroup/17.png"},{ bytes : 16220, md5 : "5e145dd93f53f567a0bb6bc42a992b5f", name : "game/spatulagroup/18.png"},{ bytes : 14546, md5 : "531a95627713970cab89b5a0c59fdcd2", name : "game/spatulagroup/2.png"},{ bytes : 14320, md5 : "0fdfb947cfccf733df6d3707e2d8e131", name : "game/spatulagroup/3.png"},{ bytes : 14433, md5 : "ecf83499b36892b46e0cf902b2bfd34a", name : "game/spatulagroup/4.png"},{ bytes : 14177, md5 : "48288fd92fc427787bf0704cc15a24ea", name : "game/spatulagroup/5.png"},{ bytes : 13935, md5 : "20b8d26d7b96fb50ab8d7f78c564670b", name : "game/spatulagroup/6.png"},{ bytes : 13737, md5 : "1ee54e321a9a8a7d7d4118d746bdc8c5", name : "game/spatulagroup/7.png"},{ bytes : 14185, md5 : "8d0a4f243175190f2197f134aa883323", name : "game/spatulagroup/8.png"},{ bytes : 14975, md5 : "ac92e054dff429cabd08eccf0367d32f", name : "game/spatulagroup/9.png"},{ bytes : 43712, md5 : "255c1ea6ed14553d920e76c9920a6259", name : "game/spongebob/left_mid.png"},{ bytes : 49012, md5 : "7e68ce3ad004a059c9fb666730a26360", name : "game/spongebob/left_mid_throw1.png"},{ bytes : 43696, md5 : "866a588a2177e569d58ef88cba8c7555", name : "game/spongebob/left_mid_throw2.png"},{ bytes : 43443, md5 : "4cf13959ce817b632433ee4757484da1", name : "game/spongebob/right_mid.png"},{ bytes : 48944, md5 : "08fc7e37d0ac075abf180afb33be8baa", name : "game/spongebob/right_mid_throw1.png"},{ bytes : 45116, md5 : "2ae8368aa17eeb88e985d9354ac065d5", name : "game/spongebob/right_mid_throw2.png"},{ bytes : 42558, md5 : "567e203dbeaaa1bb854ceb06b8f68ae1", name : "game/spongebob/straight_mid.png"},{ bytes : 47798, md5 : "46b9f13174d8a7c469a7289a391e4403", name : "game/spongebob/straight_mid_throw1.png"},{ bytes : 43819, md5 : "450b216b1d7d4591c69e36eee1f6b6a7", name : "game/spongebob/straight_mid_throw2.png"},{ bytes : 64755, md5 : "73494d5ae006293e38d732c9dde0861b", name : "game/spongebob_spin/00000.png"},{ bytes : 57816, md5 : "c85e6987a0aa17f8acc002ca67d302c0", name : "game/spongebob_spin/00001.png"},{ bytes : 68338, md5 : "e4f46e1e0079d7b4cb4b678e79b79ad4", name : "game/spongebob_spin/00002.png"},{ bytes : 61218, md5 : "861c048904d11e2a1e33c03a7f41cd7c", name : "game/spongebob_spin/00003.png"},{ bytes : 66202, md5 : "d5392326ac2b1bfe23d26ea66daa3f77", name : "game/spongebob_spin/00004.png"},{ bytes : 59065, md5 : "21972fff7001b01beae5c651d1b3b091", name : "game/spongebob_spin/00005.png"},{ bytes : 67887, md5 : "cb9d50b53a44b09fdf185fe11ef2252e", name : "game/spongebob_spin/00006.png"},{ bytes : 64621, md5 : "a14e9ea2692157b764974922855d8010", name : "game/spongebob_spin/00007.png"},{ bytes : 64483, md5 : "a3eb50666eb4f2074d629a008e2f0b54", name : "game/spongebob_spin/00008.png"},{ bytes : 41306, md5 : "5e209b7efff9decfad97afdfccdf6b65", name : "game/squidward/left_mid.png"},{ bytes : 44916, md5 : "bbcdda9cb9b2a081c474cc0e5f8d597b", name : "game/squidward/left_mid_throw1.png"},{ bytes : 42212, md5 : "66878efb63638c706a38458463023bfe", name : "game/squidward/left_mid_throw2.png"},{ bytes : 40733, md5 : "239f95d9c4201332aa608f07e80fe39c", name : "game/squidward/right_mid.png"},{ bytes : 43142, md5 : "fd2802e89522e0b4bf21b9a6f95ed291", name : "game/squidward/right_mid_throw1.png"},{ bytes : 42132, md5 : "422fb52ea904dc52790f4102459a8363", name : "game/squidward/right_mid_throw2.png"},{ bytes : 40854, md5 : "85c8d2de98fd48f1cf6b46dbea29caff", name : "game/squidward/straight_mid.png"},{ bytes : 44322, md5 : "0808ac4ee6013742d102ab1af658a50b", name : "game/squidward/straight_mid_throw1.png"},{ bytes : 41530, md5 : "624adc44a87a4f1211756ad3e94506e3", name : "game/squidward/straight_mid_throw2.png"},{ bytes : 69014, md5 : "4535453b104693ec87e32ddfe902d1e0", name : "game/squidward_spin/00000.png"},{ bytes : 61020, md5 : "3a1de6a190f8c5bc8ff06604f20f0f0c", name : "game/squidward_spin/00001.png"},{ bytes : 70975, md5 : "0d6efdcfb81ef58121a2467a7d195558", name : "game/squidward_spin/00002.png"},{ bytes : 59539, md5 : "ba8c5e81a3a1793653e8876b19219c93", name : "game/squidward_spin/00003.png"},{ bytes : 69172, md5 : "c235c5893c417057a4b97a33a0675e8a", name : "game/squidward_spin/00004.png"},{ bytes : 58650, md5 : "07bbc3957b11ad49ba4fd4cd9083c9d1", name : "game/squidward_spin/00005.png"},{ bytes : 68817, md5 : "05559bb4e854042c6da83375566fb565", name : "game/squidward_spin/00006.png"},{ bytes : 63436, md5 : "d675b5057a5208aa0849fc5eea571fb1", name : "game/squidward_spin/00007.png"},{ bytes : 66683, md5 : "fc76fe2309303f076ac336636b9bcae9", name : "game/squidward_spin/00008.png"},{ bytes : 4111, md5 : "b1b3f9dfb5ad9dc7995a83aa0599bb04", name : "game/star1.png"},{ bytes : 4465, md5 : "39f3d5f9bb62c4620d88dfda77647e2a", name : "game/star2.png"},{ bytes : 4626, md5 : "d0488211c81f3185d8d1b9c8667d3bff", name : "game/star3.png"},{ bytes : 66329, md5 : "9e04398c7dd189df855eb83e1091d340", name : "game/star_crab/left_mid.png"},{ bytes : 68673, md5 : "74343970fea88fcb96dd8bcd493d1be4", name : "game/star_crab/left_mid_throw1.png"},{ bytes : 67024, md5 : "3d31f2ed3663df982c50934575c4002d", name : "game/star_crab/left_mid_throw2.png"},{ bytes : 66938, md5 : "17ec3d60e80615f98e89f323a57c1112", name : "game/star_crab/right_mid.png"},{ bytes : 69857, md5 : "9bccef9b57f2449076a36a1b9a707a90", name : "game/star_crab/right_mid_throw1.png"},{ bytes : 66744, md5 : "a6fed0309b27577a3990761c16b3e706", name : "game/star_crab/right_mid_throw2.png"},{ bytes : 63877, md5 : "a041df1a698193277a88d5e178ef05df", name : "game/star_crab/straight_mid.png"},{ bytes : 65424, md5 : "cfd869b6ca699da8a5485ea20e3437a9", name : "game/star_crab/straight_mid_throw1.png"},{ bytes : 63530, md5 : "6e0933749a98faaf46eda1fc77efa9bf", name : "game/star_crab/straight_mid_throw2.png"},{ bytes : 61511, md5 : "27b61f11bfcf8829b52508ea14edd615", name : "game/star_patrick/left_mid.png"},{ bytes : 66513, md5 : "8a43d6e04531cd314698037ed24488ac", name : "game/star_patrick/left_mid_throw1.png"},{ bytes : 63064, md5 : "181264df6dbee50f8f65b0804a479022", name : "game/star_patrick/left_mid_throw2.png"},{ bytes : 61621, md5 : "5d6441c4eb8bd47ace143230b287aa66", name : "game/star_patrick/right_mid.png"},{ bytes : 65994, md5 : "3e437988f5093293cf1b72f0ffbda9bb", name : "game/star_patrick/right_mid_throw1.png"},{ bytes : 61377, md5 : "bb920f62b6d21515e75525ffcdd6d4f4", name : "game/star_patrick/right_mid_throw2.png"},{ bytes : 58453, md5 : "7e0f284f3face9909228847521aa7071", name : "game/star_patrick/straight_mid.png"},{ bytes : 63533, md5 : "5b30c48989572dd9109f2144b85a4a0e", name : "game/star_patrick/straight_mid_throw1.png"},{ bytes : 59565, md5 : "c40a735ba71eb790093cba5f89f2c493", name : "game/star_patrick/straight_mid_throw2.png"},{ bytes : 63276, md5 : "88ac9f859bf5f4990bee205dde2d553e", name : "game/star_spongebob/left_mid.png"},{ bytes : 65695, md5 : "968308601c82c4ed01e09ff450528bf9", name : "game/star_spongebob/left_mid_throw1.png"},{ bytes : 63300, md5 : "37e23136e3c3af8fd80fbec4e946d4df", name : "game/star_spongebob/left_mid_throw2.png"},{ bytes : 63664, md5 : "718786e2de859a3ed0500af54778f897", name : "game/star_spongebob/right_mid.png"},{ bytes : 67564, md5 : "856b83242170c5fdeb2ff29173b8c395", name : "game/star_spongebob/right_mid_throw1.png"},{ bytes : 64258, md5 : "65b00452904cadc28a13bc2673c37936", name : "game/star_spongebob/right_mid_throw2.png"},{ bytes : 59687, md5 : "867b14471a0f5e01932f58805b198f27", name : "game/star_spongebob/straight_mid.png"},{ bytes : 62188, md5 : "6b4a3f8b7503d1e53060ab39ebf195e2", name : "game/star_spongebob/straight_mid_throw1.png"},{ bytes : 59917, md5 : "f3e0550b3aa743be42b72cdf6a216a6b", name : "game/star_spongebob/straight_mid_throw2.png"},{ bytes : 67382, md5 : "047086fb6c52ae1b9d05abae24ccc6e7", name : "game/star_squidward/left_mid.png"},{ bytes : 69634, md5 : "28d48e8955174cda28127cb3193705ee", name : "game/star_squidward/left_mid_throw1.png"},{ bytes : 68169, md5 : "2068ea89713e4c479b2810a0c2a0e562", name : "game/star_squidward/left_mid_throw2.png"},{ bytes : 67703, md5 : "03131c28294d1b4b414582f6be966311", name : "game/star_squidward/right_mid.png"},{ bytes : 69931, md5 : "027f69114e20e7a90c6b4b36e017ccf5", name : "game/star_squidward/right_mid_throw1.png"},{ bytes : 68796, md5 : "9017c21011b1b2e00a6fdce661c42ab5", name : "game/star_squidward/right_mid_throw2.png"},{ bytes : 64162, md5 : "71213ac10cb807a98e17c5d80bc1e864", name : "game/star_squidward/straight_mid.png"},{ bytes : 66872, md5 : "f89a1070826d549b6a075e17a217fcf4", name : "game/star_squidward/straight_mid_throw1.png"},{ bytes : 64850, md5 : "2822c0cecc9173ce14836474a58505d5", name : "game/star_squidward/straight_mid_throw2.png"},{ bytes : 6491, md5 : "356d9984b1e2f2f74fa389538d4d51a8", name : "game/stars/1.png"},{ bytes : 6422, md5 : "570b2a6d7796130c0ac1298f69dca54e", name : "game/stars/2.png"},{ bytes : 6129, md5 : "451c8cec232072a7cb75eefbfd475d64", name : "game/stars/3.png"},{ bytes : 5882, md5 : "f3e5c93f35001eb75acaf2dc40e74921", name : "game/stars/4.png"},{ bytes : 5749, md5 : "812e525bc76e16acb82f194058c4e026", name : "game/stars/5.png"},{ bytes : 5808, md5 : "8fd65fb4f880e053d30795f286d19331", name : "game/stars/6.png"},{ bytes : 6024, md5 : "f610db4f5705df5e4409416dc231ca6c", name : "game/stars/7.png"},{ bytes : 6280, md5 : "862c8361639971410bbfa5a2178cd603", name : "game/stars/8.png"},{ bytes : 20664, md5 : "692832fa859b8a435962531609a72b87", name : "game/stoplight.png"},{ bytes : 12885, md5 : "11cd263b9cc1c4d1882018136edf4a43", name : "game/text_finished.png"},{ bytes : 7864, md5 : "87441aef0d00bcaa52f4fbfd1cc804ab", name : "game/text_go.png"},{ bytes : 2070, md5 : "b49c0e6435aea7b05e036963acff5785", name : "instructions/btn_close.png"},{ bytes : 30167, md5 : "f09ab664ec0b49958cd33620fbce2083", name : "instructions/btn_start.png"},{ bytes : 31592, md5 : "25d1b5eea5fe40fec8d7adcb09ed0305", name : "instructions/btn_start_over.png"},{ bytes : 73001, md5 : "ca0db47526400205d5d8adad594aa810", name : "instructions/instructions.png"},{ bytes : 78477, md5 : "da469b1e75a8d4b237b490453429ad3f", name : "instructions/instructions_mobile.png"},{ bytes : 1515553, md5 : "102bb5b512f51b0cdc59306d69d31a76", name : "sounds/bgmusic_game.mp3"},{ bytes : 734405, md5 : "87267b9b5d9ff2cf2ee95c9dc045a5d3", name : "sounds/bgmusic_start.mp3"},{ bytes : 10577, md5 : "897de292110800dec8d8c85a35beb0ac", name : "sounds/buttonclick.mp3"},{ bytes : 18427, md5 : "069287ee65b1652fa15ebfdffa332eb3", name : "sounds/buttonclick2.mp3"},{ bytes : 15981, md5 : "e34d4c6a3c4fa4955f83669db4d69b9e", name : "sounds/countdown1.mp3"},{ bytes : 38302, md5 : "672865762c56691c1e674a6a90343d96", name : "sounds/countdown2.mp3"},{ bytes : 27583, md5 : "dff59e2493735a73e924dae8df3c9a8f", name : "sounds/finishedlap.mp3"},{ bytes : 39844, md5 : "b814f9b39c48da483be75cef04291ce4", name : "sounds/hitracer.mp3"},{ bytes : 33662, md5 : "ad736a4edb365a6a9bece9c61d34ab73", name : "sounds/hole.mp3"},{ bytes : 50217, md5 : "bb5b045d69548b4f1f94c260dd44cac7", name : "sounds/motor_together.mp3"},{ bytes : 25317, md5 : "4680385df8c47f2dee14ff26589db392", name : "sounds/pillow_pickup.mp3"},{ bytes : 21302, md5 : "02aa02a6c254787abeecbf79a638114c", name : "sounds/rank.mp3"},{ bytes : 10556, md5 : "8a6c0ae8258e57d7cd7ef32d79a8095a", name : "sounds/shotpillow.mp3"},{ bytes : 20662, md5 : "8a54ec7e66e0da4aaafd71ba45a94cf5", name : "sounds/spinout.mp3"},{ bytes : 26370, md5 : "9b278e06401e6053a25172be125ebf69", name : "sounds/turbo.mp3"},{ bytes : 24771, md5 : "235c53047fed2abc56ac55231d3c61e2", name : "sounds/woosh.mp3"}], bootstrap : [{ bytes : 1149, md5 : "77425716e8804750911e096d5265bf1a", name : "bg_gradient.png"},{ bytes : 2023, md5 : "340fccf4bc4843dad65011dfb7974fa2", name : "feather-1.png"},{ bytes : 1699, md5 : "239c3a21dd0e96147560c3412382a8b2", name : "feather-2.png"},{ bytes : 1425, md5 : "005fe5a93032600023abbddc9adbb81f", name : "font_preload.fnt"},{ bytes : 4754, md5 : "9389e5a6fc78b2012af120c8d89ef76d", name : "font_preload.png"},{ bytes : 11858, md5 : "f702a6119d74c648c4e04c04bea1e6c1", name : "pillow.png"},{ bytes : 3844, md5 : "35cf577c2ff1fe5e45d62395b5e503aa", name : "preloader_roll.png"},{ bytes : 2653, md5 : "03a9742a3095967a29bc07dd0d21b2fe", name : "preloader_tap.png"},{ bytes : 10577, md5 : "897de292110800dec8d8c85a35beb0ac", name : "sounds/buttonclick.mp3"},{ bytes : 18427, md5 : "069287ee65b1652fa15ebfdffa332eb3", name : "sounds/buttonclick2.mp3"},{ bytes : 11385, md5 : "632b7704b3c6155b92cd7ef5c020eaae", name : "txt_1.png"},{ bytes : 12057, md5 : "07e402cc75acbc7f519a011346b3b5c4", name : "txt_2.png"},{ bytes : 11402, md5 : "a8b86ee6811aed43015be61f43f68622", name : "txt_3.png"}], mobile_game : [{ bytes : 21252, md5 : "5877b1d4a01b8121aabe67941261b04b", name : "closeconfirm/background.png"},{ bytes : 15095, md5 : "c33c8b44382c57ffc9c38a9d4c9dda76", name : "closeconfirm/btn_no.png"},{ bytes : 15995, md5 : "0121a6cafd0a1a6be83b470c38d05d53", name : "closeconfirm/btn_no_over.png"},{ bytes : 17034, md5 : "7dfafbb5a21377d4475e4629bac9c2dd", name : "closeconfirm/btn_yes.png"},{ bytes : 17986, md5 : "6b2fc243f1c277481122f872bdd8f772", name : "closeconfirm/btn_yes_over.png"},{ bytes : 2023, md5 : "340fccf4bc4843dad65011dfb7974fa2", name : "feather-1.png"},{ bytes : 1699, md5 : "239c3a21dd0e96147560c3412382a8b2", name : "feather-2.png"},{ bytes : 3120, md5 : "93f472bc04753f6d640d503352e05d48", name : "finishstar.png"},{ bytes : 12020, md5 : "41c9651f17260e54dfa1714f85d947a2", name : "fonts/BonusTxt.fnt"},{ bytes : 30036, md5 : "7431cc42c16824474ad9d13d22f2299c", name : "fonts/BonusTxt.png"},{ bytes : 12023, md5 : "f1085f9ecf08af337b2360b21e055dff", name : "fonts/BonusTxtErr.fnt"},{ bytes : 32284, md5 : "02baeae8936b0bca50469b34b80caecd", name : "fonts/BonusTxtErr.png"},{ bytes : 12028, md5 : "b32e8ebaa230a2a72894b55541cab9d4", name : "fonts/BonusTxtErrLarge.fnt"},{ bytes : 54011, md5 : "eb1ea4b3c748a00169726ba14ede84c8", name : "fonts/BonusTxtErrLarge.png"},{ bytes : 12025, md5 : "54db9f2a2e830c3fb601690c318298e0", name : "fonts/BonusTxtLarge.fnt"},{ bytes : 50756, md5 : "88b42e6650bd3523b4f524619627cda1", name : "fonts/BonusTxtLarge.png"},{ bytes : 2348, md5 : "e9f8f7153af0d66c00032c52e3023d21", name : "fonts/endscore.fnt"},{ bytes : 7117, md5 : "85e23213e3fccc67db47a0a7c92aeb90", name : "fonts/endscore.png"},{ bytes : 2355, md5 : "fee429c3385ddb62aea095b71fbcaf77", name : "fonts/endscore_yellow.fnt"},{ bytes : 10298, md5 : "82089e4fe2c65c2336691f1f34cd3f81", name : "fonts/endscore_yellow.png"},{ bytes : 2470, md5 : "26aba01678f91b7d5bda227a4b56275e", name : "fonts/LapTxt.fnt"},{ bytes : 8699, md5 : "52cc19360fbf6d0c67d621b3de602683", name : "fonts/LapTxt.png"},{ bytes : 2348, md5 : "205d4eaed7f981d891eeecdc8c37d508", name : "fonts/TimerTxt.fnt"},{ bytes : 14013, md5 : "c2d1aeb60917ed8a3560ca4e916f5f60", name : "fonts/TimerTxt.png"},{ bytes : 326124, md5 : "ebae99f69a69cf7e592e09a93968b3b2", name : "game/bg_hills.png"},{ bytes : 292076, md5 : "3a64991c706a5db482e7683e7fe1514d", name : "game/bg_sky_left.png"},{ bytes : 289483, md5 : "b6e074cdea33cd3e50da53ee53897ee2", name : "game/bg_sky_mid.png"},{ bytes : 70991, md5 : "dee3db288f73e46211b421f6d3bcbca7", name : "game/bg_sky_right.png"},{ bytes : 160125, md5 : "962c6da970416b1d99093a63c87c8429", name : "game/bg_trees.png"},{ bytes : 21150, md5 : "9a9f50185e237586fd9896825bfc67db", name : "game/books.png"},{ bytes : 2916, md5 : "7650ff1d258274108c5cb51d06184ba0", name : "game/btn_close.png"},{ bytes : 15019, md5 : "66275ff02d01a06aa67dfa145cc29f00", name : "game/clock.png"},{ bytes : 39440, md5 : "539600c8f82fe46258f2b70ac6a18596", name : "game/crab/left_down.png"},{ bytes : 44393, md5 : "c7c7261c0f7cd59c8c0f778a43ba3d11", name : "game/crab/left_mid.png"},{ bytes : 49133, md5 : "4c02058557f11b042c4c8987ad8ebb6e", name : "game/crab/left_up.png"},{ bytes : 40285, md5 : "04ff5b0fe6aa0a04af09c69c88cb2208", name : "game/crab/right_down.png"},{ bytes : 44922, md5 : "b119074d65a387f1b99f98b85565d64e", name : "game/crab/right_mid.png"},{ bytes : 48981, md5 : "a0122b88dff88b4d49ce0dab5d98648a", name : "game/crab/right_up.png"},{ bytes : 39954, md5 : "08f2ef0e1225d30362068338cb0312ea", name : "game/crab/straight_down.png"},{ bytes : 45378, md5 : "732a674cd58dcff64906a2b1b8e66b44", name : "game/crab/straight_mid.png"},{ bytes : 49167, md5 : "b2ae034966c78c63ad79a64359525f73", name : "game/crab/straight_up.png"},{ bytes : 1213, md5 : "4362ff4242cd6c3e58d36c10190633db", name : "game/flag.png"},{ bytes : 20332, md5 : "019fc6313db24ce6cc940ead932048d4", name : "game/hole.png"},{ bytes : 41554, md5 : "83852fd3ba3082b8dc4142edc57999d9", name : "game/hotrod_crab/left_down.png"},{ bytes : 45883, md5 : "0412227275d38362ddbc2acf9ad0399c", name : "game/hotrod_crab/left_mid.png"},{ bytes : 49657, md5 : "13a0c106548d0c433b4ec08fd1fdde7c", name : "game/hotrod_crab/left_up.png"},{ bytes : 42132, md5 : "cc51d4f4054f155ba4e0993d99fab78c", name : "game/hotrod_crab/right_down.png"},{ bytes : 46674, md5 : "168121051885c7cad6c2d1dc4f3f2af2", name : "game/hotrod_crab/right_mid.png"},{ bytes : 50557, md5 : "93c6b75c11b919b1c09b1488e8a769d8", name : "game/hotrod_crab/right_up.png"},{ bytes : 41689, md5 : "06041df8cf85ca95fd14c36a8276ac15", name : "game/hotrod_crab/straight_down.png"},{ bytes : 46569, md5 : "da5aedb0eaac4b710b763f79655f0850", name : "game/hotrod_crab/straight_mid.png"},{ bytes : 50282, md5 : "c88b3f6db2f3eef8483992953925cc38", name : "game/hotrod_crab/straight_up.png"},{ bytes : 36919, md5 : "4df0c24207cd50398523ec10c8826dd0", name : "game/hotrod_patrick/left_down.png"},{ bytes : 41749, md5 : "6a2b152220f4b73bfe6fdc298bb4d6f0", name : "game/hotrod_patrick/left_mid.png"},{ bytes : 45878, md5 : "8b567d759db4f5a82cde4e5d8f5dc28e", name : "game/hotrod_patrick/left_up.png"},{ bytes : 37253, md5 : "7d775a85976b067dd1dfc260dc5c6044", name : "game/hotrod_patrick/right_down.png"},{ bytes : 42406, md5 : "132a5f5792b3a298365148f09d8ff448", name : "game/hotrod_patrick/right_mid.png"},{ bytes : 46553, md5 : "b6011d4a851b2109be35f24a5e1f7bb4", name : "game/hotrod_patrick/right_up.png"},{ bytes : 37814, md5 : "104d1aeb3944f051cc341f5e83888fb0", name : "game/hotrod_patrick/straight_down.png"},{ bytes : 42982, md5 : "0f046f6fa3eefc2de7c54c22920bf485", name : "game/hotrod_patrick/straight_mid.png"},{ bytes : 46691, md5 : "81036669a6f619a793ea564a1527feef", name : "game/hotrod_patrick/straight_up.png"},{ bytes : 39542, md5 : "e28e15b481eccfebea9c276c565156e2", name : "game/hotrod_spongebob/left_down.png"},{ bytes : 44247, md5 : "f79d3032420e070ed9fcacd88c6e8062", name : "game/hotrod_spongebob/left_mid.png"},{ bytes : 47437, md5 : "8e188a2b19a7793677d2587248adeba2", name : "game/hotrod_spongebob/left_up.png"},{ bytes : 39750, md5 : "136a53bb1bc1d0ae5ad35c2daad02ecb", name : "game/hotrod_spongebob/right_down.png"},{ bytes : 44274, md5 : "008cbeef95c0d12d84badd57d6154415", name : "game/hotrod_spongebob/right_mid.png"},{ bytes : 47514, md5 : "72a0b13fb0f67ffe7e5a35627310d99b", name : "game/hotrod_spongebob/right_up.png"},{ bytes : 37868, md5 : "7df149b38461afb17f8227248b582d69", name : "game/hotrod_spongebob/straight_down.png"},{ bytes : 43173, md5 : "ec33207ba0ca9b2e145bdee20eec689b", name : "game/hotrod_spongebob/straight_mid.png"},{ bytes : 46895, md5 : "5544bd7ca6c666d46a8f69537d6c30d3", name : "game/hotrod_spongebob/straight_up.png"},{ bytes : 39071, md5 : "cfd13d65c63b1099f81d0b194f22f327", name : "game/hotrod_squidward/left_down.png"},{ bytes : 45397, md5 : "3ceb86490bb76bd0d9f77219af51a02e", name : "game/hotrod_squidward/left_mid.png"},{ bytes : 50218, md5 : "cff8adec251d5c10bc2b9fc18ee0a667", name : "game/hotrod_squidward/left_up.png"},{ bytes : 39090, md5 : "6a2f6109962e193ead6576060ec62316", name : "game/hotrod_squidward/right_down.png"},{ bytes : 45281, md5 : "64d7ac510db20d771836005c853516b6", name : "game/hotrod_squidward/right_mid.png"},{ bytes : 50432, md5 : "ffd781f5898d4d5a7a61b7dd9f233c30", name : "game/hotrod_squidward/right_up.png"},{ bytes : 38878, md5 : "20c8d99af46ff71e5617b64c78186920", name : "game/hotrod_squidward/straight_down.png"},{ bytes : 45118, md5 : "34367c512d0ce9d493255240706fce07", name : "game/hotrod_squidward/straight_mid.png"},{ bytes : 49774, md5 : "816f3de602db6bdd9450f2dc95632301", name : "game/hotrod_squidward/straight_up.png"},{ bytes : 8214, md5 : "eab011678c23a800e0738f28c9039a65", name : "game/lightning.png"},{ bytes : 1532, md5 : "c02b6e635716051c28470b436b275a63", name : "game/mobile_btn_help.png"},{ bytes : 1475, md5 : "f1e95282067d828f33400b0a2f9950e9", name : "game/mobile_btn_help_over.png"},{ bytes : 1229, md5 : "021841e01c7011b83ab65aeab7325fda", name : "game/mobile_btn_sound_off.png"},{ bytes : 1218, md5 : "5cb17da0d9b243813e4d1f796de0757a", name : "game/mobile_btn_sound_off_over.png"},{ bytes : 1659, md5 : "712cf2f26c6e2e14716713a7f6457e5d", name : "game/mobile_btn_sound_on.png"},{ bytes : 1578, md5 : "79fa20839298354ebac39bd1b50f7433", name : "game/mobile_btn_sound_on_over.png"},{ bytes : 16236, md5 : "dab88afe2fb29c5c2b1ea35f1446ec08", name : "game/mobile_ui.png"},{ bytes : 37066, md5 : "4b8aa2b52bdd93647c38e03d38e1b4b7", name : "game/moon.png"},{ bytes : 410, md5 : "7c3e0bd4d41b94f559c6c99eee11882d", name : "game/particles/bubble.png"},{ bytes : 1369, md5 : "9280e2001c21a4da81a8d56895bf090a", name : "game/particles/bubbles.pex"},{ bytes : 1366, md5 : "df3e96b6b48cab515988fc92558d62e0", name : "game/particles/bubbles_front.pex"},{ bytes : 1370, md5 : "8a3a3c86a589cbc35f681a427083f927", name : "game/particles/bubbles_npc.pex"},{ bytes : 1365, md5 : "b3298b37a1bf7fe1817dddd3c30406cf", name : "game/particles/bubbles_spin.pex"},{ bytes : 1376, md5 : "7842676766feaf7ed1e8a2fafe2f2ab8", name : "game/particles/bubbles_turbo.pex"},{ bytes : 1372, md5 : "a3d55daac869940f797341351093c780", name : "game/particles/bubbles_turbo_front.pex"},{ bytes : 1308, md5 : "af708314cc05e80c56cef89c1c2bacc8", name : "game/particles/bubbleYellow.png"},{ bytes : 35140, md5 : "9f632720fd37dff8c42fe1988e3a1ed9", name : "game/patrick/left_down.png"},{ bytes : 40864, md5 : "ef1292ec5927ab7a38f9dff92937c83d", name : "game/patrick/left_mid.png"},{ bytes : 45868, md5 : "be319a8b324a4fa2bf60db2bb33165b5", name : "game/patrick/left_up.png"},{ bytes : 35789, md5 : "3e2a808c451906f76e5a504cc3a63826", name : "game/patrick/right_down.png"},{ bytes : 40630, md5 : "9560be6187e8c395a8b455b57bc18f6c", name : "game/patrick/right_mid.png"},{ bytes : 45678, md5 : "af268d3b897cd47d6717ecdc564f629f", name : "game/patrick/right_up.png"},{ bytes : 36395, md5 : "6c91cb8d2669111748c7ee2cff4f51e1", name : "game/patrick/straight_down.png"},{ bytes : 41705, md5 : "d5c13165b754884c1276d83346669e77", name : "game/patrick/straight_mid.png"},{ bytes : 45777, md5 : "f92de18f13bb72e602a61ae63289efc1", name : "game/patrick/straight_up.png"},{ bytes : 6898, md5 : "3c9765d3309384feb7d2daf55133d97a", name : "game/pillow.png"},{ bytes : 7403, md5 : "9c430918dae34ac2c0269f3fe20b2336", name : "game/pillow_left.png"},{ bytes : 7477, md5 : "5618339c3dcaf0e1e435f5befb911015", name : "game/pillow_right.png"},{ bytes : 7515, md5 : "cf22990fbe6833f945091d657d93024b", name : "game/place_1.png"},{ bytes : 8279, md5 : "3f57b67b93b284f184504b70783ad578", name : "game/place_2.png"},{ bytes : 8812, md5 : "0f38b710c7ea598757c0bb574fa6edd2", name : "game/place_3.png"},{ bytes : 7133, md5 : "4710f886c8e3a8bbfda1d0a9707cae26", name : "game/place_4.png"},{ bytes : 5508, md5 : "2b57b25292128c86ed3b2664ca131ac7", name : "game/place_empty.png"},{ bytes : 16122, md5 : "0b5999d5b839cf04360544b3c4da9cbe", name : "game/powerup_pillow.png"},{ bytes : 47431, md5 : "c1b27f688bfc676ac8aa6d3f002fde27", name : "game/ramp_large.png"},{ bytes : 20240, md5 : "a372a2cfb4003ddc6cc27df3b0f628c7", name : "game/ramp_small.png"},{ bytes : 64894, md5 : "d8f15738655623b8393ef80c94fe51f7", name : "game/ring.png"},{ bytes : 92497, md5 : "2225c7ecac32f67ee448743592b6a5d1", name : "game/ring_finish.png"},{ bytes : 75810, md5 : "c9618cce73701eb756a42d72183a750d", name : "game/ring_lap1.png"},{ bytes : 76229, md5 : "4d1c831863398354294178651f6d30c1", name : "game/ring_lap2.png"},{ bytes : 76483, md5 : "2e4f46f1940c363d4ce4d5efaef9b8dd", name : "game/ring_lap3.png"},{ bytes : 77193, md5 : "84cc79cb9184bb65688515dfa7cf091b", name : "game/ring_start.png"},{ bytes : 2551, md5 : "d467d6c9a2a900acdb2bfcd3e71b8a7e", name : "game/road/rail_left.png"},{ bytes : 2472, md5 : "3cb70ca0a719ebda02117fde864dd2d3", name : "game/road/rail_right.png"},{ bytes : 1314, md5 : "8bf795593ccec0d5b337fc48abf7163c", name : "game/road/road_left.png"},{ bytes : 2221, md5 : "ab31169be696dd97922f8f5096ab08fb", name : "game/road/road_mobile.png"},{ bytes : 1347, md5 : "7435b42e341c87ce2b4339f6bc632156", name : "game/road/road_right.png"},{ bytes : 14674, md5 : "0b3dda4d20ea5103286a6ccf6bb3deae", name : "game/scoreboard.png"},{ bytes : 13400, md5 : "73a381862466d619fa2c86f130536dc8", name : "game/sheep.png"},{ bytes : 13899, md5 : "cd9d8284d3af82fc238eda5505ef93da", name : "game/spatula.png"},{ bytes : 16084, md5 : "f1702b6b20e6f03c818ceaafdda068ab", name : "game/spatulagroup.png"},{ bytes : 39467, md5 : "a644f03a7233682986c0a6ed577523a0", name : "game/spongebob/left_down.png"},{ bytes : 37149, md5 : "54908364c1beaf2256a8c89ff68f90f6", name : "game/spongebob/left_down2.png"},{ bytes : 43712, md5 : "255c1ea6ed14553d920e76c9920a6259", name : "game/spongebob/left_mid.png"},{ bytes : 45989, md5 : "4d7e4d04fd9e89cd89564ceff2a38268", name : "game/spongebob/left_mid2.png"},{ bytes : 46766, md5 : "55c86a664ebcc029935b6920ca1950be", name : "game/spongebob/left_up.png"},{ bytes : 49021, md5 : "9a954ecd5aa6a8e16017656a76e25c16", name : "game/spongebob/left_up2.png"},{ bytes : 39828, md5 : "75666c782010eb088bdc935785d803d6", name : "game/spongebob/right_down.png"},{ bytes : 37546, md5 : "cd4f90ffd5afcdfa8d5642b406d789ec", name : "game/spongebob/right_down2.png"},{ bytes : 43443, md5 : "4cf13959ce817b632433ee4757484da1", name : "game/spongebob/right_mid.png"},{ bytes : 46713, md5 : "45d6df21daa573f6e180d505c47e1a80", name : "game/spongebob/right_mid2.png"},{ bytes : 46624, md5 : "e657a9eab33aebd80210787abfe1114b", name : "game/spongebob/right_up.png"},{ bytes : 51153, md5 : "64768f4fa0b68e8fa9977653f41dd449", name : "game/spongebob/right_up2.png"},{ bytes : 38067, md5 : "f5fc7075a7635a3817860276f04b3664", name : "game/spongebob/straight_down.png"},{ bytes : 42558, md5 : "567e203dbeaaa1bb854ceb06b8f68ae1", name : "game/spongebob/straight_mid.png"},{ bytes : 46473, md5 : "89c7f3c354bc371e7df2b8b4da52a7eb", name : "game/spongebob/straight_up.png"},{ bytes : 34289, md5 : "1d2ea8d562f2a131b732e56ce7d07126", name : "game/squidward/left_down.png"},{ bytes : 41306, md5 : "5e209b7efff9decfad97afdfccdf6b65", name : "game/squidward/left_mid.png"},{ bytes : 47560, md5 : "6723b29e9d7e15be8766a9cba547ae01", name : "game/squidward/left_up.png"},{ bytes : 34327, md5 : "015e5c0b8977bd5b665d70fce7525365", name : "game/squidward/right_down.png"},{ bytes : 40733, md5 : "239f95d9c4201332aa608f07e80fe39c", name : "game/squidward/right_mid.png"},{ bytes : 46799, md5 : "02ef120e81d264970067894796951f6a", name : "game/squidward/right_up.png"},{ bytes : 34388, md5 : "2f85ea403c3225c6e0e91e283859ad44", name : "game/squidward/straight_down.png"},{ bytes : 40854, md5 : "85c8d2de98fd48f1cf6b46dbea29caff", name : "game/squidward/straight_mid.png"},{ bytes : 46397, md5 : "c12c53f6813b3dc80f0d7c39d3559b62", name : "game/squidward/straight_up.png"},{ bytes : 4111, md5 : "b1b3f9dfb5ad9dc7995a83aa0599bb04", name : "game/star1.png"},{ bytes : 4465, md5 : "39f3d5f9bb62c4620d88dfda77647e2a", name : "game/star2.png"},{ bytes : 4626, md5 : "d0488211c81f3185d8d1b9c8667d3bff", name : "game/star3.png"},{ bytes : 57935, md5 : "034b5beaaf6fe0e52188addfd605f033", name : "game/star_crab/left_down.png"},{ bytes : 66329, md5 : "9e04398c7dd189df855eb83e1091d340", name : "game/star_crab/left_mid.png"},{ bytes : 74078, md5 : "001407480e9caabc26a5ddaf09c9cf4c", name : "game/star_crab/left_up.png"},{ bytes : 59147, md5 : "ad563dff6ead8172260ae8047cc84a9a", name : "game/star_crab/right_down.png"},{ bytes : 66938, md5 : "17ec3d60e80615f98e89f323a57c1112", name : "game/star_crab/right_mid.png"},{ bytes : 74221, md5 : "4e1979f898c6962dbacac28eedefc82f", name : "game/star_crab/right_up.png"},{ bytes : 55469, md5 : "3a55e5d809bca6062081a9849e0897a0", name : "game/star_crab/straight_down.png"},{ bytes : 63877, md5 : "a041df1a698193277a88d5e178ef05df", name : "game/star_crab/straight_mid.png"},{ bytes : 70582, md5 : "e9925600c2f84f04137ff343ad4f527a", name : "game/star_crab/straight_up.png"},{ bytes : 53717, md5 : "5bd2e1170e564eb29803c070c6dff385", name : "game/star_patrick/left_down.png"},{ bytes : 61511, md5 : "27b61f11bfcf8829b52508ea14edd615", name : "game/star_patrick/left_mid.png"},{ bytes : 68114, md5 : "c34b68ace2fe70d02a701dea1e28a5c0", name : "game/star_patrick/left_up.png"},{ bytes : 54158, md5 : "e05422e1afb791539885ae05c75d8b3c", name : "game/star_patrick/right_down.png"},{ bytes : 61621, md5 : "5d6441c4eb8bd47ace143230b287aa66", name : "game/star_patrick/right_mid.png"},{ bytes : 68374, md5 : "c64fc5db5a79c994969ca54862f4ed24", name : "game/star_patrick/right_up.png"},{ bytes : 50612, md5 : "34c07035ff39fa68e19b0e5d8bca9de8", name : "game/star_patrick/straight_down.png"},{ bytes : 58453, md5 : "7e0f284f3face9909228847521aa7071", name : "game/star_patrick/straight_mid.png"},{ bytes : 64691, md5 : "a90030e2811c72730ed37d2e9bdb9e06", name : "game/star_patrick/straight_up.png"},{ bytes : 56621, md5 : "1c6ce43dcdc8a4649f915d705214b4b7", name : "game/star_spongebob/left_down.png"},{ bytes : 63276, md5 : "88ac9f859bf5f4990bee205dde2d553e", name : "game/star_spongebob/left_mid.png"},{ bytes : 69036, md5 : "1e0a87e987bd97e942e05c0323f43a82", name : "game/star_spongebob/left_up.png"},{ bytes : 57201, md5 : "6ade1ab3c5c3bdf6ac86e0c504c39625", name : "game/star_spongebob/right_down.png"},{ bytes : 63664, md5 : "718786e2de859a3ed0500af54778f897", name : "game/star_spongebob/right_mid.png"},{ bytes : 69095, md5 : "78c966db7fe27b77cd0823a218b35420", name : "game/star_spongebob/right_up.png"},{ bytes : 52630, md5 : "051c6335ddeb7a49e3d5d4a1a96b1632", name : "game/star_spongebob/straight_down.png"},{ bytes : 59687, md5 : "867b14471a0f5e01932f58805b198f27", name : "game/star_spongebob/straight_mid.png"},{ bytes : 65094, md5 : "7df40dfcbd5b5b8c70b4c9cdf4528e74", name : "game/star_spongebob/straight_up.png"},{ bytes : 58924, md5 : "a7e90a88c0f424a8e752c3dae7e41f22", name : "game/star_squidward/left_down.png"},{ bytes : 67382, md5 : "047086fb6c52ae1b9d05abae24ccc6e7", name : "game/star_squidward/left_mid.png"},{ bytes : 74546, md5 : "91e435553c3c96d9bea998f85b7b2a8a", name : "game/star_squidward/left_up.png"},{ bytes : 59313, md5 : "c82338753b87faab79111ae2eaf5b409", name : "game/star_squidward/right_down.png"},{ bytes : 67703, md5 : "03131c28294d1b4b414582f6be966311", name : "game/star_squidward/right_mid.png"},{ bytes : 74654, md5 : "df10aa656cba78dd752e86d54177c966", name : "game/star_squidward/right_up.png"},{ bytes : 55797, md5 : "b98aaf8e044d8ae4e42d32301640a6d3", name : "game/star_squidward/straight_down.png"},{ bytes : 64162, md5 : "71213ac10cb807a98e17c5d80bc1e864", name : "game/star_squidward/straight_mid.png"},{ bytes : 70825, md5 : "bc76b968163b9ab2ac51589b56d25547", name : "game/star_squidward/straight_up.png"},{ bytes : 5882, md5 : "f3e5c93f35001eb75acaf2dc40e74921", name : "game/stars.png"},{ bytes : 20664, md5 : "692832fa859b8a435962531609a72b87", name : "game/stoplight.png"},{ bytes : 12885, md5 : "11cd263b9cc1c4d1882018136edf4a43", name : "game/text_finished.png"},{ bytes : 7864, md5 : "87441aef0d00bcaa52f4fbfd1cc804ab", name : "game/text_go.png"},{ bytes : 2070, md5 : "b49c0e6435aea7b05e036963acff5785", name : "instructions/btn_close.png"},{ bytes : 30167, md5 : "f09ab664ec0b49958cd33620fbce2083", name : "instructions/btn_start.png"},{ bytes : 31592, md5 : "25d1b5eea5fe40fec8d7adcb09ed0305", name : "instructions/btn_start_over.png"},{ bytes : 73001, md5 : "ca0db47526400205d5d8adad594aa810", name : "instructions/instructions.png"},{ bytes : 78477, md5 : "da469b1e75a8d4b237b490453429ad3f", name : "instructions/instructions_mobile.png"},{ bytes : 1515553, md5 : "102bb5b512f51b0cdc59306d69d31a76", name : "sounds/bgmusic_game.mp3"},{ bytes : 10577, md5 : "897de292110800dec8d8c85a35beb0ac", name : "sounds/buttonclick.mp3"},{ bytes : 18427, md5 : "069287ee65b1652fa15ebfdffa332eb3", name : "sounds/buttonclick2.mp3"},{ bytes : 15981, md5 : "e34d4c6a3c4fa4955f83669db4d69b9e", name : "sounds/countdown1.mp3"},{ bytes : 38302, md5 : "672865762c56691c1e674a6a90343d96", name : "sounds/countdown2.mp3"},{ bytes : 27583, md5 : "dff59e2493735a73e924dae8df3c9a8f", name : "sounds/finishedlap.mp3"},{ bytes : 39844, md5 : "b814f9b39c48da483be75cef04291ce4", name : "sounds/hitracer.mp3"},{ bytes : 33662, md5 : "ad736a4edb365a6a9bece9c61d34ab73", name : "sounds/hole.mp3"},{ bytes : 50217, md5 : "bb5b045d69548b4f1f94c260dd44cac7", name : "sounds/motor_together.mp3"},{ bytes : 25317, md5 : "4680385df8c47f2dee14ff26589db392", name : "sounds/pillow_pickup.mp3"},{ bytes : 10556, md5 : "8a6c0ae8258e57d7cd7ef32d79a8095a", name : "sounds/shotpillow.mp3"},{ bytes : 20662, md5 : "8a54ec7e66e0da4aaafd71ba45a94cf5", name : "sounds/spinout.mp3"},{ bytes : 26370, md5 : "9b278e06401e6053a25172be125ebf69", name : "sounds/turbo.mp3"},{ bytes : 24771, md5 : "235c53047fed2abc56ac55231d3c61e2", name : "sounds/woosh.mp3"}], main : [{ bytes : 141190, md5 : "cd05a0849852412b886b317de815ac79", name : "chooseracer/bed_crab.png"},{ bytes : 159909, md5 : "436dcd3692bee02c33c1348c114482a1", name : "chooseracer/bed_hotrod.png"},{ bytes : 148608, md5 : "56cb4f079295ae3906d0d7fb9c49b8dc", name : "chooseracer/bed_invincible.png"},{ bytes : 138692, md5 : "5dd28f1aecd2a9a19def9dec9794006d", name : "chooseracer/bed_patrick.png"},{ bytes : 142257, md5 : "5cde1b69a58354ca66caeff3dd7fc011", name : "chooseracer/bed_spongebob.png"},{ bytes : 134187, md5 : "b7309b422becfec334d991b20c5514db", name : "chooseracer/bed_squidward.png"},{ bytes : 17996, md5 : "1574478cb7d42990ad781046c8023c7c", name : "chooseracer/bedpost_crab.png"},{ bytes : 26176, md5 : "f8513cc99855f36b640ac916aba5d022", name : "chooseracer/bedpost_hotrod.png"},{ bytes : 17771, md5 : "98b29686a30e1e244736dfb88024219c", name : "chooseracer/bedpost_invincible.png"},{ bytes : 17566, md5 : "4ecd65d857a074ff62f43e2aef4df03f", name : "chooseracer/bedpost_patrick.png"},{ bytes : 20456, md5 : "9e76b70df75123d6c139ecdafbb3ad48", name : "chooseracer/bedpost_spongebob.png"},{ bytes : 17612, md5 : "24bf38b8d185f53d37fb6e7446a6baff", name : "chooseracer/bedpost_squidward.png"},{ bytes : 19085, md5 : "c55b9fc20426cdf1b029decd4665102a", name : "chooseracer/btn_choose.png"},{ bytes : 27423, md5 : "415fe2fc12826053451ca2b815622991", name : "chooseracer/btn_choose_over.png"},{ bytes : 10207, md5 : "b245848686ef7e8374d54aefc1d72a8b", name : "chooseracer/btn_left.png"},{ bytes : 8124, md5 : "222fcca0ef53e914c1656c2d0b0fe9ff", name : "chooseracer/btn_left_over.png"},{ bytes : 10297, md5 : "a4a488b212a7e9ce0033c1e2543d4291", name : "chooseracer/btn_right.png"},{ bytes : 8122, md5 : "39599fffea7966bd033f2e2ded6d4ea8", name : "chooseracer/btn_right_over.png"},{ bytes : 53588, md5 : "2d021061628a6a8a28253d5ac1f6fdd3", name : "chooseracer/crab.png"},{ bytes : 9133, md5 : "9413ad57608f7f58a15f1ae1af551baa", name : "chooseracer/crab_text.png"},{ bytes : 3810, md5 : "8203f8caaf2b4f58bc4d6ed94ce92aa5", name : "chooseracer/flags.png"},{ bytes : 90819, md5 : "8e735bb5e223c91256db21de0da09a74", name : "chooseracer/headline.png"},{ bytes : 44045, md5 : "0dc64f3a167652dc63cd2cd509342e02", name : "chooseracer/patrick.png"},{ bytes : 7560, md5 : "5f16ec1de62c0dcca0404b76ef342399", name : "chooseracer/patrick_text.png"},{ bytes : 40192, md5 : "6dbec21d03bd52a5551d07c5a9895588", name : "chooseracer/pillows.png"},{ bytes : 59046, md5 : "1b00f3697ed0ee747f4789e3fe7ff448", name : "chooseracer/spongebob.png"},{ bytes : 5697, md5 : "f47a5448181f027f6fc5163030e2cda6", name : "chooseracer/spongebob_arm.png"},{ bytes : 9944, md5 : "1ca9a887cbac72acccec992d066b94d1", name : "chooseracer/spongebob_text.png"},{ bytes : 41484, md5 : "13dd11193ca7345045e2332437e68ea3", name : "chooseracer/squidward.png"},{ bytes : 9806, md5 : "b13ccb5459bd1bb94adb5e10e5e4462e", name : "chooseracer/squidward_text.png"},{ bytes : 9454, md5 : "46d286249661f245c4afc27e9b8a36a9", name : "chooseracer/stars.png"},{ bytes : 14774, md5 : "00d27059fb7f1e77f00d2bd8d5562fdc", name : "end/btn_play.png"},{ bytes : 21767, md5 : "7d8086ff76fa9cf3ae2aca09b3285932", name : "end/btn_play_over.png"},{ bytes : 135170, md5 : "b58ef16bc6269480e8fa108d01964c38", name : "end/crab.png"},{ bytes : 185159, md5 : "a20b015731187893ec31644cbcf78f10", name : "end/crab_hotrod.png"},{ bytes : 6143, md5 : "0e8312a24007baa0e934d15d94f29922", name : "end/crab_score.png"},{ bytes : 146293, md5 : "3c55b4a07ab23d433ef8040526c2b19f", name : "end/crab_star.png"},{ bytes : 170395, md5 : "8062f5a2b9dcef6a70fbc8658dbec38c", name : "end/end_bg1.png"},{ bytes : 162854, md5 : "01b4323595bc83f830d762538867172b", name : "end/end_bg2.png"},{ bytes : 1359, md5 : "4996791c44b28f58bf142869ef17ab4b", name : "end/first_score.png"},{ bytes : 1360, md5 : "91ea35f70472de23bdf49795e05135ab", name : "end/first_score_me.png"},{ bytes : 1369, md5 : "cd3eb5be8640f94ba988cc1ba294d22a", name : "end/fourth_score.png"},{ bytes : 1367, md5 : "52fa2180dab0bab8da180409418607e7", name : "end/fourth_score_me.png"},{ bytes : 72766, md5 : "a8bd7809d854ca51406fa0e2fd62070a", name : "end/headline.png"},{ bytes : 121691, md5 : "da99e5842009039d75cb578dbfbf7d26", name : "end/patrick.png"},{ bytes : 165015, md5 : "dc85afa5818b9cfece7cef4521efe2da", name : "end/patrick_hotrod.png"},{ bytes : 4997, md5 : "96cb0bd3904f1ebbbd2f2ecd23ce1aa2", name : "end/patrick_score.png"},{ bytes : 144831, md5 : "e9c8a3409899721aae5122fecd991f8b", name : "end/patrick_star.png"},{ bytes : 1505, md5 : "15dafc2383273c982ccf88cae7fab7cd", name : "end/second_score.png"},{ bytes : 1504, md5 : "0a86b5e2d772975b90ce8164e19ff9f1", name : "end/second_score_me.png"},{ bytes : 152542, md5 : "ffccdbe5ddfff104712786fca59ebb3e", name : "end/spongebob.png"},{ bytes : 206583, md5 : "d3802015ba88fce86d736b1bbec692c9", name : "end/spongebob_hotrod.png"},{ bytes : 6864, md5 : "43eb32919748e16b2de322d5e42c3917", name : "end/spongebob_score.png"},{ bytes : 166849, md5 : "ba62cf6ed14a4f46caec90a79d2bb692", name : "end/spongebob_star.png"},{ bytes : 131541, md5 : "691257d4d6645c16be760c11da0c808d", name : "end/squidward.png"},{ bytes : 189824, md5 : "86c4d525e6592649c0cb7bce83fdc07c", name : "end/squidward_hotrod.png"},{ bytes : 4982, md5 : "51a4f31465ab7b287e2084bee78ffbed", name : "end/squidward_score.png"},{ bytes : 147938, md5 : "00fe4d19b710504ab7dec792399e3ea0", name : "end/squidward_star.png"},{ bytes : 1600, md5 : "d9c666db70a6ea1aadc9cca47318142d", name : "end/third_score.png"},{ bytes : 1600, md5 : "15f572b933822e8d0b162cd39914314a", name : "end/third_score_me.png"},{ bytes : 2023, md5 : "340fccf4bc4843dad65011dfb7974fa2", name : "feather-1.png"},{ bytes : 1699, md5 : "239c3a21dd0e96147560c3412382a8b2", name : "feather-2.png"},{ bytes : 3120, md5 : "93f472bc04753f6d640d503352e05d48", name : "finishstar.png"},{ bytes : 12020, md5 : "41c9651f17260e54dfa1714f85d947a2", name : "fonts/BonusTxt.fnt"},{ bytes : 30036, md5 : "7431cc42c16824474ad9d13d22f2299c", name : "fonts/BonusTxt.png"},{ bytes : 12023, md5 : "f1085f9ecf08af337b2360b21e055dff", name : "fonts/BonusTxtErr.fnt"},{ bytes : 32284, md5 : "02baeae8936b0bca50469b34b80caecd", name : "fonts/BonusTxtErr.png"},{ bytes : 2348, md5 : "e9f8f7153af0d66c00032c52e3023d21", name : "fonts/endscore.fnt"},{ bytes : 7117, md5 : "85e23213e3fccc67db47a0a7c92aeb90", name : "fonts/endscore.png"},{ bytes : 2355, md5 : "fee429c3385ddb62aea095b71fbcaf77", name : "fonts/endscore_yellow.fnt"},{ bytes : 10298, md5 : "82089e4fe2c65c2336691f1f34cd3f81", name : "fonts/endscore_yellow.png"},{ bytes : 2470, md5 : "26aba01678f91b7d5bda227a4b56275e", name : "fonts/LapTxt.fnt"},{ bytes : 8699, md5 : "52cc19360fbf6d0c67d621b3de602683", name : "fonts/LapTxt.png"},{ bytes : 2348, md5 : "205d4eaed7f981d891eeecdc8c37d508", name : "fonts/TimerTxt.fnt"},{ bytes : 14013, md5 : "c2d1aeb60917ed8a3560ca4e916f5f60", name : "fonts/TimerTxt.png"},{ bytes : 21534, md5 : "e28bc37d11b9e2b6db1b5cb6d2726a22", name : "game/books/1.png"},{ bytes : 21015, md5 : "db747ffb0fc8bf256b46ca06f92ff60f", name : "game/books/10.png"},{ bytes : 21292, md5 : "3e3e1bf7b6cf0d33ae0a0092aa9a0ee2", name : "game/books/11.png"},{ bytes : 21610, md5 : "63d270727bed15d9f13623983319403d", name : "game/books/12.png"},{ bytes : 21772, md5 : "ca0231abc75ee39fa9ce5d312e9e7b5b", name : "game/books/13.png"},{ bytes : 21331, md5 : "7a6c53654ee7195664248b91745b1000", name : "game/books/14.png"},{ bytes : 21584, md5 : "b71fbe41724140ff9cd8d263f4e8c9c2", name : "game/books/2.png"},{ bytes : 21129, md5 : "9638a0149094c45d3d05a0b172636266", name : "game/books/3.png"},{ bytes : 19758, md5 : "6977c34d531882ea4c095f6dfb262936", name : "game/books/4.png"},{ bytes : 20062, md5 : "abd574670c1ab18639915091b4376516", name : "game/books/5.png"},{ bytes : 21103, md5 : "d5af76453d30bf6621934143e60d5782", name : "game/books/6.png"},{ bytes : 21150, md5 : "9a9f50185e237586fd9896825bfc67db", name : "game/books/7.png"},{ bytes : 21063, md5 : "bc870a4f1729ebbadb9b3e9631e56396", name : "game/books/8.png"},{ bytes : 21290, md5 : "da91a4310bc0f2091083096a054d43e0", name : "game/books/9.png"},{ bytes : 33260, md5 : "8dda896866f44e6502425a68ba8bab5c", name : "game/moon/1.png"},{ bytes : 36182, md5 : "6150e34bf42519118f959340ad44b241", name : "game/moon/10.png"},{ bytes : 36395, md5 : "503a40751826a7ffec5545ba3c2fcf70", name : "game/moon/11.png"},{ bytes : 36810, md5 : "5df077440e4173654fc002f841d6dad0", name : "game/moon/12.png"},{ bytes : 36809, md5 : "2973c5a1c381459aecdc3760ed778a2f", name : "game/moon/13.png"},{ bytes : 36901, md5 : "336786e4b240910d45a1090bd41ad024", name : "game/moon/14.png"},{ bytes : 36953, md5 : "9057def31c3191431809de2b028aaa92", name : "game/moon/15.png"},{ bytes : 36951, md5 : "38d02e5ab1879daf69c0fbd58857b747", name : "game/moon/16.png"},{ bytes : 36945, md5 : "2baf60b6d40eccf790684258962acb5e", name : "game/moon/17.png"},{ bytes : 37041, md5 : "eb127019ba50bea5126201584d367ac6", name : "game/moon/18.png"},{ bytes : 37049, md5 : "3740cc7f81694c03a96f63d8e1e808e2", name : "game/moon/19.png"},{ bytes : 34045, md5 : "4426e7c991c173a259eb12ed1e94c8e5", name : "game/moon/2.png"},{ bytes : 37066, md5 : "4b8aa2b52bdd93647c38e03d38e1b4b7", name : "game/moon/20.png"},{ bytes : 36923, md5 : "a935ca06ba65955c9cdec7c208e73d3d", name : "game/moon/21.png"},{ bytes : 36884, md5 : "f7ae22c1e328afa96ea69d56c5577789", name : "game/moon/22.png"},{ bytes : 36851, md5 : "0b1044d0179d80e4587e07069fb53b2a", name : "game/moon/23.png"},{ bytes : 36838, md5 : "73080fe3ab22031411464d2346ea8e6a", name : "game/moon/24.png"},{ bytes : 36550, md5 : "090b8ad1e23d1cebc929c38cd3d3a6f7", name : "game/moon/25.png"},{ bytes : 35945, md5 : "96e9fa95e09080b764c29c8b26df6da1", name : "game/moon/26.png"},{ bytes : 35935, md5 : "a6716696fdc1995073f2371896a64d17", name : "game/moon/27.png"},{ bytes : 35531, md5 : "f4fdcdb94f2b5fc35cf58113a361e697", name : "game/moon/28.png"},{ bytes : 34930, md5 : "f4cc05683f386743a6310d1a9b499a18", name : "game/moon/29.png"},{ bytes : 34187, md5 : "4febaab2a980677d1c3eb8a308570c9b", name : "game/moon/3.png"},{ bytes : 34726, md5 : "801939afc4b70fec62c434184947b3d7", name : "game/moon/30.png"},{ bytes : 34335, md5 : "8fd474cd2ceeb0b97fd3d72c99d8ed25", name : "game/moon/31.png"},{ bytes : 34197, md5 : "cfd4c83c2e84b5bfe7fea0117197d94d", name : "game/moon/32.png"},{ bytes : 34004, md5 : "efcb58b28e55503cfd415f29432e019c", name : "game/moon/33.png"},{ bytes : 33690, md5 : "e59e026060b35950e7fbdc50b843afac", name : "game/moon/34.png"},{ bytes : 33669, md5 : "3701fa58d88536158b37ee2b0f845b09", name : "game/moon/35.png"},{ bytes : 33172, md5 : "3818bf756fe96eb63c4c0d36efe198bf", name : "game/moon/36.png"},{ bytes : 34167, md5 : "8e98fb631865b899eecb73814ecfb596", name : "game/moon/4.png"},{ bytes : 34834, md5 : "be1a9e4521584ae1b351a9c8ee313e46", name : "game/moon/5.png"},{ bytes : 34998, md5 : "b69d648888cb56b7e937fe1a97871a9c", name : "game/moon/6.png"},{ bytes : 35445, md5 : "25b8cba9d0a29ae51a23dc36653b373e", name : "game/moon/7.png"},{ bytes : 35602, md5 : "68495ccc17b0a2733dc45fe45fe1b151", name : "game/moon/8.png"},{ bytes : 35711, md5 : "4443ee6f9bbd346fcee039ae45effe03", name : "game/moon/9.png"},{ bytes : 5262, md5 : "14cb260d9a48c1b25ebd42a495592ba3", name : "game/sheep/1.png"},{ bytes : 10534, md5 : "fb6ca93ab7c420ba61063a84034a435c", name : "game/sheep/10.png"},{ bytes : 11048, md5 : "56915e2e0d00c85fab853be3818abd88", name : "game/sheep/11.png"},{ bytes : 11505, md5 : "0f28aa9c91df121bf3cd01914b593a1b", name : "game/sheep/12.png"},{ bytes : 11949, md5 : "437841ff75382eaf4392b3a32907d90d", name : "game/sheep/13.png"},{ bytes : 12416, md5 : "82bb0590d9e7a8ccde710b9175ca5e3f", name : "game/sheep/14.png"},{ bytes : 12928, md5 : "5b2f0be8bc5240d6f15373d684a2fc7d", name : "game/sheep/15.png"},{ bytes : 13400, md5 : "73a381862466d619fa2c86f130536dc8", name : "game/sheep/16.png"},{ bytes : 13839, md5 : "fa9f75c202d451d5a49a6d5ac027c2db", name : "game/sheep/17.png"},{ bytes : 14205, md5 : "34287e59fe11d7b69fa4a8095a1cfaab", name : "game/sheep/18.png"},{ bytes : 14595, md5 : "9323dadbf07cd0629489bd328b842ba7", name : "game/sheep/19.png"},{ bytes : 6000, md5 : "b127337a1baa9d4bd8db8522f8bea75f", name : "game/sheep/2.png"},{ bytes : 14847, md5 : "652c247a393498a91065a74cac393ea5", name : "game/sheep/20.png"},{ bytes : 15204, md5 : "efd6f195fa9ab60a48bf91f1242ae200", name : "game/sheep/21.png"},{ bytes : 15190, md5 : "a35abdaab8e20466d23d142cf8a7dca8", name : "game/sheep/22.png"},{ bytes : 15301, md5 : "109d4ce1b4ba4358b83ad4bc50adcf10", name : "game/sheep/23.png"},{ bytes : 15324, md5 : "569dee24fb3350bfa4e9bef69fa17b73", name : "game/sheep/24.png"},{ bytes : 15231, md5 : "7e1030363e0f6e3459e9a4777f4a6cc8", name : "game/sheep/25.png"},{ bytes : 14965, md5 : "858ea3da70473af0527a14ec7438b49f", name : "game/sheep/26.png"},{ bytes : 14584, md5 : "15f5d8caf52822f3010a76fa64ad99ef", name : "game/sheep/27.png"},{ bytes : 14347, md5 : "c9514df875ba9ea09f165ae1f65b3d1e", name : "game/sheep/28.png"},{ bytes : 13860, md5 : "ba1181959cfff09ddb3d90a8fd473774", name : "game/sheep/29.png"},{ bytes : 6985, md5 : "852e9ede527b98ed93efd3025edb1207", name : "game/sheep/3.png"},{ bytes : 13366, md5 : "d0be7f8433dcdd1e30539b786f7b3ff4", name : "game/sheep/30.png"},{ bytes : 12765, md5 : "951d0ce2caecb83318922b0250b4dc7f", name : "game/sheep/31.png"},{ bytes : 12097, md5 : "41e7df4a47cdaaa025b69c2903ac8e4d", name : "game/sheep/32.png"},{ bytes : 11249, md5 : "f4dedbdb47de671cfb7e4d676fb2eeac", name : "game/sheep/33.png"},{ bytes : 10574, md5 : "56f034b9866cd7dab9130b98bf31741a", name : "game/sheep/34.png"},{ bytes : 9683, md5 : "b328f5f6a1b24adcdcbfdbf674d25d38", name : "game/sheep/35.png"},{ bytes : 8971, md5 : "89a7029f5268f0ef3c19b0e4e8534464", name : "game/sheep/36.png"},{ bytes : 8179, md5 : "ed79ee8ef1a8374d80d6f99953b71836", name : "game/sheep/37.png"},{ bytes : 7464, md5 : "6d018f4a766d7cbf61aef5b87f6bb8a0", name : "game/sheep/38.png"},{ bytes : 6902, md5 : "dd714d7ac0443b66f24696a0b5035fa2", name : "game/sheep/39.png"},{ bytes : 7703, md5 : "77a3b9d3b9b26e594da07457b1ecca51", name : "game/sheep/4.png"},{ bytes : 6492, md5 : "d974b90f48e23edb064920a6a858f9e4", name : "game/sheep/40.png"},{ bytes : 6104, md5 : "553ed080fceecef757b51bdb8b34080e", name : "game/sheep/41.png"},{ bytes : 5712, md5 : "2da5d92cd43bd2f1dd04ee2e14cc67f8", name : "game/sheep/42.png"},{ bytes : 5330, md5 : "77774fc7b24aca78e0fe0bab1340f37f", name : "game/sheep/43.png"},{ bytes : 5261, md5 : "4b635779f6bdf7a476c39423b9b57dfb", name : "game/sheep/44.png"},{ bytes : 8429, md5 : "574735b6d7275de1531a3681263c9206", name : "game/sheep/5.png"},{ bytes : 9014, md5 : "d3b7a787af569eb914e4d4fa357cf6c5", name : "game/sheep/6.png"},{ bytes : 9464, md5 : "00ba9d61a4c575a835a819a4146e655b", name : "game/sheep/7.png"},{ bytes : 9856, md5 : "e7b2d44444618489b003d02423170054", name : "game/sheep/8.png"},{ bytes : 10205, md5 : "9882796ea723104085c13d59aa8a9747", name : "game/sheep/9.png"},{ bytes : 12662, md5 : "3dfbb471cbf1a5edc3c5a4a2c0c02491", name : "game/spatula/1.png"},{ bytes : 14209, md5 : "f25f88631d238eff2f3c452fb7dc4dcf", name : "game/spatula/10.png"},{ bytes : 14363, md5 : "cbc8339c0d4f540014d03e8b5b4f33be", name : "game/spatula/11.png"},{ bytes : 14421, md5 : "e2066142882a4407a3b0b21c34bf1649", name : "game/spatula/12.png"},{ bytes : 14304, md5 : "41f7c7daee8cb8aa6aa447438485c455", name : "game/spatula/13.png"},{ bytes : 14011, md5 : "052c6ea9d0646fce8442c5cad66345c6", name : "game/spatula/14.png"},{ bytes : 13899, md5 : "cd9d8284d3af82fc238eda5505ef93da", name : "game/spatula/15.png"},{ bytes : 13779, md5 : "8937b7eecbf6be48cb3df9c75cbeba38", name : "game/spatula/16.png"},{ bytes : 13593, md5 : "169af1e8e0e26be7c15d0bae639914bf", name : "game/spatula/17.png"},{ bytes : 13433, md5 : "15f31426e9d3a04ac37ff5dcc0c0f7f5", name : "game/spatula/18.png"},{ bytes : 13192, md5 : "bbbb426a38093cf52fd651ead05b060b", name : "game/spatula/19.png"},{ bytes : 12825, md5 : "84b3ad0a0726542beaaf21c79391bcfb", name : "game/spatula/2.png"},{ bytes : 13138, md5 : "daef0f2095f72f035b80e3f5c7fe2b3f", name : "game/spatula/20.png"},{ bytes : 13286, md5 : "8d508145c9880f03c8be0fac5892b37c", name : "game/spatula/21.png"},{ bytes : 13009, md5 : "c63b495269ee737efe8266069ee9c767", name : "game/spatula/22.png"},{ bytes : 12957, md5 : "c5409850df75bc6fd8d4491daf9dcd88", name : "game/spatula/23.png"},{ bytes : 13061, md5 : "df725c0171a2ab5ce7d20f20e34824b9", name : "game/spatula/24.png"},{ bytes : 13235, md5 : "fd08aa74ecd81256f733a52c8faa1a13", name : "game/spatula/25.png"},{ bytes : 13585, md5 : "c28dc82e013eb68caf99b3aac0086762", name : "game/spatula/26.png"},{ bytes : 14007, md5 : "ed34d164b3cf5eccd83d8ae77d60b176", name : "game/spatula/27.png"},{ bytes : 14621, md5 : "47bca230ed3e1c2c56da7757b6f098d6", name : "game/spatula/28.png"},{ bytes : 15042, md5 : "5a457288c8cf717d649dbe21fafd63d8", name : "game/spatula/29.png"},{ bytes : 13017, md5 : "bfa17313e1dadc263a6a534c65d642fd", name : "game/spatula/3.png"},{ bytes : 15528, md5 : "d94e8c5b28a5cef5e96846b237ea3909", name : "game/spatula/30.png"},{ bytes : 16159, md5 : "0a5f05620f8d8c06ff9cc2417761a889", name : "game/spatula/31.png"},{ bytes : 16700, md5 : "cef672e89deaee8dbc24be721120ac4e", name : "game/spatula/32.png"},{ bytes : 17076, md5 : "51e3a7025d354cfecca1227990eec9bf", name : "game/spatula/33.png"},{ bytes : 17240, md5 : "951ebec4c738ff9fcba4ce8ad6b036f7", name : "game/spatula/34.png"},{ bytes : 17152, md5 : "72c6c21ef9f1a64b07e67239a9ff9e61", name : "game/spatula/35.png"},{ bytes : 16673, md5 : "19cbfe379ec91b42092750036880f316", name : "game/spatula/36.png"},{ bytes : 16368, md5 : "b29d7fb26b72e4398ec618be50dec8b2", name : "game/spatula/37.png"},{ bytes : 16012, md5 : "0c48ebadc57edabbe00064702e9ffe7c", name : "game/spatula/38.png"},{ bytes : 15748, md5 : "01754bed716f2e08b18c01194d9413cd", name : "game/spatula/39.png"},{ bytes : 13189, md5 : "0a90b753533f1d88aa7672b84699f319", name : "game/spatula/4.png"},{ bytes : 15189, md5 : "4b9e74f57847a7d7e8d19be6096b1d2f", name : "game/spatula/40.png"},{ bytes : 14878, md5 : "e4c7bf86be9c9bfc524c665691ff4155", name : "game/spatula/41.png"},{ bytes : 14698, md5 : "bc078901edef69418a41bc437acc3505", name : "game/spatula/42.png"},{ bytes : 14523, md5 : "12542b26541875454ad632d97981dc5f", name : "game/spatula/43.png"},{ bytes : 14139, md5 : "632bb075b0010c324df01c29428888ce", name : "game/spatula/44.png"},{ bytes : 13228, md5 : "caa59c78991332b6144a963c06bb609a", name : "game/spatula/5.png"},{ bytes : 13300, md5 : "6b20f9437916a42c9a6e6960b537f049", name : "game/spatula/6.png"},{ bytes : 13511, md5 : "29e1899388c25fa01b3dd0ff4071afb4", name : "game/spatula/7.png"},{ bytes : 13633, md5 : "e9820bf819f08fc172ed12e3ddad32a9", name : "game/spatula/8.png"},{ bytes : 13958, md5 : "5287bce481841a8e3019de5caf2b5dba", name : "game/spatula/9.png"},{ bytes : 15549, md5 : "0765a62c6e982711a71ab11b7971b22b", name : "game/spatulagroup/1.png"},{ bytes : 15533, md5 : "4043f5e5b5f9f2d2639b46019d49628c", name : "game/spatulagroup/10.png"},{ bytes : 15515, md5 : "f2b9dde6e8e92ca3e1b238576103134c", name : "game/spatulagroup/11.png"},{ bytes : 16084, md5 : "f1702b6b20e6f03c818ceaafdda068ab", name : "game/spatulagroup/12.png"},{ bytes : 16741, md5 : "eea2e86db701cd1a4dbe9614e7f1adbd", name : "game/spatulagroup/13.png"},{ bytes : 17141, md5 : "cc538e8f5cbbfce1e50e170199edfd30", name : "game/spatulagroup/14.png"},{ bytes : 16768, md5 : "d0fe04cad453ae2840d8ddcbd13fd937", name : "game/spatulagroup/15.png"},{ bytes : 16483, md5 : "a73dd96ff5b97a4a04845e8597616871", name : "game/spatulagroup/16.png"},{ bytes : 16095, md5 : "443edb4501f66793ae59716530c97d03", name : "game/spatulagroup/17.png"},{ bytes : 16220, md5 : "5e145dd93f53f567a0bb6bc42a992b5f", name : "game/spatulagroup/18.png"},{ bytes : 14546, md5 : "531a95627713970cab89b5a0c59fdcd2", name : "game/spatulagroup/2.png"},{ bytes : 14320, md5 : "0fdfb947cfccf733df6d3707e2d8e131", name : "game/spatulagroup/3.png"},{ bytes : 14433, md5 : "ecf83499b36892b46e0cf902b2bfd34a", name : "game/spatulagroup/4.png"},{ bytes : 14177, md5 : "48288fd92fc427787bf0704cc15a24ea", name : "game/spatulagroup/5.png"},{ bytes : 13935, md5 : "20b8d26d7b96fb50ab8d7f78c564670b", name : "game/spatulagroup/6.png"},{ bytes : 13737, md5 : "1ee54e321a9a8a7d7d4118d746bdc8c5", name : "game/spatulagroup/7.png"},{ bytes : 14185, md5 : "8d0a4f243175190f2197f134aa883323", name : "game/spatulagroup/8.png"},{ bytes : 14975, md5 : "ac92e054dff429cabd08eccf0367d32f", name : "game/spatulagroup/9.png"},{ bytes : 7154, md5 : "66db5a4fb995733d488bec28e1e217d9", name : "home/btn_code.png"},{ bytes : 16736, md5 : "c1a96d513e6db05e5652440102ee94f1", name : "home/btn_code_large_over.png"},{ bytes : 7466, md5 : "1f149ae2a09fc038e6f67dbfc91a7f7c", name : "home/btn_code_over.png"},{ bytes : 17640, md5 : "b3b90f9b5cb81e47f1ee0b287eb12769", name : "home/btn_enteragain.png"},{ bytes : 46354, md5 : "c4a3e3ea5529218636edb339f7ad50d5", name : "home/btn_enteragain_large_over.png"},{ bytes : 17997, md5 : "dbd661d3ac07c586608b597c66419cb8", name : "home/btn_enteragain_over.png"},{ bytes : 3189, md5 : "1681d71b6ec8d2e223f8597a615d182e", name : "home/btn_sound_off.png"},{ bytes : 3145, md5 : "6bb19dcac3911731d221e3ddde64ca9c", name : "home/btn_sound_off_over.png"},{ bytes : 3765, md5 : "75981b9d0c0e14a0f7af96605566886a", name : "home/btn_sound_on.png"},{ bytes : 3613, md5 : "27ba4380e86c4e189cb7af76dfd02c3c", name : "home/btn_sound_on_over.png"},{ bytes : 26918, md5 : "fb525d14c07967270491b05e3cd4f1e5", name : "home/btn_start.png"},{ bytes : 28268, md5 : "1e11b382514aded37228c8400a60f2c6", name : "home/btn_start_over.png"},{ bytes : 36424, md5 : "f5a84e099546111d97d2f79f37a1830e", name : "home/code_bg.png"},{ bytes : 23877, md5 : "0f625243311438ddde454eebcd4fd417", name : "home/code_success.png"},{ bytes : 192069, md5 : "20429ca967c1842f1d7e73d9dbda231e", name : "home/headline.png"},{ bytes : 247478, md5 : "c08eff1ed3868e77a4fb21d1f5d7cc01", name : "home/home_bg1.png"},{ bytes : 248136, md5 : "5fd195594dc1a513243e47ac820ada0b", name : "home/home_bg2.png"},{ bytes : 44398, md5 : "b6d33351cc9360e74f83ecb73f6e4aa9", name : "home/patrick.png"},{ bytes : 7164, md5 : "8474c2943205cb5510287d8482be24c3", name : "home/powerup_entertwice.png"},{ bytes : 154852, md5 : "bf40d179feba8bb38dd3f4ae3c23440c", name : "home/road1.png"},{ bytes : 92227, md5 : "c014bfd948a75058c33eaea0959ec300", name : "home/road2.png"},{ bytes : 190161, md5 : "78ae1386950f95379e53266c8e965825", name : "home/spongebob.png"},{ bytes : 10103, md5 : "d10b6cdce10eba31e4f7a2693e38351f", name : "home/txt_bonus1.png"},{ bytes : 10274, md5 : "838c28c7e9db1af6b7e7b0ca35734eaf", name : "home/txt_bonus2.png"},{ bytes : 10470, md5 : "c086f2d7c7dffeac7e8c142d98e97ae3", name : "home/txt_bonus3.png"},{ bytes : 2070, md5 : "b49c0e6435aea7b05e036963acff5785", name : "instructions/btn_close.png"},{ bytes : 30167, md5 : "f09ab664ec0b49958cd33620fbce2083", name : "instructions/btn_start.png"},{ bytes : 31592, md5 : "25d1b5eea5fe40fec8d7adcb09ed0305", name : "instructions/btn_start_over.png"},{ bytes : 73001, md5 : "ca0db47526400205d5d8adad594aa810", name : "instructions/instructions.png"},{ bytes : 78477, md5 : "da469b1e75a8d4b237b490453429ad3f", name : "instructions/instructions_mobile.png"},{ bytes : 1515553, md5 : "102bb5b512f51b0cdc59306d69d31a76", name : "sounds/bgmusic_game.mp3"},{ bytes : 734405, md5 : "87267b9b5d9ff2cf2ee95c9dc045a5d3", name : "sounds/bgmusic_start.mp3"},{ bytes : 10577, md5 : "897de292110800dec8d8c85a35beb0ac", name : "sounds/buttonclick.mp3"},{ bytes : 18427, md5 : "069287ee65b1652fa15ebfdffa332eb3", name : "sounds/buttonclick2.mp3"},{ bytes : 15981, md5 : "e34d4c6a3c4fa4955f83669db4d69b9e", name : "sounds/countdown1.mp3"},{ bytes : 38302, md5 : "672865762c56691c1e674a6a90343d96", name : "sounds/countdown2.mp3"},{ bytes : 27583, md5 : "dff59e2493735a73e924dae8df3c9a8f", name : "sounds/finishedlap.mp3"},{ bytes : 39844, md5 : "b814f9b39c48da483be75cef04291ce4", name : "sounds/hitracer.mp3"},{ bytes : 33662, md5 : "ad736a4edb365a6a9bece9c61d34ab73", name : "sounds/hole.mp3"},{ bytes : 50217, md5 : "bb5b045d69548b4f1f94c260dd44cac7", name : "sounds/motor_together.mp3"},{ bytes : 25317, md5 : "4680385df8c47f2dee14ff26589db392", name : "sounds/pillow_pickup.mp3"},{ bytes : 21302, md5 : "02aa02a6c254787abeecbf79a638114c", name : "sounds/rank.mp3"},{ bytes : 10556, md5 : "8a6c0ae8258e57d7cd7ef32d79a8095a", name : "sounds/shotpillow.mp3"},{ bytes : 20662, md5 : "8a54ec7e66e0da4aaafd71ba45a94cf5", name : "sounds/spinout.mp3"},{ bytes : 26370, md5 : "9b278e06401e6053a25172be125ebf69", name : "sounds/turbo.mp3"},{ bytes : 24771, md5 : "235c53047fed2abc56ac55231d3c61e2", name : "sounds/woosh.mp3"}]}]}};
flambe_asset_Manifest._supportsCrossOrigin = (function() {
	var detected = (function() {
		if(js_Browser.get_navigator().userAgent.indexOf("Linux; U; Android") >= 0) return false;
		var xhr = new XMLHttpRequest();
		return xhr.withCredentials != null;
	})();
	if(!detected) flambe_Log.warn("This browser does not support cross-domain asset loading, any Manifest.remoteBase setting will be ignored.");
	return detected;
})();
flambe_display_Font.NEWLINE = new flambe_display_Glyph(10);
flambe_platform_BasicKeyboard._sharedEvent = new flambe_input_KeyboardEvent();
flambe_platform_BasicMouse._sharedEvent = new flambe_input_MouseEvent();
flambe_platform_BasicPointer._sharedEvent = new flambe_input_PointerEvent();
flambe_platform_html_CanvasRenderer.CANVAS_TEXTURES = (function() {
	var pattern = new EReg("(iPhone|iPod|iPad)","");
	return pattern.match(js_Browser.get_window().navigator.userAgent);
})();
flambe_platform_html_HtmlAssetPackLoader._mediaRefCount = 0;
flambe_platform_html_HtmlAssetPackLoader._detectBlobSupport = true;
flambe_platform_html_HtmlUtil.VENDOR_PREFIXES = ["webkit","moz","ms","o","khtml"];
flambe_platform_html_HtmlUtil.SHOULD_HIDE_MOBILE_BROWSER = js_Browser.get_window().top == js_Browser.get_window() && new EReg("Mobile(/.*)? Safari","").match(js_Browser.get_navigator().userAgent);
flambe_platform_html_WebAudioSound._detectSupport = true;
flambe_platform_html_WebGLGraphics._scratchMatrix = new flambe_math_Matrix();
haxe_xml_Parser.escapes = (function($this) {
	var $r;
	var h = new haxe_ds_StringMap();
	h.set("lt","<");
	h.set("gt",">");
	h.set("amp","&");
	h.set("quot","\"");
	h.set("apos","'");
	h.set("nbsp",String.fromCharCode(160));
	$r = h;
	return $r;
}(this));
threedracer_anims_Feather.maxY = 3;
threedracer_anims_Feather.frcX = 0.3;
threedracer_anims_FinishStar.maxY = 3;
threedracer_anims_FinishStar.frcX = 0.3;
threedracer_Main.main();
})();

//# sourceMappingURL=main-html.js.map